-- Generated by WaveFormer Lite Version 9.0u at 19:48:41 on 5/17/2004
-- Stimulator for stimulus

library ieee, std;
use ieee.std_logic_1164.all;
-- Libraries used by Model Under Test.
use IEEE.std_logic_1164.all;
-- End Libraries used by Model Under Test.

entity stimulus is
  port (
    LOAD : out std_logic_vector(4 downto 0) := "ZZZZZ";
    CLR : out std_logic := 'Z';
    NEW_VALUE : out std_logic_vector(9 downto 0) := "ZZZZZZZZZZ";
    CLK : out std_logic := 'Z');

  signal LOAD_driver : std_logic_vector(4 downto 0);
  signal CLR_driver : std_logic;
  signal NEW_VALUE_driver : std_logic_vector(9 downto 0);
  signal CLK_driver : std_logic;
end stimulus;

architecture STIMULATOR of stimulus is

  -- Control Signal Declarations
  type TStatus is (TB_INIT,TB_ABORT,TB_ONCE,TB_LOOPING,TB_DONE,TB_TIMEOUT,TB_RESTART);
  signal tb_status : TStatus;
  signal tb_ParameterInitFlag : boolean := false;

  -- Parm Declarations
  signal CLK_JFall : real := 0.0;
  signal CLK_JRise : real := 0.0;
  signal CLK_MinHL : real := 0.0;
  signal CLK_MaxHL : real := 0.0;
  signal CLK_MinLH : real := 0.0;
  signal CLK_MaxLH : real := 0.0;
  signal CLK_Duty : real := 0.0;
  signal CLK_Period : real := 0.0;
  signal CLK_Offset : real := 0.0;

  -- Assignments from drivers to output and inout ports.

begin

  LOAD <= LOAD_driver;
  CLR <= CLR_driver;
  NEW_VALUE <= NEW_VALUE_driver;
  CLK <= CLK_driver;

  -- Status Control block.
  process
    variable good : boolean;
  begin
    wait until tb_ParameterInitFlag;
    tb_status <= TB_ONCE;
    wait for 110.0 ns;
    tb_status <= TB_DONE;
    wait;
  end process;

  -- Parm Assignment Block
  AssignParms : process
    variable CLK_JFall_real : real;
    variable CLK_JRise_real : real;
    variable CLK_MinHL_real : real;
    variable CLK_MaxHL_real : real;
    variable CLK_MinLH_real : real;
    variable CLK_MaxLH_real : real;
    variable CLK_Duty_real : real;
    variable CLK_Period_real : real;
    variable CLK_Offset_real : real;
  begin
    CLK_JFall_real := 0.0;
    CLK_JFall <= CLK_JFall_real;
    CLK_JRise_real := 0.0;
    CLK_JRise <= CLK_JRise_real;
    CLK_MinHL_real := 0.0;
    CLK_MinHL <= CLK_MinHL_real;
    CLK_MaxHL_real := 0.0;
    CLK_MaxHL <= CLK_MaxHL_real;
    CLK_MinLH_real := 0.0;
    CLK_MinLH <= CLK_MinLH_real;
    CLK_MaxLH_real := 0.0;
    CLK_MaxLH <= CLK_MaxLH_real;
    CLK_Duty_real := 50.0;
    CLK_Duty <= CLK_Duty_real;
    CLK_Period_real := 1.0;
    CLK_Period <= CLK_Period_real;
    CLK_Offset_real := 0.0;
    CLK_Offset <= CLK_Offset_real;
    tb_ParameterInitFlag <= true;
    wait;
  end process;

  -- Clocks

  -- Clock Process
  CLK_process : process
    variable CLK_low : real;
    variable CLK_high : real;
  begin
    tb_mainloop : loop
      wait until (tb_status = TB_ONCE) or (tb_status = TB_LOOPING);
      CLK_high := CLK_Period * CLK_Duty / 100.0;
      CLK_low := CLK_Period - CLK_high;
      CLK_driver <= '0';
      wait until (tb_status = TB_DONE) for (CLK_Offset + (CLK_MinLH - CLK_JRise/2.0)) * 1 ns;
      next tb_mainloop when tb_status = TB_DONE;
      loop
        CLK_driver <= '1';
        wait until (tb_status = TB_DONE) for ((CLK_high - (CLK_MaxLH + CLK_JRise/2.0) + (CLK_MinHL - CLK_JFall/2.0))) * 1 ns;
        next tb_mainloop when tb_status = TB_DONE;
        CLK_driver <= '0';
        wait until (tb_status = TB_DONE) for ((CLK_low - (CLK_MaxHL + CLK_JFall/2.0) + (CLK_MinLH - CLK_JRise/2.0))) * 1 ns;
        next tb_mainloop when tb_status = TB_DONE;
      end loop;
    end loop;
  end process;

  -- Clocked Sequences

  -- Sequence: Unclocked
  Unclocked : process
  begin
    LOAD_driver <= "00000";
    CLR_driver <= '0';
    NEW_VALUE_driver <= "1111111111";
    wait for 10.0 ns;
    CLR_driver <= '1';
    wait for 10.0 ns;
    LOAD_driver <= "11111";
    wait for 1.0 ns;
    LOAD_driver <= "00000";
    wait for 19.0 ns;
    NEW_VALUE_driver <= "0000000111";
    wait for 1.0 ns;
    LOAD_driver <= "11111";
    wait for 1.0 ns;
    LOAD_driver <= "00000";
    wait for 19.0 ns;
    NEW_VALUE_driver <= "1010101010";
    wait for 1.0 ns;
    LOAD_driver <= "11111";
    wait for 1.0 ns;
    LOAD_driver <= "00000";
    wait for 47.0 ns;
    wait;
  end process;
end STIMULATOR;

-- Test Bench wrapper for stimulus and Model Under Test
library ieee, std;
use ieee.std_logic_1164.all;
-- Libraries used by Model Under Test.
use IEEE.std_logic_1164.all;
-- End Libraries used by Model Under Test.

entity testbench is
end testbench;
architecture tbGeneratedCode of testbench is
  signal LOAD : std_logic_vector(4 downto 0);
  signal CLR : std_logic;
  signal NEW_VALUE : std_logic_vector(9 downto 0);
  signal CLK : std_logic;
  signal REG9 : std_logic;

  -- Stimulator instance

begin

  stimulus_0 : entity work.stimulus
    port map (LOAD => LOAD,
              CLR => CLR,
              NEW_VALUE => NEW_VALUE,
              CLK => CLK);

  -- Instantiation of Model Under Test.
  SHREG10_LD_0 : entity work.SHREG10_LD
    port map (LOAD => LOAD,
              CLR => CLR,
              NEW_VALUE => NEW_VALUE,
              CLK => CLK,
              REG9 => REG9);
end tbGeneratedCode;
