-- Generated by WaveFormer Lite Version 8.9 at 21:23:17 on 6/22/2003 
library ieee, std;
-- Libraries used by model under test
use IEEE.std_logic_1164.all;
-- End of libraries used by model under test

entity stimulus is
  port(
      DATA_OUTPUT	: in std_logic_vector(31 downto 0);
      EN    		: out std_logic_vector(31 downto 0);
      RESET		    : out std_logic;
      DATA_INPUT_A	: out std_logic_vector(9 downto 0);
      DATA_INPUT_B	: out std_logic_vector(9 downto 0);
      CLK50		    : out std_logic
      );
end stimulus;

architecture GeneratedCode of stimulus is
begin

CLK50_process : process
  variable tb_stop_time : time := 2000 ns;
  variable CLK50_Offset : time := 0 ns;
  variable CLK50_Period : time := 20 ns;
  variable CLK50_MinLH : time := 0 ns;
  variable CLK50_MaxLH : time := 0 ns;
  variable CLK50_MinHL : time := 0 ns;
  variable CLK50_MaxHL : time := 0 ns;
  variable CLK50_JRise : time := 0 ns;
  variable CLK50_JFall : time := 0 ns;
  variable CLK50_Duty : time := 50 ns;
  variable CLK50_high : time;
  variable CLK50_low : time;
begin 
  CLK50_high := CLK50_Period * (CLK50_Duty / ns) / 100;
  CLK50_low := CLK50_Period - CLK50_high;
  CLK50 <= '0';
  if (CLK50_Offset + (CLK50_MinLH - CLK50_JRise/2) < 0 ns) then
    assert FALSE report "Clock offset is less than 0 for CLK50. This could be caused by jitter. Increase offset to get rid of this error." severity FAILURE;
  else
    wait for CLK50_Offset + (CLK50_MinLH - CLK50_JRise/2);
    while (now < tb_stop_time) loop
      CLK50 <= '1';
      wait for (CLK50_high - (CLK50_MaxLH + CLK50_JRise/2) + (CLK50_MinHL - CLK50_JFall/2));
      CLK50 <= '0';
      wait for (CLK50_low - (CLK50_MaxHL + CLK50_JFall/2) + (CLK50_MinLH - CLK50_JRise/2));
    end loop;
  end if;
end process;

  process
  begin
        EN	            <=	x"00000000";
        RESET	        <=	'1';
        DATA_INPUT_A	<=	"0000000000";
        DATA_INPUT_B	<=	"0000000000";
  	wait for 56 ns;   -- Accumulated time = 56 ns

        RESET	        <=	'0';
    wait for 104 ns;   -- Accumulated time = 160 ns
        RESET	        <=	'1';
    wait for 3 ns;     -- Accumulated time = 163 ns
--*************************************
        DATA_INPUT_A	<=	"1111111111";
        DATA_INPUT_B	<=	"0000000000";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 177 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 183 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111111110";
        DATA_INPUT_B	<=	"0000000001";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 187 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 193 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111111100";
        DATA_INPUT_B	<=	"0000000011";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 197 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 203 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111111000";
        DATA_INPUT_B	<=	"0000000111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 207 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 213 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111110000";
        DATA_INPUT_B	<=	"0000001111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 217 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 223 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111100000";
        DATA_INPUT_B	<=	"0000011111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 227 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 233 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1111000000";
        DATA_INPUT_B	<=	"0000111111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 237 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 243 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1110000000";
        DATA_INPUT_B	<=	"0001111111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 247 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 253 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1100000000";
        DATA_INPUT_B	<=	"0011111111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 257 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 263 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"1000000000";
        DATA_INPUT_B	<=	"0111111111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 267 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 273 ns
        EN	            <=	x"00000000";
--*************************************
        DATA_INPUT_A	<=	"0000000000";
        DATA_INPUT_B	<=	"1111111111";
        EN	            <=	x"00000000";
  	wait for 4 ns;   -- Accumulated time = 277 ns
        EN          	<=	x"FFFFFFFF";
  	wait for 6 ns;   -- Accumulated time = 283 ns
        EN	            <=	x"00000000";
--*************************************


  	wait for 89 ns;   -- Accumulated time = 372 ns

  	wait for 49 ns;   -- Accumulated time = 421 ns

  	wait;
  end process;

end GeneratedCode;

--Top Level Test Bench Module
  -- Contains an instance of the Stimulus Module and an instance of the Product Module
library ieee, std;
-- Libraries used by model under test
use IEEE.std_logic_1164.all;
-- End of libraries used by model under test

use work.all;

entity testbench is
  end testbench;

architecture tbGeneratedCode of testbench is
   -- Component declaration for the stimulus module
   component stimulus
    port(
      DATA_OUTPUT		: in  std_logic_vector(31 downto 0);
      EN        		: out std_logic_vector(31 downto 0);
      RESET		        : out std_logic;
      DATA_INPUT_A		: out std_logic_vector(9 downto 0);
      DATA_INPUT_B		: out std_logic_vector(9 downto 0);
      CLK50		        : out std_logic
        );
   end component;

   -- Component declaration for the product module
   component TOP_CHANNEL
    port(
      DATA_OUTPUT	    : out std_logic_vector(31 downto 0);
      CLK50	            : in  std_logic;
      EN    	        : in  std_logic_vector(31 downto 0);
      RESET	            : in  std_logic;
      DATA_INPUT_A	    : in  std_logic_vector(9 downto 0);
      DATA_INPUT_B	    : in  std_logic_vector(9 downto 0)
        );
   end component;
   -- Signal Declarations for the test bench module
    signal		DATA_OUTPUT		: std_logic_vector(31 downto 0);
    signal		EN  			: std_logic_vector(31 downto 0);
    signal		RESET			: std_logic;
    signal		DATA_INPUT_A	: std_logic_vector(9 downto 0);
    signal		DATA_INPUT_B	: std_logic_vector(9 downto 0);
    signal		CLK50			: std_logic;

   -- Ports are connected by matching the port names of the Test Module
   begin
     stimulus_0: stimulus
       port map(
                  DATA_OUTPUT,
                  EN,
                  RESET,
                  DATA_INPUT_A,
                  DATA_INPUT_B,
                  CLK50
                    );
    TOP_CHANNEL_0 : TOP_CHANNEL
      port map(
                  DATA_OUTPUT => DATA_OUTPUT,
                  CLK50 => CLK50,
                  EN => EN,
                  RESET => RESET,
                  DATA_INPUT_A => DATA_INPUT_A,
                  DATA_INPUT_B => DATA_INPUT_B
                  );
end tbGeneratedCode;
