
library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_35 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_35;

architecture DEF_ARCH of SHREG10_35 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_36 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_36;

architecture DEF_ARCH of SHREG10_36 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_18 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; ENABLE : in std_logic);

end regcc10_18;

architecture DEF_ARCH of regcc10_18 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => ENABLE, 
        Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => ENABLE, 
        Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => ENABLE, 
        Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => ENABLE, 
        Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => ENABLE, 
        Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => ENABLE, 
        Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => ENABLE, 
        Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => ENABLE, 
        Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => ENABLE, 
        Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => ENABLE, 
        Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_18 is

    port(\dout[31]\ : out std_logic; \load[4]\, \new_value[9]\, 
        new_value_net_8, new_value_net_2, new_value_net_4, 
        new_value_net_3, new_value_net_5, new_value_net_1, 
        new_value_net_7, load_net_1, load_net_3, LOAD_scalar_0, 
        new_value_net_6, CLR, clk_1000, load_net_2, 
        NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_18;

architecture DEF_ARCH of SHREG10_LD_18 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => \dout[31]\, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_18 is

    port(\dout[31]\ : out std_logic; \dat_b[9]\, ENABLE, 
        dat_b_net_1, dat_b_net_6, dat_b_net_8, dat_b_net_3, 
        dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, dat_b_net_2, 
        dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_18;

architecture DEF_ARCH of CHANNEL_SHIFT_18 is 

  component SHREG10_35
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_36
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_18
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; ENABLE : 
        in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_18
    port(\dout[31]\ : out std_logic; \load[4]\, \new_value[9]\, 
        new_value_net_8, new_value_net_2, new_value_net_4, 
        new_value_net_3, new_value_net_5, new_value_net_1, 
        new_value_net_7, load_net_1, load_net_3, LOAD_scalar_0, 
        new_value_net_6, CLR, clk_1000, load_net_2, 
        NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_35
	Use entity work.SHREG10_35(DEF_ARCH);
    for all : SHREG10_36
	Use entity work.SHREG10_36(DEF_ARCH);
    for all : regcc10_18
	Use entity work.regcc10_18(DEF_ARCH);
    for all : SHREG10_LD_18
	Use entity work.SHREG10_LD_18(DEF_ARCH);
begin 


    REG_B : SHREG10_35
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_36
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_18
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        ENABLE => ENABLE);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_18
      port map(\dout[31]\ => \dout[31]\, \load[4]\ => load_4, 
        \new_value[9]\ => new_value_9, new_value_net_8 => 
        new_value_net_8, new_value_net_2 => new_value_net_2, 
        new_value_net_4 => new_value_net_4, new_value_net_3 => 
        new_value_net_3, new_value_net_5 => new_value_net_5, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_51 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_51;

architecture DEF_ARCH of SHREG10_51 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_52 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_52;

architecture DEF_ARCH of SHREG10_52 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_26 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_18 : in
         std_logic);

end regcc10_26;

architecture DEF_ARCH of regcc10_26 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_18, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_18, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_18, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_18, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_18, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_18, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_18, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_18, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_18, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_18, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_26 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_17 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_26;

architecture DEF_ARCH of SHREG10_LD_26 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_17, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_26 is

    port(\dat_a[9]\ : in std_logic; dout_net_17 : out std_logic; 
        enable_net_18, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_26;

architecture DEF_ARCH of CHANNEL_SHIFT_26 is 

  component SHREG10_51
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_52
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_26
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_18 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_26
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_17 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_51
	Use entity work.SHREG10_51(DEF_ARCH);
    for all : SHREG10_52
	Use entity work.SHREG10_52(DEF_ARCH);
    for all : regcc10_26
	Use entity work.regcc10_26(DEF_ARCH);
    for all : SHREG10_LD_26
	Use entity work.SHREG10_LD_26(DEF_ARCH);
begin 


    REG_B : SHREG10_51
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_52
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_26
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_18 => enable_net_18);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_26
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_17 => dout_net_17, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_61 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_61;

architecture DEF_ARCH of SHREG10_61 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_62 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_62;

architecture DEF_ARCH of SHREG10_62 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_31 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_15 : in std_logic);

end regcc10_31;

architecture DEF_ARCH of regcc10_31 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_15, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_15, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_15, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_15, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_15, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_15, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_15, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_15, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_15, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_15, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_31 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_14 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_31;

architecture DEF_ARCH of SHREG10_LD_31 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_14, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_31 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_14 : out std_logic; 
        enable_net_15, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_31;

architecture DEF_ARCH of CHANNEL_SHIFT_31 is 

  component SHREG10_61
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_62
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_31
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_15 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_31
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_14 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_61
	Use entity work.SHREG10_61(DEF_ARCH);
    for all : SHREG10_62
	Use entity work.SHREG10_62(DEF_ARCH);
    for all : regcc10_31
	Use entity work.regcc10_31(DEF_ARCH);
    for all : SHREG10_LD_31
	Use entity work.SHREG10_LD_31(DEF_ARCH);
begin 


    REG_B : SHREG10_61
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_62
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_31
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_15 => enable_net_15);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_31
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_14 => dout_net_14, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_23 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_23;

architecture DEF_ARCH of SHREG10_23 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_24 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_24;

architecture DEF_ARCH of SHREG10_24 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_12 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_16 : in
         std_logic);

end regcc10_12;

architecture DEF_ARCH of regcc10_12 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_16, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_16, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_16, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_16, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_16, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_16, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_16, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_16, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_16, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_16, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_12 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_15 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_12;

architecture DEF_ARCH of SHREG10_LD_12 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_15, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_12 is

    port(\dat_a[9]\ : in std_logic; dout_net_15 : out std_logic; 
        enable_net_16, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_12;

architecture DEF_ARCH of CHANNEL_SHIFT_12 is 

  component SHREG10_23
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_24
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_12
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_16 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_12
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_15 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_23
	Use entity work.SHREG10_23(DEF_ARCH);
    for all : SHREG10_24
	Use entity work.SHREG10_24(DEF_ARCH);
    for all : regcc10_12
	Use entity work.regcc10_12(DEF_ARCH);
    for all : SHREG10_LD_12
	Use entity work.SHREG10_LD_12(DEF_ARCH);
begin 


    REG_B : SHREG10_23
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_24
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_12
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_16 => enable_net_16);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_12
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_15 => dout_net_15, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_29 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_29;

architecture DEF_ARCH of SHREG10_29 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_30 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_30;

architecture DEF_ARCH of SHREG10_30 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_15 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_23 : in
         std_logic);

end regcc10_15;

architecture DEF_ARCH of regcc10_15 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_23, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_23, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_23, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_23, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_23, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_23, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_23, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_23, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_23, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_23, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_15 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_22 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_15;

architecture DEF_ARCH of SHREG10_LD_15 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_22, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_15 is

    port(\dat_a[9]\ : in std_logic; dout_net_22 : out std_logic; 
        enable_net_23, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_15;

architecture DEF_ARCH of CHANNEL_SHIFT_15 is 

  component SHREG10_29
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_30
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_15
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_23 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_15
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_22 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_29
	Use entity work.SHREG10_29(DEF_ARCH);
    for all : SHREG10_30
	Use entity work.SHREG10_30(DEF_ARCH);
    for all : regcc10_15
	Use entity work.regcc10_15(DEF_ARCH);
    for all : SHREG10_LD_15
	Use entity work.SHREG10_LD_15(DEF_ARCH);
begin 


    REG_B : SHREG10_29
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_30
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_15
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_23 => enable_net_23);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_15
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_22 => dout_net_22, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_43 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_43;

architecture DEF_ARCH of SHREG10_43 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_44 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_44;

architecture DEF_ARCH of SHREG10_44 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_22 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_8 : in std_logic);

end regcc10_22;

architecture DEF_ARCH of regcc10_22 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_8, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_8, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_8, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_8, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_8, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_8, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_8, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_8, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_8, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_8, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_22 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_7 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_22;

architecture DEF_ARCH of SHREG10_LD_22 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_7, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_22 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_7 : out std_logic; 
        enable_net_8, dat_b_net_1_0, dat_b_net_6_0, dat_b_net_8_0, 
        dat_b_net_3_0, dat_b_net_7_0, DAT_B_0_scalar_0, 
        dat_b_net_5_0, dat_b_net_2_0, dat_b_net_4_0, CLR, 
        clk_1000 : in std_logic);

end CHANNEL_SHIFT_22;

architecture DEF_ARCH of CHANNEL_SHIFT_22 is 

  component SHREG10_43
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_44
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_22
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_8 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_22
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_7 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_43
	Use entity work.SHREG10_43(DEF_ARCH);
    for all : SHREG10_44
	Use entity work.SHREG10_44(DEF_ARCH);
    for all : regcc10_22
	Use entity work.regcc10_22(DEF_ARCH);
    for all : SHREG10_LD_22
	Use entity work.SHREG10_LD_22(DEF_ARCH);
begin 


    REG_B : SHREG10_43
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_44
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_22
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_8 => enable_net_8);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_22
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_7 => dout_net_7, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_27 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_27;

architecture DEF_ARCH of SHREG10_27 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_28 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_28;

architecture DEF_ARCH of SHREG10_28 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_14 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_21 : in
         std_logic);

end regcc10_14;

architecture DEF_ARCH of regcc10_14 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_21, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_21, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_21, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_21, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_21, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_21, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_21, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_21, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_21, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_21, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_14 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_20 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_14;

architecture DEF_ARCH of SHREG10_LD_14 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_20, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_14 is

    port(\dat_a[9]\ : in std_logic; dout_net_20 : out std_logic; 
        enable_net_21, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_14;

architecture DEF_ARCH of CHANNEL_SHIFT_14 is 

  component SHREG10_27
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_28
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_14
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_21 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_14
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_20 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_27
	Use entity work.SHREG10_27(DEF_ARCH);
    for all : SHREG10_28
	Use entity work.SHREG10_28(DEF_ARCH);
    for all : regcc10_14
	Use entity work.regcc10_14(DEF_ARCH);
    for all : SHREG10_LD_14
	Use entity work.SHREG10_LD_14(DEF_ARCH);
begin 


    REG_B : SHREG10_27
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_28
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_14
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_21 => enable_net_21);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_14
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_20 => dout_net_20, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_41 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_41;

architecture DEF_ARCH of SHREG10_41 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_42 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_42;

architecture DEF_ARCH of SHREG10_42 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_21 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_27 : in std_logic);

end regcc10_21;

architecture DEF_ARCH of regcc10_21 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_27, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_27, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_27, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_27, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_27, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_27, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_27, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_27, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_27, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_27, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_21 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_26 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_21;

architecture DEF_ARCH of SHREG10_LD_21 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_26, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_21 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_26 : out std_logic; 
        enable_net_27, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_21;

architecture DEF_ARCH of CHANNEL_SHIFT_21 is 

  component SHREG10_41
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_42
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_21
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_27 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_21
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_26 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_41
	Use entity work.SHREG10_41(DEF_ARCH);
    for all : SHREG10_42
	Use entity work.SHREG10_42(DEF_ARCH);
    for all : regcc10_21
	Use entity work.regcc10_21(DEF_ARCH);
    for all : SHREG10_LD_21
	Use entity work.SHREG10_LD_21(DEF_ARCH);
begin 


    REG_B : SHREG10_41
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_42
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_21
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_27 => enable_net_27);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_21
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_26 => dout_net_26, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_25 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_25;

architecture DEF_ARCH of SHREG10_25 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_26 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_26;

architecture DEF_ARCH of SHREG10_26 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_13 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_30 : in std_logic);

end regcc10_13;

architecture DEF_ARCH of regcc10_13 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_30, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_30, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_30, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_30, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_30, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_30, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_30, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_30, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_30, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_30, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_13 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_29 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_13;

architecture DEF_ARCH of SHREG10_LD_13 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_29, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_13 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_29 : out std_logic; 
        enable_net_30, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_13;

architecture DEF_ARCH of CHANNEL_SHIFT_13 is 

  component SHREG10_25
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_26
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_13
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_30 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_13
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_29 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_25
	Use entity work.SHREG10_25(DEF_ARCH);
    for all : SHREG10_26
	Use entity work.SHREG10_26(DEF_ARCH);
    for all : regcc10_13
	Use entity work.regcc10_13(DEF_ARCH);
    for all : SHREG10_LD_13
	Use entity work.SHREG10_LD_13(DEF_ARCH);
begin 


    REG_B : SHREG10_25
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_26
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_13
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_30 => enable_net_30);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_13
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_29 => dout_net_29, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_47 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_47;

architecture DEF_ARCH of SHREG10_47 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_48 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_48;

architecture DEF_ARCH of SHREG10_48 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_24 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_5 : in
         std_logic);

end regcc10_24;

architecture DEF_ARCH of regcc10_24 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_5, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_5, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_5, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_5, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_5, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_5, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_5, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_5, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_5, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_5, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_24 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_4 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_24;

architecture DEF_ARCH of SHREG10_LD_24 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_4, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_24 is

    port(\dat_b[9]\ : in std_logic; dout_net_4 : out std_logic; 
        enable_net_5, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_24;

architecture DEF_ARCH of CHANNEL_SHIFT_24 is 

  component SHREG10_47
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_48
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_24
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_5 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_24
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_4 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_47
	Use entity work.SHREG10_47(DEF_ARCH);
    for all : SHREG10_48
	Use entity work.SHREG10_48(DEF_ARCH);
    for all : regcc10_24
	Use entity work.regcc10_24(DEF_ARCH);
    for all : SHREG10_LD_24
	Use entity work.SHREG10_LD_24(DEF_ARCH);
begin 


    REG_B : SHREG10_47
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_48
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_24
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_5 => enable_net_5);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_24
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_4 => dout_net_4, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_39 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_39;

architecture DEF_ARCH of SHREG10_39 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_40 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_40;

architecture DEF_ARCH of SHREG10_40 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_20 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_19 : in
         std_logic);

end regcc10_20;

architecture DEF_ARCH of regcc10_20 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_19, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_19, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_19, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_19, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_19, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_19, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_19, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_19, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_19, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_19, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_20 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_18 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_20;

architecture DEF_ARCH of SHREG10_LD_20 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_18, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_20 is

    port(\dat_a[9]\ : in std_logic; dout_net_18 : out std_logic; 
        enable_net_19, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_20;

architecture DEF_ARCH of CHANNEL_SHIFT_20 is 

  component SHREG10_39
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_40
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_20
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_19 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_20
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_18 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_39
	Use entity work.SHREG10_39(DEF_ARCH);
    for all : SHREG10_40
	Use entity work.SHREG10_40(DEF_ARCH);
    for all : regcc10_20
	Use entity work.regcc10_20(DEF_ARCH);
    for all : SHREG10_LD_20
	Use entity work.SHREG10_LD_20(DEF_ARCH);
begin 


    REG_B : SHREG10_39
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_40
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_20
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_19 => enable_net_19);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_20
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_18 => dout_net_18, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_7 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_7;

architecture DEF_ARCH of SHREG10_7 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_8 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_8;

architecture DEF_ARCH of SHREG10_8 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_4 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_6 : in
         std_logic);

end regcc10_4;

architecture DEF_ARCH of regcc10_4 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_6, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_6, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_6, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_6, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_6, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_6, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_6, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_6, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_6, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_6, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_4 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_5 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_4;

architecture DEF_ARCH of SHREG10_LD_4 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_5, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_4 is

    port(\dat_b[9]\ : in std_logic; dout_net_5 : out std_logic; 
        enable_net_6, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_4;

architecture DEF_ARCH of CHANNEL_SHIFT_4 is 

  component SHREG10_7
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_8
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_4
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_6 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_4
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_5 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_7
	Use entity work.SHREG10_7(DEF_ARCH);
    for all : SHREG10_8
	Use entity work.SHREG10_8(DEF_ARCH);
    for all : regcc10_4
	Use entity work.regcc10_4(DEF_ARCH);
    for all : SHREG10_LD_4
	Use entity work.SHREG10_LD_4(DEF_ARCH);
begin 


    REG_B : SHREG10_7
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_8
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_4
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_6 => enable_net_6);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_4
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_5 => dout_net_5, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_11 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_11;

architecture DEF_ARCH of SHREG10_11 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_12 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_12;

architecture DEF_ARCH of SHREG10_12 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_6 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_11 : in std_logic);

end regcc10_6;

architecture DEF_ARCH of regcc10_6 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_11, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_11, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_11, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_11, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_11, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_11, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_11, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_11, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_11, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_11, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_6 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_10 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_6;

architecture DEF_ARCH of SHREG10_LD_6 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_10, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_6 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_10 : out std_logic; 
        enable_net_11, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_6;

architecture DEF_ARCH of CHANNEL_SHIFT_6 is 

  component SHREG10_11
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_12
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_6
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_11 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_6
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_10 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_11
	Use entity work.SHREG10_11(DEF_ARCH);
    for all : SHREG10_12
	Use entity work.SHREG10_12(DEF_ARCH);
    for all : regcc10_6
	Use entity work.regcc10_6(DEF_ARCH);
    for all : SHREG10_LD_6
	Use entity work.SHREG10_LD_6(DEF_ARCH);
begin 


    REG_B : SHREG10_11
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_12
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_6
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_11 => enable_net_11);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_6
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_10 => dout_net_10, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_31 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_31;

architecture DEF_ARCH of SHREG10_31 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_32 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_32;

architecture DEF_ARCH of SHREG10_32 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_16 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_13 : in std_logic);

end regcc10_16;

architecture DEF_ARCH of regcc10_16 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_13, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_13, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_13, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_13, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_13, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_13, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_13, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_13, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_13, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_13, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_16 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_12 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_16;

architecture DEF_ARCH of SHREG10_LD_16 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_12, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_16 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_12 : out std_logic; 
        enable_net_13, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_16;

architecture DEF_ARCH of CHANNEL_SHIFT_16 is 

  component SHREG10_31
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_32
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_16
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_13 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_16
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_12 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_31
	Use entity work.SHREG10_31(DEF_ARCH);
    for all : SHREG10_32
	Use entity work.SHREG10_32(DEF_ARCH);
    for all : regcc10_16
	Use entity work.regcc10_16(DEF_ARCH);
    for all : SHREG10_LD_16
	Use entity work.SHREG10_LD_16(DEF_ARCH);
begin 


    REG_B : SHREG10_31
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_32
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_16
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_13 => enable_net_13);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_16
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_12 => dout_net_12, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_5 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_5;

architecture DEF_ARCH of SHREG10_5 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_6 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_6;

architecture DEF_ARCH of SHREG10_6 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_3 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_24 : in std_logic);

end regcc10_3;

architecture DEF_ARCH of regcc10_3 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_24, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_24, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_24, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_24, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_24, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_24, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_24, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_24, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_24, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_24, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_3 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_23 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_3;

architecture DEF_ARCH of SHREG10_LD_3 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_23, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_3 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_23 : out std_logic; 
        enable_net_24, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_3;

architecture DEF_ARCH of CHANNEL_SHIFT_3 is 

  component SHREG10_5
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_6
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_3
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_24 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_3
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_23 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_5
	Use entity work.SHREG10_5(DEF_ARCH);
    for all : SHREG10_6
	Use entity work.SHREG10_6(DEF_ARCH);
    for all : regcc10_3
	Use entity work.regcc10_3(DEF_ARCH);
    for all : SHREG10_LD_3
	Use entity work.SHREG10_LD_3(DEF_ARCH);
begin 


    REG_B : SHREG10_5
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_6
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_3
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_24 => enable_net_24);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_3
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_23 => dout_net_23, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_9 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_9;

architecture DEF_ARCH of SHREG10_9 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_10 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_10;

architecture DEF_ARCH of SHREG10_10 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_5 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_29 : in std_logic);

end regcc10_5;

architecture DEF_ARCH of regcc10_5 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_29, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_29, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_29, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_29, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_29, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_29, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_29, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_29, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_29, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_29, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_5 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_28 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_5;

architecture DEF_ARCH of SHREG10_LD_5 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_28, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_5 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_28 : out std_logic; 
        enable_net_29, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_5;

architecture DEF_ARCH of CHANNEL_SHIFT_5 is 

  component SHREG10_9
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_10
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_5
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_29 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_5
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_28 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_9
	Use entity work.SHREG10_9(DEF_ARCH);
    for all : SHREG10_10
	Use entity work.SHREG10_10(DEF_ARCH);
    for all : regcc10_5
	Use entity work.regcc10_5(DEF_ARCH);
    for all : SHREG10_LD_5
	Use entity work.SHREG10_LD_5(DEF_ARCH);
begin 


    REG_B : SHREG10_9
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_10
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_5
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_29 => enable_net_29);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_5
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_28 => dout_net_28, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_13 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_13;

architecture DEF_ARCH of SHREG10_13 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_14 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_14;

architecture DEF_ARCH of SHREG10_14 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_7 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_14 : in std_logic);

end regcc10_7;

architecture DEF_ARCH of regcc10_7 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_14, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_14, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_14, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_14, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_14, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_14, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_14, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_14, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_14, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_14, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_7 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_13 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_7;

architecture DEF_ARCH of SHREG10_LD_7 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_13, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_7 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_13 : out std_logic; 
        enable_net_14, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_7;

architecture DEF_ARCH of CHANNEL_SHIFT_7 is 

  component SHREG10_13
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_14
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_7
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_14 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_7
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_13 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_13
	Use entity work.SHREG10_13(DEF_ARCH);
    for all : SHREG10_14
	Use entity work.SHREG10_14(DEF_ARCH);
    for all : regcc10_7
	Use entity work.regcc10_7(DEF_ARCH);
    for all : SHREG10_LD_7
	Use entity work.SHREG10_LD_7(DEF_ARCH);
begin 


    REG_B : SHREG10_13
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_14
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_7
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_14 => enable_net_14);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_7
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_13 => dout_net_13, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_33 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_33;

architecture DEF_ARCH of SHREG10_33 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_34 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_34;

architecture DEF_ARCH of SHREG10_34 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_17 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_9 : in std_logic);

end regcc10_17;

architecture DEF_ARCH of regcc10_17 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_9, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_9, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_9, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_9, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_9, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_9, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_9, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_9, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_9, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_9, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_17 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_8 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_17;

architecture DEF_ARCH of SHREG10_LD_17 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_8, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_17 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_8 : out std_logic; 
        enable_net_9, dat_b_net_1_0, dat_b_net_6_0, dat_b_net_8_0, 
        dat_b_net_3_0, dat_b_net_7_0, DAT_B_0_scalar_0, 
        dat_b_net_5_0, dat_b_net_2_0, dat_b_net_4_0, CLR, 
        clk_1000 : in std_logic);

end CHANNEL_SHIFT_17;

architecture DEF_ARCH of CHANNEL_SHIFT_17 is 

  component SHREG10_33
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_34
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_17
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_9 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_17
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_8 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_33
	Use entity work.SHREG10_33(DEF_ARCH);
    for all : SHREG10_34
	Use entity work.SHREG10_34(DEF_ARCH);
    for all : regcc10_17
	Use entity work.regcc10_17(DEF_ARCH);
    for all : SHREG10_LD_17
	Use entity work.SHREG10_LD_17(DEF_ARCH);
begin 


    REG_B : SHREG10_33
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_34
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_17
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_9 => enable_net_9);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_17
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_8 => dout_net_8, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_3 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_3;

architecture DEF_ARCH of SHREG10_3 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_4 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_4;

architecture DEF_ARCH of SHREG10_4 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_2 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_12 : in std_logic);

end regcc10_2;

architecture DEF_ARCH of regcc10_2 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_12, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_12, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_12, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_12, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_12, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_12, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_12, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_12, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_12, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_12, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_2 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_11 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_2;

architecture DEF_ARCH of SHREG10_LD_2 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_11, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_2 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_11 : out std_logic; 
        enable_net_12, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_2;

architecture DEF_ARCH of CHANNEL_SHIFT_2 is 

  component SHREG10_3
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_4
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_2
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_12 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_2
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_11 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_3
	Use entity work.SHREG10_3(DEF_ARCH);
    for all : SHREG10_4
	Use entity work.SHREG10_4(DEF_ARCH);
    for all : regcc10_2
	Use entity work.regcc10_2(DEF_ARCH);
    for all : SHREG10_LD_2
	Use entity work.SHREG10_LD_2(DEF_ARCH);
begin 


    REG_B : SHREG10_3
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_4
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_2
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_12 => enable_net_12);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_2
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_11 => dout_net_11, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_37 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_37;

architecture DEF_ARCH of SHREG10_37 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_38 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_38;

architecture DEF_ARCH of SHREG10_38 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_19 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_17 : in
         std_logic);

end regcc10_19;

architecture DEF_ARCH of regcc10_19 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_17, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_17, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_17, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_17, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_17, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_17, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_17, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_17, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_17, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_17, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_19 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_16 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_19;

architecture DEF_ARCH of SHREG10_LD_19 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_16, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_19 is

    port(\dat_a[9]\ : in std_logic; dout_net_16 : out std_logic; 
        enable_net_17, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_19;

architecture DEF_ARCH of CHANNEL_SHIFT_19 is 

  component SHREG10_37
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_38
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_19
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_17 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_19
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_16 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_37
	Use entity work.SHREG10_37(DEF_ARCH);
    for all : SHREG10_38
	Use entity work.SHREG10_38(DEF_ARCH);
    for all : regcc10_19
	Use entity work.regcc10_19(DEF_ARCH);
    for all : SHREG10_LD_19
	Use entity work.SHREG10_LD_19(DEF_ARCH);
begin 


    REG_B : SHREG10_37
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_38
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_19
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_17 => enable_net_17);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_19
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_16 => dout_net_16, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_55 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_55;

architecture DEF_ARCH of SHREG10_55 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_56 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_56;

architecture DEF_ARCH of SHREG10_56 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_28 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_1 : in
         std_logic);

end regcc10_28;

architecture DEF_ARCH of regcc10_28 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_1, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_1, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_1, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_1, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_1, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_1, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_1, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_1, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_1, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_1, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_28 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; DOUT : out std_logic; 
        new_value_net_1, new_value_net_7, load_net_1, load_net_3, 
        LOAD_scalar_0, new_value_net_6, CLR, clk_1000, load_net_2, 
        NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_28;

architecture DEF_ARCH of SHREG10_LD_28 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => DOUT, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_28 is

    port(\dat_b[9]\ : in std_logic; DOUT : out std_logic; 
        enable_net_1, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_28;

architecture DEF_ARCH of CHANNEL_SHIFT_28 is 

  component SHREG10_55
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_56
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_28
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_1 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_28
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; DOUT : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_55
	Use entity work.SHREG10_55(DEF_ARCH);
    for all : SHREG10_56
	Use entity work.SHREG10_56(DEF_ARCH);
    for all : regcc10_28
	Use entity work.regcc10_28(DEF_ARCH);
    for all : SHREG10_LD_28
	Use entity work.SHREG10_LD_28(DEF_ARCH);
begin 


    REG_B : SHREG10_55
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_56
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_28
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_1 => enable_net_1);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_28
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, DOUT => DOUT, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        load_net_1 => load_net_1, load_net_3 => load_net_3, 
        LOAD_scalar_0 => LOAD, new_value_net_6 => new_value_net_6, 
        CLR => CLR, clk_1000 => clk_1000, load_net_2 => 
        load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_59 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_59;

architecture DEF_ARCH of SHREG10_59 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_60 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_60;

architecture DEF_ARCH of SHREG10_60 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_30 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_31 : in std_logic);

end regcc10_30;

architecture DEF_ARCH of regcc10_30 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_31, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_31, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_31, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_31, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_31, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_31, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_31, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_31, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_31, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_31, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_30 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_30 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_30;

architecture DEF_ARCH of SHREG10_LD_30 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_30, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_30 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_30 : out std_logic; 
        enable_net_31, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_30;

architecture DEF_ARCH of CHANNEL_SHIFT_30 is 

  component SHREG10_59
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_60
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_30
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_31 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_30
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_30 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_59
	Use entity work.SHREG10_59(DEF_ARCH);
    for all : SHREG10_60
	Use entity work.SHREG10_60(DEF_ARCH);
    for all : regcc10_30
	Use entity work.regcc10_30(DEF_ARCH);
    for all : SHREG10_LD_30
	Use entity work.SHREG10_LD_30(DEF_ARCH);
begin 


    REG_B : SHREG10_59
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_60
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_30
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_31 => enable_net_31);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_30
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_30 => dout_net_30, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_53 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_53;

architecture DEF_ARCH of SHREG10_53 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_54 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_54;

architecture DEF_ARCH of SHREG10_54 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_27 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_28 : in std_logic);

end regcc10_27;

architecture DEF_ARCH of regcc10_27 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_28, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_28, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_28, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_28, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_28, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_28, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_28, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_28, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_28, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_28, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_27 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_27 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_27;

architecture DEF_ARCH of SHREG10_LD_27 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_27, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_27 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_27 : out std_logic; 
        enable_net_28, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_27;

architecture DEF_ARCH of CHANNEL_SHIFT_27 is 

  component SHREG10_53
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_54
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_27
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_28 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_27
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_27 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_53
	Use entity work.SHREG10_53(DEF_ARCH);
    for all : SHREG10_54
	Use entity work.SHREG10_54(DEF_ARCH);
    for all : regcc10_27
	Use entity work.regcc10_27(DEF_ARCH);
    for all : SHREG10_LD_27
	Use entity work.SHREG10_LD_27(DEF_ARCH);
begin 


    REG_B : SHREG10_53
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_54
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_27
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_28 => enable_net_28);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_27
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_27 => dout_net_27, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_15 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_15;

architecture DEF_ARCH of SHREG10_15 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_16 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_16;

architecture DEF_ARCH of SHREG10_16 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_8 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_3 : in
         std_logic);

end regcc10_8;

architecture DEF_ARCH of regcc10_8 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_3, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_3, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_3, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_3, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_3, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_3, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_3, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_3, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_3, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_3, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_8 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_2 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_8;

architecture DEF_ARCH of SHREG10_LD_8 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_2, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_8 is

    port(\dat_b[9]\ : in std_logic; dout_net_2 : out std_logic; 
        enable_net_3, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_8;

architecture DEF_ARCH of CHANNEL_SHIFT_8 is 

  component SHREG10_15
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_16
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_8
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_3 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_8
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_2 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_15
	Use entity work.SHREG10_15(DEF_ARCH);
    for all : SHREG10_16
	Use entity work.SHREG10_16(DEF_ARCH);
    for all : regcc10_8
	Use entity work.regcc10_8(DEF_ARCH);
    for all : SHREG10_LD_8
	Use entity work.SHREG10_LD_8(DEF_ARCH);
begin 


    REG_B : SHREG10_15
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_16
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_8
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_3 => enable_net_3);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_8
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_2 => dout_net_2, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_57 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_57;

architecture DEF_ARCH of SHREG10_57 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_58 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_58;

architecture DEF_ARCH of SHREG10_58 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_29 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_20 : in
         std_logic);

end regcc10_29;

architecture DEF_ARCH of regcc10_29 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_20, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_20, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_20, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_20, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_20, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_20, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_20, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_20, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_20, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_20, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_29 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_19 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_29;

architecture DEF_ARCH of SHREG10_LD_29 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_19, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_29 is

    port(\dat_a[9]\ : in std_logic; dout_net_19 : out std_logic; 
        enable_net_20, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_29;

architecture DEF_ARCH of CHANNEL_SHIFT_29 is 

  component SHREG10_57
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_58
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_29
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_20 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_29
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_19 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_57
	Use entity work.SHREG10_57(DEF_ARCH);
    for all : SHREG10_58
	Use entity work.SHREG10_58(DEF_ARCH);
    for all : regcc10_29
	Use entity work.regcc10_29(DEF_ARCH);
    for all : SHREG10_LD_29
	Use entity work.SHREG10_LD_29(DEF_ARCH);
begin 


    REG_B : SHREG10_57
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_58
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_29
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_20 => enable_net_20);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_29
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_19 => dout_net_19, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_63 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_63;

architecture DEF_ARCH of SHREG10_63 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_64 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_64;

architecture DEF_ARCH of SHREG10_64 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_32 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_4 : in
         std_logic);

end regcc10_32;

architecture DEF_ARCH of regcc10_32 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_4, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_4, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_4, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_4, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_4, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_4, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_4, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_4, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_4, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_4, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_32 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_3 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_32;

architecture DEF_ARCH of SHREG10_LD_32 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_3, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_32 is

    port(\dat_b[9]\ : in std_logic; dout_net_3 : out std_logic; 
        enable_net_4, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_32;

architecture DEF_ARCH of CHANNEL_SHIFT_32 is 

  component SHREG10_63
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_64
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_32
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_4 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_32
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_3 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_63
	Use entity work.SHREG10_63(DEF_ARCH);
    for all : SHREG10_64
	Use entity work.SHREG10_64(DEF_ARCH);
    for all : regcc10_32
	Use entity work.regcc10_32(DEF_ARCH);
    for all : SHREG10_LD_32
	Use entity work.SHREG10_LD_32(DEF_ARCH);
begin 


    REG_B : SHREG10_63
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_64
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_32
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_4 => enable_net_4);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_32
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_3 => dout_net_3, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_49 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_49;

architecture DEF_ARCH of SHREG10_49 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_50 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_50;

architecture DEF_ARCH of SHREG10_50 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_25 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_2 : in
         std_logic);

end regcc10_25;

architecture DEF_ARCH of regcc10_25 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_2, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_2, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_2, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_2, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_2, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_2, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_2, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_2, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_2, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_2, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_25 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_1 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_25;

architecture DEF_ARCH of SHREG10_LD_25 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_1, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_25 is

    port(\dat_b[9]\ : in std_logic; dout_net_1 : out std_logic; 
        enable_net_2, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_25;

architecture DEF_ARCH of CHANNEL_SHIFT_25 is 

  component SHREG10_49
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_50
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_25
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_2 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_25
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_1 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_49
	Use entity work.SHREG10_49(DEF_ARCH);
    for all : SHREG10_50
	Use entity work.SHREG10_50(DEF_ARCH);
    for all : regcc10_25
	Use entity work.regcc10_25(DEF_ARCH);
    for all : SHREG10_LD_25
	Use entity work.SHREG10_LD_25(DEF_ARCH);
begin 


    REG_B : SHREG10_49
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_50
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_25
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_2 => enable_net_2);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_25
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_1 => dout_net_1, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_17 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_17;

architecture DEF_ARCH of SHREG10_17 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_18 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_18;

architecture DEF_ARCH of SHREG10_18 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_9 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_26 : in std_logic);

end regcc10_9;

architecture DEF_ARCH of regcc10_9 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_26, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_26, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_26, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_26, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_26, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_26, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_26, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_26, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_26, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_26, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_9 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_25 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_9;

architecture DEF_ARCH of SHREG10_LD_9 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_25, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_9 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_25 : out std_logic; 
        enable_net_26, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_9;

architecture DEF_ARCH of CHANNEL_SHIFT_9 is 

  component SHREG10_17
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_18
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_9
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_26 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_9
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_25 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_17
	Use entity work.SHREG10_17(DEF_ARCH);
    for all : SHREG10_18
	Use entity work.SHREG10_18(DEF_ARCH);
    for all : regcc10_9
	Use entity work.regcc10_9(DEF_ARCH);
    for all : SHREG10_LD_9
	Use entity work.SHREG10_LD_9(DEF_ARCH);
begin 


    REG_B : SHREG10_17
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_18
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_9
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_26 => enable_net_26);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_9
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_25 => dout_net_25, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_21 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_21;

architecture DEF_ARCH of SHREG10_21 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_22 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_22;

architecture DEF_ARCH of SHREG10_22 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_11 is

    port(\dat_b[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5, 
        DAT_B_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7, CLR, dat_b_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_b_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_b_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_7 : in
         std_logic);

end regcc10_11;

architecture DEF_ARCH of regcc10_11 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_7, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_7, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_7, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_7, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_7, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_7, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_7, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_7, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_7, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_7, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_11 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_6 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_11;

architecture DEF_ARCH of SHREG10_LD_11 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_6, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_11 is

    port(\dat_b[9]\ : in std_logic; dout_net_6 : out std_logic; 
        enable_net_7, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_11;

architecture DEF_ARCH of CHANNEL_SHIFT_11 is 

  component SHREG10_21
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_22
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_11
    port(\dat_b[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5, DAT_B_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7, CLR, 
        dat_b_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_b_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_7 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_11
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_6 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_21
	Use entity work.SHREG10_21(DEF_ARCH);
    for all : SHREG10_22
	Use entity work.SHREG10_22(DEF_ARCH);
    for all : regcc10_11
	Use entity work.regcc10_11(DEF_ARCH);
    for all : SHREG10_LD_11
	Use entity work.SHREG10_LD_11(DEF_ARCH);
begin 


    REG_B : SHREG10_21
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_22
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_11
      port map(\dat_b[9]\ => \dat_b[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4 => dat_b_net_4, new_value_net_4
         => new_value_net_4, dat_b_net_2 => dat_b_net_2, 
        new_value_net_2 => new_value_net_2, dat_b_net_5 => 
        dat_b_net_5, DAT_B_scalar_0 => DAT_B_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_b_net_7 => 
        dat_b_net_7, CLR => CLR, dat_b_net_3 => dat_b_net_3, 
        new_value_net_3 => new_value_net_3, dat_b_net_8 => 
        dat_b_net_8, new_value_net_8 => new_value_net_8, 
        dat_b_net_6 => dat_b_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_b_net_1 => dat_b_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_7 => enable_net_7);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_11
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_6 => dout_net_6, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_19 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_19;

architecture DEF_ARCH of SHREG10_19 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_20 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_20;

architecture DEF_ARCH of SHREG10_20 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_10 is

    port(\dat_a_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5_0, 
        DAT_A_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7_0, CLR, dat_a_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_a_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_a_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_a_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_25 : in std_logic);

end regcc10_10;

architecture DEF_ARCH of regcc10_10 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_25, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_25, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_25, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_25, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_25, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_25, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_25, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_25, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_25, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_25, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_10 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_24 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_10;

architecture DEF_ARCH of SHREG10_LD_10 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_24, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_10 is

    port(\dat_a_0[9]\ : in std_logic; dout_net_24 : out std_logic; 
        enable_net_25, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_10;

architecture DEF_ARCH of CHANNEL_SHIFT_10 is 

  component SHREG10_19
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_20
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_10
    port(\dat_a_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5_0, DAT_A_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7_0, CLR, 
        dat_a_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_a_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_25 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_10
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_24 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_19
	Use entity work.SHREG10_19(DEF_ARCH);
    for all : SHREG10_20
	Use entity work.SHREG10_20(DEF_ARCH);
    for all : regcc10_10
	Use entity work.regcc10_10(DEF_ARCH);
    for all : SHREG10_LD_10
	Use entity work.SHREG10_LD_10(DEF_ARCH);
begin 


    REG_B : SHREG10_19
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_20
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_10
      port map(\dat_a_0[9]\ => \dat_a_0[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4_0 => dat_a_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_a_net_2_0 => 
        dat_a_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_a_net_5_0 => dat_a_net_5_0, DAT_A_0_scalar_0 => 
        DAT_A_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_a_net_7_0 => dat_a_net_7_0, CLR => CLR, dat_a_net_3_0
         => dat_a_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_a_net_8_0 => dat_a_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_a_net_6_0 => dat_a_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_a_net_1_0 => dat_a_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_25 => enable_net_25);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_10
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_24 => dout_net_24, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity clk1gig_pll_1 is

    port(clk_50 : in std_logic; clk_1000 : out std_logic);

end clk1gig_pll_1;

architecture DEF_ARCH of clk1gig_pll_1 is 

  component VCC
    port(Y : out std_logic);
  end component;

  component PLL
    port(PWRDWN, REFCLK, LOWFREQ, OSC2, OSC1, OSC0, DIVI5, DIVI4, 
        DIVI3, DIVI2, DIVI1, DIVI0, DIVJ5, DIVJ4, DIVJ3, DIVJ2, 
        DIVJ1, DIVJ0, DELAYLINE4, DELAYLINE3, DELAYLINE2, 
        DELAYLINE1, DELAYLINE0 : in std_logic := 'U'; LOCK, CLK1, 
        CLK2 : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

  component PLLHCLK
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

    signal PLL_clk1p, lock, clk2, VCCZ0, GNDZ0 : std_logic;

begin 


    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    PLL_INT : PLL
      port map(PWRDWN => VCCZ0, REFCLK => clk_50, LOWFREQ => 
        VCCZ0, OSC2 => GNDZ0, OSC1 => GNDZ0, OSC0 => GNDZ0, DIVI5
         => GNDZ0, DIVI4 => VCCZ0, DIVI3 => GNDZ0, DIVI2 => GNDZ0, 
        DIVI1 => VCCZ0, DIVI0 => VCCZ0, DIVJ5 => GNDZ0, DIVJ4 => 
        GNDZ0, DIVJ3 => GNDZ0, DIVJ2 => GNDZ0, DIVJ1 => GNDZ0, 
        DIVJ0 => GNDZ0, DELAYLINE4 => GNDZ0, DELAYLINE3 => GNDZ0, 
        DELAYLINE2 => GNDZ0, DELAYLINE1 => GNDZ0, DELAYLINE0 => 
        GNDZ0, LOCK => lock, CLK1 => PLL_clk1p, CLK2 => clk2);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    PLLHCLK1 : PLLHCLK
      port map(A => PLL_clk1p, Y => clk_1000);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_1 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_1;

architecture DEF_ARCH of SHREG10_1 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_2 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_2;

architecture DEF_ARCH of SHREG10_2 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_1 is

    port(\dat_a[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic; new_value_net_4 : 
        out std_logic; dat_a_net_2 : in std_logic; 
        new_value_net_2 : out std_logic; dat_a_net_5, 
        DAT_A_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_a_net_7, CLR, dat_a_net_3 : in std_logic; 
        new_value_net_3 : out std_logic; dat_a_net_8 : in
         std_logic; new_value_net_8 : out std_logic; dat_a_net_6 : 
        in std_logic; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic; new_value_net_1, 
        new_value_net_7 : out std_logic; enable_net_22 : in
         std_logic);

end regcc10_1;

architecture DEF_ARCH of regcc10_1 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_22, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_a_net_4, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_22, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_a_net_2, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_22, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_a_net_5, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_22, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_22, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_A_scalar_0, S
         => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_22, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_22, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_a_net_7, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_a_net_3, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_22, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_22, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_a[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_a_net_8, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_a_net_6, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_a_net_1, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_22, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_1 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_21 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_1;

architecture DEF_ARCH of SHREG10_LD_1 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_21, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_1 is

    port(\dat_a[9]\ : in std_logic; dout_net_21 : out std_logic; 
        enable_net_22, dat_a_net_1, dat_a_net_6, dat_a_net_8, 
        dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, dat_a_net_5, 
        dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_1;

architecture DEF_ARCH of CHANNEL_SHIFT_1 is 

  component SHREG10_1
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_2
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_1
    port(\dat_a[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_a_net_4 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_a_net_2 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_a_net_5, DAT_A_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_a_net_7, CLR, 
        dat_a_net_3 : in std_logic := 'U'; new_value_net_3 : out
         std_logic; dat_a_net_8 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_a_net_6 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_a_net_1 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_22 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_1
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_21 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_1
	Use entity work.SHREG10_1(DEF_ARCH);
    for all : SHREG10_2
	Use entity work.SHREG10_2(DEF_ARCH);
    for all : regcc10_1
	Use entity work.regcc10_1(DEF_ARCH);
    for all : SHREG10_LD_1
	Use entity work.SHREG10_LD_1(DEF_ARCH);
begin 


    REG_B : SHREG10_1
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_2
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_1
      port map(\dat_a[9]\ => \dat_a[9]\, \new_value[9]\ => 
        new_value_9, dat_a_net_4 => dat_a_net_4, new_value_net_4
         => new_value_net_4, dat_a_net_2 => dat_a_net_2, 
        new_value_net_2 => new_value_net_2, dat_a_net_5 => 
        dat_a_net_5, DAT_A_scalar_0 => DAT_A_scalar_0, 
        NEW_VALUE_scalar_0 => NEW_VALUE, dat_a_net_7 => 
        dat_a_net_7, CLR => CLR, dat_a_net_3 => dat_a_net_3, 
        new_value_net_3 => new_value_net_3, dat_a_net_8 => 
        dat_a_net_8, new_value_net_8 => new_value_net_8, 
        dat_a_net_6 => dat_a_net_6, new_value_net_6 => 
        new_value_net_6, new_value_net_5 => new_value_net_5, 
        dat_a_net_1 => dat_a_net_1, new_value_net_1 => 
        new_value_net_1, new_value_net_7 => new_value_net_7, 
        enable_net_22 => enable_net_22);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_1
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_21 => dout_net_21, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_45 is

    port(reg8_b : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_45;

architecture DEF_ARCH of SHREG10_45 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_b\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_b <= \reg8_b\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_b\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_b\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_46 is

    port(reg8_a : out std_logic; CLR, clk_1000 : in std_logic);

end SHREG10_46;

architecture DEF_ARCH of SHREG10_46 is 

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFP1B
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

    signal reg1, reg0, reg2, reg3, reg7, \reg8_a\, reg9, reg4, 
        reg5, reg6 : std_logic;

begin 

    reg8_a <= \reg8_a\;

    REGFF_6 : DFC1B
      port map(D => reg5, CLK => clk_1000, CLR => CLR, Q => reg6);
    
    REGFF_5 : DFC1B
      port map(D => reg4, CLK => clk_1000, CLR => CLR, Q => reg5);
    
    REGFF_9 : DFC1B
      port map(D => \reg8_a\, CLK => clk_1000, CLR => CLR, Q => 
        reg9);
    
    REGFF_8 : DFC1B
      port map(D => reg7, CLK => clk_1000, CLR => CLR, Q => 
        \reg8_a\);
    
    REGFF_4 : DFC1B
      port map(D => reg3, CLK => clk_1000, CLR => CLR, Q => reg4);
    
    REGFF_3 : DFC1B
      port map(D => reg2, CLK => clk_1000, CLR => CLR, Q => reg3);
    
    REGFF_7 : DFC1B
      port map(D => reg6, CLK => clk_1000, CLR => CLR, Q => reg7);
    
    REGFF_0 : DFP1B
      port map(D => reg9, CLK => clk_1000, PRE => CLR, Q => reg0);
    
    REGFF_2 : DFC1B
      port map(D => reg1, CLK => clk_1000, CLR => CLR, Q => reg2);
    
    REGFF_1 : DFC1B
      port map(D => reg0, CLK => clk_1000, CLR => CLR, Q => reg1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity regcc10_23 is

    port(\dat_b_0[9]\ : in std_logic; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic; new_value_net_4 : 
        out std_logic; dat_b_net_2_0 : in std_logic; 
        new_value_net_2 : out std_logic; dat_b_net_5_0, 
        DAT_B_0_scalar_0 : in std_logic; NEW_VALUE_scalar_0 : out
         std_logic; dat_b_net_7_0, CLR, dat_b_net_3_0 : in
         std_logic; new_value_net_3 : out std_logic; 
        dat_b_net_8_0 : in std_logic; new_value_net_8 : out
         std_logic; dat_b_net_6_0 : in std_logic; new_value_net_6, 
        new_value_net_5 : out std_logic; dat_b_net_1_0 : in
         std_logic; new_value_net_1, new_value_net_7 : out
         std_logic; enable_net_10 : in std_logic);

end regcc10_23;

architecture DEF_ARCH of regcc10_23 is 

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

    signal mx2_5_y, \new_value_net_3\, mx2_1_y, 
        \new_value_net_1\, \new_value_net_7\, mx2_4_y, mx2_7_y, 
        \new_value_net_6\, mx2_3_y, \NEW_VALUE_scalar_0\, mx2_8_y, 
        new_value_9, \new_value_net_5\, mx2_6_y, enaux_5_net, 
        \new_value_net_4\, mx2_9_y, mx2_0_y, clraux_5_net, 
        \new_value_net_2\, mx2_2_y, clraux_0_net, 
        \new_value_net_8\, enaux_0_net, VCCZ0 : std_logic;

begin 

    \new_value[9]\ <= new_value_9;
    new_value_net_4 <= \new_value_net_4\;
    new_value_net_2 <= \new_value_net_2\;
    NEW_VALUE_scalar_0 <= \NEW_VALUE_scalar_0\;
    new_value_net_3 <= \new_value_net_3\;
    new_value_net_8 <= \new_value_net_8\;
    new_value_net_6 <= \new_value_net_6\;
    new_value_net_5 <= \new_value_net_5\;
    new_value_net_1 <= \new_value_net_1\;
    new_value_net_7 <= \new_value_net_7\;

    BUFF_ClrAux_0_inst : BUFF
      port map(A => CLR, Y => clraux_0_net);
    
    DFC1B_CC_Q_5_inst : DFC1B_CC
      port map(D => mx2_5_y, CLR => clraux_5_net, CLK => 
        enable_net_10, Q => \new_value_net_3\);
    
    MX2_9 : MX2
      port map(A => \new_value_net_4\, B => dat_b_net_4_0, S => 
        enaux_0_net, Y => mx2_9_y);
    
    DFC1B_CC_Q_4_inst : DFC1B_CC
      port map(D => mx2_9_y, CLR => clraux_0_net, CLK => 
        enable_net_10, Q => \new_value_net_4\);
    
    MX2_0 : MX2
      port map(A => \new_value_net_2\, B => dat_b_net_2_0, S => 
        enaux_5_net, Y => mx2_0_y);
    
    DFC1B_CC_Q_0_inst : DFC1B_CC
      port map(D => mx2_2_y, CLR => clraux_0_net, CLK => 
        enable_net_10, Q => \new_value_net_8\);
    
    MX2_6 : MX2
      port map(A => \new_value_net_5\, B => dat_b_net_5_0, S => 
        enaux_0_net, Y => mx2_6_y);
    
    DFC1B_CC_Q_7_inst : DFC1B_CC
      port map(D => mx2_1_y, CLR => clraux_5_net, CLK => 
        enable_net_10, Q => \new_value_net_1\);
    
    DFC1B_CC_Q_8_inst : DFC1B_CC
      port map(D => mx2_3_y, CLR => clraux_5_net, CLK => 
        enable_net_10, Q => \NEW_VALUE_scalar_0\);
    
    MX2_3 : MX2
      port map(A => \NEW_VALUE_scalar_0\, B => DAT_B_0_scalar_0, 
        S => enaux_5_net, Y => mx2_3_y);
    
    DFC1B_CC_Q_2_inst : DFC1B_CC
      port map(D => mx2_7_y, CLR => clraux_0_net, CLK => 
        enable_net_10, Q => \new_value_net_6\);
    
    DFC1B_CC_Q_9_inst : DFC1B_CC
      port map(D => mx2_8_y, CLR => clraux_5_net, CLK => 
        enable_net_10, Q => new_value_9);
    
    MX2_4 : MX2
      port map(A => \new_value_net_7\, B => dat_b_net_7_0, S => 
        enaux_0_net, Y => mx2_4_y);
    
    BUFF_ClrAux_5_inst : BUFF
      port map(A => CLR, Y => clraux_5_net);
    
    MX2_5 : MX2
      port map(A => \new_value_net_3\, B => dat_b_net_3_0, S => 
        enaux_5_net, Y => mx2_5_y);
    
    DFC1B_CC_Q_3_inst : DFC1B_CC
      port map(D => mx2_6_y, CLR => clraux_0_net, CLK => 
        enable_net_10, Q => \new_value_net_5\);
    
    DFC1B_CC_Q_1_inst : DFC1B_CC
      port map(D => mx2_4_y, CLR => clraux_0_net, CLK => 
        enable_net_10, Q => \new_value_net_7\);
    
    BUFF_EnAux_5_inst : BUFF
      port map(A => VCCZ0, Y => enaux_5_net);
    
    MX2_8 : MX2
      port map(A => new_value_9, B => \dat_b_0[9]\, S => 
        enaux_5_net, Y => mx2_8_y);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    MX2_2 : MX2
      port map(A => \new_value_net_8\, B => dat_b_net_8_0, S => 
        enaux_0_net, Y => mx2_2_y);
    
    MX2_7 : MX2
      port map(A => \new_value_net_6\, B => dat_b_net_6_0, S => 
        enaux_0_net, Y => mx2_7_y);
    
    MX2_1 : MX2
      port map(A => \new_value_net_1\, B => dat_b_net_1_0, S => 
        enaux_5_net, Y => mx2_1_y);
    
    DFC1B_CC_Q_6_inst : DFC1B_CC
      port map(D => mx2_0_y, CLR => clraux_5_net, CLK => 
        enable_net_10, Q => \new_value_net_2\);
    
    BUFF_EnAux_0_inst : BUFF
      port map(A => VCCZ0, Y => enaux_0_net);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity SHREG10_LD_23 is

    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic; dout_net_9 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic);

end SHREG10_LD_23;

architecture DEF_ARCH of SHREG10_LD_23 is 

  component DFMB
    port(A, B, CLK, CLR : in std_logic := 'U'; Q : out std_logic; 
        S : in std_logic := 'U');
  end component;

  component BUFD
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic);
  end component;

    signal reg7, DATA, data_net_7, data_net_1, reg8, data_9, 
        data_net_5, reg0, data_net_3, data_net_8, reg1, 
        data_net_6, reg2, reg3, data_net_4, reg4, reg5, 
        data_net_2, reg6, GNDZ0 : std_logic;

begin 


    REGFF_6 : DFMB
      port map(A => reg5, B => data_net_2, CLK => clk_1000, CLR
         => CLR, Q => reg6, S => LOAD_scalar_0);
    
    REGFF_4 : DFMB
      port map(A => reg3, B => data_net_4, CLK => clk_1000, CLR
         => CLR, Q => reg4, S => load_net_1);
    
    REGFF_2 : DFMB
      port map(A => reg1, B => data_net_6, CLK => clk_1000, CLR
         => CLR, Q => reg2, S => load_net_2);
    
    DC0 : BUFD
      port map(A => new_value_net_8, Y => data_net_8);
    
    DC6 : BUFD
      port map(A => new_value_net_2, Y => data_net_2);
    
    DC4 : BUFD
      port map(A => new_value_net_4, Y => data_net_4);
    
    DC5 : BUFD
      port map(A => new_value_net_3, Y => data_net_3);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    REGFF_0 : DFMB
      port map(A => GNDZ0, B => data_net_8, CLK => clk_1000, CLR
         => CLR, Q => reg0, S => load_net_3);
    
    DC3 : BUFD
      port map(A => new_value_net_5, Y => data_net_5);
    
    REGFF_9 : DFMB
      port map(A => reg8, B => data_9, CLK => clk_1000, CLR => 
        CLR, Q => dout_net_9, S => \load[4]\);
    
    DC7 : BUFD
      port map(A => new_value_net_1, Y => data_net_1);
    
    DC1 : BUFD
      port map(A => new_value_net_7, Y => data_net_7);
    
    REGFF_8 : DFMB
      port map(A => reg7, B => DATA, CLK => clk_1000, CLR => CLR, 
        Q => reg8, S => \load[4]\);
    
    REGFF_5 : DFMB
      port map(A => reg4, B => data_net_3, CLK => clk_1000, CLR
         => CLR, Q => reg5, S => load_net_1);
    
    DC9 : BUFD
      port map(A => \new_value[9]\, Y => data_9);
    
    REGFF_1 : DFMB
      port map(A => reg0, B => data_net_7, CLK => clk_1000, CLR
         => CLR, Q => reg1, S => load_net_3);
    
    REGFF_7 : DFMB
      port map(A => reg6, B => data_net_1, CLK => clk_1000, CLR
         => CLR, Q => reg7, S => LOAD_scalar_0);
    
    DC2 : BUFD
      port map(A => new_value_net_6, Y => data_net_6);
    
    REGFF_3 : DFMB
      port map(A => reg2, B => data_net_5, CLK => clk_1000, CLR
         => CLR, Q => reg3, S => load_net_2);
    
    DC8 : BUFD
      port map(A => NEW_VALUE_scalar_0, Y => DATA);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity CHANNEL_SHIFT_23 is

    port(\dat_b_0[9]\ : in std_logic; dout_net_9 : out std_logic; 
        enable_net_10, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic);

end CHANNEL_SHIFT_23;

architecture DEF_ARCH of CHANNEL_SHIFT_23 is 

  component SHREG10_45
    port(reg8_b : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component SHREG10_46
    port(reg8_a : out std_logic; CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component regcc10_23
    port(\dat_b_0[9]\ : in std_logic := 'U'; \new_value[9]\ : out
         std_logic; dat_b_net_4_0 : in std_logic := 'U'; 
        new_value_net_4 : out std_logic; dat_b_net_2_0 : in
         std_logic := 'U'; new_value_net_2 : out std_logic; 
        dat_b_net_5_0, DAT_B_0_scalar_0 : in std_logic := 'U'; 
        NEW_VALUE_scalar_0 : out std_logic; dat_b_net_7_0, CLR, 
        dat_b_net_3_0 : in std_logic := 'U'; new_value_net_3 : 
        out std_logic; dat_b_net_8_0 : in std_logic := 'U'; 
        new_value_net_8 : out std_logic; dat_b_net_6_0 : in
         std_logic := 'U'; new_value_net_6, new_value_net_5 : out
         std_logic; dat_b_net_1_0 : in std_logic := 'U'; 
        new_value_net_1, new_value_net_7 : out std_logic; 
        enable_net_10 : in std_logic := 'U');
  end component;

  component DFC1B
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component SHREG10_LD_23
    port(\load[4]\, \new_value[9]\, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5 : in std_logic := 'U'; dout_net_9 : out
         std_logic; new_value_net_1, new_value_net_7, load_net_1, 
        load_net_3, LOAD_scalar_0, new_value_net_6, CLR, clk_1000, 
        load_net_2, NEW_VALUE_scalar_0 : in std_logic := 'U');
  end component;

    signal reg8_b, reg8_a, load_4, new_value_9, new_value_net_8, 
        new_value_net_2, new_value_net_4, new_value_net_3, 
        new_value_net_5, new_value_net_1, new_value_net_7, 
        load_net_1, load_net_3, LOAD, new_value_net_6, load_net_2, 
        NEW_VALUE : std_logic;

    for all : SHREG10_45
	Use entity work.SHREG10_45(DEF_ARCH);
    for all : SHREG10_46
	Use entity work.SHREG10_46(DEF_ARCH);
    for all : regcc10_23
	Use entity work.regcc10_23(DEF_ARCH);
    for all : SHREG10_LD_23
	Use entity work.SHREG10_LD_23(DEF_ARCH);
begin 


    REG_B : SHREG10_45
      port map(reg8_b => reg8_b, CLR => CLR, clk_1000 => clk_1000);
    
    REG_A : SHREG10_46
      port map(reg8_a => reg8_a, CLR => CLR, clk_1000 => clk_1000);
    
    REGCC10 : regcc10_23
      port map(\dat_b_0[9]\ => \dat_b_0[9]\, \new_value[9]\ => 
        new_value_9, dat_b_net_4_0 => dat_b_net_4_0, 
        new_value_net_4 => new_value_net_4, dat_b_net_2_0 => 
        dat_b_net_2_0, new_value_net_2 => new_value_net_2, 
        dat_b_net_5_0 => dat_b_net_5_0, DAT_B_0_scalar_0 => 
        DAT_B_0_scalar_0, NEW_VALUE_scalar_0 => NEW_VALUE, 
        dat_b_net_7_0 => dat_b_net_7_0, CLR => CLR, dat_b_net_3_0
         => dat_b_net_3_0, new_value_net_3 => new_value_net_3, 
        dat_b_net_8_0 => dat_b_net_8_0, new_value_net_8 => 
        new_value_net_8, dat_b_net_6_0 => dat_b_net_6_0, 
        new_value_net_6 => new_value_net_6, new_value_net_5 => 
        new_value_net_5, dat_b_net_1_0 => dat_b_net_1_0, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, enable_net_10 => enable_net_10);
    
    LOAD3 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        LOAD);
    
    LOAD0 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_3);
    
    REGFF : SHREG10_LD_23
      port map(\load[4]\ => load_4, \new_value[9]\ => new_value_9, 
        new_value_net_8 => new_value_net_8, new_value_net_2 => 
        new_value_net_2, new_value_net_4 => new_value_net_4, 
        new_value_net_3 => new_value_net_3, new_value_net_5 => 
        new_value_net_5, dout_net_9 => dout_net_9, 
        new_value_net_1 => new_value_net_1, new_value_net_7 => 
        new_value_net_7, load_net_1 => load_net_1, load_net_3 => 
        load_net_3, LOAD_scalar_0 => LOAD, new_value_net_6 => 
        new_value_net_6, CLR => CLR, clk_1000 => clk_1000, 
        load_net_2 => load_net_2, NEW_VALUE_scalar_0 => NEW_VALUE);
    
    LOAD1 : DFC1B
      port map(D => reg8_a, CLK => clk_1000, CLR => CLR, Q => 
        load_net_2);
    
    LOAD4 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_4);
    
    LOAD2 : DFC1B
      port map(D => reg8_b, CLK => clk_1000, CLR => CLR, Q => 
        load_net_1);
    

end DEF_ARCH; 

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity TOP_CHANNEL is

    port(DATA_OUTPUT : out std_logic_vector(31 downto 0); 
        DATA_INPUT_B : in std_logic_vector(9 downto 0); EN : 
        in std_logic_vector(31 downto 0); DATA_INPUT_A : 
        in std_logic_vector(9 downto 0); CLK50, RESET : in
         std_logic);

end TOP_CHANNEL;

architecture DEF_ARCH of TOP_CHANNEL is 

  component OUTBUF
    port(D : in std_logic := 'U'; PAD : out std_logic);
  end component;

  component INBUF
    port(PAD : in std_logic := 'U'; Y : out std_logic);
  end component;

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component CHANNEL_SHIFT_18
    port(\dout[31]\ : out std_logic; \dat_b[9]\, ENABLE, 
        dat_b_net_1, dat_b_net_6, dat_b_net_8, dat_b_net_3, 
        dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, dat_b_net_2, 
        dat_b_net_4, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_26
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_17 : out
         std_logic; enable_net_18, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component GND
    port(Y : out std_logic);
  end component;

  component CHANNEL_SHIFT_31
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_14 : out
         std_logic; enable_net_15, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_12
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_15 : out
         std_logic; enable_net_16, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_15
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_22 : out
         std_logic; enable_net_23, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_22
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_7 : out
         std_logic; enable_net_8, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component VCC
    port(Y : out std_logic);
  end component;

  component CHANNEL_SHIFT_14
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_20 : out
         std_logic; enable_net_21, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_21
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_26 : out
         std_logic; enable_net_27, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_13
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_29 : out
         std_logic; enable_net_30, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_24
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_4 : out
         std_logic; enable_net_5, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_20
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_18 : out
         std_logic; enable_net_19, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_4
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_5 : out
         std_logic; enable_net_6, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CLKBUF
    port(PAD : in std_logic := 'U'; Y : out std_logic);
  end component;

  component CHANNEL_SHIFT_6
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_10 : out
         std_logic; enable_net_11, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_16
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_12 : out
         std_logic; enable_net_13, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_3
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_23 : out
         std_logic; enable_net_24, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_5
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_28 : out
         std_logic; enable_net_29, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_7
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_13 : out
         std_logic; enable_net_14, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_17
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_8 : out
         std_logic; enable_net_9, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_2
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_11 : out
         std_logic; enable_net_12, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_19
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_16 : out
         std_logic; enable_net_17, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_28
    port(\dat_b[9]\ : in std_logic := 'U'; DOUT : out std_logic; 
        enable_net_1, dat_b_net_1, dat_b_net_6, dat_b_net_8, 
        dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, dat_b_net_5, 
        dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_30
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_30 : out
         std_logic; enable_net_31, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_27
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_27 : out
         std_logic; enable_net_28, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_8
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_2 : out
         std_logic; enable_net_3, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_29
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_19 : out
         std_logic; enable_net_20, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_32
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_3 : out
         std_logic; enable_net_4, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_25
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_1 : out
         std_logic; enable_net_2, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_9
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_25 : out
         std_logic; enable_net_26, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_11
    port(\dat_b[9]\ : in std_logic := 'U'; dout_net_6 : out
         std_logic; enable_net_7, dat_b_net_1, dat_b_net_6, 
        dat_b_net_8, dat_b_net_3, dat_b_net_7, DAT_B_scalar_0, 
        dat_b_net_5, dat_b_net_2, dat_b_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_10
    port(\dat_a_0[9]\ : in std_logic := 'U'; dout_net_24 : out
         std_logic; enable_net_25, dat_a_net_1_0, dat_a_net_6_0, 
        dat_a_net_8_0, dat_a_net_3_0, dat_a_net_7_0, 
        DAT_A_0_scalar_0, dat_a_net_5_0, dat_a_net_2_0, 
        dat_a_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

  component clk1gig_pll_1
    port(clk_50 : in std_logic := 'U'; clk_1000 : out std_logic);
  end component;

  component CHANNEL_SHIFT_1
    port(\dat_a[9]\ : in std_logic := 'U'; dout_net_21 : out
         std_logic; enable_net_22, dat_a_net_1, dat_a_net_6, 
        dat_a_net_8, dat_a_net_3, dat_a_net_7, DAT_A_scalar_0, 
        dat_a_net_5, dat_a_net_2, dat_a_net_4, CLR, clk_1000 : in
         std_logic := 'U');
  end component;

  component CHANNEL_SHIFT_23
    port(\dat_b_0[9]\ : in std_logic := 'U'; dout_net_9 : out
         std_logic; enable_net_10, dat_b_net_1_0, dat_b_net_6_0, 
        dat_b_net_8_0, dat_b_net_3_0, dat_b_net_7_0, 
        DAT_B_0_scalar_0, dat_b_net_5_0, dat_b_net_2_0, 
        dat_b_net_4_0, CLR, clk_1000 : in std_logic := 'U');
  end component;

    signal CLRZ0, clk_1000, dout_net_21, dout_net_11, 
        dat_a_net_8, dat_a_net_7, dat_a_net_6, dat_a_net_5, 
        dat_a_net_4, dat_a_net_3, dat_a_net_2, dat_a_net_1, DAT_A, 
        dat_a_9, dout_net_23, dout_net_5, dout_net_28, 
        dout_net_10, dout_net_13, dout_net_2, dout_net_25, 
        dout_net_24, dout_net_6, dat_b_net_8, dat_b_net_7, 
        dat_b_net_6, dat_b_net_5, dat_b_net_4, dat_b_net_3, 
        dat_b_net_2, dat_b_net_1, DAT_B, dat_b_9, dout_net_15, 
        dout_net_29, dout_net_20, clk_50, dout_net_22, 
        dout_net_12, dout_net_8, dout_31, dout_net_16, 
        enable_net_31, enable_net_30, enable_net_29, 
        enable_net_28, enable_net_27, enable_net_26, 
        enable_net_25, enable_net_24, enable_net_23, 
        enable_net_22, enable_net_21, enable_net_20, 
        enable_net_19, enable_net_18, enable_net_17, 
        enable_net_16, enable_net_15, enable_net_14, 
        enable_net_13, enable_net_12, enable_net_11, 
        enable_net_10, enable_net_9, enable_net_8, enable_net_7, 
        enable_net_6, enable_net_5, enable_net_4, enable_net_3, 
        enable_net_2, enable_net_1, ENABLE, dout_net_18, 
        dout_net_26, dout_net_30, dout_net_27, dout_net_19, 
        dout_net_17, dout_net_14, dout_net_9, dout_net_7, 
        dout_net_4, dout_net_3, dout_net_1, DOUT, VCCZ0, GNDZ0, 
        dat_b_0_9, DAT_B_0, dat_b_net_1_0, dat_b_net_2_0, 
        dat_b_net_3_0, dat_b_net_4_0, dat_b_net_5_0, 
        dat_b_net_6_0, dat_b_net_7_0, dat_b_net_8_0, dat_a_0_9, 
        DAT_A_0, dat_a_net_1_0, dat_a_net_2_0, dat_a_net_3_0, 
        dat_a_net_4_0, dat_a_net_5_0, dat_a_net_6_0, 
        dat_a_net_7_0, dat_a_net_8_0 : std_logic;

    for all : CHANNEL_SHIFT_18
	Use entity work.CHANNEL_SHIFT_18(DEF_ARCH);
    for all : CHANNEL_SHIFT_26
	Use entity work.CHANNEL_SHIFT_26(DEF_ARCH);
    for all : CHANNEL_SHIFT_31
	Use entity work.CHANNEL_SHIFT_31(DEF_ARCH);
    for all : CHANNEL_SHIFT_12
	Use entity work.CHANNEL_SHIFT_12(DEF_ARCH);
    for all : CHANNEL_SHIFT_15
	Use entity work.CHANNEL_SHIFT_15(DEF_ARCH);
    for all : CHANNEL_SHIFT_22
	Use entity work.CHANNEL_SHIFT_22(DEF_ARCH);
    for all : CHANNEL_SHIFT_14
	Use entity work.CHANNEL_SHIFT_14(DEF_ARCH);
    for all : CHANNEL_SHIFT_21
	Use entity work.CHANNEL_SHIFT_21(DEF_ARCH);
    for all : CHANNEL_SHIFT_13
	Use entity work.CHANNEL_SHIFT_13(DEF_ARCH);
    for all : CHANNEL_SHIFT_24
	Use entity work.CHANNEL_SHIFT_24(DEF_ARCH);
    for all : CHANNEL_SHIFT_20
	Use entity work.CHANNEL_SHIFT_20(DEF_ARCH);
    for all : CHANNEL_SHIFT_4
	Use entity work.CHANNEL_SHIFT_4(DEF_ARCH);
    for all : CHANNEL_SHIFT_6
	Use entity work.CHANNEL_SHIFT_6(DEF_ARCH);
    for all : CHANNEL_SHIFT_16
	Use entity work.CHANNEL_SHIFT_16(DEF_ARCH);
    for all : CHANNEL_SHIFT_3
	Use entity work.CHANNEL_SHIFT_3(DEF_ARCH);
    for all : CHANNEL_SHIFT_5
	Use entity work.CHANNEL_SHIFT_5(DEF_ARCH);
    for all : CHANNEL_SHIFT_7
	Use entity work.CHANNEL_SHIFT_7(DEF_ARCH);
    for all : CHANNEL_SHIFT_17
	Use entity work.CHANNEL_SHIFT_17(DEF_ARCH);
    for all : CHANNEL_SHIFT_2
	Use entity work.CHANNEL_SHIFT_2(DEF_ARCH);
    for all : CHANNEL_SHIFT_19
	Use entity work.CHANNEL_SHIFT_19(DEF_ARCH);
    for all : CHANNEL_SHIFT_28
	Use entity work.CHANNEL_SHIFT_28(DEF_ARCH);
    for all : CHANNEL_SHIFT_30
	Use entity work.CHANNEL_SHIFT_30(DEF_ARCH);
    for all : CHANNEL_SHIFT_27
	Use entity work.CHANNEL_SHIFT_27(DEF_ARCH);
    for all : CHANNEL_SHIFT_8
	Use entity work.CHANNEL_SHIFT_8(DEF_ARCH);
    for all : CHANNEL_SHIFT_29
	Use entity work.CHANNEL_SHIFT_29(DEF_ARCH);
    for all : CHANNEL_SHIFT_32
	Use entity work.CHANNEL_SHIFT_32(DEF_ARCH);
    for all : CHANNEL_SHIFT_25
	Use entity work.CHANNEL_SHIFT_25(DEF_ARCH);
    for all : CHANNEL_SHIFT_9
	Use entity work.CHANNEL_SHIFT_9(DEF_ARCH);
    for all : CHANNEL_SHIFT_11
	Use entity work.CHANNEL_SHIFT_11(DEF_ARCH);
    for all : CHANNEL_SHIFT_10
	Use entity work.CHANNEL_SHIFT_10(DEF_ARCH);
    for all : clk1gig_pll_1
	Use entity work.clk1gig_pll_1(DEF_ARCH);
    for all : CHANNEL_SHIFT_1
	Use entity work.CHANNEL_SHIFT_1(DEF_ARCH);
    for all : CHANNEL_SHIFT_23
	Use entity work.CHANNEL_SHIFT_23(DEF_ARCH);
begin 


    OUTBUF32_OUTBUF_20_inst : OUTBUF
      port map(D => dout_net_10, PAD => DATA_OUTPUT(20));
    
    OUTBUF32_OUTBUF_22_inst : OUTBUF
      port map(D => dout_net_8, PAD => DATA_OUTPUT(22));
    
    ENABLE_INBUF_10_inst : INBUF
      port map(PAD => EN(10), Y => enable_net_21);
    
    OUTBUF32_OUTBUF_19_inst : OUTBUF
      port map(D => dout_net_11, PAD => DATA_OUTPUT(19));
    
    NEW_VALUE_A_INBUF_1_inst : INBUF
      port map(PAD => DATA_INPUT_A(1), Y => dat_a_net_7);
    
    ENABLE_INBUF_4_inst : INBUF
      port map(PAD => EN(4), Y => enable_net_27);
    
    NEW_VALUE_A_INBUF_5_inst_0 : BUFF
      port map(A => dat_a_net_3, Y => dat_a_net_3_0);
    
    OUTBUF32_OUTBUF_29_inst : OUTBUF
      port map(D => dout_net_1, PAD => DATA_OUTPUT(29));
    
    NEW_VALUE_A_INBUF_2_inst_0 : BUFF
      port map(A => dat_a_net_6, Y => dat_a_net_6_0);
    
    CHANNEL31 : CHANNEL_SHIFT_18
      port map(\dout[31]\ => dout_31, \dat_b[9]\ => dat_b_9, 
        ENABLE => ENABLE, dat_b_net_1 => dat_b_net_1, dat_b_net_6
         => dat_b_net_6, dat_b_net_8 => dat_b_net_8, dat_b_net_3
         => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_B_INBUF_5_inst_0 : BUFF
      port map(A => dat_b_net_3, Y => dat_b_net_3_0);
    
    NEW_VALUE_A_INBUF_1_inst_0 : BUFF
      port map(A => dat_a_net_7, Y => dat_a_net_7_0);
    
    ENABLE_INBUF_3_inst : INBUF
      port map(PAD => EN(3), Y => enable_net_28);
    
    CHANNEL13 : CHANNEL_SHIFT_26
      port map(\dat_a[9]\ => dat_a_9, dout_net_17 => dout_net_17, 
        enable_net_18 => enable_net_18, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_A_INBUF_8_inst : INBUF
      port map(PAD => DATA_INPUT_A(8), Y => DAT_A);
    
    ENABLE_INBUF_31_inst : INBUF
      port map(PAD => EN(31), Y => ENABLE);
    
    NEW_VALUE_A_INBUF_7_inst : INBUF
      port map(PAD => DATA_INPUT_A(7), Y => dat_a_net_1);
    
    \GND\ : GND
      port map(Y => GNDZ0);
    
    OUTBUF32_OUTBUF_30_inst : OUTBUF
      port map(D => DOUT, PAD => DATA_OUTPUT(30));
    
    ENABLE_INBUF_8_inst : INBUF
      port map(PAD => EN(8), Y => enable_net_23);
    
    OUTBUF32_OUTBUF_3_inst : OUTBUF
      port map(D => dout_net_27, PAD => DATA_OUTPUT(3));
    
    ENABLE_INBUF_17_inst : INBUF
      port map(PAD => EN(17), Y => enable_net_14);
    
    CHANNEL16 : CHANNEL_SHIFT_31
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_14 => 
        dout_net_14, enable_net_15 => enable_net_15, 
        dat_b_net_1_0 => dat_b_net_1_0, dat_b_net_6_0 => 
        dat_b_net_6_0, dat_b_net_8_0 => dat_b_net_8_0, 
        dat_b_net_3_0 => dat_b_net_3_0, dat_b_net_7_0 => 
        dat_b_net_7_0, DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0
         => dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    ENABLE_INBUF_20_inst : INBUF
      port map(PAD => EN(20), Y => enable_net_11);
    
    ENABLE_INBUF_18_inst : INBUF
      port map(PAD => EN(18), Y => enable_net_13);
    
    NEW_VALUE_B_INBUF_1_inst_0 : BUFF
      port map(A => dat_b_net_7, Y => dat_b_net_7_0);
    
    ENABLE_INBUF_11_inst : INBUF
      port map(PAD => EN(11), Y => enable_net_20);
    
    CHANNEL15 : CHANNEL_SHIFT_12
      port map(\dat_a[9]\ => dat_a_9, dout_net_15 => dout_net_15, 
        enable_net_16 => enable_net_16, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_B_INBUF_0_inst : INBUF
      port map(PAD => DATA_INPUT_B(0), Y => dat_b_net_8);
    
    NEW_VALUE_A_INBUF_3_inst : INBUF
      port map(PAD => DATA_INPUT_A(3), Y => dat_a_net_5);
    
    CHANNEL8 : CHANNEL_SHIFT_15
      port map(\dat_a[9]\ => dat_a_9, dout_net_22 => dout_net_22, 
        enable_net_23 => enable_net_23, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    CHANNEL23 : CHANNEL_SHIFT_22
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_7 => 
        dout_net_7, enable_net_8 => enable_net_8, dat_b_net_1_0
         => dat_b_net_1_0, dat_b_net_6_0 => dat_b_net_6_0, 
        dat_b_net_8_0 => dat_b_net_8_0, dat_b_net_3_0 => 
        dat_b_net_3_0, dat_b_net_7_0 => dat_b_net_7_0, 
        DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0 => 
        dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_A_INBUF_8_inst_0 : BUFF
      port map(A => DAT_A, Y => DAT_A_0);
    
    NEW_VALUE_B_INBUF_4_inst_0 : BUFF
      port map(A => dat_b_net_4, Y => dat_b_net_4_0);
    
    \VCC\ : VCC
      port map(Y => VCCZ0);
    
    NEW_VALUE_A_INBUF_6_inst : INBUF
      port map(PAD => DATA_INPUT_A(6), Y => dat_a_net_2);
    
    ENABLE_INBUF_16_inst : INBUF
      port map(PAD => EN(16), Y => enable_net_15);
    
    NEW_VALUE_A_INBUF_6_inst_0 : BUFF
      port map(A => dat_a_net_2, Y => dat_a_net_2_0);
    
    CHANNEL10 : CHANNEL_SHIFT_14
      port map(\dat_a[9]\ => dat_a_9, dout_net_20 => dout_net_20, 
        enable_net_21 => enable_net_21, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_B_INBUF_9_inst : INBUF
      port map(PAD => DATA_INPUT_B(9), Y => dat_b_9);
    
    NEW_VALUE_B_INBUF_6_inst : INBUF
      port map(PAD => DATA_INPUT_B(6), Y => dat_b_net_2);
    
    CHANNEL4 : CHANNEL_SHIFT_21
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_26 => 
        dout_net_26, enable_net_27 => enable_net_27, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    OUTBUF32_OUTBUF_4_inst : OUTBUF
      port map(D => dout_net_26, PAD => DATA_OUTPUT(4));
    
    CHANNEL1 : CHANNEL_SHIFT_13
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_29 => 
        dout_net_29, enable_net_30 => enable_net_30, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_B_INBUF_8_inst : INBUF
      port map(PAD => DATA_INPUT_B(8), Y => DAT_B);
    
    NEW_VALUE_A_INBUF_5_inst : INBUF
      port map(PAD => DATA_INPUT_A(5), Y => dat_a_net_3);
    
    CHANNEL26 : CHANNEL_SHIFT_24
      port map(\dat_b[9]\ => dat_b_9, dout_net_4 => dout_net_4, 
        enable_net_5 => enable_net_5, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    OUTBUF32_OUTBUF_11_inst : OUTBUF
      port map(D => dout_net_19, PAD => DATA_OUTPUT(11));
    
    CHANNEL12 : CHANNEL_SHIFT_20
      port map(\dat_a[9]\ => dat_a_9, dout_net_18 => dout_net_18, 
        enable_net_19 => enable_net_19, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    ENABLE_INBUF_27_inst : INBUF
      port map(PAD => EN(27), Y => enable_net_4);
    
    CHANNEL25 : CHANNEL_SHIFT_4
      port map(\dat_b[9]\ => dat_b_9, dout_net_5 => dout_net_5, 
        enable_net_6 => enable_net_6, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    CLR : CLKBUF
      port map(PAD => RESET, Y => CLRZ0);
    
    OUTBUF32_OUTBUF_21_inst : OUTBUF
      port map(D => dout_net_9, PAD => DATA_OUTPUT(21));
    
    ENABLE_INBUF_28_inst : INBUF
      port map(PAD => EN(28), Y => enable_net_3);
    
    OUTBUF32_OUTBUF_8_inst : OUTBUF
      port map(D => dout_net_22, PAD => DATA_OUTPUT(8));
    
    NEW_VALUE_B_INBUF_7_inst : INBUF
      port map(PAD => DATA_INPUT_B(7), Y => dat_b_net_1);
    
    NEW_VALUE_B_INBUF_2_inst : INBUF
      port map(PAD => DATA_INPUT_B(2), Y => dat_b_net_6);
    
    NEW_VALUE_B_INBUF_1_inst : INBUF
      port map(PAD => DATA_INPUT_B(1), Y => dat_b_net_7);
    
    OUTBUF32_OUTBUF_5_inst : OUTBUF
      port map(D => dout_net_25, PAD => DATA_OUTPUT(5));
    
    ENABLE_INBUF_21_inst : INBUF
      port map(PAD => EN(21), Y => enable_net_10);
    
    NEW_VALUE_B_INBUF_3_inst : INBUF
      port map(PAD => DATA_INPUT_B(3), Y => dat_b_net_5);
    
    NEW_VALUE_A_INBUF_9_inst_0 : BUFF
      port map(A => dat_a_9, Y => dat_a_0_9);
    
    NEW_VALUE_A_INBUF_4_inst_0 : BUFF
      port map(A => dat_a_net_4, Y => dat_a_net_4_0);
    
    ENABLE_INBUF_7_inst : INBUF
      port map(PAD => EN(7), Y => enable_net_24);
    
    OUTBUF32_OUTBUF_15_inst : OUTBUF
      port map(D => dout_net_15, PAD => DATA_OUTPUT(15));
    
    NEW_VALUE_B_INBUF_4_inst : INBUF
      port map(PAD => DATA_INPUT_B(4), Y => dat_b_net_4);
    
    NEW_VALUE_B_INBUF_5_inst : INBUF
      port map(PAD => DATA_INPUT_B(5), Y => dat_b_net_3);
    
    ENABLE_INBUF_12_inst : INBUF
      port map(PAD => EN(12), Y => enable_net_19);
    
    NEW_VALUE_A_INBUF_4_inst : INBUF
      port map(PAD => DATA_INPUT_A(4), Y => dat_a_net_4);
    
    OUTBUF32_OUTBUF_25_inst : OUTBUF
      port map(D => dout_net_5, PAD => DATA_OUTPUT(25));
    
    OUTBUF32_OUTBUF_18_inst : OUTBUF
      port map(D => dout_net_12, PAD => DATA_OUTPUT(18));
    
    OUTBUF32_OUTBUF_16_inst : OUTBUF
      port map(D => dout_net_14, PAD => DATA_OUTPUT(16));
    
    CHANNEL20 : CHANNEL_SHIFT_6
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_10 => 
        dout_net_10, enable_net_11 => enable_net_11, 
        dat_b_net_1_0 => dat_b_net_1_0, dat_b_net_6_0 => 
        dat_b_net_6_0, dat_b_net_8_0 => dat_b_net_8_0, 
        dat_b_net_3_0 => dat_b_net_3_0, dat_b_net_7_0 => 
        dat_b_net_7_0, DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0
         => dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_A_INBUF_2_inst : INBUF
      port map(PAD => DATA_INPUT_A(2), Y => dat_a_net_6);
    
    NEW_VALUE_A_INBUF_3_inst_0 : BUFF
      port map(A => dat_a_net_5, Y => dat_a_net_5_0);
    
    ENABLE_INBUF_26_inst : INBUF
      port map(PAD => EN(26), Y => enable_net_5);
    
    CHANNEL18 : CHANNEL_SHIFT_16
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_12 => 
        dout_net_12, enable_net_13 => enable_net_13, 
        dat_b_net_1_0 => dat_b_net_1_0, dat_b_net_6_0 => 
        dat_b_net_6_0, dat_b_net_8_0 => dat_b_net_8_0, 
        dat_b_net_3_0 => dat_b_net_3_0, dat_b_net_7_0 => 
        dat_b_net_7_0, DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0
         => dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    ENABLE_INBUF_13_inst : INBUF
      port map(PAD => EN(13), Y => enable_net_18);
    
    CHANNEL7 : CHANNEL_SHIFT_3
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_23 => 
        dout_net_23, enable_net_24 => enable_net_24, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    OUTBUF32_OUTBUF_28_inst : OUTBUF
      port map(D => dout_net_2, PAD => DATA_OUTPUT(28));
    
    OUTBUF32_OUTBUF_26_inst : OUTBUF
      port map(D => dout_net_4, PAD => DATA_OUTPUT(26));
    
    CHANNEL2 : CHANNEL_SHIFT_5
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_28 => 
        dout_net_28, enable_net_29 => enable_net_29, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_A_INBUF_9_inst : INBUF
      port map(PAD => DATA_INPUT_A(9), Y => dat_a_9);
    
    CHANNEL17 : CHANNEL_SHIFT_7
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_13 => 
        dout_net_13, enable_net_14 => enable_net_14, 
        dat_b_net_1_0 => dat_b_net_1_0, dat_b_net_6_0 => 
        dat_b_net_6_0, dat_b_net_8_0 => dat_b_net_8_0, 
        dat_b_net_3_0 => dat_b_net_3_0, dat_b_net_7_0 => 
        dat_b_net_7_0, DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0
         => dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    CHANNEL22 : CHANNEL_SHIFT_17
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_8 => 
        dout_net_8, enable_net_9 => enable_net_9, dat_b_net_1_0
         => dat_b_net_1_0, dat_b_net_6_0 => dat_b_net_6_0, 
        dat_b_net_8_0 => dat_b_net_8_0, dat_b_net_3_0 => 
        dat_b_net_3_0, dat_b_net_7_0 => dat_b_net_7_0, 
        DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0 => 
        dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    OUTBUF32_OUTBUF_17_inst : OUTBUF
      port map(D => dout_net_13, PAD => DATA_OUTPUT(17));
    
    CHANNEL19 : CHANNEL_SHIFT_2
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_11 => 
        dout_net_11, enable_net_12 => enable_net_12, 
        dat_b_net_1_0 => dat_b_net_1_0, dat_b_net_6_0 => 
        dat_b_net_6_0, dat_b_net_8_0 => dat_b_net_8_0, 
        dat_b_net_3_0 => dat_b_net_3_0, dat_b_net_7_0 => 
        dat_b_net_7_0, DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0
         => dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_B_INBUF_9_inst_0 : BUFF
      port map(A => dat_b_9, Y => dat_b_0_9);
    
    OUTBUF32_OUTBUF_7_inst : OUTBUF
      port map(D => dout_net_23, PAD => DATA_OUTPUT(7));
    
    ENABLE_INBUF_19_inst : INBUF
      port map(PAD => EN(19), Y => enable_net_12);
    
    CHANNEL14 : CHANNEL_SHIFT_19
      port map(\dat_a[9]\ => dat_a_9, dout_net_16 => dout_net_16, 
        enable_net_17 => enable_net_17, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_B_INBUF_3_inst_0 : BUFF
      port map(A => dat_b_net_5, Y => dat_b_net_5_0);
    
    OUTBUF32_OUTBUF_31_inst : OUTBUF
      port map(D => dout_31, PAD => DATA_OUTPUT(31));
    
    NEW_VALUE_B_INBUF_2_inst_0 : BUFF
      port map(A => dat_b_net_6, Y => dat_b_net_6_0);
    
    OUTBUF32_OUTBUF_27_inst : OUTBUF
      port map(D => dout_net_3, PAD => DATA_OUTPUT(27));
    
    NEW_VALUE_A_INBUF_0_inst : INBUF
      port map(PAD => DATA_INPUT_A(0), Y => dat_a_net_8);
    
    ENABLE_INBUF_5_inst : INBUF
      port map(PAD => EN(5), Y => enable_net_26);
    
    ENABLE_INBUF_2_inst : INBUF
      port map(PAD => EN(2), Y => enable_net_29);
    
    CHANNEL30 : CHANNEL_SHIFT_28
      port map(\dat_b[9]\ => dat_b_9, DOUT => DOUT, enable_net_1
         => enable_net_1, dat_b_net_1 => dat_b_net_1, dat_b_net_6
         => dat_b_net_6, dat_b_net_8 => dat_b_net_8, dat_b_net_3
         => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    ENABLE_INBUF_1_inst : INBUF
      port map(PAD => EN(1), Y => enable_net_30);
    
    ENABLE_INBUF_14_inst : INBUF
      port map(PAD => EN(14), Y => enable_net_17);
    
    CHANNEL0 : CHANNEL_SHIFT_30
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_30 => 
        dout_net_30, enable_net_31 => enable_net_31, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    ENABLE_INBUF_15_inst : INBUF
      port map(PAD => EN(15), Y => enable_net_16);
    
    CHANNEL3 : CHANNEL_SHIFT_27
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_27 => 
        dout_net_27, enable_net_28 => enable_net_28, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    NEW_VALUE_B_INBUF_6_inst_0 : BUFF
      port map(A => dat_b_net_2, Y => dat_b_net_2_0);
    
    ENABLE_INBUF_22_inst : INBUF
      port map(PAD => EN(22), Y => enable_net_9);
    
    NEW_VALUE_B_INBUF_7_inst_0 : BUFF
      port map(A => dat_b_net_1, Y => dat_b_net_1_0);
    
    CHANNEL28 : CHANNEL_SHIFT_8
      port map(\dat_b[9]\ => dat_b_9, dout_net_2 => dout_net_2, 
        enable_net_3 => enable_net_3, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    CHANNEL11 : CHANNEL_SHIFT_29
      port map(\dat_a[9]\ => dat_a_9, dout_net_19 => dout_net_19, 
        enable_net_20 => enable_net_20, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    ENABLE_INBUF_9_inst : INBUF
      port map(PAD => EN(9), Y => enable_net_22);
    
    CHANNEL27 : CHANNEL_SHIFT_32
      port map(\dat_b[9]\ => dat_b_9, dout_net_3 => dout_net_3, 
        enable_net_4 => enable_net_4, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    OUTBUF32_OUTBUF_13_inst : OUTBUF
      port map(D => dout_net_17, PAD => DATA_OUTPUT(13));
    
    ENABLE_INBUF_23_inst : INBUF
      port map(PAD => EN(23), Y => enable_net_8);
    
    CHANNEL29 : CHANNEL_SHIFT_25
      port map(\dat_b[9]\ => dat_b_9, dout_net_1 => dout_net_1, 
        enable_net_2 => enable_net_2, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    CHANNEL5 : CHANNEL_SHIFT_9
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_25 => 
        dout_net_25, enable_net_26 => enable_net_26, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    OUTBUF32_OUTBUF_2_inst : OUTBUF
      port map(D => dout_net_28, PAD => DATA_OUTPUT(2));
    
    OUTBUF32_OUTBUF_1_inst : OUTBUF
      port map(D => dout_net_29, PAD => DATA_OUTPUT(1));
    
    OUTBUF32_OUTBUF_14_inst : OUTBUF
      port map(D => dout_net_16, PAD => DATA_OUTPUT(14));
    
    CHANNEL24 : CHANNEL_SHIFT_11
      port map(\dat_b[9]\ => dat_b_9, dout_net_6 => dout_net_6, 
        enable_net_7 => enable_net_7, dat_b_net_1 => dat_b_net_1, 
        dat_b_net_6 => dat_b_net_6, dat_b_net_8 => dat_b_net_8, 
        dat_b_net_3 => dat_b_net_3, dat_b_net_7 => dat_b_net_7, 
        DAT_B_scalar_0 => DAT_B, dat_b_net_5 => dat_b_net_5, 
        dat_b_net_2 => dat_b_net_2, dat_b_net_4 => dat_b_net_4, 
        CLR => CLRZ0, clk_1000 => clk_1000);
    
    OUTBUF32_OUTBUF_23_inst : OUTBUF
      port map(D => dout_net_7, PAD => DATA_OUTPUT(23));
    
    OUTBUF32_OUTBUF_0_inst : OUTBUF
      port map(D => dout_net_30, PAD => DATA_OUTPUT(0));
    
    NEW_VALUE_B_INBUF_0_inst_0 : BUFF
      port map(A => dat_b_net_8, Y => dat_b_net_8_0);
    
    Z_1I155 : INBUF
      port map(PAD => CLK50, Y => clk_50);
    
    ENABLE_INBUF_30_inst : INBUF
      port map(PAD => EN(30), Y => enable_net_1);
    
    ENABLE_INBUF_6_inst : INBUF
      port map(PAD => EN(6), Y => enable_net_25);
    
    CHANNEL6 : CHANNEL_SHIFT_10
      port map(\dat_a_0[9]\ => dat_a_0_9, dout_net_24 => 
        dout_net_24, enable_net_25 => enable_net_25, 
        dat_a_net_1_0 => dat_a_net_1_0, dat_a_net_6_0 => 
        dat_a_net_6_0, dat_a_net_8_0 => dat_a_net_8_0, 
        dat_a_net_3_0 => dat_a_net_3_0, dat_a_net_7_0 => 
        dat_a_net_7_0, DAT_A_0_scalar_0 => DAT_A_0, dat_a_net_5_0
         => dat_a_net_5_0, dat_a_net_2_0 => dat_a_net_2_0, 
        dat_a_net_4_0 => dat_a_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    
    OUTBUF32_OUTBUF_6_inst : OUTBUF
      port map(D => dout_net_24, PAD => DATA_OUTPUT(6));
    
    NEW_VALUE_B_INBUF_8_inst_0 : BUFF
      port map(A => DAT_B, Y => DAT_B_0);
    
    PLL : clk1gig_pll_1
      port map(clk_50 => clk_50, clk_1000 => clk_1000);
    
    OUTBUF32_OUTBUF_24_inst : OUTBUF
      port map(D => dout_net_6, PAD => DATA_OUTPUT(24));
    
    ENABLE_INBUF_29_inst : INBUF
      port map(PAD => EN(29), Y => enable_net_2);
    
    CHANNEL9 : CHANNEL_SHIFT_1
      port map(\dat_a[9]\ => dat_a_9, dout_net_21 => dout_net_21, 
        enable_net_22 => enable_net_22, dat_a_net_1 => 
        dat_a_net_1, dat_a_net_6 => dat_a_net_6, dat_a_net_8 => 
        dat_a_net_8, dat_a_net_3 => dat_a_net_3, dat_a_net_7 => 
        dat_a_net_7, DAT_A_scalar_0 => DAT_A, dat_a_net_5 => 
        dat_a_net_5, dat_a_net_2 => dat_a_net_2, dat_a_net_4 => 
        dat_a_net_4, CLR => CLRZ0, clk_1000 => clk_1000);
    
    NEW_VALUE_A_INBUF_0_inst_0 : BUFF
      port map(A => dat_a_net_8, Y => dat_a_net_8_0);
    
    ENABLE_INBUF_0_inst : INBUF
      port map(PAD => EN(0), Y => enable_net_31);
    
    NEW_VALUE_A_INBUF_7_inst_0 : BUFF
      port map(A => dat_a_net_1, Y => dat_a_net_1_0);
    
    OUTBUF32_OUTBUF_9_inst : OUTBUF
      port map(D => dout_net_21, PAD => DATA_OUTPUT(9));
    
    ENABLE_INBUF_24_inst : INBUF
      port map(PAD => EN(24), Y => enable_net_7);
    
    OUTBUF32_OUTBUF_10_inst : OUTBUF
      port map(D => dout_net_20, PAD => DATA_OUTPUT(10));
    
    OUTBUF32_OUTBUF_12_inst : OUTBUF
      port map(D => dout_net_18, PAD => DATA_OUTPUT(12));
    
    ENABLE_INBUF_25_inst : INBUF
      port map(PAD => EN(25), Y => enable_net_6);
    
    CHANNEL21 : CHANNEL_SHIFT_23
      port map(\dat_b_0[9]\ => dat_b_0_9, dout_net_9 => 
        dout_net_9, enable_net_10 => enable_net_10, dat_b_net_1_0
         => dat_b_net_1_0, dat_b_net_6_0 => dat_b_net_6_0, 
        dat_b_net_8_0 => dat_b_net_8_0, dat_b_net_3_0 => 
        dat_b_net_3_0, dat_b_net_7_0 => dat_b_net_7_0, 
        DAT_B_0_scalar_0 => DAT_B_0, dat_b_net_5_0 => 
        dat_b_net_5_0, dat_b_net_2_0 => dat_b_net_2_0, 
        dat_b_net_4_0 => dat_b_net_4_0, CLR => CLRZ0, clk_1000
         => clk_1000);
    

end DEF_ARCH; 
