-- File used only for Simulation

library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity TOP_CHANNEL is

    port(DATA_OUTPUT : out std_logic_vector(31 downto 0); 
        DATA_INPUT_B : in std_logic_vector(9 downto 0); EN : 
        in std_logic_vector(31 downto 0); DATA_INPUT_A : 
        in std_logic_vector(9 downto 0); CLK50, RESET : in
         std_logic);

end TOP_CHANNEL;

architecture DEF_ARCH of TOP_CHANNEL is 

  component IOPAD_TRI
    port(D, E : in std_logic := 'U'; PAD : out std_logic);
  end component;

  component IOOE_BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFEG
    port(D, CLK, CLR, PRE, E : in std_logic := 'U'; Q : out
         std_logic);
  end component;

  component DFC1B_CC
    port(D, CLR, CLK : in std_logic := 'U'; Q : out std_logic);
  end component;

  component DFMEG
    port(A, B, CLK, CLR, PRE, E, S : in std_logic := 'U'; Q : out
         std_logic);
  end component;

  component CM8BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component CM8
    port(D0, D1, D2, D3, S00, S01, S10, S11 : in std_logic := 'U'; 
        Y : out std_logic);
  end component;

  component IOFIFO_OUTBUF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOPAD_IN
    port(PAD : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOFIFO_INBUF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOI_BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component HCLKMUX
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component PLL
    port(PWRDWN, REFCLK, LOWFREQ, OSC2, OSC1, OSC0, DIVI5, DIVI4, 
        DIVI3, DIVI2, DIVI1, DIVI0, DIVJ5, DIVJ4, DIVJ3, DIVJ2, 
        DIVJ1, DIVJ0, DELAYLINE4, DELAYLINE3, DELAYLINE2, 
        DELAYLINE1, DELAYLINE0 : in std_logic := 'U'; LOCK, CLK1, 
        CLK2 : out std_logic);
  end component;

  component RCLKMUX
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic); 
  end component;

  component VCC
    port(Y : out std_logic); 
  end component;

    signal clk_1000, dout_net_21, dout_net_11, dat_a_net_8, 
        dat_a_net_7, dat_a_net_6, dat_a_net_5, dat_a_net_4, 
        dat_a_net_3, dat_a_net_2, dat_a_net_1, DAT_A, dat_a_9, 
        dout_net_23, dout_net_5, dout_net_28, dout_net_10, 
        dout_net_13, dout_net_2, dout_net_25, dout_net_24, 
        dout_net_6, dat_b_net_8, dat_b_net_7, dat_b_net_6, 
        dat_b_net_5, dat_b_net_4, dat_b_net_3, dat_b_net_2, 
        dat_b_net_1, DAT_B, dat_b_9, dout_net_15, dout_net_29, 
        dout_net_20, dout_net_22, dout_net_12, dout_net_8, 
        dout_31, dout_net_16, dout_net_18, dout_net_26, 
        dout_net_30, dout_net_27, dout_net_19, dout_net_17, 
        dout_net_14, dout_net_9, dout_net_7, dout_net_4, 
        dout_net_3, dout_net_1, DOUT, dat_b_0_9, DAT_B_0, 
        dat_b_net_1_0, dat_b_net_2_0, dat_b_net_3_0, 
        dat_b_net_4_0, dat_b_net_5_0, dat_b_net_6_0, 
        dat_b_net_7_0, dat_b_net_8_0, dat_a_0_9, DAT_A_0, 
        dat_a_net_1_0, dat_a_net_2_0, dat_a_net_3_0, 
        dat_a_net_4_0, dat_a_net_5_0, dat_a_net_6_0, 
        dat_a_net_7_0, dat_a_net_8_0, 
        \OUTBUF32_OUTBUF_20_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_20_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_20_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_22_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_22_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_22_inst/U0/NET3\, 
        \ENABLE_INBUF_10_inst/U0/NET1\, 
        \ENABLE_INBUF_10_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_19_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_19_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_19_inst/U0/NET3\, 
        \NEW_VALUE_A_INBUF_1_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_1_inst/U0/NET2\, 
        \ENABLE_INBUF_4_inst/U0/NET1\, 
        \ENABLE_INBUF_4_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_29_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_29_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_29_inst/U0/NET3\, \CHANNEL31/reg8_b\, 
        \CHANNEL31/reg8_a\, \CHANNEL31/load_4\, 
        \CHANNEL31/load_net_1\, \CHANNEL31/load_net_3\, 
        \CHANNEL31/LOAD\, \CHANNEL31/load_net_2\, 
        \CHANNEL31/REG_B/reg1\, \CHANNEL31/REG_B/reg0\, 
        \CHANNEL31/REG_B/reg2\, \CHANNEL31/REG_B/reg3\, 
        \CHANNEL31/REG_B/reg7\, \CHANNEL31/REG_B/reg9\, 
        \CHANNEL31/REG_B/reg4\, \CHANNEL31/REG_B/reg5\, 
        \CHANNEL31/REG_B/reg6\, \CHANNEL31/REG_A/reg1\, 
        \CHANNEL31/REG_A/reg0\, \CHANNEL31/REG_A/reg2\, 
        \CHANNEL31/REG_A/reg3\, \CHANNEL31/REG_A/reg7\, 
        \CHANNEL31/REG_A/reg9\, \CHANNEL31/REG_A/reg4\, 
        \CHANNEL31/REG_A/reg5\, \CHANNEL31/REG_A/reg6\, 
        \CHANNEL31/REGFF/reg7\, \CHANNEL31/REGFF/DATA\, 
        \CHANNEL31/REGFF/data_net_7\, 
        \CHANNEL31/REGFF/data_net_1\, \CHANNEL31/REGFF/reg8\, 
        \CHANNEL31/REGFF/data_9\, \CHANNEL31/REGFF/data_net_5\, 
        \CHANNEL31/REGFF/reg0\, \CHANNEL31/REGFF/data_net_3\, 
        \CHANNEL31/REGFF/data_net_8\, \CHANNEL31/REGFF/reg1\, 
        \CHANNEL31/REGFF/data_net_6\, \CHANNEL31/REGFF/reg2\, 
        \CHANNEL31/REGFF/reg3\, \CHANNEL31/REGFF/data_net_4\, 
        \CHANNEL31/REGFF/reg4\, \CHANNEL31/REGFF/reg5\, 
        \CHANNEL31/REGFF/data_net_2\, \CHANNEL31/REGFF/reg6\, 
        \CHANNEL31/REGFF/GNDZ0\, \ENABLE_INBUF_3_inst/U0/NET1\, 
        \ENABLE_INBUF_3_inst/U0/NET2\, \CHANNEL13/reg8_b\, 
        \CHANNEL13/reg8_a\, \CHANNEL13/load_4\, 
        \CHANNEL13/load_net_1\, \CHANNEL13/load_net_3\, 
        \CHANNEL13/LOAD\, \CHANNEL13/load_net_2\, 
        \CHANNEL13/REG_B/reg1\, \CHANNEL13/REG_B/reg0\, 
        \CHANNEL13/REG_B/reg2\, \CHANNEL13/REG_B/reg3\, 
        \CHANNEL13/REG_B/reg7\, \CHANNEL13/REG_B/reg9\, 
        \CHANNEL13/REG_B/reg4\, \CHANNEL13/REG_B/reg5\, 
        \CHANNEL13/REG_B/reg6\, \CHANNEL13/REG_A/reg1\, 
        \CHANNEL13/REG_A/reg0\, \CHANNEL13/REG_A/reg2\, 
        \CHANNEL13/REG_A/reg3\, \CHANNEL13/REG_A/reg7\, 
        \CHANNEL13/REG_A/reg9\, \CHANNEL13/REG_A/reg4\, 
        \CHANNEL13/REG_A/reg5\, \CHANNEL13/REG_A/reg6\, 
        \CHANNEL13/REGFF/reg7\, \CHANNEL13/REGFF/DATA\, 
        \CHANNEL13/REGFF/data_net_7\, 
        \CHANNEL13/REGFF/data_net_1\, \CHANNEL13/REGFF/reg8\, 
        \CHANNEL13/REGFF/data_9\, \CHANNEL13/REGFF/data_net_5\, 
        \CHANNEL13/REGFF/reg0\, \CHANNEL13/REGFF/data_net_3\, 
        \CHANNEL13/REGFF/data_net_8\, \CHANNEL13/REGFF/reg1\, 
        \CHANNEL13/REGFF/data_net_6\, \CHANNEL13/REGFF/reg2\, 
        \CHANNEL13/REGFF/reg3\, \CHANNEL13/REGFF/data_net_4\, 
        \CHANNEL13/REGFF/reg4\, \CHANNEL13/REGFF/reg5\, 
        \CHANNEL13/REGFF/data_net_2\, \CHANNEL13/REGFF/reg6\, 
        \CHANNEL13/REGFF/GNDZ0\, 
        \NEW_VALUE_A_INBUF_8_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_8_inst/U0/NET2\, 
        \ENABLE_INBUF_31_inst/U0/NET1\, 
        \ENABLE_INBUF_31_inst/U0/NET2\, 
        \NEW_VALUE_A_INBUF_7_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_7_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_30_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_30_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_30_inst/U0/NET3\, 
        \ENABLE_INBUF_8_inst/U0/NET1\, 
        \ENABLE_INBUF_8_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_3_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_3_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_3_inst/U0/NET3\, 
        \ENABLE_INBUF_17_inst/U0/NET1\, 
        \ENABLE_INBUF_17_inst/U0/NET2\, \CHANNEL16/reg8_b\, 
        \CHANNEL16/reg8_a\, \CHANNEL16/load_4\, 
        \CHANNEL16/load_net_1\, \CHANNEL16/load_net_3\, 
        \CHANNEL16/LOAD\, \CHANNEL16/load_net_2\, 
        \CHANNEL16/REG_B/reg1\, \CHANNEL16/REG_B/reg0\, 
        \CHANNEL16/REG_B/reg2\, \CHANNEL16/REG_B/reg3\, 
        \CHANNEL16/REG_B/reg7\, \CHANNEL16/REG_B/reg9\, 
        \CHANNEL16/REG_B/reg4\, \CHANNEL16/REG_B/reg5\, 
        \CHANNEL16/REG_B/reg6\, \CHANNEL16/REG_A/reg1\, 
        \CHANNEL16/REG_A/reg0\, \CHANNEL16/REG_A/reg2\, 
        \CHANNEL16/REG_A/reg3\, \CHANNEL16/REG_A/reg7\, 
        \CHANNEL16/REG_A/reg9\, \CHANNEL16/REG_A/reg4\, 
        \CHANNEL16/REG_A/reg5\, \CHANNEL16/REG_A/reg6\, 
        \CHANNEL16/REGFF/reg7\, \CHANNEL16/REGFF/DATA\, 
        \CHANNEL16/REGFF/data_net_7\, 
        \CHANNEL16/REGFF/data_net_1\, \CHANNEL16/REGFF/reg8\, 
        \CHANNEL16/REGFF/data_9\, \CHANNEL16/REGFF/data_net_5\, 
        \CHANNEL16/REGFF/reg0\, \CHANNEL16/REGFF/data_net_3\, 
        \CHANNEL16/REGFF/data_net_8\, \CHANNEL16/REGFF/reg1\, 
        \CHANNEL16/REGFF/data_net_6\, \CHANNEL16/REGFF/reg2\, 
        \CHANNEL16/REGFF/reg3\, \CHANNEL16/REGFF/data_net_4\, 
        \CHANNEL16/REGFF/reg4\, \CHANNEL16/REGFF/reg5\, 
        \CHANNEL16/REGFF/data_net_2\, \CHANNEL16/REGFF/reg6\, 
        \CHANNEL16/REGFF/GNDZ0\, \ENABLE_INBUF_20_inst/U0/NET1\, 
        \ENABLE_INBUF_20_inst/U0/NET2\, 
        \ENABLE_INBUF_18_inst/U0/NET1\, 
        \ENABLE_INBUF_18_inst/U0/NET2\, 
        \ENABLE_INBUF_11_inst/U0/NET1\, 
        \ENABLE_INBUF_11_inst/U0/NET2\, \CHANNEL15/reg8_b\, 
        \CHANNEL15/reg8_a\, \CHANNEL15/load_4\, 
        \CHANNEL15/load_net_1\, \CHANNEL15/load_net_3\, 
        \CHANNEL15/LOAD\, \CHANNEL15/load_net_2\, 
        \CHANNEL15/REG_B/reg1\, \CHANNEL15/REG_B/reg0\, 
        \CHANNEL15/REG_B/reg2\, \CHANNEL15/REG_B/reg3\, 
        \CHANNEL15/REG_B/reg7\, \CHANNEL15/REG_B/reg9\, 
        \CHANNEL15/REG_B/reg4\, \CHANNEL15/REG_B/reg5\, 
        \CHANNEL15/REG_B/reg6\, \CHANNEL15/REG_A/reg1\, 
        \CHANNEL15/REG_A/reg0\, \CHANNEL15/REG_A/reg2\, 
        \CHANNEL15/REG_A/reg3\, \CHANNEL15/REG_A/reg7\, 
        \CHANNEL15/REG_A/reg9\, \CHANNEL15/REG_A/reg4\, 
        \CHANNEL15/REG_A/reg5\, \CHANNEL15/REG_A/reg6\, 
        \CHANNEL15/REGFF/reg7\, \CHANNEL15/REGFF/DATA\, 
        \CHANNEL15/REGFF/data_net_7\, 
        \CHANNEL15/REGFF/data_net_1\, \CHANNEL15/REGFF/reg8\, 
        \CHANNEL15/REGFF/data_9\, \CHANNEL15/REGFF/data_net_5\, 
        \CHANNEL15/REGFF/reg0\, \CHANNEL15/REGFF/data_net_3\, 
        \CHANNEL15/REGFF/data_net_8\, \CHANNEL15/REGFF/reg1\, 
        \CHANNEL15/REGFF/data_net_6\, \CHANNEL15/REGFF/reg2\, 
        \CHANNEL15/REGFF/reg3\, \CHANNEL15/REGFF/data_net_4\, 
        \CHANNEL15/REGFF/reg4\, \CHANNEL15/REGFF/reg5\, 
        \CHANNEL15/REGFF/data_net_2\, \CHANNEL15/REGFF/reg6\, 
        \CHANNEL15/REGFF/GNDZ0\, 
        \NEW_VALUE_B_INBUF_0_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_0_inst/U0/NET2\, 
        \NEW_VALUE_A_INBUF_3_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_3_inst/U0/NET2\, \CHANNEL8/reg8_b\, 
        \CHANNEL8/reg8_a\, \CHANNEL8/load_4\, 
        \CHANNEL8/load_net_1\, \CHANNEL8/load_net_3\, 
        \CHANNEL8/LOAD\, \CHANNEL8/load_net_2\, 
        \CHANNEL8/REG_B/reg1\, \CHANNEL8/REG_B/reg0\, 
        \CHANNEL8/REG_B/reg2\, \CHANNEL8/REG_B/reg3\, 
        \CHANNEL8/REG_B/reg7\, \CHANNEL8/REG_B/reg9\, 
        \CHANNEL8/REG_B/reg4\, \CHANNEL8/REG_B/reg5\, 
        \CHANNEL8/REG_B/reg6\, \CHANNEL8/REG_A/reg1\, 
        \CHANNEL8/REG_A/reg0\, \CHANNEL8/REG_A/reg2\, 
        \CHANNEL8/REG_A/reg3\, \CHANNEL8/REG_A/reg7\, 
        \CHANNEL8/REG_A/reg9\, \CHANNEL8/REG_A/reg4\, 
        \CHANNEL8/REG_A/reg5\, \CHANNEL8/REG_A/reg6\, 
        \CHANNEL8/REGFF/reg7\, \CHANNEL8/REGFF/DATA\, 
        \CHANNEL8/REGFF/data_net_7\, \CHANNEL8/REGFF/data_net_1\, 
        \CHANNEL8/REGFF/reg8\, \CHANNEL8/REGFF/data_9\, 
        \CHANNEL8/REGFF/data_net_5\, \CHANNEL8/REGFF/reg0\, 
        \CHANNEL8/REGFF/data_net_3\, \CHANNEL8/REGFF/data_net_8\, 
        \CHANNEL8/REGFF/reg1\, \CHANNEL8/REGFF/data_net_6\, 
        \CHANNEL8/REGFF/reg2\, \CHANNEL8/REGFF/reg3\, 
        \CHANNEL8/REGFF/data_net_4\, \CHANNEL8/REGFF/reg4\, 
        \CHANNEL8/REGFF/reg5\, \CHANNEL8/REGFF/data_net_2\, 
        \CHANNEL8/REGFF/reg6\, \CHANNEL8/REGFF/GNDZ0\, 
        \CHANNEL23/reg8_b\, \CHANNEL23/reg8_a\, 
        \CHANNEL23/load_4\, \CHANNEL23/load_net_1\, 
        \CHANNEL23/load_net_3\, \CHANNEL23/LOAD\, 
        \CHANNEL23/load_net_2\, \CHANNEL23/REG_B/reg1\, 
        \CHANNEL23/REG_B/reg0\, \CHANNEL23/REG_B/reg2\, 
        \CHANNEL23/REG_B/reg3\, \CHANNEL23/REG_B/reg7\, 
        \CHANNEL23/REG_B/reg9\, \CHANNEL23/REG_B/reg4\, 
        \CHANNEL23/REG_B/reg5\, \CHANNEL23/REG_B/reg6\, 
        \CHANNEL23/REG_A/reg1\, \CHANNEL23/REG_A/reg0\, 
        \CHANNEL23/REG_A/reg2\, \CHANNEL23/REG_A/reg3\, 
        \CHANNEL23/REG_A/reg7\, \CHANNEL23/REG_A/reg9\, 
        \CHANNEL23/REG_A/reg4\, \CHANNEL23/REG_A/reg5\, 
        \CHANNEL23/REG_A/reg6\, \CHANNEL23/REGFF/reg7\, 
        \CHANNEL23/REGFF/DATA\, \CHANNEL23/REGFF/data_net_7\, 
        \CHANNEL23/REGFF/data_net_1\, \CHANNEL23/REGFF/reg8\, 
        \CHANNEL23/REGFF/data_9\, \CHANNEL23/REGFF/data_net_5\, 
        \CHANNEL23/REGFF/reg0\, \CHANNEL23/REGFF/data_net_3\, 
        \CHANNEL23/REGFF/data_net_8\, \CHANNEL23/REGFF/reg1\, 
        \CHANNEL23/REGFF/data_net_6\, \CHANNEL23/REGFF/reg2\, 
        \CHANNEL23/REGFF/reg3\, \CHANNEL23/REGFF/data_net_4\, 
        \CHANNEL23/REGFF/reg4\, \CHANNEL23/REGFF/reg5\, 
        \CHANNEL23/REGFF/data_net_2\, \CHANNEL23/REGFF/reg6\, 
        \CHANNEL23/REGFF/GNDZ0\, 
        \NEW_VALUE_A_INBUF_6_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_6_inst/U0/NET2\, 
        \ENABLE_INBUF_16_inst/U0/NET1\, 
        \ENABLE_INBUF_16_inst/U0/NET2\, \CHANNEL10/reg8_b\, 
        \CHANNEL10/reg8_a\, \CHANNEL10/load_4\, 
        \CHANNEL10/load_net_1\, \CHANNEL10/load_net_3\, 
        \CHANNEL10/LOAD\, \CHANNEL10/load_net_2\, 
        \CHANNEL10/REG_B/reg1\, \CHANNEL10/REG_B/reg0\, 
        \CHANNEL10/REG_B/reg2\, \CHANNEL10/REG_B/reg3\, 
        \CHANNEL10/REG_B/reg7\, \CHANNEL10/REG_B/reg9\, 
        \CHANNEL10/REG_B/reg4\, \CHANNEL10/REG_B/reg5\, 
        \CHANNEL10/REG_B/reg6\, \CHANNEL10/REG_A/reg1\, 
        \CHANNEL10/REG_A/reg0\, \CHANNEL10/REG_A/reg2\, 
        \CHANNEL10/REG_A/reg3\, \CHANNEL10/REG_A/reg7\, 
        \CHANNEL10/REG_A/reg9\, \CHANNEL10/REG_A/reg4\, 
        \CHANNEL10/REG_A/reg5\, \CHANNEL10/REG_A/reg6\, 
        \CHANNEL10/REGFF/reg7\, \CHANNEL10/REGFF/DATA\, 
        \CHANNEL10/REGFF/data_net_7\, 
        \CHANNEL10/REGFF/data_net_1\, \CHANNEL10/REGFF/reg8\, 
        \CHANNEL10/REGFF/data_9\, \CHANNEL10/REGFF/data_net_5\, 
        \CHANNEL10/REGFF/reg0\, \CHANNEL10/REGFF/data_net_3\, 
        \CHANNEL10/REGFF/data_net_8\, \CHANNEL10/REGFF/reg1\, 
        \CHANNEL10/REGFF/data_net_6\, \CHANNEL10/REGFF/reg2\, 
        \CHANNEL10/REGFF/reg3\, \CHANNEL10/REGFF/data_net_4\, 
        \CHANNEL10/REGFF/reg4\, \CHANNEL10/REGFF/reg5\, 
        \CHANNEL10/REGFF/data_net_2\, \CHANNEL10/REGFF/reg6\, 
        \CHANNEL10/REGFF/GNDZ0\, 
        \NEW_VALUE_B_INBUF_9_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_9_inst/U0/NET2\, 
        \NEW_VALUE_B_INBUF_6_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_6_inst/U0/NET2\, \CHANNEL4/reg8_b\, 
        \CHANNEL4/reg8_a\, \CHANNEL4/load_4\, 
        \CHANNEL4/load_net_1\, \CHANNEL4/load_net_3\, 
        \CHANNEL4/LOAD\, \CHANNEL4/load_net_2\, 
        \CHANNEL4/REG_B/reg1\, \CHANNEL4/REG_B/reg0\, 
        \CHANNEL4/REG_B/reg2\, \CHANNEL4/REG_B/reg3\, 
        \CHANNEL4/REG_B/reg7\, \CHANNEL4/REG_B/reg9\, 
        \CHANNEL4/REG_B/reg4\, \CHANNEL4/REG_B/reg5\, 
        \CHANNEL4/REG_B/reg6\, \CHANNEL4/REG_A/reg1\, 
        \CHANNEL4/REG_A/reg0\, \CHANNEL4/REG_A/reg2\, 
        \CHANNEL4/REG_A/reg3\, \CHANNEL4/REG_A/reg7\, 
        \CHANNEL4/REG_A/reg9\, \CHANNEL4/REG_A/reg4\, 
        \CHANNEL4/REG_A/reg5\, \CHANNEL4/REG_A/reg6\, 
        \CHANNEL4/REGFF/reg7\, \CHANNEL4/REGFF/DATA\, 
        \CHANNEL4/REGFF/data_net_7\, \CHANNEL4/REGFF/data_net_1\, 
        \CHANNEL4/REGFF/reg8\, \CHANNEL4/REGFF/data_9\, 
        \CHANNEL4/REGFF/data_net_5\, \CHANNEL4/REGFF/reg0\, 
        \CHANNEL4/REGFF/data_net_3\, \CHANNEL4/REGFF/data_net_8\, 
        \CHANNEL4/REGFF/reg1\, \CHANNEL4/REGFF/data_net_6\, 
        \CHANNEL4/REGFF/reg2\, \CHANNEL4/REGFF/reg3\, 
        \CHANNEL4/REGFF/data_net_4\, \CHANNEL4/REGFF/reg4\, 
        \CHANNEL4/REGFF/reg5\, \CHANNEL4/REGFF/data_net_2\, 
        \CHANNEL4/REGFF/reg6\, \CHANNEL4/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_4_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_4_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_4_inst/U0/NET3\, \CHANNEL1/reg8_b\, 
        \CHANNEL1/reg8_a\, \CHANNEL1/load_4\, 
        \CHANNEL1/load_net_1\, \CHANNEL1/load_net_3\, 
        \CHANNEL1/LOAD\, \CHANNEL1/load_net_2\, 
        \CHANNEL1/REG_B/reg1\, \CHANNEL1/REG_B/reg0\, 
        \CHANNEL1/REG_B/reg2\, \CHANNEL1/REG_B/reg3\, 
        \CHANNEL1/REG_B/reg7\, \CHANNEL1/REG_B/reg9\, 
        \CHANNEL1/REG_B/reg4\, \CHANNEL1/REG_B/reg5\, 
        \CHANNEL1/REG_B/reg6\, \CHANNEL1/REG_A/reg1\, 
        \CHANNEL1/REG_A/reg0\, \CHANNEL1/REG_A/reg2\, 
        \CHANNEL1/REG_A/reg3\, \CHANNEL1/REG_A/reg7\, 
        \CHANNEL1/REG_A/reg9\, \CHANNEL1/REG_A/reg4\, 
        \CHANNEL1/REG_A/reg5\, \CHANNEL1/REG_A/reg6\, 
        \CHANNEL1/REGFF/reg7\, \CHANNEL1/REGFF/DATA\, 
        \CHANNEL1/REGFF/data_net_7\, \CHANNEL1/REGFF/data_net_1\, 
        \CHANNEL1/REGFF/reg8\, \CHANNEL1/REGFF/data_9\, 
        \CHANNEL1/REGFF/data_net_5\, \CHANNEL1/REGFF/reg0\, 
        \CHANNEL1/REGFF/data_net_3\, \CHANNEL1/REGFF/data_net_8\, 
        \CHANNEL1/REGFF/reg1\, \CHANNEL1/REGFF/data_net_6\, 
        \CHANNEL1/REGFF/reg2\, \CHANNEL1/REGFF/reg3\, 
        \CHANNEL1/REGFF/data_net_4\, \CHANNEL1/REGFF/reg4\, 
        \CHANNEL1/REGFF/reg5\, \CHANNEL1/REGFF/data_net_2\, 
        \CHANNEL1/REGFF/reg6\, \CHANNEL1/REGFF/GNDZ0\, 
        \NEW_VALUE_B_INBUF_8_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_8_inst/U0/NET2\, 
        \NEW_VALUE_A_INBUF_5_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_5_inst/U0/NET2\, \CHANNEL26/reg8_b\, 
        \CHANNEL26/reg8_a\, \CHANNEL26/load_4\, 
        \CHANNEL26/load_net_1\, \CHANNEL26/load_net_3\, 
        \CHANNEL26/LOAD\, \CHANNEL26/load_net_2\, 
        \CHANNEL26/REG_B/reg1\, \CHANNEL26/REG_B/reg0\, 
        \CHANNEL26/REG_B/reg2\, \CHANNEL26/REG_B/reg3\, 
        \CHANNEL26/REG_B/reg7\, \CHANNEL26/REG_B/reg9\, 
        \CHANNEL26/REG_B/reg4\, \CHANNEL26/REG_B/reg5\, 
        \CHANNEL26/REG_B/reg6\, \CHANNEL26/REG_A/reg1\, 
        \CHANNEL26/REG_A/reg0\, \CHANNEL26/REG_A/reg2\, 
        \CHANNEL26/REG_A/reg3\, \CHANNEL26/REG_A/reg7\, 
        \CHANNEL26/REG_A/reg9\, \CHANNEL26/REG_A/reg4\, 
        \CHANNEL26/REG_A/reg5\, \CHANNEL26/REG_A/reg6\, 
        \CHANNEL26/REGFF/reg7\, \CHANNEL26/REGFF/DATA\, 
        \CHANNEL26/REGFF/data_net_7\, 
        \CHANNEL26/REGFF/data_net_1\, \CHANNEL26/REGFF/reg8\, 
        \CHANNEL26/REGFF/data_9\, \CHANNEL26/REGFF/data_net_5\, 
        \CHANNEL26/REGFF/reg0\, \CHANNEL26/REGFF/data_net_3\, 
        \CHANNEL26/REGFF/data_net_8\, \CHANNEL26/REGFF/reg1\, 
        \CHANNEL26/REGFF/data_net_6\, \CHANNEL26/REGFF/reg2\, 
        \CHANNEL26/REGFF/reg3\, \CHANNEL26/REGFF/data_net_4\, 
        \CHANNEL26/REGFF/reg4\, \CHANNEL26/REGFF/reg5\, 
        \CHANNEL26/REGFF/data_net_2\, \CHANNEL26/REGFF/reg6\, 
        \CHANNEL26/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_11_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_11_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_11_inst/U0/NET3\, \CHANNEL12/reg8_b\, 
        \CHANNEL12/reg8_a\, \CHANNEL12/load_4\, 
        \CHANNEL12/load_net_1\, \CHANNEL12/load_net_3\, 
        \CHANNEL12/LOAD\, \CHANNEL12/load_net_2\, 
        \CHANNEL12/REG_B/reg1\, \CHANNEL12/REG_B/reg0\, 
        \CHANNEL12/REG_B/reg2\, \CHANNEL12/REG_B/reg3\, 
        \CHANNEL12/REG_B/reg7\, \CHANNEL12/REG_B/reg9\, 
        \CHANNEL12/REG_B/reg4\, \CHANNEL12/REG_B/reg5\, 
        \CHANNEL12/REG_B/reg6\, \CHANNEL12/REG_A/reg1\, 
        \CHANNEL12/REG_A/reg0\, \CHANNEL12/REG_A/reg2\, 
        \CHANNEL12/REG_A/reg3\, \CHANNEL12/REG_A/reg7\, 
        \CHANNEL12/REG_A/reg9\, \CHANNEL12/REG_A/reg4\, 
        \CHANNEL12/REG_A/reg5\, \CHANNEL12/REG_A/reg6\, 
        \CHANNEL12/REGFF/reg7\, \CHANNEL12/REGFF/DATA\, 
        \CHANNEL12/REGFF/data_net_7\, 
        \CHANNEL12/REGFF/data_net_1\, \CHANNEL12/REGFF/reg8\, 
        \CHANNEL12/REGFF/data_9\, \CHANNEL12/REGFF/data_net_5\, 
        \CHANNEL12/REGFF/reg0\, \CHANNEL12/REGFF/data_net_3\, 
        \CHANNEL12/REGFF/data_net_8\, \CHANNEL12/REGFF/reg1\, 
        \CHANNEL12/REGFF/data_net_6\, \CHANNEL12/REGFF/reg2\, 
        \CHANNEL12/REGFF/reg3\, \CHANNEL12/REGFF/data_net_4\, 
        \CHANNEL12/REGFF/reg4\, \CHANNEL12/REGFF/reg5\, 
        \CHANNEL12/REGFF/data_net_2\, \CHANNEL12/REGFF/reg6\, 
        \CHANNEL12/REGFF/GNDZ0\, \ENABLE_INBUF_27_inst/U0/NET1\, 
        \ENABLE_INBUF_27_inst/U0/NET2\, \CHANNEL25/reg8_b\, 
        \CHANNEL25/reg8_a\, \CHANNEL25/load_4\, 
        \CHANNEL25/load_net_1\, \CHANNEL25/load_net_3\, 
        \CHANNEL25/LOAD\, \CHANNEL25/load_net_2\, 
        \CHANNEL25/REG_B/reg1\, \CHANNEL25/REG_B/reg0\, 
        \CHANNEL25/REG_B/reg2\, \CHANNEL25/REG_B/reg3\, 
        \CHANNEL25/REG_B/reg7\, \CHANNEL25/REG_B/reg9\, 
        \CHANNEL25/REG_B/reg4\, \CHANNEL25/REG_B/reg5\, 
        \CHANNEL25/REG_B/reg6\, \CHANNEL25/REG_A/reg1\, 
        \CHANNEL25/REG_A/reg0\, \CHANNEL25/REG_A/reg2\, 
        \CHANNEL25/REG_A/reg3\, \CHANNEL25/REG_A/reg7\, 
        \CHANNEL25/REG_A/reg9\, \CHANNEL25/REG_A/reg4\, 
        \CHANNEL25/REG_A/reg5\, \CHANNEL25/REG_A/reg6\, 
        \CHANNEL25/REGFF/reg7\, \CHANNEL25/REGFF/DATA\, 
        \CHANNEL25/REGFF/data_net_7\, 
        \CHANNEL25/REGFF/data_net_1\, \CHANNEL25/REGFF/reg8\, 
        \CHANNEL25/REGFF/data_9\, \CHANNEL25/REGFF/data_net_5\, 
        \CHANNEL25/REGFF/reg0\, \CHANNEL25/REGFF/data_net_3\, 
        \CHANNEL25/REGFF/data_net_8\, \CHANNEL25/REGFF/reg1\, 
        \CHANNEL25/REGFF/data_net_6\, \CHANNEL25/REGFF/reg2\, 
        \CHANNEL25/REGFF/reg3\, \CHANNEL25/REGFF/data_net_4\, 
        \CHANNEL25/REGFF/reg4\, \CHANNEL25/REGFF/reg5\, 
        \CHANNEL25/REGFF/data_net_2\, \CHANNEL25/REGFF/reg6\, 
        \CHANNEL25/REGFF/GNDZ0\, \CLR/U0/NET1\, 
        \OUTBUF32_OUTBUF_21_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_21_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_21_inst/U0/NET3\, 
        \ENABLE_INBUF_28_inst/U0/NET1\, 
        \ENABLE_INBUF_28_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_8_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_8_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_8_inst/U0/NET3\, 
        \NEW_VALUE_B_INBUF_7_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_7_inst/U0/NET2\, 
        \NEW_VALUE_B_INBUF_2_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_2_inst/U0/NET2\, 
        \NEW_VALUE_B_INBUF_1_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_1_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_5_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_5_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_5_inst/U0/NET3\, 
        \ENABLE_INBUF_21_inst/U0/NET1\, 
        \ENABLE_INBUF_21_inst/U0/NET2\, 
        \NEW_VALUE_B_INBUF_3_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_3_inst/U0/NET2\, 
        \ENABLE_INBUF_7_inst/U0/NET1\, 
        \ENABLE_INBUF_7_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_15_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_15_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_15_inst/U0/NET3\, 
        \NEW_VALUE_B_INBUF_4_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_4_inst/U0/NET2\, 
        \NEW_VALUE_B_INBUF_5_inst/U0/NET1\, 
        \NEW_VALUE_B_INBUF_5_inst/U0/NET2\, 
        \ENABLE_INBUF_12_inst/U0/NET1\, 
        \ENABLE_INBUF_12_inst/U0/NET2\, 
        \NEW_VALUE_A_INBUF_4_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_4_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_25_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_25_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_25_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_18_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_18_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_18_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_16_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_16_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_16_inst/U0/NET3\, \CHANNEL20/reg8_b\, 
        \CHANNEL20/reg8_a\, \CHANNEL20/load_4\, 
        \CHANNEL20/load_net_1\, \CHANNEL20/load_net_3\, 
        \CHANNEL20/LOAD\, \CHANNEL20/load_net_2\, 
        \CHANNEL20/REG_B/reg1\, \CHANNEL20/REG_B/reg0\, 
        \CHANNEL20/REG_B/reg2\, \CHANNEL20/REG_B/reg3\, 
        \CHANNEL20/REG_B/reg7\, \CHANNEL20/REG_B/reg9\, 
        \CHANNEL20/REG_B/reg4\, \CHANNEL20/REG_B/reg5\, 
        \CHANNEL20/REG_B/reg6\, \CHANNEL20/REG_A/reg1\, 
        \CHANNEL20/REG_A/reg0\, \CHANNEL20/REG_A/reg2\, 
        \CHANNEL20/REG_A/reg3\, \CHANNEL20/REG_A/reg7\, 
        \CHANNEL20/REG_A/reg9\, \CHANNEL20/REG_A/reg4\, 
        \CHANNEL20/REG_A/reg5\, \CHANNEL20/REG_A/reg6\, 
        \CHANNEL20/REGFF/reg7\, \CHANNEL20/REGFF/DATA\, 
        \CHANNEL20/REGFF/data_net_7\, 
        \CHANNEL20/REGFF/data_net_1\, \CHANNEL20/REGFF/reg8\, 
        \CHANNEL20/REGFF/data_9\, \CHANNEL20/REGFF/data_net_5\, 
        \CHANNEL20/REGFF/reg0\, \CHANNEL20/REGFF/data_net_3\, 
        \CHANNEL20/REGFF/data_net_8\, \CHANNEL20/REGFF/reg1\, 
        \CHANNEL20/REGFF/data_net_6\, \CHANNEL20/REGFF/reg2\, 
        \CHANNEL20/REGFF/reg3\, \CHANNEL20/REGFF/data_net_4\, 
        \CHANNEL20/REGFF/reg4\, \CHANNEL20/REGFF/reg5\, 
        \CHANNEL20/REGFF/data_net_2\, \CHANNEL20/REGFF/reg6\, 
        \CHANNEL20/REGFF/GNDZ0\, 
        \NEW_VALUE_A_INBUF_2_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_2_inst/U0/NET2\, 
        \ENABLE_INBUF_26_inst/U0/NET1\, 
        \ENABLE_INBUF_26_inst/U0/NET2\, \CHANNEL18/reg8_b\, 
        \CHANNEL18/reg8_a\, \CHANNEL18/load_4\, 
        \CHANNEL18/load_net_1\, \CHANNEL18/load_net_3\, 
        \CHANNEL18/LOAD\, \CHANNEL18/load_net_2\, 
        \CHANNEL18/REG_B/reg1\, \CHANNEL18/REG_B/reg0\, 
        \CHANNEL18/REG_B/reg2\, \CHANNEL18/REG_B/reg3\, 
        \CHANNEL18/REG_B/reg7\, \CHANNEL18/REG_B/reg9\, 
        \CHANNEL18/REG_B/reg4\, \CHANNEL18/REG_B/reg5\, 
        \CHANNEL18/REG_B/reg6\, \CHANNEL18/REG_A/reg1\, 
        \CHANNEL18/REG_A/reg0\, \CHANNEL18/REG_A/reg2\, 
        \CHANNEL18/REG_A/reg3\, \CHANNEL18/REG_A/reg7\, 
        \CHANNEL18/REG_A/reg9\, \CHANNEL18/REG_A/reg4\, 
        \CHANNEL18/REG_A/reg5\, \CHANNEL18/REG_A/reg6\, 
        \CHANNEL18/REGFF/reg7\, \CHANNEL18/REGFF/DATA\, 
        \CHANNEL18/REGFF/data_net_7\, 
        \CHANNEL18/REGFF/data_net_1\, \CHANNEL18/REGFF/reg8\, 
        \CHANNEL18/REGFF/data_9\, \CHANNEL18/REGFF/data_net_5\, 
        \CHANNEL18/REGFF/reg0\, \CHANNEL18/REGFF/data_net_3\, 
        \CHANNEL18/REGFF/data_net_8\, \CHANNEL18/REGFF/reg1\, 
        \CHANNEL18/REGFF/data_net_6\, \CHANNEL18/REGFF/reg2\, 
        \CHANNEL18/REGFF/reg3\, \CHANNEL18/REGFF/data_net_4\, 
        \CHANNEL18/REGFF/reg4\, \CHANNEL18/REGFF/reg5\, 
        \CHANNEL18/REGFF/data_net_2\, \CHANNEL18/REGFF/reg6\, 
        \CHANNEL18/REGFF/GNDZ0\, \ENABLE_INBUF_13_inst/U0/NET1\, 
        \ENABLE_INBUF_13_inst/U0/NET2\, \CHANNEL7/reg8_b\, 
        \CHANNEL7/reg8_a\, \CHANNEL7/load_4\, 
        \CHANNEL7/load_net_1\, \CHANNEL7/load_net_3\, 
        \CHANNEL7/LOAD\, \CHANNEL7/load_net_2\, 
        \CHANNEL7/REG_B/reg1\, \CHANNEL7/REG_B/reg0\, 
        \CHANNEL7/REG_B/reg2\, \CHANNEL7/REG_B/reg3\, 
        \CHANNEL7/REG_B/reg7\, \CHANNEL7/REG_B/reg9\, 
        \CHANNEL7/REG_B/reg4\, \CHANNEL7/REG_B/reg5\, 
        \CHANNEL7/REG_B/reg6\, \CHANNEL7/REG_A/reg1\, 
        \CHANNEL7/REG_A/reg0\, \CHANNEL7/REG_A/reg2\, 
        \CHANNEL7/REG_A/reg3\, \CHANNEL7/REG_A/reg7\, 
        \CHANNEL7/REG_A/reg9\, \CHANNEL7/REG_A/reg4\, 
        \CHANNEL7/REG_A/reg5\, \CHANNEL7/REG_A/reg6\, 
        \CHANNEL7/REGFF/reg7\, \CHANNEL7/REGFF/DATA\, 
        \CHANNEL7/REGFF/data_net_7\, \CHANNEL7/REGFF/data_net_1\, 
        \CHANNEL7/REGFF/reg8\, \CHANNEL7/REGFF/data_9\, 
        \CHANNEL7/REGFF/data_net_5\, \CHANNEL7/REGFF/reg0\, 
        \CHANNEL7/REGFF/data_net_3\, \CHANNEL7/REGFF/data_net_8\, 
        \CHANNEL7/REGFF/reg1\, \CHANNEL7/REGFF/data_net_6\, 
        \CHANNEL7/REGFF/reg2\, \CHANNEL7/REGFF/reg3\, 
        \CHANNEL7/REGFF/data_net_4\, \CHANNEL7/REGFF/reg4\, 
        \CHANNEL7/REGFF/reg5\, \CHANNEL7/REGFF/data_net_2\, 
        \CHANNEL7/REGFF/reg6\, \CHANNEL7/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_28_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_28_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_28_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_26_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_26_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_26_inst/U0/NET3\, \CHANNEL2/reg8_b\, 
        \CHANNEL2/reg8_a\, \CHANNEL2/load_4\, 
        \CHANNEL2/load_net_1\, \CHANNEL2/load_net_3\, 
        \CHANNEL2/LOAD\, \CHANNEL2/load_net_2\, 
        \CHANNEL2/REG_B/reg1\, \CHANNEL2/REG_B/reg0\, 
        \CHANNEL2/REG_B/reg2\, \CHANNEL2/REG_B/reg3\, 
        \CHANNEL2/REG_B/reg7\, \CHANNEL2/REG_B/reg9\, 
        \CHANNEL2/REG_B/reg4\, \CHANNEL2/REG_B/reg5\, 
        \CHANNEL2/REG_B/reg6\, \CHANNEL2/REG_A/reg1\, 
        \CHANNEL2/REG_A/reg0\, \CHANNEL2/REG_A/reg2\, 
        \CHANNEL2/REG_A/reg3\, \CHANNEL2/REG_A/reg7\, 
        \CHANNEL2/REG_A/reg9\, \CHANNEL2/REG_A/reg4\, 
        \CHANNEL2/REG_A/reg5\, \CHANNEL2/REG_A/reg6\, 
        \CHANNEL2/REGFF/reg7\, \CHANNEL2/REGFF/DATA\, 
        \CHANNEL2/REGFF/data_net_7\, \CHANNEL2/REGFF/data_net_1\, 
        \CHANNEL2/REGFF/reg8\, \CHANNEL2/REGFF/data_9\, 
        \CHANNEL2/REGFF/data_net_5\, \CHANNEL2/REGFF/reg0\, 
        \CHANNEL2/REGFF/data_net_3\, \CHANNEL2/REGFF/data_net_8\, 
        \CHANNEL2/REGFF/reg1\, \CHANNEL2/REGFF/data_net_6\, 
        \CHANNEL2/REGFF/reg2\, \CHANNEL2/REGFF/reg3\, 
        \CHANNEL2/REGFF/data_net_4\, \CHANNEL2/REGFF/reg4\, 
        \CHANNEL2/REGFF/reg5\, \CHANNEL2/REGFF/data_net_2\, 
        \CHANNEL2/REGFF/reg6\, \CHANNEL2/REGFF/GNDZ0\, 
        \NEW_VALUE_A_INBUF_9_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_9_inst/U0/NET2\, \CHANNEL17/reg8_b\, 
        \CHANNEL17/reg8_a\, \CHANNEL17/load_4\, 
        \CHANNEL17/load_net_1\, \CHANNEL17/load_net_3\, 
        \CHANNEL17/LOAD\, \CHANNEL17/load_net_2\, 
        \CHANNEL17/REG_B/reg1\, \CHANNEL17/REG_B/reg0\, 
        \CHANNEL17/REG_B/reg2\, \CHANNEL17/REG_B/reg3\, 
        \CHANNEL17/REG_B/reg7\, \CHANNEL17/REG_B/reg9\, 
        \CHANNEL17/REG_B/reg4\, \CHANNEL17/REG_B/reg5\, 
        \CHANNEL17/REG_B/reg6\, \CHANNEL17/REG_A/reg1\, 
        \CHANNEL17/REG_A/reg0\, \CHANNEL17/REG_A/reg2\, 
        \CHANNEL17/REG_A/reg3\, \CHANNEL17/REG_A/reg7\, 
        \CHANNEL17/REG_A/reg9\, \CHANNEL17/REG_A/reg4\, 
        \CHANNEL17/REG_A/reg5\, \CHANNEL17/REG_A/reg6\, 
        \CHANNEL17/REGFF/reg7\, \CHANNEL17/REGFF/DATA\, 
        \CHANNEL17/REGFF/data_net_7\, 
        \CHANNEL17/REGFF/data_net_1\, \CHANNEL17/REGFF/reg8\, 
        \CHANNEL17/REGFF/data_9\, \CHANNEL17/REGFF/data_net_5\, 
        \CHANNEL17/REGFF/reg0\, \CHANNEL17/REGFF/data_net_3\, 
        \CHANNEL17/REGFF/data_net_8\, \CHANNEL17/REGFF/reg1\, 
        \CHANNEL17/REGFF/data_net_6\, \CHANNEL17/REGFF/reg2\, 
        \CHANNEL17/REGFF/reg3\, \CHANNEL17/REGFF/data_net_4\, 
        \CHANNEL17/REGFF/reg4\, \CHANNEL17/REGFF/reg5\, 
        \CHANNEL17/REGFF/data_net_2\, \CHANNEL17/REGFF/reg6\, 
        \CHANNEL17/REGFF/GNDZ0\, \CHANNEL22/reg8_b\, 
        \CHANNEL22/reg8_a\, \CHANNEL22/load_4\, 
        \CHANNEL22/load_net_1\, \CHANNEL22/load_net_3\, 
        \CHANNEL22/LOAD\, \CHANNEL22/load_net_2\, 
        \CHANNEL22/REG_B/reg1\, \CHANNEL22/REG_B/reg0\, 
        \CHANNEL22/REG_B/reg2\, \CHANNEL22/REG_B/reg3\, 
        \CHANNEL22/REG_B/reg7\, \CHANNEL22/REG_B/reg9\, 
        \CHANNEL22/REG_B/reg4\, \CHANNEL22/REG_B/reg5\, 
        \CHANNEL22/REG_B/reg6\, \CHANNEL22/REG_A/reg1\, 
        \CHANNEL22/REG_A/reg0\, \CHANNEL22/REG_A/reg2\, 
        \CHANNEL22/REG_A/reg3\, \CHANNEL22/REG_A/reg7\, 
        \CHANNEL22/REG_A/reg9\, \CHANNEL22/REG_A/reg4\, 
        \CHANNEL22/REG_A/reg5\, \CHANNEL22/REG_A/reg6\, 
        \CHANNEL22/REGFF/reg7\, \CHANNEL22/REGFF/DATA\, 
        \CHANNEL22/REGFF/data_net_7\, 
        \CHANNEL22/REGFF/data_net_1\, \CHANNEL22/REGFF/reg8\, 
        \CHANNEL22/REGFF/data_9\, \CHANNEL22/REGFF/data_net_5\, 
        \CHANNEL22/REGFF/reg0\, \CHANNEL22/REGFF/data_net_3\, 
        \CHANNEL22/REGFF/data_net_8\, \CHANNEL22/REGFF/reg1\, 
        \CHANNEL22/REGFF/data_net_6\, \CHANNEL22/REGFF/reg2\, 
        \CHANNEL22/REGFF/reg3\, \CHANNEL22/REGFF/data_net_4\, 
        \CHANNEL22/REGFF/reg4\, \CHANNEL22/REGFF/reg5\, 
        \CHANNEL22/REGFF/data_net_2\, \CHANNEL22/REGFF/reg6\, 
        \CHANNEL22/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_17_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_17_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_17_inst/U0/NET3\, \CHANNEL19/reg8_b\, 
        \CHANNEL19/reg8_a\, \CHANNEL19/load_4\, 
        \CHANNEL19/load_net_1\, \CHANNEL19/load_net_3\, 
        \CHANNEL19/LOAD\, \CHANNEL19/load_net_2\, 
        \CHANNEL19/REG_B/reg1\, \CHANNEL19/REG_B/reg0\, 
        \CHANNEL19/REG_B/reg2\, \CHANNEL19/REG_B/reg3\, 
        \CHANNEL19/REG_B/reg7\, \CHANNEL19/REG_B/reg9\, 
        \CHANNEL19/REG_B/reg4\, \CHANNEL19/REG_B/reg5\, 
        \CHANNEL19/REG_B/reg6\, \CHANNEL19/REG_A/reg1\, 
        \CHANNEL19/REG_A/reg0\, \CHANNEL19/REG_A/reg2\, 
        \CHANNEL19/REG_A/reg3\, \CHANNEL19/REG_A/reg7\, 
        \CHANNEL19/REG_A/reg9\, \CHANNEL19/REG_A/reg4\, 
        \CHANNEL19/REG_A/reg5\, \CHANNEL19/REG_A/reg6\, 
        \CHANNEL19/REGFF/reg7\, \CHANNEL19/REGFF/DATA\, 
        \CHANNEL19/REGFF/data_net_7\, 
        \CHANNEL19/REGFF/data_net_1\, \CHANNEL19/REGFF/reg8\, 
        \CHANNEL19/REGFF/data_9\, \CHANNEL19/REGFF/data_net_5\, 
        \CHANNEL19/REGFF/reg0\, \CHANNEL19/REGFF/data_net_3\, 
        \CHANNEL19/REGFF/data_net_8\, \CHANNEL19/REGFF/reg1\, 
        \CHANNEL19/REGFF/data_net_6\, \CHANNEL19/REGFF/reg2\, 
        \CHANNEL19/REGFF/reg3\, \CHANNEL19/REGFF/data_net_4\, 
        \CHANNEL19/REGFF/reg4\, \CHANNEL19/REGFF/reg5\, 
        \CHANNEL19/REGFF/data_net_2\, \CHANNEL19/REGFF/reg6\, 
        \CHANNEL19/REGFF/GNDZ0\, \OUTBUF32_OUTBUF_7_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_7_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_7_inst/U0/NET3\, 
        \ENABLE_INBUF_19_inst/U0/NET1\, 
        \ENABLE_INBUF_19_inst/U0/NET2\, \CHANNEL14/reg8_b\, 
        \CHANNEL14/reg8_a\, \CHANNEL14/load_4\, 
        \CHANNEL14/load_net_1\, \CHANNEL14/load_net_3\, 
        \CHANNEL14/LOAD\, \CHANNEL14/load_net_2\, 
        \CHANNEL14/REG_B/reg1\, \CHANNEL14/REG_B/reg0\, 
        \CHANNEL14/REG_B/reg2\, \CHANNEL14/REG_B/reg3\, 
        \CHANNEL14/REG_B/reg7\, \CHANNEL14/REG_B/reg9\, 
        \CHANNEL14/REG_B/reg4\, \CHANNEL14/REG_B/reg5\, 
        \CHANNEL14/REG_B/reg6\, \CHANNEL14/REG_A/reg1\, 
        \CHANNEL14/REG_A/reg0\, \CHANNEL14/REG_A/reg2\, 
        \CHANNEL14/REG_A/reg3\, \CHANNEL14/REG_A/reg7\, 
        \CHANNEL14/REG_A/reg9\, \CHANNEL14/REG_A/reg4\, 
        \CHANNEL14/REG_A/reg5\, \CHANNEL14/REG_A/reg6\, 
        \CHANNEL14/REGFF/reg7\, \CHANNEL14/REGFF/DATA\, 
        \CHANNEL14/REGFF/data_net_7\, 
        \CHANNEL14/REGFF/data_net_1\, \CHANNEL14/REGFF/reg8\, 
        \CHANNEL14/REGFF/data_9\, \CHANNEL14/REGFF/data_net_5\, 
        \CHANNEL14/REGFF/reg0\, \CHANNEL14/REGFF/data_net_3\, 
        \CHANNEL14/REGFF/data_net_8\, \CHANNEL14/REGFF/reg1\, 
        \CHANNEL14/REGFF/data_net_6\, \CHANNEL14/REGFF/reg2\, 
        \CHANNEL14/REGFF/reg3\, \CHANNEL14/REGFF/data_net_4\, 
        \CHANNEL14/REGFF/reg4\, \CHANNEL14/REGFF/reg5\, 
        \CHANNEL14/REGFF/data_net_2\, \CHANNEL14/REGFF/reg6\, 
        \CHANNEL14/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_31_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_31_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_31_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_27_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_27_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_27_inst/U0/NET3\, 
        \NEW_VALUE_A_INBUF_0_inst/U0/NET1\, 
        \NEW_VALUE_A_INBUF_0_inst/U0/NET2\, 
        \ENABLE_INBUF_5_inst/U0/NET1\, 
        \ENABLE_INBUF_5_inst/U0/NET2\, 
        \ENABLE_INBUF_2_inst/U0/NET1\, 
        \ENABLE_INBUF_2_inst/U0/NET2\, \CHANNEL30/reg8_b\, 
        \CHANNEL30/reg8_a\, \CHANNEL30/load_4\, 
        \CHANNEL30/load_net_1\, \CHANNEL30/load_net_3\, 
        \CHANNEL30/LOAD\, \CHANNEL30/load_net_2\, 
        \CHANNEL30/REG_B/reg1\, \CHANNEL30/REG_B/reg0\, 
        \CHANNEL30/REG_B/reg2\, \CHANNEL30/REG_B/reg3\, 
        \CHANNEL30/REG_B/reg7\, \CHANNEL30/REG_B/reg9\, 
        \CHANNEL30/REG_B/reg4\, \CHANNEL30/REG_B/reg5\, 
        \CHANNEL30/REG_B/reg6\, \CHANNEL30/REG_A/reg1\, 
        \CHANNEL30/REG_A/reg0\, \CHANNEL30/REG_A/reg2\, 
        \CHANNEL30/REG_A/reg3\, \CHANNEL30/REG_A/reg7\, 
        \CHANNEL30/REG_A/reg9\, \CHANNEL30/REG_A/reg4\, 
        \CHANNEL30/REG_A/reg5\, \CHANNEL30/REG_A/reg6\, 
        \CHANNEL30/REGFF/reg7\, \CHANNEL30/REGFF/DATA\, 
        \CHANNEL30/REGFF/data_net_7\, 
        \CHANNEL30/REGFF/data_net_1\, \CHANNEL30/REGFF/reg8\, 
        \CHANNEL30/REGFF/data_9\, \CHANNEL30/REGFF/data_net_5\, 
        \CHANNEL30/REGFF/reg0\, \CHANNEL30/REGFF/data_net_3\, 
        \CHANNEL30/REGFF/data_net_8\, \CHANNEL30/REGFF/reg1\, 
        \CHANNEL30/REGFF/data_net_6\, \CHANNEL30/REGFF/reg2\, 
        \CHANNEL30/REGFF/reg3\, \CHANNEL30/REGFF/data_net_4\, 
        \CHANNEL30/REGFF/reg4\, \CHANNEL30/REGFF/reg5\, 
        \CHANNEL30/REGFF/data_net_2\, \CHANNEL30/REGFF/reg6\, 
        \CHANNEL30/REGFF/GNDZ0\, \ENABLE_INBUF_1_inst/U0/NET1\, 
        \ENABLE_INBUF_1_inst/U0/NET2\, 
        \ENABLE_INBUF_14_inst/U0/NET1\, 
        \ENABLE_INBUF_14_inst/U0/NET2\, \CHANNEL0/reg8_b\, 
        \CHANNEL0/reg8_a\, \CHANNEL0/load_4\, 
        \CHANNEL0/load_net_1\, \CHANNEL0/load_net_3\, 
        \CHANNEL0/LOAD\, \CHANNEL0/load_net_2\, 
        \CHANNEL0/REG_B/reg1\, \CHANNEL0/REG_B/reg0\, 
        \CHANNEL0/REG_B/reg2\, \CHANNEL0/REG_B/reg3\, 
        \CHANNEL0/REG_B/reg7\, \CHANNEL0/REG_B/reg9\, 
        \CHANNEL0/REG_B/reg4\, \CHANNEL0/REG_B/reg5\, 
        \CHANNEL0/REG_B/reg6\, \CHANNEL0/REG_A/reg1\, 
        \CHANNEL0/REG_A/reg0\, \CHANNEL0/REG_A/reg2\, 
        \CHANNEL0/REG_A/reg3\, \CHANNEL0/REG_A/reg7\, 
        \CHANNEL0/REG_A/reg9\, \CHANNEL0/REG_A/reg4\, 
        \CHANNEL0/REG_A/reg5\, \CHANNEL0/REG_A/reg6\, 
        \CHANNEL0/REGFF/reg7\, \CHANNEL0/REGFF/DATA\, 
        \CHANNEL0/REGFF/data_net_7\, \CHANNEL0/REGFF/data_net_1\, 
        \CHANNEL0/REGFF/reg8\, \CHANNEL0/REGFF/data_9\, 
        \CHANNEL0/REGFF/data_net_5\, \CHANNEL0/REGFF/reg0\, 
        \CHANNEL0/REGFF/data_net_3\, \CHANNEL0/REGFF/data_net_8\, 
        \CHANNEL0/REGFF/reg1\, \CHANNEL0/REGFF/data_net_6\, 
        \CHANNEL0/REGFF/reg2\, \CHANNEL0/REGFF/reg3\, 
        \CHANNEL0/REGFF/data_net_4\, \CHANNEL0/REGFF/reg4\, 
        \CHANNEL0/REGFF/reg5\, \CHANNEL0/REGFF/data_net_2\, 
        \CHANNEL0/REGFF/reg6\, \CHANNEL0/REGFF/GNDZ0\, 
        \ENABLE_INBUF_15_inst/U0/NET1\, 
        \ENABLE_INBUF_15_inst/U0/NET2\, \CHANNEL3/reg8_b\, 
        \CHANNEL3/reg8_a\, \CHANNEL3/load_4\, 
        \CHANNEL3/load_net_1\, \CHANNEL3/load_net_3\, 
        \CHANNEL3/LOAD\, \CHANNEL3/load_net_2\, 
        \CHANNEL3/REG_B/reg1\, \CHANNEL3/REG_B/reg0\, 
        \CHANNEL3/REG_B/reg2\, \CHANNEL3/REG_B/reg3\, 
        \CHANNEL3/REG_B/reg7\, \CHANNEL3/REG_B/reg9\, 
        \CHANNEL3/REG_B/reg4\, \CHANNEL3/REG_B/reg5\, 
        \CHANNEL3/REG_B/reg6\, \CHANNEL3/REG_A/reg1\, 
        \CHANNEL3/REG_A/reg0\, \CHANNEL3/REG_A/reg2\, 
        \CHANNEL3/REG_A/reg3\, \CHANNEL3/REG_A/reg7\, 
        \CHANNEL3/REG_A/reg9\, \CHANNEL3/REG_A/reg4\, 
        \CHANNEL3/REG_A/reg5\, \CHANNEL3/REG_A/reg6\, 
        \CHANNEL3/REGFF/reg7\, \CHANNEL3/REGFF/DATA\, 
        \CHANNEL3/REGFF/data_net_7\, \CHANNEL3/REGFF/data_net_1\, 
        \CHANNEL3/REGFF/reg8\, \CHANNEL3/REGFF/data_9\, 
        \CHANNEL3/REGFF/data_net_5\, \CHANNEL3/REGFF/reg0\, 
        \CHANNEL3/REGFF/data_net_3\, \CHANNEL3/REGFF/data_net_8\, 
        \CHANNEL3/REGFF/reg1\, \CHANNEL3/REGFF/data_net_6\, 
        \CHANNEL3/REGFF/reg2\, \CHANNEL3/REGFF/reg3\, 
        \CHANNEL3/REGFF/data_net_4\, \CHANNEL3/REGFF/reg4\, 
        \CHANNEL3/REGFF/reg5\, \CHANNEL3/REGFF/data_net_2\, 
        \CHANNEL3/REGFF/reg6\, \CHANNEL3/REGFF/GNDZ0\, 
        \ENABLE_INBUF_22_inst/U0/NET1\, 
        \ENABLE_INBUF_22_inst/U0/NET2\, \CHANNEL28/reg8_b\, 
        \CHANNEL28/reg8_a\, \CHANNEL28/load_4\, 
        \CHANNEL28/load_net_1\, \CHANNEL28/load_net_3\, 
        \CHANNEL28/LOAD\, \CHANNEL28/load_net_2\, 
        \CHANNEL28/REG_B/reg1\, \CHANNEL28/REG_B/reg0\, 
        \CHANNEL28/REG_B/reg2\, \CHANNEL28/REG_B/reg3\, 
        \CHANNEL28/REG_B/reg7\, \CHANNEL28/REG_B/reg9\, 
        \CHANNEL28/REG_B/reg4\, \CHANNEL28/REG_B/reg5\, 
        \CHANNEL28/REG_B/reg6\, \CHANNEL28/REG_A/reg1\, 
        \CHANNEL28/REG_A/reg0\, \CHANNEL28/REG_A/reg2\, 
        \CHANNEL28/REG_A/reg3\, \CHANNEL28/REG_A/reg7\, 
        \CHANNEL28/REG_A/reg9\, \CHANNEL28/REG_A/reg4\, 
        \CHANNEL28/REG_A/reg5\, \CHANNEL28/REG_A/reg6\, 
        \CHANNEL28/REGFF/reg7\, \CHANNEL28/REGFF/DATA\, 
        \CHANNEL28/REGFF/data_net_7\, 
        \CHANNEL28/REGFF/data_net_1\, \CHANNEL28/REGFF/reg8\, 
        \CHANNEL28/REGFF/data_9\, \CHANNEL28/REGFF/data_net_5\, 
        \CHANNEL28/REGFF/reg0\, \CHANNEL28/REGFF/data_net_3\, 
        \CHANNEL28/REGFF/data_net_8\, \CHANNEL28/REGFF/reg1\, 
        \CHANNEL28/REGFF/data_net_6\, \CHANNEL28/REGFF/reg2\, 
        \CHANNEL28/REGFF/reg3\, \CHANNEL28/REGFF/data_net_4\, 
        \CHANNEL28/REGFF/reg4\, \CHANNEL28/REGFF/reg5\, 
        \CHANNEL28/REGFF/data_net_2\, \CHANNEL28/REGFF/reg6\, 
        \CHANNEL28/REGFF/GNDZ0\, \CHANNEL11/reg8_b\, 
        \CHANNEL11/reg8_a\, \CHANNEL11/load_4\, 
        \CHANNEL11/load_net_1\, \CHANNEL11/load_net_3\, 
        \CHANNEL11/LOAD\, \CHANNEL11/load_net_2\, 
        \CHANNEL11/REG_B/reg1\, \CHANNEL11/REG_B/reg0\, 
        \CHANNEL11/REG_B/reg2\, \CHANNEL11/REG_B/reg3\, 
        \CHANNEL11/REG_B/reg7\, \CHANNEL11/REG_B/reg9\, 
        \CHANNEL11/REG_B/reg4\, \CHANNEL11/REG_B/reg5\, 
        \CHANNEL11/REG_B/reg6\, \CHANNEL11/REG_A/reg1\, 
        \CHANNEL11/REG_A/reg0\, \CHANNEL11/REG_A/reg2\, 
        \CHANNEL11/REG_A/reg3\, \CHANNEL11/REG_A/reg7\, 
        \CHANNEL11/REG_A/reg9\, \CHANNEL11/REG_A/reg4\, 
        \CHANNEL11/REG_A/reg5\, \CHANNEL11/REG_A/reg6\, 
        \CHANNEL11/REGFF/reg7\, \CHANNEL11/REGFF/DATA\, 
        \CHANNEL11/REGFF/data_net_7\, 
        \CHANNEL11/REGFF/data_net_1\, \CHANNEL11/REGFF/reg8\, 
        \CHANNEL11/REGFF/data_9\, \CHANNEL11/REGFF/data_net_5\, 
        \CHANNEL11/REGFF/reg0\, \CHANNEL11/REGFF/data_net_3\, 
        \CHANNEL11/REGFF/data_net_8\, \CHANNEL11/REGFF/reg1\, 
        \CHANNEL11/REGFF/data_net_6\, \CHANNEL11/REGFF/reg2\, 
        \CHANNEL11/REGFF/reg3\, \CHANNEL11/REGFF/data_net_4\, 
        \CHANNEL11/REGFF/reg4\, \CHANNEL11/REGFF/reg5\, 
        \CHANNEL11/REGFF/data_net_2\, \CHANNEL11/REGFF/reg6\, 
        \CHANNEL11/REGFF/GNDZ0\, \ENABLE_INBUF_9_inst/U0/NET1\, 
        \ENABLE_INBUF_9_inst/U0/NET2\, \CHANNEL27/reg8_b\, 
        \CHANNEL27/reg8_a\, \CHANNEL27/load_4\, 
        \CHANNEL27/load_net_1\, \CHANNEL27/load_net_3\, 
        \CHANNEL27/LOAD\, \CHANNEL27/load_net_2\, 
        \CHANNEL27/REG_B/reg1\, \CHANNEL27/REG_B/reg0\, 
        \CHANNEL27/REG_B/reg2\, \CHANNEL27/REG_B/reg3\, 
        \CHANNEL27/REG_B/reg7\, \CHANNEL27/REG_B/reg9\, 
        \CHANNEL27/REG_B/reg4\, \CHANNEL27/REG_B/reg5\, 
        \CHANNEL27/REG_B/reg6\, \CHANNEL27/REG_A/reg1\, 
        \CHANNEL27/REG_A/reg0\, \CHANNEL27/REG_A/reg2\, 
        \CHANNEL27/REG_A/reg3\, \CHANNEL27/REG_A/reg7\, 
        \CHANNEL27/REG_A/reg9\, \CHANNEL27/REG_A/reg4\, 
        \CHANNEL27/REG_A/reg5\, \CHANNEL27/REG_A/reg6\, 
        \CHANNEL27/REGFF/reg7\, \CHANNEL27/REGFF/DATA\, 
        \CHANNEL27/REGFF/data_net_7\, 
        \CHANNEL27/REGFF/data_net_1\, \CHANNEL27/REGFF/reg8\, 
        \CHANNEL27/REGFF/data_9\, \CHANNEL27/REGFF/data_net_5\, 
        \CHANNEL27/REGFF/reg0\, \CHANNEL27/REGFF/data_net_3\, 
        \CHANNEL27/REGFF/data_net_8\, \CHANNEL27/REGFF/reg1\, 
        \CHANNEL27/REGFF/data_net_6\, \CHANNEL27/REGFF/reg2\, 
        \CHANNEL27/REGFF/reg3\, \CHANNEL27/REGFF/data_net_4\, 
        \CHANNEL27/REGFF/reg4\, \CHANNEL27/REGFF/reg5\, 
        \CHANNEL27/REGFF/data_net_2\, \CHANNEL27/REGFF/reg6\, 
        \CHANNEL27/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_13_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_13_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_13_inst/U0/NET3\, 
        \ENABLE_INBUF_23_inst/U0/NET1\, 
        \ENABLE_INBUF_23_inst/U0/NET2\, \CHANNEL29/reg8_b\, 
        \CHANNEL29/reg8_a\, \CHANNEL29/load_4\, 
        \CHANNEL29/load_net_1\, \CHANNEL29/load_net_3\, 
        \CHANNEL29/LOAD\, \CHANNEL29/load_net_2\, 
        \CHANNEL29/REG_B/reg1\, \CHANNEL29/REG_B/reg0\, 
        \CHANNEL29/REG_B/reg2\, \CHANNEL29/REG_B/reg3\, 
        \CHANNEL29/REG_B/reg7\, \CHANNEL29/REG_B/reg9\, 
        \CHANNEL29/REG_B/reg4\, \CHANNEL29/REG_B/reg5\, 
        \CHANNEL29/REG_B/reg6\, \CHANNEL29/REG_A/reg1\, 
        \CHANNEL29/REG_A/reg0\, \CHANNEL29/REG_A/reg2\, 
        \CHANNEL29/REG_A/reg3\, \CHANNEL29/REG_A/reg7\, 
        \CHANNEL29/REG_A/reg9\, \CHANNEL29/REG_A/reg4\, 
        \CHANNEL29/REG_A/reg5\, \CHANNEL29/REG_A/reg6\, 
        \CHANNEL29/REGFF/reg7\, \CHANNEL29/REGFF/DATA\, 
        \CHANNEL29/REGFF/data_net_7\, 
        \CHANNEL29/REGFF/data_net_1\, \CHANNEL29/REGFF/reg8\, 
        \CHANNEL29/REGFF/data_9\, \CHANNEL29/REGFF/data_net_5\, 
        \CHANNEL29/REGFF/reg0\, \CHANNEL29/REGFF/data_net_3\, 
        \CHANNEL29/REGFF/data_net_8\, \CHANNEL29/REGFF/reg1\, 
        \CHANNEL29/REGFF/data_net_6\, \CHANNEL29/REGFF/reg2\, 
        \CHANNEL29/REGFF/reg3\, \CHANNEL29/REGFF/data_net_4\, 
        \CHANNEL29/REGFF/reg4\, \CHANNEL29/REGFF/reg5\, 
        \CHANNEL29/REGFF/data_net_2\, \CHANNEL29/REGFF/reg6\, 
        \CHANNEL29/REGFF/GNDZ0\, \CHANNEL5/reg8_b\, 
        \CHANNEL5/reg8_a\, \CHANNEL5/load_4\, 
        \CHANNEL5/load_net_1\, \CHANNEL5/load_net_3\, 
        \CHANNEL5/LOAD\, \CHANNEL5/load_net_2\, 
        \CHANNEL5/REG_B/reg1\, \CHANNEL5/REG_B/reg0\, 
        \CHANNEL5/REG_B/reg2\, \CHANNEL5/REG_B/reg3\, 
        \CHANNEL5/REG_B/reg7\, \CHANNEL5/REG_B/reg9\, 
        \CHANNEL5/REG_B/reg4\, \CHANNEL5/REG_B/reg5\, 
        \CHANNEL5/REG_B/reg6\, \CHANNEL5/REG_A/reg1\, 
        \CHANNEL5/REG_A/reg0\, \CHANNEL5/REG_A/reg2\, 
        \CHANNEL5/REG_A/reg3\, \CHANNEL5/REG_A/reg7\, 
        \CHANNEL5/REG_A/reg9\, \CHANNEL5/REG_A/reg4\, 
        \CHANNEL5/REG_A/reg5\, \CHANNEL5/REG_A/reg6\, 
        \CHANNEL5/REGFF/reg7\, \CHANNEL5/REGFF/DATA\, 
        \CHANNEL5/REGFF/data_net_7\, \CHANNEL5/REGFF/data_net_1\, 
        \CHANNEL5/REGFF/reg8\, \CHANNEL5/REGFF/data_9\, 
        \CHANNEL5/REGFF/data_net_5\, \CHANNEL5/REGFF/reg0\, 
        \CHANNEL5/REGFF/data_net_3\, \CHANNEL5/REGFF/data_net_8\, 
        \CHANNEL5/REGFF/reg1\, \CHANNEL5/REGFF/data_net_6\, 
        \CHANNEL5/REGFF/reg2\, \CHANNEL5/REGFF/reg3\, 
        \CHANNEL5/REGFF/data_net_4\, \CHANNEL5/REGFF/reg4\, 
        \CHANNEL5/REGFF/reg5\, \CHANNEL5/REGFF/data_net_2\, 
        \CHANNEL5/REGFF/reg6\, \CHANNEL5/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_2_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_2_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_2_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_1_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_1_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_1_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_14_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_14_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_14_inst/U0/NET3\, \CHANNEL24/reg8_b\, 
        \CHANNEL24/reg8_a\, \CHANNEL24/load_4\, 
        \CHANNEL24/load_net_1\, \CHANNEL24/load_net_3\, 
        \CHANNEL24/LOAD\, \CHANNEL24/load_net_2\, 
        \CHANNEL24/REG_B/reg1\, \CHANNEL24/REG_B/reg0\, 
        \CHANNEL24/REG_B/reg2\, \CHANNEL24/REG_B/reg3\, 
        \CHANNEL24/REG_B/reg7\, \CHANNEL24/REG_B/reg9\, 
        \CHANNEL24/REG_B/reg4\, \CHANNEL24/REG_B/reg5\, 
        \CHANNEL24/REG_B/reg6\, \CHANNEL24/REG_A/reg1\, 
        \CHANNEL24/REG_A/reg0\, \CHANNEL24/REG_A/reg2\, 
        \CHANNEL24/REG_A/reg3\, \CHANNEL24/REG_A/reg7\, 
        \CHANNEL24/REG_A/reg9\, \CHANNEL24/REG_A/reg4\, 
        \CHANNEL24/REG_A/reg5\, \CHANNEL24/REG_A/reg6\, 
        \CHANNEL24/REGFF/reg7\, \CHANNEL24/REGFF/DATA\, 
        \CHANNEL24/REGFF/data_net_7\, 
        \CHANNEL24/REGFF/data_net_1\, \CHANNEL24/REGFF/reg8\, 
        \CHANNEL24/REGFF/data_9\, \CHANNEL24/REGFF/data_net_5\, 
        \CHANNEL24/REGFF/reg0\, \CHANNEL24/REGFF/data_net_3\, 
        \CHANNEL24/REGFF/data_net_8\, \CHANNEL24/REGFF/reg1\, 
        \CHANNEL24/REGFF/data_net_6\, \CHANNEL24/REGFF/reg2\, 
        \CHANNEL24/REGFF/reg3\, \CHANNEL24/REGFF/data_net_4\, 
        \CHANNEL24/REGFF/reg4\, \CHANNEL24/REGFF/reg5\, 
        \CHANNEL24/REGFF/data_net_2\, \CHANNEL24/REGFF/reg6\, 
        \CHANNEL24/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_23_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_23_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_23_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_0_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_0_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_0_inst/U0/NET3\, 
        \ENABLE_INBUF_30_inst/U0/NET1\, 
        \ENABLE_INBUF_30_inst/U0/NET2\, 
        \ENABLE_INBUF_6_inst/U0/NET1\, 
        \ENABLE_INBUF_6_inst/U0/NET2\, \CHANNEL6/reg8_b\, 
        \CHANNEL6/reg8_a\, \CHANNEL6/load_4\, 
        \CHANNEL6/load_net_1\, \CHANNEL6/load_net_3\, 
        \CHANNEL6/LOAD\, \CHANNEL6/load_net_2\, 
        \CHANNEL6/REG_B/reg1\, \CHANNEL6/REG_B/reg0\, 
        \CHANNEL6/REG_B/reg2\, \CHANNEL6/REG_B/reg3\, 
        \CHANNEL6/REG_B/reg7\, \CHANNEL6/REG_B/reg9\, 
        \CHANNEL6/REG_B/reg4\, \CHANNEL6/REG_B/reg5\, 
        \CHANNEL6/REG_B/reg6\, \CHANNEL6/REG_A/reg1\, 
        \CHANNEL6/REG_A/reg0\, \CHANNEL6/REG_A/reg2\, 
        \CHANNEL6/REG_A/reg3\, \CHANNEL6/REG_A/reg7\, 
        \CHANNEL6/REG_A/reg9\, \CHANNEL6/REG_A/reg4\, 
        \CHANNEL6/REG_A/reg5\, \CHANNEL6/REG_A/reg6\, 
        \CHANNEL6/REGFF/reg7\, \CHANNEL6/REGFF/DATA\, 
        \CHANNEL6/REGFF/data_net_7\, \CHANNEL6/REGFF/data_net_1\, 
        \CHANNEL6/REGFF/reg8\, \CHANNEL6/REGFF/data_9\, 
        \CHANNEL6/REGFF/data_net_5\, \CHANNEL6/REGFF/reg0\, 
        \CHANNEL6/REGFF/data_net_3\, \CHANNEL6/REGFF/data_net_8\, 
        \CHANNEL6/REGFF/reg1\, \CHANNEL6/REGFF/data_net_6\, 
        \CHANNEL6/REGFF/reg2\, \CHANNEL6/REGFF/reg3\, 
        \CHANNEL6/REGFF/data_net_4\, \CHANNEL6/REGFF/reg4\, 
        \CHANNEL6/REGFF/reg5\, \CHANNEL6/REGFF/data_net_2\, 
        \CHANNEL6/REGFF/reg6\, \CHANNEL6/REGFF/GNDZ0\, 
        \OUTBUF32_OUTBUF_6_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_6_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_6_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_24_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_24_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_24_inst/U0/NET3\, 
        \ENABLE_INBUF_29_inst/U0/NET1\, 
        \ENABLE_INBUF_29_inst/U0/NET2\, \CHANNEL9/reg8_b\, 
        \CHANNEL9/reg8_a\, \CHANNEL9/load_4\, 
        \CHANNEL9/load_net_1\, \CHANNEL9/load_net_3\, 
        \CHANNEL9/LOAD\, \CHANNEL9/load_net_2\, 
        \CHANNEL9/REG_B/reg1\, \CHANNEL9/REG_B/reg0\, 
        \CHANNEL9/REG_B/reg2\, \CHANNEL9/REG_B/reg3\, 
        \CHANNEL9/REG_B/reg7\, \CHANNEL9/REG_B/reg9\, 
        \CHANNEL9/REG_B/reg4\, \CHANNEL9/REG_B/reg5\, 
        \CHANNEL9/REG_B/reg6\, \CHANNEL9/REG_A/reg1\, 
        \CHANNEL9/REG_A/reg0\, \CHANNEL9/REG_A/reg2\, 
        \CHANNEL9/REG_A/reg3\, \CHANNEL9/REG_A/reg7\, 
        \CHANNEL9/REG_A/reg9\, \CHANNEL9/REG_A/reg4\, 
        \CHANNEL9/REG_A/reg5\, \CHANNEL9/REG_A/reg6\, 
        \CHANNEL9/REGFF/reg7\, \CHANNEL9/REGFF/DATA\, 
        \CHANNEL9/REGFF/data_net_7\, \CHANNEL9/REGFF/data_net_1\, 
        \CHANNEL9/REGFF/reg8\, \CHANNEL9/REGFF/data_9\, 
        \CHANNEL9/REGFF/data_net_5\, \CHANNEL9/REGFF/reg0\, 
        \CHANNEL9/REGFF/data_net_3\, \CHANNEL9/REGFF/data_net_8\, 
        \CHANNEL9/REGFF/reg1\, \CHANNEL9/REGFF/data_net_6\, 
        \CHANNEL9/REGFF/reg2\, \CHANNEL9/REGFF/reg3\, 
        \CHANNEL9/REGFF/data_net_4\, \CHANNEL9/REGFF/reg4\, 
        \CHANNEL9/REGFF/reg5\, \CHANNEL9/REGFF/data_net_2\, 
        \CHANNEL9/REGFF/reg6\, \CHANNEL9/REGFF/GNDZ0\, 
        \ENABLE_INBUF_0_inst/U0/NET1\, 
        \ENABLE_INBUF_0_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_9_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_9_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_9_inst/U0/NET3\, 
        \ENABLE_INBUF_24_inst/U0/NET1\, 
        \ENABLE_INBUF_24_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_10_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_10_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_10_inst/U0/NET3\, 
        \OUTBUF32_OUTBUF_12_inst/U0/NET1\, 
        \OUTBUF32_OUTBUF_12_inst/U0/NET2\, 
        \OUTBUF32_OUTBUF_12_inst/U0/NET3\, 
        \ENABLE_INBUF_25_inst/U0/NET1\, 
        \ENABLE_INBUF_25_inst/U0/NET2\, \CHANNEL21/reg8_b\, 
        \CHANNEL21/reg8_a\, \CHANNEL21/load_4\, 
        \CHANNEL21/load_net_1\, \CHANNEL21/load_net_3\, 
        \CHANNEL21/LOAD\, \CHANNEL21/load_net_2\, 
        \CHANNEL21/REG_B/reg1\, \CHANNEL21/REG_B/reg0\, 
        \CHANNEL21/REG_B/reg2\, \CHANNEL21/REG_B/reg3\, 
        \CHANNEL21/REG_B/reg7\, \CHANNEL21/REG_B/reg9\, 
        \CHANNEL21/REG_B/reg4\, \CHANNEL21/REG_B/reg5\, 
        \CHANNEL21/REG_B/reg6\, \CHANNEL21/REG_A/reg1\, 
        \CHANNEL21/REG_A/reg0\, \CHANNEL21/REG_A/reg2\, 
        \CHANNEL21/REG_A/reg3\, \CHANNEL21/REG_A/reg7\, 
        \CHANNEL21/REG_A/reg9\, \CHANNEL21/REG_A/reg4\, 
        \CHANNEL21/REG_A/reg5\, \CHANNEL21/REG_A/reg6\, 
        \CHANNEL21/REGFF/reg7\, \CHANNEL21/REGFF/DATA\, 
        \CHANNEL21/REGFF/data_net_7\, 
        \CHANNEL21/REGFF/data_net_1\, \CHANNEL21/REGFF/reg8\, 
        \CHANNEL21/REGFF/data_9\, \CHANNEL21/REGFF/data_net_5\, 
        \CHANNEL21/REGFF/reg0\, \CHANNEL21/REGFF/data_net_3\, 
        \CHANNEL21/REGFF/data_net_8\, \CHANNEL21/REGFF/reg1\, 
        \CHANNEL21/REGFF/data_net_6\, \CHANNEL21/REGFF/reg2\, 
        \CHANNEL21/REGFF/reg3\, \CHANNEL21/REGFF/data_net_4\, 
        \CHANNEL21/REGFF/reg4\, \CHANNEL21/REGFF/reg5\, 
        \CHANNEL21/REGFF/data_net_2\, \CHANNEL21/REGFF/reg6\, 
        \CHANNEL21/REGFF/GNDZ0\, \VCC\, \GND\, 
        \CHANNEL27/REGCC10/mx2_0_y\, \CHANNEL27/new_value_net_2\, 
        \CHANNEL12/REGCC10/mx2_3_y\, \CHANNEL12/NEW_VALUE\, 
        \CHANNEL27/REGCC10/mx2_4_y\, \CHANNEL27/new_value_net_7\, 
        \CHANNEL31/REGCC10/mx2_2_y\, \CHANNEL31/new_value_net_8\, 
        \CHANNEL30/REGCC10/mx2_3_y\, \CHANNEL30/NEW_VALUE\, 
        \CHANNEL17/REGCC10/mx2_0_y\, \CHANNEL17/new_value_net_2\, 
        \CHANNEL1/REGCC10/mx2_4_y\, \CHANNEL1/new_value_net_7\, 
        \CHANNEL21/REGCC10/mx2_7_y\, \CHANNEL21/new_value_net_6\, 
        \CHANNEL11/REGCC10/mx2_7_y\, \CHANNEL11/new_value_net_6\, 
        \CHANNEL0/REGCC10/mx2_0_y\, \CHANNEL0/new_value_net_2\, 
        \CHANNEL23/REGCC10/mx2_0_y\, \CHANNEL23/new_value_net_2\, 
        \CHANNEL29/REGCC10/mx2_6_y\, \CHANNEL29/new_value_net_5\, 
        \CHANNEL23/REGCC10/mx2_4_y\, \CHANNEL23/new_value_net_7\, 
        \CHANNEL3/REGCC10/mx2_5_y\, \CHANNEL3/new_value_net_3\, 
        \CHANNEL8/REGCC10/mx2_8_y\, \CHANNEL8/new_value_9\, 
        \CHANNEL24/REGCC10/mx2_3_y\, \CHANNEL24/NEW_VALUE\, 
        \CHANNEL9/REGCC10/mx2_1_y\, \CHANNEL9/new_value_net_1\, 
        \CHANNEL20/REGCC10/mx2_6_y\, \CHANNEL20/new_value_net_5\, 
        \CHANNEL0/REGCC10/mx2_7_y\, \CHANNEL0/new_value_net_6\, 
        \CHANNEL13/REGCC10/mx2_0_y\, \CHANNEL13/new_value_net_2\, 
        \CHANNEL16/REGCC10/mx2_1_y\, \CHANNEL16/new_value_net_1\, 
        \CHANNEL30/REGCC10/mx2_9_y\, \CHANNEL30/new_value_net_4\, 
        \CHANNEL2/REGCC10/mx2_8_y\, \CHANNEL2/new_value_9\, 
        \CHANNEL15/REGCC10/mx2_1_y\, \CHANNEL15/new_value_net_1\, 
        \CHANNEL28/REGCC10/mx2_3_y\, \CHANNEL28/NEW_VALUE\, 
        \CHANNEL7/REGCC10/mx2_1_y\, \CHANNEL7/new_value_net_1\, 
        \CHANNEL0/REGCC10/mx2_6_y\, \CHANNEL0/new_value_net_5\, 
        \CHANNEL17/REGCC10/mx2_4_y\, \CHANNEL17/new_value_net_7\, 
        \CHANNEL3/REGCC10/mx2_0_y\, \CHANNEL3/new_value_net_2\, 
        \CHANNEL12/REGCC10/mx2_1_y\, \CHANNEL12/new_value_net_1\, 
        \CHANNEL16/REGCC10/mx2_9_y\, \CHANNEL16/new_value_net_4\, 
        \CHANNEL15/REGCC10/mx2_9_y\, \CHANNEL15/new_value_net_4\, 
        \CHANNEL5/REGCC10/mx2_1_y\, \CHANNEL5/new_value_net_1\, 
        \CHANNEL3/REGCC10/mx2_7_y\, \CHANNEL3/new_value_net_6\, 
        \CHANNEL31/REGCC10/mx2_3_y\, \CHANNEL31/NEW_VALUE\, 
        \CHANNEL6/REGCC10/mx2_2_y\, \CHANNEL6/new_value_net_8\, 
        \CHANNEL12/REGCC10/mx2_9_y\, \CHANNEL12/new_value_net_4\, 
        \CHANNEL13/REGCC10/mx2_4_y\, \CHANNEL13/new_value_net_7\, 
        \CHANNEL4/REGCC10/mx2_2_y\, \CHANNEL4/new_value_net_8\, 
        \CHANNEL3/REGCC10/mx2_6_y\, \CHANNEL3/new_value_net_5\, 
        \CHANNEL16/REGCC10/mx2_2_y\, \CHANNEL16/new_value_net_8\, 
        \CHANNEL24/REGCC10/mx2_9_y\, \CHANNEL24/new_value_net_4\, 
        \CHANNEL29/REGCC10/mx2_3_y\, \CHANNEL29/NEW_VALUE\, 
        \CHANNEL17/REGCC10/mx2_6_y\, \CHANNEL17/new_value_net_5\, 
        \CHANNEL15/REGCC10/mx2_2_y\, \CHANNEL15/new_value_net_8\, 
        \CHANNEL20/REGCC10/mx2_3_y\, \CHANNEL20/NEW_VALUE\, 
        \CHANNEL21/REGCC10/mx2_6_y\, \CHANNEL21/new_value_net_5\, 
        \CHANNEL12/REGCC10/mx2_2_y\, \CHANNEL12/new_value_net_8\, 
        \CHANNEL31/REGCC10/mx2_9_y\, \CHANNEL31/new_value_net_4\, 
        \CHANNEL28/REGCC10/mx2_9_y\, \CHANNEL28/new_value_net_4\, 
        \CHANNEL6/REGCC10/mx2_4_y\, \CHANNEL6/new_value_net_7\, 
        \CHANNEL24/REGCC10/mx2_1_y\, \CHANNEL24/new_value_net_1\, 
        \CHANNEL13/REGCC10/mx2_6_y\, \CHANNEL13/new_value_net_5\, 
        \CHANNEL4/REGCC10/mx2_4_y\, \CHANNEL4/new_value_net_7\, 
        \CHANNEL8/REGCC10/mx2_2_y\, \CHANNEL8/new_value_net_8\, 
        \CHANNEL30/REGCC10/mx2_0_y\, \CHANNEL30/new_value_net_2\, 
        \CHANNEL0/REGCC10/mx2_8_y\, \CHANNEL0/new_value_9\, 
        \CHANNEL28/REGCC10/mx2_1_y\, \CHANNEL28/new_value_net_1\, 
        \CHANNEL2/REGCC10/mx2_2_y\, \CHANNEL2/new_value_net_8\, 
        \CHANNEL24/REGCC10/mx2_5_y\, \CHANNEL24/new_value_net_3\, 
        \CHANNEL14/REGCC10/mx2_5_y\, \CHANNEL14/new_value_net_3\, 
        \CHANNEL29/REGCC10/mx2_9_y\, \CHANNEL29/new_value_net_4\, 
        \CHANNEL8/REGCC10/mx2_4_y\, \CHANNEL8/new_value_net_7\, 
        \CHANNEL9/REGCC10/mx2_9_y\, \CHANNEL9/new_value_net_4\, 
        \CHANNEL20/REGCC10/mx2_9_y\, \CHANNEL20/new_value_net_4\, 
        \CHANNEL27/REGCC10/mx2_2_y\, \CHANNEL27/new_value_net_8\, 
        \CHANNEL21/REGCC10/mx2_3_y\, \CHANNEL21/NEW_VALUE\, 
        \CHANNEL28/REGCC10/mx2_5_y\, \CHANNEL28/new_value_net_3\, 
        \CHANNEL18/REGCC10/mx2_5_y\, \CHANNEL18/new_value_net_3\, 
        \CHANNEL3/REGCC10/mx2_8_y\, \CHANNEL3/new_value_9\, 
        \CHANNEL1/REGCC10/mx2_1_y\, \CHANNEL1/new_value_net_1\, 
        \CHANNEL2/REGCC10/mx2_4_y\, \CHANNEL2/new_value_net_7\, 
        \CHANNEL24/REGCC10/mx2_0_y\, \CHANNEL24/new_value_net_2\, 
        \CHANNEL24/REGCC10/mx2_4_y\, \CHANNEL24/new_value_net_7\, 
        \CHANNEL7/REGCC10/mx2_9_y\, \CHANNEL7/new_value_net_4\, 
        \CHANNEL17/REGCC10/mx2_8_y\, \CHANNEL17/new_value_9\, 
        \CHANNEL29/REGCC10/mx2_1_y\, \CHANNEL29/new_value_net_1\, 
        \CHANNEL14/REGCC10/mx2_0_y\, \CHANNEL14/new_value_net_2\, 
        \CHANNEL26/REGCC10/mx2_7_y\, \CHANNEL26/new_value_net_6\, 
        \CHANNEL23/REGCC10/mx2_2_y\, \CHANNEL23/new_value_net_8\, 
        \CHANNEL5/REGCC10/mx2_9_y\, \CHANNEL5/new_value_net_4\, 
        \CHANNEL20/REGCC10/mx2_1_y\, \CHANNEL20/new_value_net_1\, 
        \CHANNEL16/REGCC10/mx2_7_y\, \CHANNEL16/new_value_net_6\, 
        \CHANNEL25/REGCC10/mx2_7_y\, \CHANNEL25/new_value_net_6\, 
        \CHANNEL28/REGCC10/mx2_0_y\, \CHANNEL28/new_value_net_2\, 
        \CHANNEL28/REGCC10/mx2_4_y\, \CHANNEL28/new_value_net_7\, 
        \CHANNEL31/REGCC10/mx2_0_y\, \CHANNEL31/new_value_net_2\, 
        \CHANNEL15/REGCC10/mx2_7_y\, \CHANNEL15/new_value_net_6\, 
        \CHANNEL30/REGCC10/mx2_4_y\, \CHANNEL30/new_value_net_7\, 
        \CHANNEL27/REGCC10/mx2_8_y\, \CHANNEL27/new_value_9\, 
        \CHANNEL13/REGCC10/mx2_8_y\, \CHANNEL13/new_value_9\, 
        \CHANNEL22/REGCC10/mx2_7_y\, \CHANNEL22/new_value_net_6\, 
        \CHANNEL29/REGCC10/mx2_5_y\, \CHANNEL29/new_value_net_3\, 
        \CHANNEL19/REGCC10/mx2_5_y\, \CHANNEL19/new_value_net_3\, 
        \CHANNEL18/REGCC10/mx2_0_y\, \CHANNEL18/new_value_net_2\, 
        \CHANNEL17/REGCC10/mx2_3_y\, \CHANNEL17/NEW_VALUE\, 
        \CHANNEL12/REGCC10/mx2_7_y\, \CHANNEL12/new_value_net_6\, 
        \CHANNEL20/REGCC10/mx2_5_y\, \CHANNEL20/new_value_net_3\, 
        \CHANNEL10/REGCC10/mx2_5_y\, \CHANNEL10/new_value_net_3\, 
        \CHANNEL9/REGCC10/mx2_3_y\, \CHANNEL9/NEW_VALUE\, 
        \CHANNEL23/REGCC10/mx2_8_y\, \CHANNEL23/new_value_9\, 
        \CHANNEL21/REGCC10/mx2_9_y\, \CHANNEL21/new_value_net_4\, 
        \CHANNEL14/REGCC10/mx2_4_y\, \CHANNEL14/new_value_net_7\, 
        \CHANNEL0/REGCC10/mx2_2_y\, \CHANNEL0/new_value_net_8\, 
        \CHANNEL13/REGCC10/mx2_3_y\, \CHANNEL13/NEW_VALUE\, 
        \CHANNEL29/REGCC10/mx2_0_y\, \CHANNEL29/new_value_net_2\, 
        \CHANNEL29/REGCC10/mx2_4_y\, \CHANNEL29/new_value_net_7\, 
        \CHANNEL7/REGCC10/mx2_3_y\, \CHANNEL7/NEW_VALUE\, 
        \CHANNEL20/REGCC10/mx2_0_y\, \CHANNEL20/new_value_net_2\, 
        \CHANNEL20/REGCC10/mx2_4_y\, \CHANNEL20/new_value_net_7\, 
        \CHANNEL19/REGCC10/mx2_0_y\, \CHANNEL19/new_value_net_2\, 
        \CHANNEL18/REGCC10/mx2_4_y\, \CHANNEL18/new_value_net_7\, 
        \CHANNEL21/REGCC10/mx2_1_y\, \CHANNEL21/new_value_net_1\, 
        \CHANNEL5/REGCC10/mx2_3_y\, \CHANNEL5/NEW_VALUE\, 
        \CHANNEL10/REGCC10/mx2_0_y\, \CHANNEL10/new_value_net_2\, 
        \CHANNEL0/REGCC10/mx2_4_y\, \CHANNEL0/new_value_net_7\, 
        \CHANNEL3/REGCC10/mx2_2_y\, \CHANNEL3/new_value_net_8\, 
        \CHANNEL31/REGCC10/mx2_4_y\, \CHANNEL31/new_value_net_7\, 
        \CHANNEL14/REGCC10/mx2_6_y\, \CHANNEL14/new_value_net_5\, 
        \CHANNEL17/REGCC10/mx2_1_y\, \CHANNEL17/new_value_net_1\, 
        \CHANNEL6/REGCC10/mx2_1_y\, \CHANNEL6/new_value_net_1\, 
        \CHANNEL26/REGCC10/mx2_6_y\, \CHANNEL26/new_value_net_5\, 
        \CHANNEL25/REGCC10/mx2_6_y\, \CHANNEL25/new_value_net_5\, 
        \CHANNEL4/REGCC10/mx2_1_y\, \CHANNEL4/new_value_net_1\, 
        \CHANNEL21/REGCC10/mx2_5_y\, \CHANNEL21/new_value_net_3\, 
        \CHANNEL11/REGCC10/mx2_5_y\, \CHANNEL11/new_value_net_3\, 
        \CHANNEL17/REGCC10/mx2_9_y\, \CHANNEL17/new_value_net_4\, 
        \CHANNEL18/REGCC10/mx2_6_y\, \CHANNEL18/new_value_net_5\, 
        \CHANNEL19/REGCC10/mx2_4_y\, \CHANNEL19/new_value_net_7\, 
        \CHANNEL22/REGCC10/mx2_6_y\, \CHANNEL22/new_value_net_5\, 
        \CHANNEL13/REGCC10/mx2_1_y\, \CHANNEL13/new_value_net_1\, 
        \CHANNEL1/REGCC10/mx2_9_y\, \CHANNEL1/new_value_net_4\, 
        \CHANNEL3/REGCC10/mx2_4_y\, \CHANNEL3/new_value_net_7\, 
        \CHANNEL10/REGCC10/mx2_4_y\, \CHANNEL10/new_value_net_7\, 
        \CHANNEL21/REGCC10/mx2_0_y\, \CHANNEL21/new_value_net_2\, 
        \CHANNEL13/REGCC10/mx2_9_y\, \CHANNEL13/new_value_net_4\, 
        \CHANNEL21/REGCC10/mx2_4_y\, \CHANNEL21/new_value_net_7\, 
        \CHANNEL9/REGCC10/mx2_5_y\, \CHANNEL9/new_value_net_3\, 
        \CHANNEL17/REGCC10/mx2_2_y\, \CHANNEL17/new_value_net_8\, 
        \CHANNEL8/REGCC10/mx2_1_y\, \CHANNEL8/new_value_net_1\, 
        \CHANNEL11/REGCC10/mx2_0_y\, \CHANNEL11/new_value_net_2\, 
        \CHANNEL19/REGCC10/mx2_6_y\, \CHANNEL19/new_value_net_5\, 
        \CHANNEL2/REGCC10/mx2_1_y\, \CHANNEL2/new_value_net_1\, 
        \CHANNEL7/REGCC10/mx2_5_y\, \CHANNEL7/new_value_net_3\, 
        \CHANNEL26/REGCC10/mx2_3_y\, \CHANNEL26/NEW_VALUE\, 
        \CHANNEL24/REGCC10/mx2_2_y\, \CHANNEL24/new_value_net_8\, 
        \CHANNEL10/REGCC10/mx2_6_y\, \CHANNEL10/new_value_net_5\, 
        \CHANNEL13/REGCC10/mx2_2_y\, \CHANNEL13/new_value_net_8\, 
        \CHANNEL9/REGCC10/mx2_0_y\, \CHANNEL9/new_value_net_2\, 
        \CHANNEL25/REGCC10/mx2_3_y\, \CHANNEL25/NEW_VALUE\, 
        \CHANNEL5/REGCC10/mx2_5_y\, \CHANNEL5/new_value_net_3\, 
        \CHANNEL14/REGCC10/mx2_8_y\, \CHANNEL14/new_value_9\, 
        \CHANNEL22/REGCC10/mx2_3_y\, \CHANNEL22/NEW_VALUE\, 
        \CHANNEL9/REGCC10/mx2_7_y\, \CHANNEL9/new_value_net_6\, 
        \CHANNEL28/REGCC10/mx2_2_y\, \CHANNEL28/new_value_net_8\, 
        \CHANNEL1/REGCC10/mx2_3_y\, \CHANNEL1/NEW_VALUE\, 
        \CHANNEL7/REGCC10/mx2_0_y\, \CHANNEL7/new_value_net_2\, 
        \CHANNEL11/REGCC10/mx2_4_y\, \CHANNEL11/new_value_net_7\, 
        \CHANNEL18/REGCC10/mx2_8_y\, \CHANNEL18/new_value_9\, 
        \CHANNEL24/REGCC10/mx2_8_y\, \CHANNEL24/new_value_9\, 
        \CHANNEL9/REGCC10/mx2_6_y\, \CHANNEL9/new_value_net_5\, 
        \CHANNEL5/REGCC10/mx2_0_y\, \CHANNEL5/new_value_net_2\, 
        \CHANNEL7/REGCC10/mx2_7_y\, \CHANNEL7/new_value_net_6\, 
        \PLL/PLL_INT/REFCLK\, \PLL/VCCZ0\, \PLL/GNDZ0\, 
        \PLL/lock\, \PLL/PLL_clk1p\, PLL_FLOAT_NET1, 
        \CHANNEL14/REGCC10/mx2_3_y\, \CHANNEL14/NEW_VALUE\, 
        \CHANNEL5/REGCC10/mx2_7_y\, \CHANNEL5/new_value_net_6\, 
        \CHANNEL6/REGCC10/mx2_9_y\, \CHANNEL6/new_value_net_4\, 
        \CHANNEL7/REGCC10/mx2_6_y\, \CHANNEL7/new_value_net_5\, 
        \CHANNEL28/REGCC10/mx2_8_y\, \CHANNEL28/new_value_9\, 
        \CHANNEL26/REGCC10/mx2_9_y\, \CHANNEL26/new_value_net_4\, 
        \CHANNEL29/REGCC10/mx2_2_y\, \CHANNEL29/new_value_net_8\, 
        \CHANNEL4/REGCC10/mx2_9_y\, \CHANNEL4/new_value_net_4\, 
        \CHANNEL18/REGCC10/mx2_3_y\, \CHANNEL18/NEW_VALUE\, 
        \CHANNEL11/REGCC10/mx2_6_y\, \CHANNEL11/new_value_net_5\, 
        \CHANNEL25/REGCC10/mx2_9_y\, \CHANNEL25/new_value_net_4\, 
        \CHANNEL5/REGCC10/mx2_6_y\, \CHANNEL5/new_value_net_5\, 
        \CHANNEL20/REGCC10/mx2_2_y\, \CHANNEL20/new_value_net_8\, 
        \CHANNEL27/REGCC10/mx2_7_y\, \CHANNEL27/new_value_net_6\, 
        \CHANNEL19/REGCC10/mx2_8_y\, \CHANNEL19/new_value_9\, 
        \CHANNEL30/REGCC10/mx2_5_y\, \CHANNEL30/new_value_net_3\, 
        \CHANNEL22/REGCC10/mx2_9_y\, \CHANNEL22/new_value_net_4\, 
        \CHANNEL17/REGCC10/mx2_7_y\, \CHANNEL17/new_value_net_6\, 
        \CHANNEL0/REGCC10/mx2_1_y\, \CHANNEL0/new_value_net_1\, 
        \CHANNEL10/REGCC10/mx2_8_y\, \CHANNEL10/new_value_9\, 
        \CHANNEL26/REGCC10/mx2_1_y\, \CHANNEL26/new_value_net_1\, 
        \CHANNEL25/REGCC10/mx2_1_y\, \CHANNEL25/new_value_net_1\, 
        \CHANNEL29/REGCC10/mx2_8_y\, \CHANNEL29/new_value_9\, 
        \CHANNEL23/REGCC10/mx2_7_y\, \CHANNEL23/new_value_net_6\, 
        \CHANNEL8/REGCC10/mx2_9_y\, \CHANNEL8/new_value_net_4\, 
        \CHANNEL14/REGCC10/mx2_1_y\, \CHANNEL14/new_value_net_1\, 
        \CHANNEL13/REGCC10/mx2_7_y\, \CHANNEL13/new_value_net_6\, 
        \CHANNEL19/REGCC10/mx2_3_y\, \CHANNEL19/NEW_VALUE\, 
        \CHANNEL20/REGCC10/mx2_8_y\, \CHANNEL20/new_value_9\, 
        \CHANNEL22/REGCC10/mx2_1_y\, \CHANNEL22/new_value_net_1\, 
        \CHANNEL1/REGCC10/mx2_5_y\, \CHANNEL1/new_value_net_3\, 
        \CHANNEL9/REGCC10/mx2_8_y\, \CHANNEL9/new_value_9\, 
        \CHANNEL26/REGCC10/mx2_5_y\, \CHANNEL26/new_value_net_3\, 
        \CHANNEL16/REGCC10/mx2_5_y\, \CHANNEL16/new_value_net_3\, 
        \CHANNEL10/REGCC10/mx2_3_y\, \CHANNEL10/NEW_VALUE\, 
        \CHANNEL3/REGCC10/mx2_1_y\, \CHANNEL3/new_value_net_1\, 
        \CHANNEL2/REGCC10/mx2_9_y\, \CHANNEL2/new_value_net_4\, 
        \CHANNEL25/REGCC10/mx2_5_y\, \CHANNEL25/new_value_net_3\, 
        \CHANNEL15/REGCC10/mx2_5_y\, \CHANNEL15/new_value_net_3\, 
        \CHANNEL14/REGCC10/mx2_9_y\, \CHANNEL14/new_value_net_4\, 
        \CHANNEL6/REGCC10/mx2_3_y\, \CHANNEL6/NEW_VALUE\, 
        \CHANNEL18/REGCC10/mx2_1_y\, \CHANNEL18/new_value_net_1\, 
        \CHANNEL30/REGCC10/mx2_1_y\, \CHANNEL30/new_value_net_1\, 
        \CHANNEL4/REGCC10/mx2_3_y\, \CHANNEL4/NEW_VALUE\, 
        \CHANNEL22/REGCC10/mx2_5_y\, \CHANNEL22/new_value_net_3\, 
        \CHANNEL12/REGCC10/mx2_5_y\, \CHANNEL12/new_value_net_3\, 
        \CHANNEL7/REGCC10/mx2_8_y\, \CHANNEL7/new_value_9\, 
        \CHANNEL21/REGCC10/mx2_2_y\, \CHANNEL21/new_value_net_8\, 
        \CHANNEL31/REGCC10/mx2_5_y\, \CHANNEL31/new_value_net_3\, 
        \CHANNEL18/REGCC10/mx2_9_y\, \CHANNEL18/new_value_net_4\, 
        \CHANNEL1/REGCC10/mx2_0_y\, \CHANNEL1/new_value_net_2\, 
        \CHANNEL26/REGCC10/mx2_0_y\, \CHANNEL26/new_value_net_2\, 
        \CHANNEL26/REGCC10/mx2_4_y\, \CHANNEL26/new_value_net_7\, 
        \CHANNEL14/REGCC10/mx2_2_y\, \CHANNEL14/new_value_net_8\, 
        \CHANNEL5/REGCC10/mx2_8_y\, \CHANNEL5/new_value_9\, 
        \CHANNEL11/REGCC10/mx2_8_y\, \CHANNEL11/new_value_9\, 
        \CHANNEL25/REGCC10/mx2_0_y\, \CHANNEL25/new_value_net_2\, 
        \CHANNEL25/REGCC10/mx2_4_y\, \CHANNEL25/new_value_net_7\, 
        \CHANNEL16/REGCC10/mx2_0_y\, \CHANNEL16/new_value_net_2\, 
        \CHANNEL1/REGCC10/mx2_7_y\, \CHANNEL1/new_value_net_6\, 
        \CHANNEL27/REGCC10/mx2_6_y\, \CHANNEL27/new_value_net_5\, 
        \CHANNEL15/REGCC10/mx2_0_y\, \CHANNEL15/new_value_net_2\, 
        \CHANNEL22/REGCC10/mx2_0_y\, \CHANNEL22/new_value_net_2\, 
        \CHANNEL22/REGCC10/mx2_4_y\, \CHANNEL22/new_value_net_7\, 
        \CHANNEL19/REGCC10/mx2_1_y\, \CHANNEL19/new_value_net_1\, 
        \CHANNEL8/REGCC10/mx2_3_y\, \CHANNEL8/NEW_VALUE\, 
        \CHANNEL18/REGCC10/mx2_2_y\, \CHANNEL18/new_value_net_8\, 
        \CHANNEL21/REGCC10/mx2_8_y\, enable_net_10, 
        \CHANNEL21/new_value_9\, \CHANNEL10/REGCC10/mx2_1_y\, 
        \CHANNEL10/new_value_net_1\, \CHANNEL30/REGCC10/mx2_6_y\, 
        \CHANNEL30/new_value_net_5\, \CHANNEL12/REGCC10/mx2_0_y\, 
        \CHANNEL12/new_value_net_2\, \CHANNEL1/REGCC10/mx2_6_y\, 
        \CHANNEL1/new_value_net_5\, \CHANNEL11/REGCC10/mx2_3_y\, 
        \CHANNEL11/NEW_VALUE\, \CHANNEL19/REGCC10/mx2_9_y\, 
        \CHANNEL19/new_value_net_4\, \CHANNEL2/REGCC10/mx2_3_y\, 
        \CHANNEL2/NEW_VALUE\, \CHANNEL23/REGCC10/mx2_6_y\, 
        \CHANNEL23/new_value_net_5\, \CHANNEL31/REGCC10/mx2_1_y\, 
        \CHANNEL31/new_value_net_1\, \CHANNEL10/REGCC10/mx2_9_y\, 
        \CHANNEL10/new_value_net_4\, \CHANNEL16/REGCC10/mx2_4_y\, 
        \CHANNEL16/new_value_net_7\, \CHANNEL15/REGCC10/mx2_4_y\, 
        \CHANNEL15/new_value_net_7\, \CHANNEL0/REGCC10/mx2_9_y\, 
        \CHANNEL0/new_value_net_4\, \CHANNEL9/REGCC10/mx2_2_y\, 
        \CHANNEL9/new_value_net_8\, \CHANNEL19/REGCC10/mx2_2_y\, 
        \CHANNEL19/new_value_net_8\, \CHANNEL6/REGCC10/mx2_5_y\, 
        \CHANNEL6/new_value_net_3\, \CHANNEL12/REGCC10/mx2_4_y\, 
        \CHANNEL12/new_value_net_7\, \CHANNEL10/REGCC10/mx2_2_y\, 
        \CHANNEL10/new_value_net_8\, \CHANNEL4/REGCC10/mx2_5_y\, 
        \CHANNEL4/new_value_net_3\, \CHANNEL27/REGCC10/mx2_3_y\, 
        \CHANNEL27/NEW_VALUE\, \CHANNEL7/REGCC10/mx2_2_y\, 
        \CHANNEL7/new_value_net_8\, \CHANNEL16/REGCC10/mx2_6_y\, 
        \CHANNEL16/new_value_net_5\, \CHANNEL11/REGCC10/mx2_1_y\, 
        \CHANNEL11/new_value_net_1\, \CHANNEL31/REGCC10/mx2_6_y\, 
        \CHANNEL31/new_value_net_5\, \CHANNEL3/REGCC10/mx2_9_y\, 
        \CHANNEL3/new_value_net_4\, \CHANNEL6/REGCC10/mx2_0_y\, 
        \CHANNEL6/new_value_net_2\, \CHANNEL9/REGCC10/mx2_4_y\, 
        enable_net_22, \CHANNEL9/new_value_net_7\, 
        \CHANNEL15/REGCC10/mx2_6_y\, \CHANNEL15/new_value_net_5\, 
        \CHANNEL5/REGCC10/mx2_2_y\, \CHANNEL5/new_value_net_8\, 
        \CHANNEL24/REGCC10/mx2_7_y\, \CHANNEL24/new_value_net_6\, 
        \CHANNEL30/REGCC10/mx2_8_y\, \CHANNEL30/new_value_9\, 
        \CHANNEL23/REGCC10/mx2_3_y\, \CHANNEL23/NEW_VALUE\, 
        \CHANNEL4/REGCC10/mx2_0_y\, \CHANNEL4/new_value_net_2\, 
        \CHANNEL14/REGCC10/mx2_7_y\, enable_net_17, 
        \CHANNEL14/new_value_net_6\, \CHANNEL1/REGCC10/mx2_8_y\, 
        \CHANNEL1/new_value_9\, \CHANNEL30/REGCC10/mx2_7_y\, 
        \CHANNEL30/new_value_net_6\, \CHANNEL12/REGCC10/mx2_6_y\, 
        \CHANNEL12/new_value_net_5\, \CHANNEL6/REGCC10/mx2_7_y\, 
        \CHANNEL6/new_value_net_6\, \CHANNEL8/REGCC10/mx2_5_y\, 
        \CHANNEL8/new_value_net_3\, \CHANNEL11/REGCC10/mx2_9_y\, 
        \CHANNEL11/new_value_net_4\, \CHANNEL7/REGCC10/mx2_4_y\, 
        enable_net_24, \CHANNEL7/new_value_net_7\, 
        \CHANNEL4/REGCC10/mx2_7_y\, \CHANNEL4/new_value_net_6\, 
        \CHANNEL28/REGCC10/mx2_7_y\, \CHANNEL28/new_value_net_6\, 
        \CHANNEL0/REGCC10/mx2_3_y\, \CHANNEL0/NEW_VALUE\, 
        \CHANNEL6/REGCC10/mx2_6_y\, \CHANNEL6/new_value_net_5\, 
        \CHANNEL18/REGCC10/mx2_7_y\, enable_net_13, 
        \CHANNEL18/new_value_net_6\, \CHANNEL2/REGCC10/mx2_5_y\, 
        \CHANNEL2/new_value_net_3\, \CHANNEL5/REGCC10/mx2_4_y\, 
        enable_net_26, \CHANNEL5/new_value_net_7\, 
        \CHANNEL4/REGCC10/mx2_6_y\, \CHANNEL4/new_value_net_5\, 
        \CHANNEL27/REGCC10/mx2_9_y\, \CHANNEL27/new_value_net_4\, 
        \CHANNEL8/REGCC10/mx2_0_y\, \CHANNEL8/new_value_net_2\, 
        \CHANNEL11/REGCC10/mx2_2_y\, enable_net_20, 
        \CHANNEL11/new_value_net_8\, \CHANNEL8/REGCC10/mx2_7_y\, 
        \CHANNEL8/new_value_net_6\, \CHANNEL2/REGCC10/mx2_0_y\, 
        \CHANNEL2/new_value_net_2\, \CHANNEL3/REGCC10/mx2_3_y\, 
        enable_net_28, \CHANNEL3/NEW_VALUE\, 
        \CHANNEL30/REGCC10/mx2_2_y\, enable_net_1, 
        \CHANNEL30/new_value_net_8\, \CHANNEL26/REGCC10/mx2_2_y\, 
        \CHANNEL26/new_value_net_8\, \CHANNEL29/REGCC10/mx2_7_y\, 
        enable_net_2, \CHANNEL29/new_value_net_6\, 
        \CHANNEL23/REGCC10/mx2_9_y\, \CHANNEL23/new_value_net_4\, 
        \CHANNEL31/REGCC10/mx2_8_y\, \CHANNEL31/new_value_9\, 
        \CHANNEL25/REGCC10/mx2_2_y\, \CHANNEL25/new_value_net_8\, 
        \CHANNEL19/REGCC10/mx2_7_y\, enable_net_12, 
        \CHANNEL19/new_value_net_6\, \CHANNEL27/REGCC10/mx2_1_y\, 
        \CHANNEL27/new_value_net_1\, \CHANNEL2/REGCC10/mx2_7_y\, 
        \CHANNEL2/new_value_net_6\, \CHANNEL8/REGCC10/mx2_6_y\, 
        enable_net_23, \CHANNEL8/new_value_net_5\, 
        \CHANNEL20/REGCC10/mx2_7_y\, enable_net_11, 
        \CHANNEL20/new_value_net_6\, \CHANNEL31/REGCC10/mx2_7_y\, 
        ENABLE, \CHANNEL31/new_value_net_6\, 
        \CHANNEL16/REGCC10/mx2_8_y\, \CHANNEL16/new_value_9\, 
        \CHANNEL10/REGCC10/mx2_7_y\, enable_net_21, 
        \CHANNEL10/new_value_net_6\, \CHANNEL22/REGCC10/mx2_2_y\, 
        \CHANNEL22/new_value_net_8\, \CHANNEL15/REGCC10/mx2_8_y\, 
        \CHANNEL15/new_value_9\, \CHANNEL24/REGCC10/mx2_6_y\, 
        enable_net_7, \CHANNEL24/new_value_net_5\, 
        \CHANNEL2/REGCC10/mx2_6_y\, enable_net_29, 
        \CHANNEL2/new_value_net_5\, \CHANNEL23/REGCC10/mx2_1_y\, 
        \CHANNEL23/new_value_net_1\, \CHANNEL27/REGCC10/mx2_5_y\, 
        enable_net_4, \CHANNEL27/new_value_net_3\, 
        \CHANNEL17/REGCC10/mx2_5_y\, enable_net_14, 
        \CHANNEL17/new_value_net_3\, \CHANNEL12/REGCC10/mx2_8_y\, 
        enable_net_19, \CHANNEL12/new_value_9\, 
        \CHANNEL26/REGCC10/mx2_8_y\, enable_net_5, 
        \CHANNEL26/new_value_9\, \CHANNEL1/REGCC10/mx2_2_y\, 
        enable_net_30, \CHANNEL1/new_value_net_8\, 
        \CHANNEL25/REGCC10/mx2_8_y\, enable_net_6, 
        \CHANNEL25/new_value_9\, \CHANNEL16/REGCC10/mx2_3_y\, 
        enable_net_15, \CHANNEL16/NEW_VALUE\, 
        \CHANNEL6/REGCC10/mx2_8_y\, enable_net_25, 
        \CHANNEL6/new_value_9\, \CHANNEL28/REGCC10/mx2_6_y\, 
        enable_net_3, \CHANNEL28/new_value_net_5\, 
        \CHANNEL15/REGCC10/mx2_3_y\, enable_net_16, 
        \CHANNEL15/NEW_VALUE\, \CHANNEL4/REGCC10/mx2_8_y\, 
        enable_net_27, \CHANNEL4/new_value_9\, 
        \CHANNEL0/REGCC10/mx2_5_y\, enable_net_31, 
        \CHANNEL0/new_value_net_3\, \CHANNEL22/REGCC10/mx2_8_y\, 
        enable_net_9, \CHANNEL22/new_value_9\, 
        \CHANNEL23/REGCC10/mx2_5_y\, enable_net_8, 
        \CHANNEL23/new_value_net_3\, \CHANNEL13/REGCC10/mx2_5_y\, 
        enable_net_18, CLRZ0, \CHANNEL13/new_value_net_3\, 
        AFLSDF_GND, AFLSDF_VCC : std_logic;
    signal GND_power_net1 : std_logic;
    signal VCC_power_net1 : std_logic;

begin 

    \CHANNEL4/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL13/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL6/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL19/REGFF/GNDZ0\ <= GND_power_net1;
    AFLSDF_GND <= GND_power_net1;
    \CHANNEL28/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL31/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL27/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL5/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL18/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL21/REGFF/GNDZ0\ <= GND_power_net1;
    \GND\ <= GND_power_net1;
    \CHANNEL17/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL26/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL24/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL3/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL11/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL16/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL30/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL14/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL9/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL22/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL7/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL20/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL8/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL12/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL25/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL10/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL2/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL15/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL1/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL0/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL23/REGFF/GNDZ0\ <= GND_power_net1;
    \CHANNEL29/REGFF/GNDZ0\ <= GND_power_net1;
    \PLL/GNDZ0\ <= GND_power_net1;
    \VCC\ <= VCC_power_net1;
    AFLSDF_VCC <= VCC_power_net1;
    \PLL/VCCZ0\ <= VCC_power_net1;

    \OUTBUF32_OUTBUF_5_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_5_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_5_inst/U0/NET2\, PAD => DATA_OUTPUT(5));
    
    \OUTBUF32_OUTBUF_26_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_26_inst/U0/NET2\);
    
    \CHANNEL16/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg5\);
    
    \CHANNEL3/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg3\);
    
    \CHANNEL14/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg5\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_2\);
    
    \CHANNEL19/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/GNDZ0\, B => 
        \CHANNEL19/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_3\, Q => \CHANNEL19/REGFF/reg0\);
    
    \CHANNEL27/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_2\, Y => 
        \CHANNEL27/REGFF/data_net_2\);
    
    \CHANNEL20/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL20/REGCC10/mx2_3_y\);
    
    \CHANNEL2/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg5\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/NEW_VALUE\);
    
    \CHANNEL0/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg0\, B => 
        \CHANNEL0/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_3\, Q => \CHANNEL0/REGFF/reg1\);
    
    \OUTBUF32_OUTBUF_18_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_18_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_18_inst/U0/NET1\);
    
    \CHANNEL28/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_1\, Y => 
        \CHANNEL28/REGFF/data_net_1\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_7\);
    
    \CHANNEL28/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg4\);
    
    \CHANNEL0/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg4\);
    
    \CHANNEL7/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_8\, Y => 
        \CHANNEL7/REGFF/data_net_8\);
    
    \CHANNEL1/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_9\, Y => 
        \CHANNEL1/REGFF/data_9\);
    
    \CHANNEL0/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL0/REGCC10/mx2_3_y\);
    
    \CHANNEL22/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg2\);
    
    \CHANNEL3/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL3/REGCC10/mx2_8_y\);
    
    \CHANNEL17/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg7\);
    
    \CHANNEL23/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg1\);
    
    \NEW_VALUE_B_INBUF_8_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(8), Y => 
        \NEW_VALUE_B_INBUF_8_inst/U0/NET1\);
    
    \CHANNEL14/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg4\);
    
    \CHANNEL10/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg2\, B => 
        \CHANNEL10/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_2\, Q => \CHANNEL10/REGFF/reg3\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_8\);
    
    \ENABLE_INBUF_27_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_27_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_27_inst/U0/NET2\);
    
    NEW_VALUE_A_INBUF_3_inst_0 : BUFF
      port map(A => dat_a_net_5, Y => dat_a_net_5_0);
    
    \CHANNEL17/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg3\);
    
    \OUTBUF32_OUTBUF_0_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_30, Y => 
        \OUTBUF32_OUTBUF_0_inst/U0/NET3\);
    
    \CHANNEL14/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg9\);
    
    \CHANNEL21/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg6\);
    
    \NEW_VALUE_A_INBUF_3_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_3_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_3_inst/U0/NET2\);
    
    \CHANNEL28/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/GNDZ0\, B => 
        \CHANNEL28/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_3\, Q => \CHANNEL28/REGFF/reg0\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/NEW_VALUE\);
    
    \CHANNEL19/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL19/REGCC10/mx2_3_y\);
    
    \CHANNEL8/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/load_net_3\);
    
    \CHANNEL17/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_0_y\);
    
    \CHANNEL26/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_6_y\);
    
    \CHANNEL31/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg5\, B => 
        \CHANNEL31/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL31/LOAD\, Q
         => \CHANNEL31/REGFF/reg6\);
    
    \CHANNEL22/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/load_net_2\);
    
    \CHANNEL14/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg6\);
    
    \OUTBUF32_OUTBUF_9_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_21, Y => 
        \OUTBUF32_OUTBUF_9_inst/U0/NET3\);
    
    \OUTBUF32_OUTBUF_31_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_31_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_31_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_23_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_23_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_23_inst/U0/NET2\, PAD => DATA_OUTPUT(23));
    
    \CHANNEL30/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_8\, Y => 
        \CHANNEL30/REGFF/data_net_8\);
    
    \CHANNEL26/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_5\, Y => 
        \CHANNEL26/REGFF/data_net_5\);
    
    \CHANNEL23/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_9_y\);
    
    \CHANNEL29/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_6_y\);
    
    \NEW_VALUE_A_INBUF_9_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_9_inst/U0/NET2\, Y => 
        dat_a_9);
    
    \CHANNEL22/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg5\);
    
    \CHANNEL0/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg1\, B => 
        \CHANNEL0/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_2\, Q => \CHANNEL0/REGFF/reg2\);
    
    \OUTBUF32_OUTBUF_6_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_6_inst/U0/NET2\);
    
    \CHANNEL29/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_3\, Y => 
        \CHANNEL29/REGFF/data_net_3\);
    
    \CHANNEL7/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL7/NEW_VALUE\, Y => 
        \CHANNEL7/REGFF/DATA\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_2\);
    
    \CHANNEL0/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg9\);
    
    \CHANNEL5/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_5\, Y => 
        \CHANNEL5/REGFF/data_net_5\);
    
    \CHANNEL25/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_5\, Y => 
        \CHANNEL25/REGFF/data_net_5\);
    
    \CHANNEL30/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/load_net_3\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_7\);
    
    \ENABLE_INBUF_20_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_20_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_20_inst/U0/NET2\);
    
    \CHANNEL30/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_7\, Y => 
        \CHANNEL30/REGFF/data_net_7\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_6\);
    
    \CHANNEL29/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg1\, B => 
        \CHANNEL29/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_2\, Q => \CHANNEL29/REGFF/reg2\);
    
    \OUTBUF32_OUTBUF_21_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_21_inst/U0/NET2\);
    
    \CHANNEL20/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg4\);
    
    \CHANNEL15/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_8_y\);
    
    \CHANNEL29/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg7\, B => 
        \CHANNEL29/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL29/load_4\, Q => 
        \CHANNEL29/REGFF/reg8\);
    
    \CHANNEL27/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg4\);
    
    \CHANNEL21/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_7\, Y => 
        \CHANNEL21/REGFF/data_net_7\);
    
    \CHANNEL14/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg3\);
    
    \CHANNEL7/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_2_y\);
    
    \CHANNEL0/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_4\, Y => 
        \CHANNEL0/REGFF/data_net_4\);
    
    \CHANNEL23/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg0\);
    
    \OUTBUF32_OUTBUF_15_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_15_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_15_inst/U0/NET1\);
    
    \CHANNEL26/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg6\, B => 
        \CHANNEL26/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL26/LOAD\, Q
         => \CHANNEL26/REGFF/reg7\);
    
    \CHANNEL10/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg1\);
    
    \OUTBUF32_OUTBUF_24_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_24_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_24_inst/U0/NET2\, PAD => DATA_OUTPUT(24));
    
    \CHANNEL1/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/load_net_1\);
    
    \CHANNEL11/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg6\, B => 
        \CHANNEL11/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL11/LOAD\, Q
         => \CHANNEL11/REGFF/reg7\);
    
    \CHANNEL22/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_2\, Y => 
        \CHANNEL22/REGFF/data_net_2\);
    
    \CHANNEL25/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL25/NEW_VALUE\, Y => 
        \CHANNEL25/REGFF/DATA\);
    
    \CHANNEL18/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg4\, B => 
        \CHANNEL18/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_1\, Q => \CHANNEL18/REGFF/reg5\);
    
    \CHANNEL27/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_6_y\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_6\);
    
    \CHANNEL12/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_5\, Y => 
        \CHANNEL12/REGFF/data_net_5\);
    
    \CHANNEL24/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_4_y\);
    
    \CHANNEL8/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg7\, B => 
        \CHANNEL8/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL8/load_4\, Q => 
        \CHANNEL8/REGFF/reg8\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_2\);
    
    \CHANNEL27/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg0\);
    
    \CHANNEL23/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg3\, B => 
        \CHANNEL23/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_1\, Q => \CHANNEL23/REGFF/reg4\);
    
    \CHANNEL2/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg6\, B => 
        \CHANNEL2/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL2/LOAD\, Q
         => \CHANNEL2/REGFF/reg7\);
    
    \CHANNEL19/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg4\, B => 
        \CHANNEL19/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_1\, Q => \CHANNEL19/REGFF/reg5\);
    
    \CHANNEL31/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg7\);
    
    \CHANNEL16/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_7\, Y => 
        \CHANNEL16/REGFF/data_net_7\);
    
    \CHANNEL27/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/GNDZ0\, B => 
        \CHANNEL27/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_3\, Q => \CHANNEL27/REGFF/reg0\);
    
    \CHANNEL26/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL26/NEW_VALUE\, Y => 
        \CHANNEL26/REGFF/DATA\);
    
    \CHANNEL3/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_6\, Y => 
        \CHANNEL3/REGFF/data_net_6\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_2\);
    
    \CHANNEL4/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_9\, Y => 
        \CHANNEL4/REGFF/data_9\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_5\);
    
    \CHANNEL3/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL3/NEW_VALUE\, Y => 
        \CHANNEL3/REGFF/DATA\);
    
    \CHANNEL26/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg0\);
    
    \CHANNEL13/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_1\, Y => 
        \CHANNEL13/REGFF/data_net_1\);
    
    \CHANNEL16/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg2\, B => 
        \CHANNEL16/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_2\, Q => \CHANNEL16/REGFF/reg3\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_7\);
    
    \CHANNEL10/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/load_net_1\);
    
    \CHANNEL2/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg9\);
    
    \CHANNEL10/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg8\, B => 
        \CHANNEL10/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL10/load_4\, Q => 
        dout_net_20);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_3\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_9\);
    
    \CHANNEL27/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_9\, Y => 
        \CHANNEL27/REGFF/data_9\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/NEW_VALUE\);
    
    \CHANNEL27/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_5_y\);
    
    \ENABLE_INBUF_8_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_8_inst/U0/NET2\, Y => 
        enable_net_23);
    
    \CHANNEL9/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg1\);
    
    \CHANNEL23/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_6_y\);
    
    \CHANNEL7/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg5\, B => 
        \CHANNEL7/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL7/LOAD\, Q
         => \CHANNEL7/REGFF/reg6\);
    
    \CHANNEL11/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_5_y\);
    
    \CHANNEL30/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg6\);
    
    \CHANNEL19/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg3\);
    
    \CHANNEL5/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL5/NEW_VALUE\, Y => 
        \CHANNEL5/REGFF/DATA\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_1\);
    
    \CHANNEL8/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg3\);
    
    \CHANNEL12/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_4\, Y => 
        \CHANNEL12/REGFF/data_net_4\);
    
    \CHANNEL0/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_0_y\);
    
    \CHANNEL30/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/load_net_2\);
    
    \CHANNEL2/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/load_net_1\);
    
    \NEW_VALUE_A_INBUF_4_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_4_inst/U0/NET2\, Y => 
        dat_a_net_4);
    
    \ENABLE_INBUF_13_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(13), Y => \ENABLE_INBUF_13_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_4_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_26, Y => 
        \OUTBUF32_OUTBUF_4_inst/U0/NET3\);
    
    \CHANNEL23/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_2_y\);
    
    \CHANNEL2/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_6_y\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_5\);
    
    \CHANNEL13/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/reg8_b\);
    
    \CHANNEL11/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_2\, Y => 
        \CHANNEL11/REGFF/data_net_2\);
    
    \CHANNEL1/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg6\, B => 
        \CHANNEL1/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL1/LOAD\, Q
         => \CHANNEL1/REGFF/reg7\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_6\);
    
    \CHANNEL21/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_9_y\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_2\);
    
    \CHANNEL28/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/load_net_1\);
    
    \CHANNEL13/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_7_y\);
    
    \CHANNEL3/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg1\);
    
    \ENABLE_INBUF_17_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_17_inst/U0/NET2\, Y => 
        enable_net_14);
    
    \CHANNEL16/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_7_y\);
    
    \CHANNEL22/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg7\, B => 
        \CHANNEL22/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL22/load_4\, Q => 
        \CHANNEL22/REGFF/reg8\);
    
    \CHANNEL31/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg1\, B => 
        \CHANNEL31/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_2\, Q => \CHANNEL31/REGFF/reg2\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_1\);
    
    \OUTBUF32_OUTBUF_19_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_19_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_19_inst/U0/NET1\);
    
    \CHANNEL26/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/reg8_a\);
    
    \CHANNEL26/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_8_y\);
    
    \CHANNEL11/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/load_net_3\);
    
    \CHANNEL6/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg9\);
    
    \OUTBUF32_OUTBUF_3_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_3_inst/U0/NET2\);
    
    \CHANNEL30/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg5\);
    
    \CHANNEL12/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg1\);
    
    \CHANNEL0/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_9\, Y => 
        \CHANNEL0/REGFF/data_9\);
    
    \CHANNEL28/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg8\, B => 
        \CHANNEL28/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL28/load_4\, Q => 
        dout_net_2);
    
    \CHANNEL13/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_5_y\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_4\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_9\);
    
    \CHANNEL6/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_6_y\);
    
    \CHANNEL14/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg7\, B => 
        \CHANNEL14/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL14/load_4\, Q => 
        \CHANNEL14/REGFF/reg8\);
    
    \CHANNEL10/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg5\);
    
    \CHANNEL9/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL9/NEW_VALUE\, Y => 
        \CHANNEL9/REGFF/DATA\);
    
    \CHANNEL12/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg0\);
    
    \CHANNEL12/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_6\, Y => 
        \CHANNEL12/REGFF/data_net_6\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_1\);
    
    \CHANNEL26/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg4\, B => 
        \CHANNEL26/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_1\, Q => \CHANNEL26/REGFF/reg5\);
    
    \ENABLE_INBUF_10_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_10_inst/U0/NET2\, Y => 
        enable_net_21);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/NEW_VALUE\);
    
    \CHANNEL29/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg4\);
    
    \CHANNEL5/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg7\);
    
    \CHANNEL4/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg6\);
    
    \CHANNEL19/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg6\, B => 
        \CHANNEL19/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL19/LOAD\, Q
         => \CHANNEL19/REGFF/reg7\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_1\);
    
    \CHANNEL21/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/GNDZ0\, B => 
        \CHANNEL21/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_3\, Q => \CHANNEL21/REGFF/reg0\);
    
    \NEW_VALUE_A_INBUF_3_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(3), Y => 
        \NEW_VALUE_A_INBUF_3_inst/U0/NET1\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_5\);
    
    \CHANNEL14/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_5_y\);
    
    \CHANNEL11/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg3\);
    
    \CHANNEL21/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg9\);
    
    \NEW_VALUE_A_INBUF_6_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_6_inst/U0/NET2\, Y => 
        dat_a_net_2);
    
    \CHANNEL29/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg0\, B => 
        \CHANNEL29/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_3\, Q => \CHANNEL29/REGFF/reg1\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_7\);
    
    \CHANNEL22/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg6\);
    
    \CHANNEL6/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg5\, B => 
        \CHANNEL6/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL6/LOAD\, Q
         => \CHANNEL6/REGFF/reg6\);
    
    \CHANNEL1/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg4\, B => 
        \CHANNEL1/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_1\, Q => \CHANNEL1/REGFF/reg5\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_2\);
    
    \CHANNEL27/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg1\);
    
    \CHANNEL31/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_8_y\);
    
    \CHANNEL23/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL23/NEW_VALUE\, Y => 
        \CHANNEL23/REGFF/DATA\);
    
    \CHANNEL9/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg3\);
    
    \CHANNEL1/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg4\);
    
    \CHANNEL3/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_1\, Y => 
        \CHANNEL3/REGFF/data_net_1\);
    
    \CHANNEL17/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_4\, Y => 
        \CHANNEL17/REGFF/data_net_4\);
    
    \CHANNEL1/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg8\, B => 
        \CHANNEL1/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL1/load_4\, Q => 
        dout_net_29);
    
    \CHANNEL23/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL23/LOAD\);
    
    \CHANNEL17/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_7\, Y => 
        \CHANNEL17/REGFF/data_net_7\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_1\);
    
    \ENABLE_INBUF_1_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_1_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_1_inst/U0/NET2\);
    
    \CHANNEL15/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg9\);
    
    \OUTBUF32_OUTBUF_1_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_1_inst/U0/NET2\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_4\);
    
    \CHANNEL8/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg3\, B => 
        \CHANNEL8/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_1\, Q => \CHANNEL8/REGFF/reg4\);
    
    \CHANNEL25/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg2\);
    
    \CHANNEL21/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL21/load_4\);
    
    \OUTBUF32_OUTBUF_28_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_2, Y => 
        \OUTBUF32_OUTBUF_28_inst/U0/NET3\);
    
    \CHANNEL12/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_1_y\);
    
    \CHANNEL8/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_2\, Y => 
        \CHANNEL8/REGFF/data_net_2\);
    
    \CHANNEL10/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg4\);
    
    \CHANNEL23/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL23/load_4\);
    
    \CHANNEL17/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg4\);
    
    \CHANNEL17/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_9_y\);
    
    \CHANNEL10/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_2_y\);
    
    \OUTBUF32_OUTBUF_5_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_25, Y => 
        \OUTBUF32_OUTBUF_5_inst/U0/NET3\);
    
    \CHANNEL0/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg0\);
    
    \CHANNEL21/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg3\);
    
    \CHANNEL30/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg7\);
    
    \CHANNEL7/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg4\, B => 
        \CHANNEL7/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_1\, Q => \CHANNEL7/REGFF/reg5\);
    
    \CHANNEL2/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/load_net_3\);
    
    \CHANNEL30/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg3\);
    
    \CHANNEL24/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg0\);
    
    \CHANNEL0/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg6\);
    
    \ENABLE_INBUF_27_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(27), Y => \ENABLE_INBUF_27_inst/U0/NET1\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_4\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_1\);
    
    \CHANNEL30/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/GNDZ0\, B => 
        \CHANNEL30/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_3\, Q => \CHANNEL30/REGFF/reg0\);
    
    \CHANNEL29/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_2_y\);
    
    \CHANNEL23/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg4\, B => 
        \CHANNEL23/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_1\, Q => \CHANNEL23/REGFF/reg5\);
    
    \NEW_VALUE_A_INBUF_5_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_5_inst/U0/NET2\, Y => 
        dat_a_net_3);
    
    \CHANNEL18/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg4\);
    
    \CHANNEL0/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_2_y\);
    
    \CHANNEL12/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg2\);
    
    \CHANNEL24/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg5\, B => 
        \CHANNEL24/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL24/LOAD\, Q
         => \CHANNEL24/REGFF/reg6\);
    
    \CHANNEL13/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg1\);
    
    \CHANNEL24/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg8\, B => 
        \CHANNEL24/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL24/load_4\, Q => 
        dout_net_6);
    
    \CHANNEL27/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg3\, B => 
        \CHANNEL27/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_1\, Q => \CHANNEL27/REGFF/reg4\);
    
    \CHANNEL10/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_9_y\);
    
    \CHANNEL5/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg8\, B => 
        \CHANNEL5/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL5/load_4\, Q => 
        dout_net_25);
    
    \CHANNEL4/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_3\, Y => 
        \CHANNEL4/REGFF/data_net_3\);
    
    \CHANNEL11/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg6\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_6\);
    
    \NEW_VALUE_A_INBUF_1_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_1_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_1_inst/U0/NET2\);
    
    \ENABLE_INBUF_6_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(6), Y => \ENABLE_INBUF_6_inst/U0/NET1\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/NEW_VALUE\);
    
    \CHANNEL28/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_3_y\);
    
    \CHANNEL19/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_9\, Y => 
        \CHANNEL19/REGFF/data_9\);
    
    \CHANNEL29/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg5\);
    
    \OUTBUF32_OUTBUF_6_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_6_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_6_inst/U0/NET1\);
    
    \CHANNEL13/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/load_net_3\);
    
    \CHANNEL6/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg4\);
    
    \CHANNEL26/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_2_y\);
    
    \CHANNEL18/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg5\, B => 
        \CHANNEL18/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL18/LOAD\, Q
         => \CHANNEL18/REGFF/reg6\);
    
    \OUTBUF32_OUTBUF_27_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_27_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_27_inst/U0/NET1\);
    
    \CHANNEL14/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_3_y\);
    
    \CHANNEL1/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg7\);
    
    \CHANNEL0/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg2\, B => 
        \CHANNEL0/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_2\, Q => \CHANNEL0/REGFF/reg3\);
    
    \CHANNEL22/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg7\);
    
    \CHANNEL11/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_3\, Y => 
        \CHANNEL11/REGFF/data_net_3\);
    
    \CHANNEL12/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg5\);
    
    \ENABLE_INBUF_20_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(20), Y => \ENABLE_INBUF_20_inst/U0/NET1\);
    
    \CHANNEL5/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg9\);
    
    \CHANNEL24/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg2\, B => 
        \CHANNEL24/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_2\, Q => \CHANNEL24/REGFF/reg3\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_8\);
    
    \CHANNEL28/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_0_y\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_4\);
    
    \CHANNEL2/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_7_y\);
    
    \OUTBUF32_OUTBUF_25_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_5, Y => 
        \OUTBUF32_OUTBUF_25_inst/U0/NET3\);
    
    \CHANNEL10/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_9\, Y => 
        \CHANNEL10/REGFF/data_9\);
    
    \CHANNEL5/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg6\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_7\);
    
    \CHANNEL10/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg4\);
    
    \CHANNEL24/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_9\, Y => 
        \CHANNEL24/REGFF/data_9\);
    
    \CHANNEL20/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_5\, Y => 
        \CHANNEL20/REGFF/data_net_5\);
    
    \CHANNEL21/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg5\);
    
    \CHANNEL17/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg4\);
    
    \CHANNEL27/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_2_y\);
    
    \CHANNEL13/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg0\);
    
    \CHANNEL9/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg1\);
    
    \CHANNEL23/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg1\, B => 
        \CHANNEL23/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_2\, Q => \CHANNEL23/REGFF/reg2\);
    
    \OUTBUF32_OUTBUF_7_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_7_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_7_inst/U0/NET2\, PAD => DATA_OUTPUT(7));
    
    \CHANNEL25/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_2_y\);
    
    \CHANNEL29/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg3\, B => 
        \CHANNEL29/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_1\, Q => \CHANNEL29/REGFF/reg4\);
    
    \CHANNEL16/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/load_net_1\);
    
    \CHANNEL8/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_1_y\);
    
    \CHANNEL17/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_7_y\);
    
    \CHANNEL22/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg3\);
    
    \CHANNEL0/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/load_net_2\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_8\);
    
    \CHANNEL17/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg0\);
    
    \CHANNEL0/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg2\);
    
    \CHANNEL8/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg3\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_5\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_8\);
    
    \CHANNEL13/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_4\, Y => 
        \CHANNEL13/REGFF/data_net_4\);
    
    \CHANNEL30/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/reg8_a\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_4\);
    
    \CHANNEL20/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL20/LOAD\);
    
    \CHANNEL0/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg6\, B => 
        \CHANNEL0/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL0/LOAD\, Q
         => \CHANNEL0/REGFF/reg7\);
    
    \CHANNEL8/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_7\, Y => 
        \CHANNEL8/REGFF/data_net_7\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/NEW_VALUE\);
    
    NEW_VALUE_B_INBUF_4_inst_0 : BUFF
      port map(A => dat_b_net_4, Y => dat_b_net_4_0);
    
    \CHANNEL22/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_1\, Y => 
        \CHANNEL22/REGFF/data_net_1\);
    
    \CHANNEL28/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg6\);
    
    \CHANNEL2/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg0\);
    
    \CHANNEL31/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg2\);
    
    \CHANNEL31/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/reg8_a\);
    
    \CHANNEL16/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg0\);
    
    \CHANNEL8/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_4_y\);
    
    \CHANNEL29/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg2\);
    
    \CHANNEL30/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_6_y\);
    
    \CHANNEL29/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/reg8_a\);
    
    \CHANNEL28/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg2\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_5\);
    
    \CHANNEL2/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg1\, B => 
        \CHANNEL2/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_2\, Q => \CHANNEL2/REGFF/reg2\);
    
    \CHANNEL21/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_6_y\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_8\);
    
    \CHANNEL12/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg0\, B => 
        \CHANNEL12/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_3\, Q => \CHANNEL12/REGFF/reg1\);
    
    \CHANNEL4/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/load_net_1\);
    
    NEW_VALUE_B_INBUF_8_inst_0 : BUFF
      port map(A => DAT_B, Y => DAT_B_0);
    
    \CHANNEL22/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg5\);
    
    \CHANNEL15/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_2\, Y => 
        \CHANNEL15/REGFF/data_net_2\);
    
    \CHANNEL21/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg0\, B => 
        \CHANNEL21/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_3\, Q => \CHANNEL21/REGFF/reg1\);
    
    \CHANNEL25/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/load_net_3\);
    
    \CHANNEL1/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_7\, Y => 
        \CHANNEL1/REGFF/data_net_7\);
    
    \CHANNEL24/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg4\, B => 
        \CHANNEL24/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_1\, Q => \CHANNEL24/REGFF/reg5\);
    
    \CHANNEL20/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_3\, Y => 
        \CHANNEL20/REGFF/data_net_3\);
    
    \CHANNEL24/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_2\, Y => 
        \CHANNEL24/REGFF/data_net_2\);
    
    \CHANNEL0/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg0\);
    
    \CHANNEL9/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg2\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/NEW_VALUE\);
    
    \CHANNEL9/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg3\, B => 
        \CHANNEL9/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_1\, Q => \CHANNEL9/REGFF/reg4\);
    
    \CHANNEL15/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_0_y\);
    
    \CHANNEL21/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL21/LOAD\);
    
    \CHANNEL9/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/reg8_a\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_5\);
    
    \CHANNEL7/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_1_y\);
    
    \CHANNEL29/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_1_y\);
    
    \CHANNEL15/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/load_net_1\);
    
    \CHANNEL22/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg5\, B => 
        \CHANNEL22/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL22/LOAD\, Q
         => \CHANNEL22/REGFF/reg6\);
    
    \CHANNEL26/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg9\);
    
    \CHANNEL26/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg1\);
    
    \CHANNEL8/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/load_net_2\);
    
    \OUTBUF32_OUTBUF_29_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_1, Y => 
        \OUTBUF32_OUTBUF_29_inst/U0/NET3\);
    
    \OUTBUF32_OUTBUF_17_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_13, Y => 
        \OUTBUF32_OUTBUF_17_inst/U0/NET3\);
    
    \OUTBUF32_OUTBUF_3_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_3_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_3_inst/U0/NET1\);
    
    \ENABLE_INBUF_2_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_2_inst/U0/NET2\, Y => 
        enable_net_29);
    
    \CHANNEL23/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg5\);
    
    \CHANNEL7/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/reg8_b\);
    
    \CHANNEL12/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_8\, Y => 
        \CHANNEL12/REGFF/data_net_8\);
    
    \CHANNEL27/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL27/LOAD\);
    
    \OUTBUF32_OUTBUF_13_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_13_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_13_inst/U0/NET1\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_8\);
    
    \CHANNEL16/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/reg8_a\);
    
    \CHANNEL18/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_8\, Y => 
        \CHANNEL18/REGFF/data_net_8\);
    
    \CHANNEL14/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_8\, Y => 
        \CHANNEL14/REGFF/data_net_8\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_4\);
    
    \CHANNEL3/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/load_net_3\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_4\);
    
    \CHANNEL25/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_8\, Y => 
        \CHANNEL25/REGFF/data_net_8\);
    
    \CHANNEL20/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL20/NEW_VALUE\, Y => 
        \CHANNEL20/REGFF/DATA\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_7\);
    
    \ENABLE_INBUF_22_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_22_inst/U0/NET2\, Y => 
        enable_net_9);
    
    \CHANNEL31/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg6\);
    
    \CHANNEL18/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_7_y\);
    
    \CHANNEL25/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg5\);
    
    \CHANNEL12/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/load_net_2\);
    
    NEW_VALUE_A_INBUF_6_inst_0 : BUFF
      port map(A => dat_a_net_2, Y => dat_a_net_2_0);
    
    \CHANNEL5/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/reg8_a\);
    
    \CHANNEL12/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_4_y\);
    
    \CHANNEL27/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL27/NEW_VALUE\, Y => 
        \CHANNEL27/REGFF/DATA\);
    
    \CHANNEL19/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg4\);
    
    \CHANNEL9/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg2\);
    
    \CHANNEL28/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/reg8_b\);
    
    \CHANNEL11/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_5\, Y => 
        \CHANNEL11/REGFF/data_net_5\);
    
    \OUTBUF32_OUTBUF_14_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_14_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_14_inst/U0/NET1\);
    
    \CHANNEL14/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_1\, Y => 
        \CHANNEL14/REGFF/data_net_1\);
    
    \CHANNEL1/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/reg8_b\);
    
    \CHANNEL29/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/reg8_b\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_1\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_5\);
    
    \CHANNEL30/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_1_y\);
    
    \NEW_VALUE_A_INBUF_1_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(1), Y => 
        \NEW_VALUE_A_INBUF_1_inst/U0/NET1\);
    
    \CHANNEL5/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg4\);
    
    \CHANNEL26/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_1_y\);
    
    \CHANNEL11/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg9\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_7\);
    
    \CHANNEL24/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg4\);
    
    \CHANNEL4/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg6\, B => 
        \CHANNEL4/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL4/LOAD\, Q
         => \CHANNEL4/REGFF/reg7\);
    
    \CHANNEL12/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg6\);
    
    \CHANNEL15/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg5\, B => 
        \CHANNEL15/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL15/LOAD\, Q
         => \CHANNEL15/REGFF/reg6\);
    
    \OUTBUF32_OUTBUF_1_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_1_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_1_inst/U0/NET1\);
    
    \CHANNEL30/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/load_net_1\);
    
    \CHANNEL15/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg8\, B => 
        \CHANNEL15/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL15/load_4\, Q => 
        dout_net_15);
    
    \CHANNEL31/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg0\);
    
    \CHANNEL28/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg1\);
    
    \CHANNEL17/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg1\);
    
    \CHANNEL22/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg1\);
    
    \CHANNEL31/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_4\, Y => 
        \CHANNEL31/REGFF/data_net_4\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_8\);
    
    \NEW_VALUE_A_INBUF_0_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_0_inst/U0/NET2\, Y => 
        dat_a_net_8);
    
    \CHANNEL26/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_6\, Y => 
        \CHANNEL26/REGFF/data_net_6\);
    
    \CHANNEL13/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg0\, B => 
        \CHANNEL13/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_3\, Q => \CHANNEL13/REGFF/reg1\);
    
    \CHANNEL2/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg4\);
    
    \CHANNEL24/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg0\);
    
    \CHANNEL24/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg3\);
    
    \ENABLE_INBUF_3_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_3_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_3_inst/U0/NET2\);
    
    \CHANNEL2/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg8\, B => 
        \CHANNEL2/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL2/load_4\, Q => 
        dout_net_28);
    
    \CHANNEL15/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg2\);
    
    \CHANNEL15/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_4\, Y => 
        \CHANNEL15/REGFF/data_net_4\);
    
    \ENABLE_INBUF_0_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_0_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_0_inst/U0/NET2\);
    
    \CHANNEL14/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_8_y\);
    
    \CHANNEL8/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL8/LOAD\);
    
    \CHANNEL26/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg9\);
    
    \CHANNEL12/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg4\, B => 
        \CHANNEL12/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_1\, Q => \CHANNEL12/REGFF/reg5\);
    
    \CHANNEL21/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg5\);
    
    \CHANNEL2/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_4_y\);
    
    \CHANNEL0/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/GNDZ0\, B => 
        \CHANNEL0/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_3\, Q => \CHANNEL0/REGFF/reg0\);
    
    \CHANNEL23/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_4_y\);
    
    \NEW_VALUE_B_INBUF_6_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_6_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_6_inst/U0/NET2\);
    
    \CHANNEL5/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_9_y\);
    
    \CHANNEL4/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_7\, Y => 
        \CHANNEL4/REGFF/data_net_7\);
    
    \CHANNEL0/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_5\, Y => 
        \CHANNEL0/REGFF/data_net_5\);
    
    \CHANNEL11/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg3\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_2\);
    
    \CHANNEL17/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL17/REGCC10/mx2_8_y\);
    
    \CHANNEL8/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_8\, Y => 
        \CHANNEL8/REGFF/data_net_8\);
    
    \OUTBUF32_OUTBUF_27_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_27_inst/U0/NET2\);
    
    \CHANNEL31/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/reg8_b\);
    
    \CHANNEL14/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg0\);
    
    \CHANNEL14/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_6_y\);
    
    \CHANNEL27/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_1\, Y => 
        \CHANNEL27/REGFF/data_net_1\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_9\);
    
    \CHANNEL7/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg7\);
    
    \CHANNEL23/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg2\, B => 
        \CHANNEL23/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_2\, Q => \CHANNEL23/REGFF/reg3\);
    
    \CHANNEL4/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg1\);
    
    \CHANNEL20/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg5\, B => 
        \CHANNEL20/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL20/LOAD\, Q
         => \CHANNEL20/REGFF/reg6\);
    
    \CHANNEL21/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg4\, B => 
        \CHANNEL21/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_1\, Q => \CHANNEL21/REGFF/reg5\);
    
    \CHANNEL23/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_7\, Y => 
        \CHANNEL23/REGFF/data_net_7\);
    
    \CHANNEL12/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_5_y\);
    
    \CHANNEL1/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL1/REGCC10/mx2_8_y\);
    
    \CHANNEL6/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg1\);
    
    \CHANNEL12/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_8_y\);
    
    \CHANNEL21/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_6\, Y => 
        \CHANNEL21/REGFF/data_net_6\);
    
    \CHANNEL31/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/load_net_3\);
    
    \CHANNEL19/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg5\);
    
    \CHANNEL15/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg1\, B => 
        \CHANNEL15/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_2\, Q => \CHANNEL15/REGFF/reg2\);
    
    \CHANNEL30/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg2\);
    
    \CHANNEL10/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_4\, Y => 
        \CHANNEL10/REGFF/data_net_4\);
    
    \CHANNEL13/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg7\, B => 
        \CHANNEL13/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL13/load_4\, Q => 
        \CHANNEL13/REGFF/reg8\);
    
    \CHANNEL13/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_8\, Y => 
        \CHANNEL13/REGFF/data_net_8\);
    
    \CHANNEL8/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg4\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_1\);
    
    \CHANNEL6/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_1_y\);
    
    \CHANNEL3/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg3\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_8\);
    
    \CHANNEL23/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg3\);
    
    \CHANNEL7/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg6\);
    
    \CHANNEL6/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL6/REGCC10/mx2_8_y\);
    
    \CHANNEL11/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_8_y\);
    
    \CHANNEL12/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg7\);
    
    \CHANNEL18/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_9_y\);
    
    \CHANNEL18/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/load_net_1\);
    
    \CHANNEL6/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_2\, Y => 
        \CHANNEL6/REGFF/data_net_2\);
    
    \CHANNEL2/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg5\);
    
    \CHANNEL1/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg0\, B => 
        \CHANNEL1/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_3\, Q => \CHANNEL1/REGFF/reg1\);
    
    \CHANNEL27/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg6\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_3\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_3\);
    
    \CHANNEL21/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg3\, B => 
        \CHANNEL21/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_1\, Q => \CHANNEL21/REGFF/reg4\);
    
    \CHANNEL28/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg7\);
    
    \CHANNEL22/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL22/load_4\);
    
    \CHANNEL7/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_7\, Y => 
        \CHANNEL7/REGFF/data_net_7\);
    
    \CHANNEL25/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg9\);
    
    \CHANNEL31/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL31/NEW_VALUE\, Y => 
        \CHANNEL31/REGFF/DATA\);
    
    \CHANNEL0/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_4_y\);
    
    \CHANNEL6/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg0\, B => 
        \CHANNEL6/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_3\, Q => \CHANNEL6/REGFF/reg1\);
    
    \CHANNEL17/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg1\, B => 
        \CHANNEL17/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_2\, Q => \CHANNEL17/REGFF/reg2\);
    
    \CHANNEL16/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL16/REGCC10/mx2_3_y\);
    
    \CHANNEL24/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg0\, B => 
        \CHANNEL24/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_3\, Q => \CHANNEL24/REGFF/reg1\);
    
    \CHANNEL20/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg6\, B => 
        \CHANNEL20/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL20/LOAD\, Q
         => \CHANNEL20/REGFF/reg7\);
    
    \CHANNEL30/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg0\);
    
    \CHANNEL20/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL20/load_4\);
    
    \CHANNEL24/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_6\, Y => 
        \CHANNEL24/REGFF/data_net_6\);
    
    \CHANNEL11/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg5\);
    
    \CHANNEL8/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg2\);
    
    \CHANNEL19/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_7_y\);
    
    \CHANNEL21/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg8\, B => 
        \CHANNEL21/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL21/load_4\, Q => 
        dout_net_9);
    
    \CHANNEL7/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_0_y\);
    
    \CHANNEL22/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/GNDZ0\, B => 
        \CHANNEL22/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_3\, Q => \CHANNEL22/REGFF/reg0\);
    
    \ENABLE_INBUF_9_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(9), Y => \ENABLE_INBUF_9_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_7_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_23, Y => 
        \OUTBUF32_OUTBUF_7_inst/U0/NET3\);
    
    \CHANNEL20/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg0\, B => 
        \CHANNEL20/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_3\, Q => \CHANNEL20/REGFF/reg1\);
    
    \CHANNEL20/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_2\, Y => 
        \CHANNEL20/REGFF/data_net_2\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_4\);
    
    \CHANNEL8/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/reg8_a\);
    
    NEW_VALUE_B_INBUF_9_inst_0 : BUFF
      port map(A => dat_b_9, Y => dat_b_0_9);
    
    \CHANNEL12/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg3\);
    
    \CHANNEL5/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg4\);
    
    \CHANNEL22/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg0\);
    
    \CHANNEL1/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL1/NEW_VALUE\, Y => 
        \CHANNEL1/REGFF/DATA\);
    
    \CHANNEL29/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg9\);
    
    \OUTBUF32_OUTBUF_0_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_0_inst/U0/NET2\);
    
    \CHANNEL17/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_2\, Y => 
        \CHANNEL17/REGFF/data_net_2\);
    
    \CHANNEL24/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_2_y\);
    
    \CHANNEL0/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg5\, B => 
        \CHANNEL0/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL0/LOAD\, Q
         => \CHANNEL0/REGFF/reg6\);
    
    \CHANNEL18/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_1\, Y => 
        \CHANNEL18/REGFF/data_net_1\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_7\);
    
    \CHANNEL7/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg1\);
    
    \CHANNEL7/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/load_net_2\);
    
    \CHANNEL9/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/GNDZ0\, B => 
        \CHANNEL9/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_3\, Q => \CHANNEL9/REGFF/reg0\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_4\);
    
    \CHANNEL18/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg6\);
    
    \CHANNEL21/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg2\, B => 
        \CHANNEL21/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_2\, Q => \CHANNEL21/REGFF/reg3\);
    
    \CHANNEL8/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg1\, B => 
        \CHANNEL8/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_2\, Q => \CHANNEL8/REGFF/reg2\);
    
    \CHANNEL19/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg2\);
    
    \OUTBUF32_OUTBUF_9_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_9_inst/U0/NET2\);
    
    \CHANNEL9/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/load_net_3\);
    
    \CHANNEL19/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/reg8_a\);
    
    \CHANNEL27/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg0\);
    
    \ENABLE_INBUF_5_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_5_inst/U0/NET2\, Y => 
        enable_net_26);
    
    \CHANNEL18/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg2\);
    
    \ENABLE_INBUF_28_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_28_inst/U0/NET2\, Y => 
        enable_net_3);
    
    \CHANNEL22/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg3\, B => 
        \CHANNEL22/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_1\, Q => \CHANNEL22/REGFF/reg4\);
    
    \CHANNEL30/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg7\);
    
    \CHANNEL30/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg1\, B => 
        \CHANNEL30/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_2\, Q => \CHANNEL30/REGFF/reg2\);
    
    \CHANNEL19/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL19/REGCC10/mx2_8_y\);
    
    \CHANNEL12/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg5\);
    
    \NEW_VALUE_B_INBUF_9_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_9_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_9_inst/U0/NET2\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_4\);
    
    \CHANNEL16/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_5\, Y => 
        \CHANNEL16/REGFF/data_net_5\);
    
    \CHANNEL31/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_3_y\);
    
    \CHANNEL26/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg6\);
    
    \CHANNEL27/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/load_net_1\);
    
    \CHANNEL0/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL0/LOAD\);
    
    \CHANNEL13/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL13/LOAD\);
    
    \ENABLE_INBUF_16_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_16_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_16_inst/U0/NET2\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_8\);
    
    \CHANNEL12/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg2\, B => 
        \CHANNEL12/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_2\, Q => \CHANNEL12/REGFF/reg3\);
    
    \CHANNEL2/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_0_y\);
    
    \CHANNEL22/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg3\);
    
    \CHANNEL27/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_4_y\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/NEW_VALUE\);
    
    \CHANNEL19/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_3\, Y => 
        \CHANNEL19/REGFF/data_net_3\);
    
    \CHANNEL1/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg1\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_3\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_3\);
    
    \CHANNEL12/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_2_y\);
    
    \OUTBUF32_OUTBUF_18_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_18_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_18_inst/U0/NET2\, PAD => DATA_OUTPUT(18));
    
    \CHANNEL13/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/GNDZ0\, B => 
        \CHANNEL13/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_3\, Q => \CHANNEL13/REGFF/reg0\);
    
    \CHANNEL11/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL11/load_4\);
    
    \CHANNEL15/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_5\, Y => 
        \CHANNEL15/REGFF/data_net_5\);
    
    \CHANNEL6/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_2_y\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_9\);
    
    \CHANNEL3/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg4\, B => 
        \CHANNEL3/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_1\, Q => \CHANNEL3/REGFF/reg5\);
    
    \CHANNEL13/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL13/load_4\);
    
    \OUTBUF32_OUTBUF_23_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_7, Y => 
        \OUTBUF32_OUTBUF_23_inst/U0/NET3\);
    
    \CHANNEL24/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_5\, Y => 
        \CHANNEL24/REGFF/data_net_5\);
    
    \CHANNEL16/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg9\);
    
    \CHANNEL16/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg1\);
    
    \CHANNEL24/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg1\, B => 
        \CHANNEL24/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_2\, Q => \CHANNEL24/REGFF/reg2\);
    
    \ENABLE_INBUF_25_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_25_inst/U0/NET2\, Y => 
        enable_net_6);
    
    \CHANNEL9/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg4\, B => 
        \CHANNEL9/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_1\, Q => \CHANNEL9/REGFF/reg5\);
    
    \CHANNEL8/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_3_y\);
    
    \CHANNEL7/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg3\, B => 
        \CHANNEL7/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_1\, Q => \CHANNEL7/REGFF/reg4\);
    
    \CHANNEL31/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg1\);
    
    \CHANNEL13/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg5\);
    
    \ENABLE_INBUF_17_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(17), Y => \ENABLE_INBUF_17_inst/U0/NET1\);
    
    \CHANNEL5/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg7\);
    
    \CHANNEL6/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/GNDZ0\, B => 
        \CHANNEL6/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_3\, Q => \CHANNEL6/REGFF/reg0\);
    
    \CHANNEL20/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg0\);
    
    \CHANNEL29/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/load_net_3\);
    
    \CHANNEL11/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_7\, Y => 
        \CHANNEL11/REGFF/data_net_7\);
    
    \CHANNEL8/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_5_y\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_1\);
    
    \CHANNEL1/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/load_net_3\);
    
    \CHANNEL7/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg5\);
    
    \CHANNEL12/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg8\, B => 
        \CHANNEL12/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL12/load_4\, Q => 
        dout_net_18);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_7\);
    
    \OUTBUF32_OUTBUF_8_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_8_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_8_inst/U0/NET2\, PAD => DATA_OUTPUT(8));
    
    \CHANNEL12/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_2\, Y => 
        \CHANNEL12/REGFF/data_net_2\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_2\);
    
    \CHANNEL1/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_1\, Y => 
        \CHANNEL1/REGFF/data_net_1\);
    
    \CHANNEL15/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL15/NEW_VALUE\, Y => 
        \CHANNEL15/REGFF/DATA\);
    
    \NEW_VALUE_B_INBUF_0_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_0_inst/U0/NET2\, Y => 
        dat_b_net_8);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_7\);
    
    \CHANNEL3/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg9\);
    
    \CHANNEL29/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_4_y\);
    
    \CHANNEL20/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_0_y\);
    
    \CHANNEL1/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL1/LOAD\);
    
    \CHANNEL24/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL24/NEW_VALUE\, Y => 
        \CHANNEL24/REGFF/DATA\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_4\);
    
    \CHANNEL15/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_5_y\);
    
    \CHANNEL10/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_6_y\);
    
    \CHANNEL15/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_7_y\);
    
    \CHANNEL7/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg4\);
    
    \CHANNEL15/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg5\);
    
    \NEW_VALUE_B_INBUF_6_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(6), Y => 
        \NEW_VALUE_B_INBUF_6_inst/U0/NET1\);
    
    \CHANNEL27/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg0\, B => 
        \CHANNEL27/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_3\, Q => \CHANNEL27/REGFF/reg1\);
    
    \CHANNEL18/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_5_y\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_9\);
    
    \CHANNEL2/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg7\, B => 
        \CHANNEL2/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL2/load_4\, Q => 
        \CHANNEL2/REGFF/reg8\);
    
    \OUTBUF32_OUTBUF_24_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_6, Y => 
        \OUTBUF32_OUTBUF_24_inst/U0/NET3\);
    
    NEW_VALUE_B_INBUF_0_inst_0 : BUFF
      port map(A => dat_b_net_8, Y => dat_b_net_8_0);
    
    \CHANNEL16/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL16/NEW_VALUE\, Y => 
        \CHANNEL16/REGFF/DATA\);
    
    \CHANNEL2/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL2/NEW_VALUE\, Y => 
        \CHANNEL2/REGFF/DATA\);
    
    \CHANNEL23/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg8\, B => 
        \CHANNEL23/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL23/load_4\, Q => 
        dout_net_7);
    
    \CHANNEL16/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_5_y\);
    
    \CHANNEL7/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/reg8_a\);
    
    \CHANNEL2/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg0\);
    
    \CHANNEL4/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_6\, Y => 
        \CHANNEL4/REGFF/data_net_6\);
    
    \CHANNEL15/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_4_y\);
    
    \ENABLE_INBUF_31_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_31_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_31_inst/U0/NET2\);
    
    \ENABLE_INBUF_10_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(10), Y => \ENABLE_INBUF_10_inst/U0/NET1\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_1\);
    
    \CHANNEL24/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg3\, B => 
        \CHANNEL24/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_1\, Q => \CHANNEL24/REGFF/reg4\);
    
    \CHANNEL26/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/load_net_2\);
    
    \CHANNEL17/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_9\, Y => 
        \CHANNEL17/REGFF/data_9\);
    
    \CHANNEL5/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_1_y\);
    
    \CHANNEL18/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/reg8_b\);
    
    \OUTBUF32_OUTBUF_15_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_15_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_15_inst/U0/NET2\, PAD => DATA_OUTPUT(15));
    
    \CHANNEL28/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_9\, Y => 
        \CHANNEL28/REGFF/data_9\);
    
    \CHANNEL28/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg1\);
    
    \OUTBUF32_OUTBUF_30_inst/U0/U3\ : IOOE_BUFF
      port map(A => DOUT, Y => \OUTBUF32_OUTBUF_30_inst/U0/NET3\);
    
    \CHANNEL19/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/reg8_b\);
    
    \OUTBUF32_OUTBUF_4_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_4_inst/U0/NET2\);
    
    \CHANNEL4/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg2\, B => 
        \CHANNEL4/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_2\, Q => \CHANNEL4/REGFF/reg3\);
    
    \CHANNEL18/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg2\, B => 
        \CHANNEL18/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_2\, Q => \CHANNEL18/REGFF/reg3\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_2\);
    
    \ENABLE_INBUF_7_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(7), Y => \ENABLE_INBUF_7_inst/U0/NET1\);
    
    \CHANNEL12/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg6\, B => 
        \CHANNEL12/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL12/LOAD\, Q
         => \CHANNEL12/REGFF/reg7\);
    
    \CHANNEL14/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg4\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_6\);
    
    \CHANNEL6/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg6\);
    
    \OUTBUF32_OUTBUF_18_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_18_inst/U0/NET2\);
    
    \CHANNEL5/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg7\, B => 
        \CHANNEL5/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL5/load_4\, Q => 
        \CHANNEL5/REGFF/reg8\);
    
    \CHANNEL18/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg1\);
    
    \CHANNEL12/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg1\);
    
    \CHANNEL29/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/GNDZ0\, B => 
        \CHANNEL29/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_3\, Q => \CHANNEL29/REGFF/reg0\);
    
    \CHANNEL4/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg2\);
    
    \CHANNEL9/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_7\, Y => 
        \CHANNEL9/REGFF/data_net_7\);
    
    \CHANNEL28/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_6\, Y => 
        \CHANNEL28/REGFF/data_net_6\);
    
    \CHANNEL7/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL7/load_4\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_8\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_4\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_1\);
    
    \CHANNEL30/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg1\);
    
    \CHANNEL8/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_8_y\);
    
    \CHANNEL30/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_5_y\);
    
    \CHANNEL1/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg3\);
    
    \CHANNEL26/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg1\);
    
    \CHANNEL0/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_7\, Y => 
        \CHANNEL0/REGFF/data_net_7\);
    
    \CHANNEL14/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg0\);
    
    \CHANNEL20/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg2\, B => 
        \CHANNEL20/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_2\, Q => \CHANNEL20/REGFF/reg3\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_6\);
    
    \CHANNEL14/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg3\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_6\);
    
    \CHANNEL5/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg2\, B => 
        \CHANNEL5/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_2\, Q => \CHANNEL5/REGFF/reg3\);
    
    \CHANNEL21/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_7_y\);
    
    \CHANNEL27/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_5\, Y => 
        \CHANNEL27/REGFF/data_net_5\);
    
    \CHANNEL10/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL10/LOAD\);
    
    \CHANNEL14/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg6\, B => 
        \CHANNEL14/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL14/LOAD\, Q
         => \CHANNEL14/REGFF/reg7\);
    
    \CHANNEL16/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg9\);
    
    \CHANNEL11/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg5\);
    
    \CHANNEL1/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg0\);
    
    \CHANNEL28/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/reg8_a\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_2\);
    
    \CHANNEL16/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg8\, B => 
        \CHANNEL16/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL16/load_4\, Q => 
        dout_net_14);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_7\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_2\);
    
    \CHANNEL23/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg5\);
    
    \CHANNEL24/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_3\, Y => 
        \CHANNEL24/REGFF/data_net_3\);
    
    \PLL/PLLHCLK1/U0\ : HCLKMUX
      port map(A => \PLL/PLL_clk1p\, Y => clk_1000);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_6\);
    
    \CHANNEL3/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg5\, B => 
        \CHANNEL3/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL3/LOAD\, Q
         => \CHANNEL3/REGFF/reg6\);
    
    \CHANNEL24/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/load_net_2\);
    
    \CHANNEL15/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg0\, B => 
        \CHANNEL15/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_3\, Q => \CHANNEL15/REGFF/reg1\);
    
    \CHANNEL23/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg9\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_7\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_9\);
    
    \CHANNEL29/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg3\);
    
    \CHANNEL15/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/load_net_3\);
    
    NEW_VALUE_A_INBUF_8_inst_0 : BUFF
      port map(A => DAT_A, Y => DAT_A_0);
    
    \CHANNEL20/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_6\, Y => 
        \CHANNEL20/REGFF/data_net_6\);
    
    \CHANNEL1/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg5\);
    
    \CHANNEL24/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_9_y\);
    
    \CHANNEL22/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg9\);
    
    \CHANNEL16/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg1\, B => 
        \CHANNEL16/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_2\, Q => \CHANNEL16/REGFF/reg2\);
    
    \OUTBUF32_OUTBUF_15_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_15_inst/U0/NET2\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_9\);
    
    \CHANNEL10/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_1_y\);
    
    \CHANNEL20/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg2\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_6\);
    
    \CHANNEL4/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/load_net_2\);
    
    \CHANNEL11/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL11/LOAD\);
    
    \CHANNEL13/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_8_y\);
    
    \CHANNEL13/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg3\);
    
    \CHANNEL0/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg5\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_3\);
    
    \CHANNEL21/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg6\, B => 
        \CHANNEL21/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL21/LOAD\, Q
         => \CHANNEL21/REGFF/reg7\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_3\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_2\);
    
    \OUTBUF32_OUTBUF_19_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_19_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_19_inst/U0/NET2\, PAD => DATA_OUTPUT(19));
    
    \CHANNEL28/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg4\, B => 
        \CHANNEL28/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_1\, Q => \CHANNEL28/REGFF/reg5\);
    
    \CHANNEL5/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg6\, B => 
        \CHANNEL5/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL5/LOAD\, Q
         => \CHANNEL5/REGFF/reg7\);
    
    \CHANNEL20/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL20/REGCC10/mx2_8_y\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/NEW_VALUE\);
    
    \CHANNEL1/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_6_y\);
    
    \NEW_VALUE_B_INBUF_9_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(9), Y => 
        \NEW_VALUE_B_INBUF_9_inst/U0/NET1\);
    
    \CHANNEL2/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg2\);
    
    \CHANNEL17/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg6\);
    
    \CHANNEL27/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_6\, Y => 
        \CHANNEL27/REGFF/data_net_6\);
    
    \CHANNEL25/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_7\, Y => 
        \CHANNEL25/REGFF/data_net_7\);
    
    \CHANNEL18/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg7\);
    
    \CHANNEL24/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_1_y\);
    
    \CHANNEL12/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_9_y\);
    
    \CHANNEL17/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL17/LOAD\);
    
    \CHANNEL16/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg7\, B => 
        \CHANNEL16/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL16/load_4\, Q => 
        \CHANNEL16/REGFF/reg8\);
    
    \CHANNEL15/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg9\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_6\);
    
    \CHANNEL3/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg0\, B => 
        \CHANNEL3/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_3\, Q => \CHANNEL3/REGFF/reg1\);
    
    \CHANNEL2/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_2_y\);
    
    \CHANNEL13/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL13/NEW_VALUE\, Y => 
        \CHANNEL13/REGFF/DATA\);
    
    \CHANNEL29/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg4\, B => 
        \CHANNEL29/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_1\, Q => \CHANNEL29/REGFF/reg5\);
    
    \CHANNEL10/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg7\, B => 
        \CHANNEL10/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL10/load_4\, Q => 
        \CHANNEL10/REGFF/reg8\);
    
    \CHANNEL1/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg7\, B => 
        \CHANNEL1/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL1/load_4\, Q => 
        \CHANNEL1/REGFF/reg8\);
    
    \CHANNEL1/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg0\);
    
    \CHANNEL26/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg3\);
    
    \CHANNEL31/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_2\, Y => 
        \CHANNEL31/REGFF/data_net_2\);
    
    \CHANNEL3/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_9_y\);
    
    \CHANNEL26/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg2\, B => 
        \CHANNEL26/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_2\, Q => \CHANNEL26/REGFF/reg3\);
    
    \OUTBUF32_OUTBUF_5_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_5_inst/U0/NET2\);
    
    \CHANNEL4/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_6_y\);
    
    \CHANNEL8/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL8/load_4\);
    
    \CHANNEL4/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL4/REGCC10/mx2_8_y\);
    
    NEW_VALUE_A_INBUF_4_inst_0 : BUFF
      port map(A => dat_a_net_4, Y => dat_a_net_4_0);
    
    \CHANNEL20/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg8\, B => 
        \CHANNEL20/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL20/load_4\, Q => 
        dout_net_10);
    
    \OUTBUF32_OUTBUF_0_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_0_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_0_inst/U0/NET1\);
    
    \CHANNEL22/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg6\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_3\);
    
    \CHANNEL18/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_2_y\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_3\);
    
    \CHANNEL30/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg5\);
    
    \OUTBUF32_OUTBUF_20_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_20_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_20_inst/U0/NET2\, PAD => DATA_OUTPUT(20));
    
    \CHANNEL28/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_4\, Y => 
        \CHANNEL28/REGFF/data_net_4\);
    
    \CHANNEL24/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg9\);
    
    \OUTBUF32_OUTBUF_9_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_9_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_9_inst/U0/NET1\);
    
    \ENABLE_INBUF_4_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_4_inst/U0/NET2\, Y => 
        enable_net_27);
    
    \CHANNEL7/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_9_y\);
    
    \CHANNEL29/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/load_net_2\);
    
    \CHANNEL12/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg0\);
    
    \CHANNEL19/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg9\);
    
    \OUTBUF32_OUTBUF_30_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_30_inst/U0/NET2\);
    
    \CHANNEL17/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_1_y\);
    
    \CHANNEL5/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg3\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/NEW_VALUE\);
    
    \CHANNEL17/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg4\, B => 
        \CHANNEL17/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_1\, Q => \CHANNEL17/REGFF/reg5\);
    
    \CHANNEL5/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_6\, Y => 
        \CHANNEL5/REGFF/data_net_6\);
    
    \CHANNEL17/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg0\);
    
    \CHANNEL28/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_7\, Y => 
        \CHANNEL28/REGFF/data_net_7\);
    
    \CHANNEL5/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/reg8_b\);
    
    \CHANNEL21/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_9\, Y => 
        \CHANNEL21/REGFF/data_9\);
    
    \ENABLE_INBUF_21_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_21_inst/U0/NET2\, Y => 
        enable_net_10);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_9\);
    
    \CHANNEL31/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg3\);
    
    \CHANNEL7/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg7\);
    
    \CHANNEL3/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg7\);
    
    \OUTBUF32_OUTBUF_22_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_22_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_22_inst/U0/NET2\, PAD => DATA_OUTPUT(22));
    
    \CHANNEL20/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg6\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_4\);
    
    \CHANNEL0/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg2\);
    
    \OUTBUF32_OUTBUF_19_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_19_inst/U0/NET2\);
    
    \CHANNEL16/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg3\, B => 
        \CHANNEL16/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_1\, Q => \CHANNEL16/REGFF/reg4\);
    
    \CHANNEL27/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_3_y\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_7\);
    
    \CHANNEL29/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_0_y\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_8\);
    
    \CHANNEL16/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg6\);
    
    \CHANNEL1/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg5\);
    
    \CHANNEL12/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg3\);
    
    \CHANNEL0/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg3\);
    
    \ENABLE_INBUF_24_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_24_inst/U0/NET2\, Y => 
        enable_net_7);
    
    \CHANNEL24/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg7\, B => 
        \CHANNEL24/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL24/load_4\, Q => 
        \CHANNEL24/REGFF/reg8\);
    
    \CHANNEL7/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL7/LOAD\);
    
    \CHANNEL2/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg9\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/NEW_VALUE\);
    
    \CHANNEL2/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL2/LOAD\);
    
    \CHANNEL24/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_7_y\);
    
    \CHANNEL30/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg4\);
    
    \CHANNEL24/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/load_net_1\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_2\);
    
    \CHANNEL14/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_9\, Y => 
        \CHANNEL14/REGFF/data_9\);
    
    \CHANNEL10/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_5\, Y => 
        \CHANNEL10/REGFF/data_net_5\);
    
    \CHANNEL26/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_8\, Y => 
        \CHANNEL26/REGFF/data_net_8\);
    
    \CHANNEL20/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_7_y\);
    
    \CHANNEL7/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_6\, Y => 
        \CHANNEL7/REGFF/data_net_6\);
    
    \CHANNEL10/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg0\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_7\);
    
    \OUTBUF32_OUTBUF_8_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_22, Y => 
        \OUTBUF32_OUTBUF_8_inst/U0/NET3\);
    
    \CHANNEL23/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg0\);
    
    \CHANNEL29/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg6\, B => 
        \CHANNEL29/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL29/LOAD\, Q
         => \CHANNEL29/REGFF/reg7\);
    
    \ENABLE_INBUF_29_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_29_inst/U0/NET2\, Y => 
        enable_net_2);
    
    \CHANNEL3/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_6_y\);
    
    \ENABLE_INBUF_26_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_26_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_26_inst/U0/NET2\);
    
    \CHANNEL25/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL25/load_4\);
    
    \CHANNEL27/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg2\);
    
    \CHANNEL12/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_3_y\);
    
    \CHANNEL29/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_8\, Y => 
        \CHANNEL29/REGFF/data_net_8\);
    
    \CHANNEL29/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg1\);
    
    \CHANNEL25/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg7\);
    
    \NEW_VALUE_A_INBUF_2_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_2_inst/U0/NET2\, Y => 
        dat_a_net_6);
    
    \CHANNEL31/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg6\);
    
    \NEW_VALUE_B_INBUF_2_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_2_inst/U0/NET2\, Y => 
        dat_b_net_6);
    
    \CHANNEL13/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg5\, B => 
        \CHANNEL13/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL13/LOAD\, Q
         => \CHANNEL13/REGFF/reg6\);
    
    \CHANNEL26/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg2\);
    
    \CHANNEL21/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_1_y\);
    
    \CHANNEL2/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_5_y\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/NEW_VALUE\);
    
    \CHANNEL17/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg6\, B => 
        \CHANNEL17/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL17/LOAD\, Q
         => \CHANNEL17/REGFF/reg7\);
    
    \CHANNEL26/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_0_y\);
    
    \CHANNEL2/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg3\, B => 
        \CHANNEL2/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_1\, Q => \CHANNEL2/REGFF/reg4\);
    
    \CHANNEL6/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg3\);
    
    \CHANNEL20/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_1\, Y => 
        \CHANNEL20/REGFF/data_net_1\);
    
    \CHANNEL22/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_7\, Y => 
        \CHANNEL22/REGFF/data_net_7\);
    
    \CHANNEL12/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_1\, Y => 
        \CHANNEL12/REGFF/data_net_1\);
    
    \OUTBUF32_OUTBUF_4_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_4_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_4_inst/U0/NET1\);
    
    \CHANNEL21/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_4_y\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_2\);
    
    \CHANNEL31/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/GNDZ0\, B => 
        \CHANNEL31/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_3\, Q => \CHANNEL31/REGFF/reg0\);
    
    \CHANNEL28/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg0\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_7\);
    
    \CHANNEL4/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_9_y\);
    
    \CHANNEL29/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_5\, Y => 
        \CHANNEL29/REGFF/data_net_5\);
    
    \CHANNEL2/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg4\, B => 
        \CHANNEL2/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_1\, Q => \CHANNEL2/REGFF/reg5\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_2\);
    
    \CHANNEL24/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL24/LOAD\);
    
    \CHANNEL11/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_3_y\);
    
    \CHANNEL3/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg5\);
    
    \CHANNEL11/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg7\, B => 
        \CHANNEL11/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL11/load_4\, Q => 
        \CHANNEL11/REGFF/reg8\);
    
    \CHANNEL29/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg6\);
    
    \CHANNEL4/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg4\, B => 
        \CHANNEL4/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_1\, Q => \CHANNEL4/REGFF/reg5\);
    
    \CHANNEL18/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg1\);
    
    \CHANNEL12/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL12/load_4\);
    
    \OUTBUF32_OUTBUF_31_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_31, Y => 
        \OUTBUF32_OUTBUF_31_inst/U0/NET3\);
    
    \NEW_VALUE_B_INBUF_7_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_7_inst/U0/NET2\, Y => 
        dat_b_net_1);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_7\);
    
    \CHANNEL10/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg3\, B => 
        \CHANNEL10/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_1\, Q => \CHANNEL10/REGFF/reg4\);
    
    \CHANNEL8/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg0\);
    
    \CHANNEL26/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_2\, Y => 
        \CHANNEL26/REGFF/data_net_2\);
    
    \NEW_VALUE_B_INBUF_5_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_5_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_5_inst/U0/NET2\);
    
    \CHANNEL6/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL6/REGCC10/mx2_3_y\);
    
    \CHANNEL10/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_3\, Y => 
        \CHANNEL10/REGFF/data_net_3\);
    
    \CHANNEL14/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_2\, Y => 
        \CHANNEL14/REGFF/data_net_2\);
    
    \CHANNEL10/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL10/load_4\);
    
    \CHANNEL30/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg4\);
    
    \CHANNEL25/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_1_y\);
    
    \CHANNEL4/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg9\);
    
    \CHANNEL31/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_3\, Y => 
        \CHANNEL31/REGFF/data_net_3\);
    
    \CHANNEL28/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_4_y\);
    
    \ENABLE_INBUF_8_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(8), Y => \ENABLE_INBUF_8_inst/U0/NET1\);
    
    \CHANNEL8/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg1\);
    
    \CHANNEL26/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg7\);
    
    \CHANNEL7/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg6\, B => 
        \CHANNEL7/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL7/LOAD\, Q
         => \CHANNEL7/REGFF/reg7\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_1\);
    
    \CHANNEL24/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_0_y\);
    
    \CHANNEL1/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg3\);
    
    \CHANNEL4/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_0_y\);
    
    \CHANNEL16/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg1\);
    
    \CHANNEL1/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/GNDZ0\, B => 
        \CHANNEL1/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_3\, Q => \CHANNEL1/REGFF/reg0\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/NEW_VALUE\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_2\);
    
    \CHANNEL30/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_9\, Y => 
        \CHANNEL30/REGFF/data_9\);
    
    \CHANNEL31/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_2_y\);
    
    \CHANNEL3/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/reg8_a\);
    
    \CHANNEL22/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL22/NEW_VALUE\, Y => 
        \CHANNEL22/REGFF/DATA\);
    
    \CHANNEL3/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_7_y\);
    
    \CHANNEL25/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_3_y\);
    
    \CHANNEL19/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg5\, B => 
        \CHANNEL19/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL19/LOAD\, Q
         => \CHANNEL19/REGFF/reg6\);
    
    \CHANNEL21/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg4\);
    
    \CHANNEL18/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/reg8_a\);
    
    \CHANNEL28/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg5\, B => 
        \CHANNEL28/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL28/LOAD\, Q
         => \CHANNEL28/REGFF/reg6\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_7\);
    
    \CHANNEL31/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL31/load_4\);
    
    \CHANNEL15/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/GNDZ0\, B => 
        \CHANNEL15/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_3\, Q => \CHANNEL15/REGFF/reg0\);
    
    \CHANNEL13/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg5\);
    
    \CHANNEL6/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg7\);
    
    \NEW_VALUE_B_INBUF_1_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_1_inst/U0/NET2\, Y => 
        dat_b_net_7);
    
    \CHANNEL4/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/reg8_a\);
    
    \CHANNEL9/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/load_net_1\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_8\);
    
    \CHANNEL7/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/load_net_1\);
    
    \OUTBUF32_OUTBUF_30_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_30_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_30_inst/U0/NET2\, PAD => DATA_OUTPUT(30));
    
    \CHANNEL23/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_5\, Y => 
        \CHANNEL23/REGFF/data_net_5\);
    
    \CHANNEL27/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_3\, Y => 
        \CHANNEL27/REGFF/data_net_3\);
    
    \CHANNEL15/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_8\, Y => 
        \CHANNEL15/REGFF/data_net_8\);
    
    \CHANNEL15/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_9_y\);
    
    \CHANNEL10/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL10/NEW_VALUE\, Y => 
        \CHANNEL10/REGFF/DATA\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_7\);
    
    \CHANNEL13/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg9\);
    
    \CHANNEL19/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg3\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_5\);
    
    \CHANNEL7/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg2\, B => 
        \CHANNEL7/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_2\, Q => \CHANNEL7/REGFF/reg3\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_1\);
    
    \CHANNEL13/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_0_y\);
    
    \OUTBUF32_OUTBUF_26_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_26_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_26_inst/U0/NET2\, PAD => DATA_OUTPUT(26));
    
    \CHANNEL27/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/reg8_a\);
    
    \CHANNEL17/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/load_net_1\);
    
    \CHANNEL12/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg9\);
    
    \CHANNEL4/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_8\, Y => 
        \CHANNEL4/REGFF/data_net_8\);
    
    \CHANNEL6/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg8\, B => 
        \CHANNEL6/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL6/load_4\, Q => 
        dout_net_24);
    
    \CHANNEL17/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL17/NEW_VALUE\, Y => 
        \CHANNEL17/REGFF/DATA\);
    
    \CHANNEL10/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg2\);
    
    \NEW_VALUE_B_INBUF_4_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_4_inst/U0/NET2\, Y => 
        dat_b_net_4);
    
    \CHANNEL23/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg3\);
    
    \CHANNEL9/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/reg8_b\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_1\);
    
    \CHANNEL9/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg4\);
    
    \CHANNEL19/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg8\, B => 
        \CHANNEL19/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL19/load_4\, Q => 
        dout_net_11);
    
    \OUTBUF32_OUTBUF_13_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_13_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_13_inst/U0/NET2\, PAD => DATA_OUTPUT(13));
    
    \CHANNEL29/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_6\, Y => 
        \CHANNEL29/REGFF/data_net_6\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_5\);
    
    \CHANNEL16/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_4_y\);
    
    \CHANNEL3/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_2_y\);
    
    \OUTBUF32_OUTBUF_5_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_5_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_5_inst/U0/NET1\);
    
    \ENABLE_INBUF_16_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_16_inst/U0/NET2\, Y => 
        enable_net_15);
    
    \CHANNEL10/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_5_y\);
    
    \CHANNEL19/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/load_net_3\);
    
    \CHANNEL23/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg2\);
    
    \CHANNEL3/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_4_y\);
    
    \CHANNEL22/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg9\);
    
    \CHANNEL23/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_3\, Y => 
        \CHANNEL23/REGFF/data_net_3\);
    
    \CHANNEL8/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_9_y\);
    
    \CHANNEL16/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_6\, Y => 
        \CHANNEL16/REGFF/data_net_6\);
    
    \CHANNEL2/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_9\, Y => 
        \CHANNEL2/REGFF/data_9\);
    
    \CHANNEL8/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL8/NEW_VALUE\, Y => 
        \CHANNEL8/REGFF/DATA\);
    
    \CHANNEL16/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg3\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_5\);
    
    \CHANNEL1/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg9\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_1\);
    
    \CHANNEL27/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg9\);
    
    \CHANNEL17/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg8\, B => 
        \CHANNEL17/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL17/load_4\, Q => 
        dout_net_13);
    
    \CHANNEL23/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/load_net_1\);
    
    \CHANNEL12/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg6\);
    
    \CHANNEL21/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_0_y\);
    
    \CHANNEL2/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg1\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_3\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_3\);
    
    \CHANNEL5/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL5/LOAD\);
    
    \OUTBUF32_OUTBUF_14_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_14_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_14_inst/U0/NET2\, PAD => DATA_OUTPUT(14));
    
    \CHANNEL3/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_0_y\);
    
    \CHANNEL22/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg0\, B => 
        \CHANNEL22/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_3\, Q => \CHANNEL22/REGFF/reg1\);
    
    \OUTBUF32_OUTBUF_21_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_21_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_21_inst/U0/NET2\, PAD => DATA_OUTPUT(21));
    
    \CHANNEL9/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_9_y\);
    
    \CHANNEL4/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_7_y\);
    
    \CHANNEL14/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg9\);
    
    \CHANNEL16/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/load_net_2\);
    
    \OUTBUF32_OUTBUF_28_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_28_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_28_inst/U0/NET1\);
    
    \CHANNEL17/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_1\, Y => 
        \CHANNEL17/REGFF/data_net_1\);
    
    \CHANNEL3/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg2\);
    
    \CHANNEL21/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/load_net_2\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_4\);
    
    \OUTBUF32_OUTBUF_31_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_31_inst/U0/NET2\);
    
    \CHANNEL0/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg5\);
    
    \CHANNEL20/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg9\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_5\);
    
    \ENABLE_INBUF_6_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_6_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_6_inst/U0/NET2\);
    
    \CHANNEL30/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL30/LOAD\);
    
    \CHANNEL13/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_7\, Y => 
        \CHANNEL13/REGFF/data_net_7\);
    
    \CHANNEL9/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg7\);
    
    \CHANNEL31/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg0\, B => 
        \CHANNEL31/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_3\, Q => \CHANNEL31/REGFF/reg1\);
    
    \CHANNEL25/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg4\);
    
    \CHANNEL6/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_9_y\);
    
    \CHANNEL10/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg4\, B => 
        \CHANNEL10/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_1\, Q => \CHANNEL10/REGFF/reg5\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_7\);
    
    \CHANNEL11/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_6\, Y => 
        \CHANNEL11/REGFF/data_net_6\);
    
    \CHANNEL31/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg9\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_5\);
    
    \OUTBUF32_OUTBUF_13_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_13_inst/U0/NET2\);
    
    \CHANNEL10/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg6\);
    
    \CHANNEL27/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg5\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_1\);
    
    \CHANNEL6/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_6\, Y => 
        \CHANNEL6/REGFF/data_net_6\);
    
    \CHANNEL5/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL5/REGCC10/mx2_8_y\);
    
    \ENABLE_INBUF_23_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_23_inst/U0/NET2\, Y => 
        enable_net_8);
    
    \CHANNEL31/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_5\, Y => 
        \CHANNEL31/REGFF/data_net_5\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_4\);
    
    \CHANNEL13/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_1_y\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_7\);
    
    \CHANNEL6/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg0\);
    
    \CHANNEL30/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_3_y\);
    
    \CHANNEL0/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg3\, B => 
        \CHANNEL0/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_1\, Q => \CHANNEL0/REGFF/reg4\);
    
    \CHANNEL26/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_4\, Y => 
        \CHANNEL26/REGFF/data_net_4\);
    
    \CHANNEL8/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg2\);
    
    \CHANNEL4/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_2_y\);
    
    \NEW_VALUE_B_INBUF_5_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(5), Y => 
        \NEW_VALUE_B_INBUF_5_inst/U0/NET1\);
    
    \CHANNEL29/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_9_y\);
    
    \OUTBUF32_OUTBUF_7_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_7_inst/U0/NET2\);
    
    \CHANNEL12/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_0_y\);
    
    \CHANNEL0/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_1_y\);
    
    \CHANNEL31/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL31/LOAD\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_7\);
    
    \NEW_VALUE_A_INBUF_8_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_8_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_8_inst/U0/NET2\);
    
    \CHANNEL20/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_4_y\);
    
    \CHANNEL4/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL4/NEW_VALUE\, Y => 
        \CHANNEL4/REGFF/DATA\);
    
    \ENABLE_INBUF_26_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(26), Y => \ENABLE_INBUF_26_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_25_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_25_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_25_inst/U0/NET1\);
    
    \CHANNEL14/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_6\, Y => 
        \CHANNEL14/REGFF/data_net_6\);
    
    \CHANNEL31/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg3\);
    
    \OUTBUF32_OUTBUF_14_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_14_inst/U0/NET2\);
    
    \CHANNEL25/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg1\);
    
    \CHANNEL14/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/load_net_2\);
    
    \CHANNEL24/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/reg8_b\);
    
    \CHANNEL6/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg6\);
    
    \CHANNEL25/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_6\, Y => 
        \CHANNEL25/REGFF/data_net_6\);
    
    \CHANNEL13/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg0\);
    
    \CHANNEL10/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_2\, Y => 
        \CHANNEL10/REGFF/data_net_2\);
    
    \CHANNEL17/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg2\);
    
    \CHANNEL3/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/GNDZ0\, B => 
        \CHANNEL3/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_3\, Q => \CHANNEL3/REGFF/reg0\);
    
    \CHANNEL19/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg1\);
    
    \CHANNEL6/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/load_net_2\);
    
    \CHANNEL15/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg7\);
    
    \CHANNEL6/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/reg8_b\);
    
    \CHANNEL16/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg2\);
    
    \CHANNEL20/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg3\);
    
    \CHANNEL19/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_5_y\);
    
    \CHANNEL28/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_5\, Y => 
        \CHANNEL28/REGFF/data_net_5\);
    
    \CHANNEL25/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg5\, B => 
        \CHANNEL25/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL25/LOAD\, Q
         => \CHANNEL25/REGFF/reg6\);
    
    NEW_VALUE_A_INBUF_5_inst_0 : BUFF
      port map(A => dat_a_net_3, Y => dat_a_net_3_0);
    
    \CHANNEL4/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_4_y\);
    
    \CHANNEL25/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/reg8_a\);
    
    \CHANNEL25/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg8\, B => 
        \CHANNEL25/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL25/load_4\, Q => 
        dout_net_5);
    
    \CHANNEL28/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_6_y\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_2\);
    
    \CHANNEL5/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/load_net_1\);
    
    \CHANNEL23/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg0\, B => 
        \CHANNEL23/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_3\, Q => \CHANNEL23/REGFF/reg1\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_4\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_7\);
    
    \CHANNEL18/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg0\);
    
    \CHANNEL15/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_6_y\);
    
    \CHANNEL3/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg5\);
    
    \CHANNEL18/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL18/REGCC10/mx2_8_y\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_3\);
    
    \CHANNEL7/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg3\);
    
    \CHANNEL19/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg6\);
    
    \CHANNEL7/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_3\, Y => 
        \CHANNEL7/REGFF/data_net_3\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_8\);
    
    \CHANNEL6/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg1\, B => 
        \CHANNEL6/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_2\, Q => \CHANNEL6/REGFF/reg2\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_1\);
    
    \OUTBUF32_OUTBUF_10_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_10_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_10_inst/U0/NET1\);
    
    \NEW_VALUE_A_INBUF_9_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_9_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_9_inst/U0/NET2\);
    
    \OUTBUF32_OUTBUF_18_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_12, Y => 
        \OUTBUF32_OUTBUF_18_inst/U0/NET3\);
    
    \CHANNEL30/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_4\, Y => 
        \CHANNEL30/REGFF/data_net_4\);
    
    \CHANNEL22/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg4\, B => 
        \CHANNEL22/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_1\, Q => \CHANNEL22/REGFF/reg5\);
    
    \CHANNEL12/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_6_y\);
    
    \CHANNEL4/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL4/REGCC10/mx2_3_y\);
    
    \CHANNEL31/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg5\);
    
    \ENABLE_INBUF_12_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_12_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_12_inst/U0/NET2\);
    
    \CHANNEL9/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg7\);
    
    \CHANNEL16/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg7\);
    
    \CHANNEL27/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL27/load_4\);
    
    \CHANNEL28/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_1_y\);
    
    \CHANNEL12/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL12/REGCC10/mx2_7_y\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_2\);
    
    \CHANNEL14/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_5\, Y => 
        \CHANNEL14/REGFF/data_net_5\);
    
    \CHANNEL2/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/GNDZ0\, B => 
        \CHANNEL2/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_3\, Q => \CHANNEL2/REGFF/reg0\);
    
    \CHANNEL8/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/load_net_1\);
    
    \CHANNEL19/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/load_net_2\);
    
    \CHANNEL6/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg1\);
    
    \CHANNEL25/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg6\);
    
    \CHANNEL26/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg4\);
    
    \CHANNEL5/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg5\);
    
    \OUTBUF32_OUTBUF_12_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_12_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_12_inst/U0/NET1\);
    
    \CHANNEL25/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg1\, B => 
        \CHANNEL25/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_2\, Q => \CHANNEL25/REGFF/reg2\);
    
    \CHANNEL21/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_1\, Y => 
        \CHANNEL21/REGFF/data_net_1\);
    
    \OUTBUF32_OUTBUF_29_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_29_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_29_inst/U0/NET1\);
    
    \CHANNEL4/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg7\);
    
    \CHANNEL11/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg4\);
    
    \ENABLE_INBUF_1_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_1_inst/U0/NET2\, Y => 
        enable_net_30);
    
    \CHANNEL9/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_4\, Y => 
        \CHANNEL9/REGFF/data_net_4\);
    
    \CHANNEL30/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg5\, B => 
        \CHANNEL30/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL30/LOAD\, Q
         => \CHANNEL30/REGFF/reg6\);
    
    \CHANNEL23/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg7\, B => 
        \CHANNEL23/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL23/load_4\, Q => 
        \CHANNEL23/REGFF/reg8\);
    
    \CHANNEL31/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg4\, B => 
        \CHANNEL31/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_1\, Q => \CHANNEL31/REGFF/reg5\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_5\);
    
    \CHANNEL6/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg7\, B => 
        \CHANNEL6/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL6/load_4\, Q => 
        \CHANNEL6/REGFF/reg8\);
    
    \CHANNEL14/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL14/NEW_VALUE\, Y => 
        \CHANNEL14/REGFF/DATA\);
    
    \ENABLE_INBUF_2_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(2), Y => \ENABLE_INBUF_2_inst/U0/NET1\);
    
    \CHANNEL21/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_8\, Y => 
        \CHANNEL21/REGFF/data_net_8\);
    
    \OUTBUF32_OUTBUF_31_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_31_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_31_inst/U0/NET2\, PAD => DATA_OUTPUT(31));
    
    \CHANNEL4/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg0\, B => 
        \CHANNEL4/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_3\, Q => \CHANNEL4/REGFF/reg1\);
    
    \CHANNEL29/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg9\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_1\);
    
    \CHANNEL17/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg5\, B => 
        \CHANNEL17/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL17/LOAD\, Q
         => \CHANNEL17/REGFF/reg6\);
    
    \CHANNEL5/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_2\, Y => 
        \CHANNEL5/REGFF/data_net_2\);
    
    \OUTBUF32_OUTBUF_15_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_15, Y => 
        \OUTBUF32_OUTBUF_15_inst/U0/NET3\);
    
    \CHANNEL31/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_9_y\);
    
    \CHANNEL22/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL22/LOAD\);
    
    \CHANNEL17/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/reg8_a\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_3\);
    
    \CHANNEL1/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg2\);
    
    \CHANNEL27/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg1\, B => 
        \CHANNEL27/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_2\, Q => \CHANNEL27/REGFF/reg2\);
    
    \CHANNEL29/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_3_y\);
    
    \CHANNEL27/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_0_y\);
    
    \CHANNEL13/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg6\, B => 
        \CHANNEL13/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL13/LOAD\, Q
         => \CHANNEL13/REGFF/reg7\);
    
    \CHANNEL13/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg3\);
    
    \CHANNEL8/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg4\, B => 
        \CHANNEL8/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_1\, Q => \CHANNEL8/REGFF/reg5\);
    
    \CHANNEL22/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_9\, Y => 
        \CHANNEL22/REGFF/data_9\);
    
    \CHANNEL11/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg5\, B => 
        \CHANNEL11/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL11/LOAD\, Q
         => \CHANNEL11/REGFF/reg6\);
    
    \CHANNEL18/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_9\, Y => 
        \CHANNEL18/REGFF/data_9\);
    
    \CHANNEL1/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL1/REGCC10/mx2_3_y\);
    
    \CHANNEL29/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_4\, Y => 
        \CHANNEL29/REGFF/data_net_4\);
    
    \CHANNEL31/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg3\, B => 
        \CHANNEL31/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_1\, Q => \CHANNEL31/REGFF/reg4\);
    
    \CHANNEL21/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg7\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/NEW_VALUE\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_8\);
    
    \CHANNEL5/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_6_y\);
    
    \CHANNEL18/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg6\, B => 
        \CHANNEL18/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL18/LOAD\, Q
         => \CHANNEL18/REGFF/reg7\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_5\);
    
    \CHANNEL28/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL28/NEW_VALUE\, Y => 
        \CHANNEL28/REGFF/DATA\);
    
    \CHANNEL6/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg5\);
    
    \CHANNEL30/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg6\, B => 
        \CHANNEL30/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL30/LOAD\, Q
         => \CHANNEL30/REGFF/reg7\);
    
    \NEW_VALUE_A_INBUF_4_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_4_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_4_inst/U0/NET2\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_8\);
    
    \CHANNEL22/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_3\, Y => 
        \CHANNEL22/REGFF/data_net_3\);
    
    \CHANNEL26/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_3\, Y => 
        \CHANNEL26/REGFF/data_net_3\);
    
    NEW_VALUE_A_INBUF_1_inst_0 : BUFF
      port map(A => dat_a_net_7, Y => dat_a_net_7_0);
    
    \CHANNEL14/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/load_net_1\);
    
    \CHANNEL0/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg3\);
    
    \CHANNEL9/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg5\);
    
    \CHANNEL2/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_6\, Y => 
        \CHANNEL2/REGFF/data_net_6\);
    
    \CHANNEL31/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg8\, B => 
        \CHANNEL31/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL31/load_4\, Q => 
        dout_31);
    
    \CHANNEL13/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg2\);
    
    \NEW_VALUE_B_INBUF_3_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_3_inst/U0/NET2\, Y => 
        dat_b_net_5);
    
    \CHANNEL11/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_2_y\);
    
    \CHANNEL9/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_0_y\);
    
    \CHANNEL12/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg9\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_2\);
    
    \CHANNEL5/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg1\);
    
    \CHANNEL30/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg0\, B => 
        \CHANNEL30/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_3\, Q => \CHANNEL30/REGFF/reg1\);
    
    NEW_VALUE_A_INBUF_9_inst_0 : BUFF
      port map(A => dat_a_9, Y => dat_a_0_9);
    
    \CHANNEL4/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg6\);
    
    \OUTBUF32_OUTBUF_28_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_28_inst/U0/NET2\);
    
    \CHANNEL18/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_6\, Y => 
        \CHANNEL18/REGFF/data_net_6\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/NEW_VALUE\);
    
    \CHANNEL25/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_8_y\);
    
    \CHANNEL15/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL15/load_4\);
    
    \CHANNEL0/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_7_y\);
    
    \CHANNEL28/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/load_net_2\);
    
    \CHANNEL17/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg9\);
    
    \CHANNEL29/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg2\);
    
    \CHANNEL17/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_5\, Y => 
        \CHANNEL17/REGFF/data_net_5\);
    
    \CHANNEL30/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL30/load_4\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_3\);
    
    \CHANNEL13/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_3_y\);
    
    \CHANNEL31/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_7\, Y => 
        \CHANNEL31/REGFF/data_net_7\);
    
    \NEW_VALUE_A_INBUF_8_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(8), Y => 
        \NEW_VALUE_A_INBUF_8_inst/U0/NET1\);
    
    \CHANNEL5/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg3\);
    
    \CHANNEL1/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_5\, Y => 
        \CHANNEL1/REGFF/data_net_5\);
    
    \CHANNEL31/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg2\, B => 
        \CHANNEL31/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL31/load_net_2\, Q => \CHANNEL31/REGFF/reg3\);
    
    NEW_VALUE_B_INBUF_7_inst_0 : BUFF
      port map(A => dat_b_net_1, Y => dat_b_net_1_0);
    
    \CHANNEL15/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg6\, B => 
        \CHANNEL15/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL15/LOAD\, Q
         => \CHANNEL15/REGFF/reg7\);
    
    \CHANNEL8/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg7\);
    
    \CHANNEL14/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_3\, Y => 
        \CHANNEL14/REGFF/data_net_3\);
    
    \CHANNEL4/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg1\, B => 
        \CHANNEL4/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_2\, Q => \CHANNEL4/REGFF/reg2\);
    
    \CHANNEL3/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL3/REGCC10/mx2_3_y\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_9\);
    
    \CHANNEL26/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg6\);
    
    \CHANNEL14/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL14/LOAD\);
    
    \CHANNEL28/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg3\);
    
    \NEW_VALUE_A_INBUF_7_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_7_inst/U0/NET2\, Y => 
        dat_a_net_1);
    
    \CHANNEL7/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg5\);
    
    \CHANNEL22/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg2\, B => 
        \CHANNEL22/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_2\, Q => \CHANNEL22/REGFF/reg3\);
    
    \CHANNEL26/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_1\, Y => 
        \CHANNEL26/REGFF/data_net_1\);
    
    \CHANNEL10/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg9\);
    
    \OUTBUF32_OUTBUF_2_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_2_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_2_inst/U0/NET2\, PAD => DATA_OUTPUT(2));
    
    \CHANNEL23/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/GNDZ0\, B => 
        \CHANNEL23/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL23/load_net_3\, Q => \CHANNEL23/REGFF/reg0\);
    
    \CHANNEL15/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg4\);
    
    \CHANNEL25/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg1\);
    
    \CHANNEL5/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg0\, B => 
        \CHANNEL5/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_3\, Q => \CHANNEL5/REGFF/reg1\);
    
    \CHANNEL10/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_6\, Y => 
        \CHANNEL10/REGFF/data_net_6\);
    
    \CHANNEL0/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_5_y\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/NEW_VALUE\);
    
    \OUTBUF32_OUTBUF_19_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_11, Y => 
        \OUTBUF32_OUTBUF_19_inst/U0/NET3\);
    
    \CHANNEL9/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_6\, Y => 
        \CHANNEL9/REGFF/data_net_6\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_6\);
    
    \CHANNEL17/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg5\);
    
    \CHANNEL21/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_5_y\);
    
    \CHANNEL8/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/GNDZ0\, B => 
        \CHANNEL8/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_3\, Q => \CHANNEL8/REGFF/reg0\);
    
    \NEW_VALUE_B_INBUF_8_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_8_inst/U0/NET2\, Y => 
        DAT_B);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_8\);
    
    \CHANNEL15/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg2\, B => 
        \CHANNEL15/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_2\, Q => \CHANNEL15/REGFF/reg3\);
    
    \CHANNEL27/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg7\);
    
    \OUTBUF32_OUTBUF_25_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_25_inst/U0/NET2\);
    
    \NEW_VALUE_A_INBUF_6_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_6_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_6_inst/U0/NET2\);
    
    \OUTBUF32_OUTBUF_7_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_7_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_7_inst/U0/NET1\);
    
    \CHANNEL22/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg8\, B => 
        \CHANNEL22/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL22/load_4\, Q => 
        dout_net_8);
    
    \CHANNEL4/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg5\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/NEW_VALUE\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_2\);
    
    \CHANNEL6/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL6/NEW_VALUE\, Y => 
        \CHANNEL6/REGFF/DATA\);
    
    \NEW_VALUE_A_INBUF_9_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(9), Y => 
        \NEW_VALUE_A_INBUF_9_inst/U0/NET1\);
    
    \CHANNEL28/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_3\, Y => 
        \CHANNEL28/REGFF/data_net_3\);
    
    \CHANNEL17/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_6\, Y => 
        \CHANNEL17/REGFF/data_net_6\);
    
    \CHANNEL15/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_7\, Y => 
        \CHANNEL15/REGFF/data_net_7\);
    
    \CHANNEL21/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg4\);
    
    \CHANNEL3/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg2\, B => 
        \CHANNEL3/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_2\, Q => \CHANNEL3/REGFF/reg3\);
    
    \CHANNEL29/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg6\);
    
    \CHANNEL9/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_1\, Y => 
        \CHANNEL9/REGFF/data_net_1\);
    
    \CHANNEL4/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg1\);
    
    \CHANNEL16/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_9_y\);
    
    \OUTBUF32_OUTBUF_16_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_16_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_16_inst/U0/NET1\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_7\);
    
    \CHANNEL5/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg1\, B => 
        \CHANNEL5/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_2\, Q => \CHANNEL5/REGFF/reg2\);
    
    \CHANNEL31/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg5\);
    
    \ENABLE_INBUF_9_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_9_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_9_inst/U0/NET2\);
    
    \ENABLE_INBUF_18_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_18_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_18_inst/U0/NET2\);
    
    \CHANNEL7/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_4_y\);
    
    \CHANNEL23/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_7_y\);
    
    \CHANNEL26/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_7_y\);
    
    \CHANNEL9/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg7\, B => 
        \CHANNEL9/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL9/load_4\, Q => 
        \CHANNEL9/REGFF/reg8\);
    
    \CHANNEL15/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg1\);
    
    \CHANNEL8/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_5\, Y => 
        \CHANNEL8/REGFF/data_net_5\);
    
    \CHANNEL14/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/reg8_b\);
    
    \CHANNEL11/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg1\, B => 
        \CHANNEL11/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_2\, Q => \CHANNEL11/REGFF/reg2\);
    
    \CHANNEL1/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg1\, B => 
        \CHANNEL1/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_2\, Q => \CHANNEL1/REGFF/reg2\);
    
    \CHANNEL29/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg7\);
    
    \CHANNEL16/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/GNDZ0\, B => 
        \CHANNEL16/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_3\, Q => \CHANNEL16/REGFF/reg0\);
    
    \CHANNEL8/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg8\, B => 
        \CHANNEL8/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL8/load_4\, Q => 
        dout_net_22);
    
    \CHANNEL20/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/reg8_b\);
    
    \CHANNEL28/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg9\);
    
    \CHANNEL7/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg9\);
    
    \CHANNEL5/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_4\, Y => 
        \CHANNEL5/REGFF/data_net_4\);
    
    \CHANNEL18/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_4\, Y => 
        \CHANNEL18/REGFF/data_net_4\);
    
    \NEW_VALUE_A_INBUF_5_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_5_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_5_inst/U0/NET2\);
    
    \CHANNEL18/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg7\, B => 
        \CHANNEL18/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL18/load_4\, Q => 
        \CHANNEL18/REGFF/reg8\);
    
    \CHANNEL28/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg2\, B => 
        \CHANNEL28/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_2\, Q => \CHANNEL28/REGFF/reg3\);
    
    \CHANNEL28/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg5\);
    
    \CHANNEL23/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_5_y\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_9\);
    
    \CHANNEL22/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg6\, B => 
        \CHANNEL22/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL22/LOAD\, Q
         => \CHANNEL22/REGFF/reg7\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_9\);
    
    \CHANNEL10/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg3\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_5\);
    
    \CHANNEL15/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/reg8_a\);
    
    \CHANNEL3/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg6\);
    
    \CHANNEL26/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg2\);
    
    \CHANNEL7/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg1\);
    
    \CHANNEL1/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg3\, B => 
        \CHANNEL1/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_1\, Q => \CHANNEL1/REGFF/reg4\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_2\);
    
    \OUTBUF32_OUTBUF_20_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_10, Y => 
        \OUTBUF32_OUTBUF_20_inst/U0/NET3\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_6\);
    
    \CHANNEL1/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_4\, Y => 
        \CHANNEL1/REGFF/data_net_4\);
    
    \ENABLE_INBUF_15_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_15_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_15_inst/U0/NET2\);
    
    \PLL/PLL_INT\ : PLL
      port map(PWRDWN => \PLL/VCCZ0\, REFCLK => 
        \PLL/PLL_INT/REFCLK\, LOWFREQ => \PLL/VCCZ0\, OSC2 => 
        \PLL/GNDZ0\, OSC1 => \PLL/GNDZ0\, OSC0 => \PLL/GNDZ0\, 
        DIVI5 => \PLL/GNDZ0\, DIVI4 => \PLL/VCCZ0\, DIVI3 => 
        \PLL/GNDZ0\, DIVI2 => \PLL/GNDZ0\, DIVI1 => \PLL/VCCZ0\, 
        DIVI0 => \PLL/VCCZ0\, DIVJ5 => \PLL/GNDZ0\, DIVJ4 => 
        \PLL/GNDZ0\, DIVJ3 => \PLL/GNDZ0\, DIVJ2 => \PLL/GNDZ0\, 
        DIVJ1 => \PLL/GNDZ0\, DIVJ0 => \PLL/GNDZ0\, DELAYLINE4
         => \PLL/GNDZ0\, DELAYLINE3 => \PLL/GNDZ0\, DELAYLINE2
         => \PLL/GNDZ0\, DELAYLINE1 => \PLL/GNDZ0\, DELAYLINE0
         => \PLL/GNDZ0\, LOCK => \PLL/lock\, CLK1 => 
        \PLL/PLL_clk1p\, CLK2 => PLL_FLOAT_NET1);
    
    \CHANNEL9/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_1_y\);
    
    \CHANNEL9/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_9\, Y => 
        \CHANNEL9/REGFF/data_9\);
    
    \CHANNEL28/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg5\);
    
    \CHANNEL26/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL26/LOAD\);
    
    \CHANNEL18/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_7\, Y => 
        \CHANNEL18/REGFF/data_net_7\);
    
    \CHANNEL15/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg4\, B => 
        \CHANNEL15/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_1\, Q => \CHANNEL15/REGFF/reg5\);
    
    \CHANNEL11/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_9\, Y => 
        \CHANNEL11/REGFF/data_9\);
    
    \CHANNEL0/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL0/load_4\);
    
    \CHANNEL9/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_8_y\);
    
    \CHANNEL2/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg6\);
    
    \CHANNEL7/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL7/REGCC10/mx2_8_y\);
    
    \CHANNEL24/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg6\);
    
    \CHANNEL10/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_3_y\);
    
    \CHANNEL24/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/reg6\, B => 
        \CHANNEL24/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL24/LOAD\, Q
         => \CHANNEL24/REGFF/reg7\);
    
    \OUTBUF32_OUTBUF_11_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_11_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_11_inst/U0/NET1\);
    
    \CHANNEL17/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg7\, B => 
        \CHANNEL17/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL17/load_4\, Q => 
        \CHANNEL17/REGFF/reg8\);
    
    \CHANNEL7/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg2\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/NEW_VALUE\);
    
    \CHANNEL4/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg3\, B => 
        \CHANNEL4/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_1\, Q => \CHANNEL4/REGFF/reg4\);
    
    \CHANNEL8/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg2\, B => 
        \CHANNEL8/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_2\, Q => \CHANNEL8/REGFF/reg3\);
    
    \CHANNEL24/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_5_y\);
    
    \CHANNEL26/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg8\, B => 
        \CHANNEL26/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL26/load_4\, Q => 
        dout_net_4);
    
    \CHANNEL23/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg9\);
    
    \ENABLE_INBUF_5_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(5), Y => \ENABLE_INBUF_5_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_29_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_29_inst/U0/NET2\);
    
    \CHANNEL30/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg2\, B => 
        \CHANNEL30/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_2\, Q => \CHANNEL30/REGFF/reg3\);
    
    \CHANNEL13/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/load_net_1\);
    
    \CHANNEL20/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_8\, Y => 
        \CHANNEL20/REGFF/data_net_8\);
    
    \CHANNEL27/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg1\);
    
    \OUTBUF32_OUTBUF_22_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_8, Y => 
        \OUTBUF32_OUTBUF_22_inst/U0/NET3\);
    
    \CHANNEL8/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg5\);
    
    \CHANNEL25/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg0\, B => 
        \CHANNEL25/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_3\, Q => \CHANNEL25/REGFF/reg1\);
    
    \CHANNEL0/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL0/NEW_VALUE\, Y => 
        \CHANNEL0/REGFF/DATA\);
    
    \CHANNEL16/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_6_y\);
    
    \NEW_VALUE_A_INBUF_4_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(4), Y => 
        \NEW_VALUE_A_INBUF_4_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_8_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_8_inst/U0/NET2\);
    
    \CHANNEL15/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg6\);
    
    \CHANNEL16/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg4\);
    
    \ENABLE_INBUF_31_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_31_inst/U0/NET2\, Y => ENABLE);
    
    \CHANNEL13/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_9_y\);
    
    \CHANNEL25/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg3\);
    
    \CHANNEL31/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_6_y\);
    
    \CHANNEL26/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg3\);
    
    \CHANNEL19/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_6_y\);
    
    \CHANNEL16/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_8\, Y => 
        \CHANNEL16/REGFF/data_net_8\);
    
    \CHANNEL3/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/reg8_b\);
    
    \CHANNEL26/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg1\, B => 
        \CHANNEL26/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_2\, Q => \CHANNEL26/REGFF/reg2\);
    
    \OUTBUF32_OUTBUF_23_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_23_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_23_inst/U0/NET1\);
    
    \CHANNEL11/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/load_net_2\);
    
    \CHANNEL8/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_6\, Y => 
        \CHANNEL8/REGFF/data_net_6\);
    
    \CHANNEL6/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_4\, Y => 
        \CHANNEL6/REGFF/data_net_4\);
    
    \CHANNEL20/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_7\, Y => 
        \CHANNEL20/REGFF/data_net_7\);
    
    \CHANNEL9/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg0\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_6\);
    
    \CHANNEL2/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg5\, B => 
        \CHANNEL2/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL2/LOAD\, Q
         => \CHANNEL2/REGFF/reg6\);
    
    \CHANNEL22/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_1_y\);
    
    \CHANNEL8/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg6\, B => 
        \CHANNEL8/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL8/LOAD\, Q
         => \CHANNEL8/REGFF/reg7\);
    
    \CHANNEL27/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_9_y\);
    
    \CHANNEL20/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_2_y\);
    
    \ENABLE_INBUF_3_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_3_inst/U0/NET2\, Y => 
        enable_net_28);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_4\);
    
    \ENABLE_INBUF_0_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_0_inst/U0/NET2\, Y => 
        enable_net_31);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_5\);
    
    \ENABLE_INBUF_22_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_22_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_22_inst/U0/NET2\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_9\);
    
    \ENABLE_INBUF_30_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_30_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_30_inst/U0/NET2\);
    
    \CHANNEL28/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/load_net_3\);
    
    \CHANNEL10/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/GNDZ0\, B => 
        \CHANNEL10/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_3\, Q => \CHANNEL10/REGFF/reg0\);
    
    \CHANNEL19/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_8\, Y => 
        \CHANNEL19/REGFF/data_net_8\);
    
    \CHANNEL7/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg4\);
    
    \CHANNEL2/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/reg8_a\);
    
    \CHANNEL19/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg9\);
    
    \CHANNEL1/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_7_y\);
    
    \CHANNEL26/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg7\, B => 
        \CHANNEL26/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL26/load_4\, Q => 
        \CHANNEL26/REGFF/reg8\);
    
    \CHANNEL20/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_9_y\);
    
    \CHANNEL10/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_1\, Y => 
        \CHANNEL10/REGFF/data_net_1\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_4\);
    
    \CHANNEL5/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_9\, Y => 
        \CHANNEL5/REGFF/data_9\);
    
    \CHANNEL12/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_7\, Y => 
        \CHANNEL12/REGFF/data_net_7\);
    
    \CHANNEL31/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg6\, B => 
        \CHANNEL31/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL31/LOAD\, Q
         => \CHANNEL31/REGFF/reg7\);
    
    \OUTBUF32_OUTBUF_27_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_27_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_27_inst/U0/NET2\, PAD => DATA_OUTPUT(27));
    
    \CHANNEL20/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg7\, B => 
        \CHANNEL20/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL20/load_4\, Q => 
        \CHANNEL20/REGFF/reg8\);
    
    \CHANNEL17/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_6_y\);
    
    \ENABLE_INBUF_31_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(31), Y => \ENABLE_INBUF_31_inst/U0/NET1\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_8\);
    
    \OUTBUF32_OUTBUF_24_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_24_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_24_inst/U0/NET1\);
    
    \CHANNEL19/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_5\, Y => 
        \CHANNEL19/REGFF/data_net_5\);
    
    \CHANNEL24/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_3_y\);
    
    \CHANNEL14/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_4_y\);
    
    \CHANNEL22/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg4\);
    
    \CHANNEL21/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg0\);
    
    \CHANNEL7/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_5_y\);
    
    \ENABLE_INBUF_7_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_7_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_7_inst/U0/NET2\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_4\);
    
    \CHANNEL3/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg1\, B => 
        \CHANNEL3/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_2\, Q => \CHANNEL3/REGFF/reg2\);
    
    \CHANNEL11/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg7\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/NEW_VALUE\);
    
    \CHANNEL3/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_9\, Y => 
        \CHANNEL3/REGFF/data_9\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_5\);
    
    \CHANNEL20/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg1\);
    
    \CHANNEL4/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg2\);
    
    \CHANNEL16/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_2\, Y => 
        \CHANNEL16/REGFF/data_net_2\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_4\);
    
    \CHANNEL26/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/reg8_b\);
    
    \CHANNEL9/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_2_y\);
    
    \CHANNEL27/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_8\, Y => 
        \CHANNEL27/REGFF/data_net_8\);
    
    \ENABLE_INBUF_16_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(16), Y => \ENABLE_INBUF_16_inst/U0/NET1\);
    
    \CHANNEL9/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg6\);
    
    \CHANNEL3/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_8\, Y => 
        \CHANNEL3/REGFF/data_net_8\);
    
    \CHANNEL30/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg8\, B => 
        \CHANNEL30/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL30/load_4\, Q => 
        DOUT);
    
    \NEW_VALUE_A_INBUF_6_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(6), Y => 
        \NEW_VALUE_A_INBUF_6_inst/U0/NET1\);
    
    \CHANNEL30/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg0\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_5\);
    
    \CHANNEL17/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_5_y\);
    
    \CHANNEL29/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg1\);
    
    \CHANNEL9/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg0\, B => 
        \CHANNEL9/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_3\, Q => \CHANNEL9/REGFF/reg1\);
    
    \CHANNEL28/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_2\, Y => 
        \CHANNEL28/REGFF/data_net_2\);
    
    \NEW_VALUE_A_INBUF_3_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_3_inst/U0/NET2\, Y => 
        dat_a_net_5);
    
    \CHANNEL23/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_6\, Y => 
        \CHANNEL23/REGFF/data_net_6\);
    
    \CHANNEL13/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_6_y\);
    
    \CHANNEL6/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/load_net_1\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_8\);
    
    \CHANNEL27/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg4\, B => 
        \CHANNEL27/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_1\, Q => \CHANNEL27/REGFF/reg5\);
    
    \CHANNEL8/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg5\, B => 
        \CHANNEL8/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL8/LOAD\, Q
         => \CHANNEL8/REGFF/reg6\);
    
    \CHANNEL19/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg2\);
    
    \CHANNEL12/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL12/NEW_VALUE\, Y => 
        \CHANNEL12/REGFF/DATA\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_6\);
    
    \CHANNEL6/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg7\);
    
    \CHANNEL28/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg9\);
    
    \CHANNEL30/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_5\, Y => 
        \CHANNEL30/REGFF/data_net_5\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_9\);
    
    \CHANNEL5/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg3\, B => 
        \CHANNEL5/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_1\, Q => \CHANNEL5/REGFF/reg4\);
    
    \CHANNEL26/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg3\, B => 
        \CHANNEL26/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_1\, Q => \CHANNEL26/REGFF/reg4\);
    
    \CHANNEL13/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_2_y\);
    
    \CHANNEL27/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_7_y\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_3\);
    
    \CHANNEL29/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg0\);
    
    \CHANNEL23/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg6\);
    
    \CHANNEL1/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_6\, Y => 
        \CHANNEL1/REGFF/data_net_6\);
    
    \CHANNEL11/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_9_y\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_4\);
    
    \CHANNEL16/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg6\);
    
    \CHANNEL18/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg3\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_6\);
    
    \CHANNEL13/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_5\, Y => 
        \CHANNEL13/REGFF/data_net_5\);
    
    \CHANNEL17/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_3\, Y => 
        \CHANNEL17/REGFF/data_net_3\);
    
    \CHANNEL29/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_1\, Y => 
        \CHANNEL29/REGFF/data_net_1\);
    
    \OUTBUF32_OUTBUF_2_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_28, Y => 
        \OUTBUF32_OUTBUF_2_inst/U0/NET3\);
    
    \CHANNEL8/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_7_y\);
    
    \NEW_VALUE_A_INBUF_5_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(5), Y => 
        \NEW_VALUE_A_INBUF_5_inst/U0/NET1\);
    
    \CHANNEL15/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg1\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_1\);
    
    \OUTBUF32_OUTBUF_13_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_17, Y => 
        \OUTBUF32_OUTBUF_13_inst/U0/NET3\);
    
    \CHANNEL5/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_2_y\);
    
    \CHANNEL29/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg7\);
    
    \CHANNEL16/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL16/REGCC10/mx2_8_y\);
    
    \CHANNEL23/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg7\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_9\);
    
    \CHANNEL16/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg0\, B => 
        \CHANNEL16/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_3\, Q => \CHANNEL16/REGFF/reg1\);
    
    \CHANNEL0/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg8\, B => 
        \CHANNEL0/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL0/load_4\, Q => 
        dout_net_30);
    
    \CHANNEL17/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg7\);
    
    \CHANNEL19/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg2\, B => 
        \CHANNEL19/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_2\, Q => \CHANNEL19/REGFF/reg3\);
    
    \CHANNEL17/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL17/load_4\);
    
    \CHANNEL19/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_6\, Y => 
        \CHANNEL19/REGFF/data_net_6\);
    
    \CHANNEL6/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_7_y\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_1\);
    
    \OUTBUF32_OUTBUF_26_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_4, Y => 
        \OUTBUF32_OUTBUF_26_inst/U0/NET3\);
    
    \CHANNEL1/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg6\);
    
    \NEW_VALUE_A_INBUF_0_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_0_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_0_inst/U0/NET2\);
    
    \CHANNEL25/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_0_y\);
    
    \CHANNEL21/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg1\);
    
    \CHANNEL0/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg1\);
    
    \CHANNEL11/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg4\);
    
    \CHANNEL8/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_9\, Y => 
        \CHANNEL8/REGFF/data_9\);
    
    \CHANNEL30/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_3\, Y => 
        \CHANNEL30/REGFF/data_net_3\);
    
    \CHANNEL22/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/reg8_a\);
    
    \ENABLE_INBUF_12_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_12_inst/U0/NET2\, Y => 
        enable_net_19);
    
    \CHANNEL23/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg5\, B => 
        \CHANNEL23/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL23/LOAD\, Q
         => \CHANNEL23/REGFF/reg6\);
    
    \ENABLE_INBUF_27_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_27_inst/U0/NET2\, Y => 
        enable_net_4);
    
    \CHANNEL0/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg9\);
    
    \CHANNEL4/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_4\, Y => 
        \CHANNEL4/REGFF/data_net_4\);
    
    \CHANNEL19/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg6\);
    
    \CHANNEL27/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg6\, B => 
        \CHANNEL27/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL27/LOAD\, Q
         => \CHANNEL27/REGFF/reg7\);
    
    \CHANNEL13/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_3\, Y => 
        \CHANNEL13/REGFF/data_net_3\);
    
    \OUTBUF32_OUTBUF_14_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_16, Y => 
        \OUTBUF32_OUTBUF_14_inst/U0/NET3\);
    
    \CHANNEL27/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg6\);
    
    \ENABLE_INBUF_11_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_11_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_11_inst/U0/NET2\);
    
    \CHANNEL1/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/reg8_a\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_1\);
    
    \CHANNEL4/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg0\);
    
    \CHANNEL19/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg7\);
    
    \CHANNEL2/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_8\, Y => 
        \CHANNEL2/REGFF/data_net_8\);
    
    \CHANNEL21/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg7\, B => 
        \CHANNEL21/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL21/load_4\, Q => 
        \CHANNEL21/REGFF/reg8\);
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_9\);
    
    \CHANNEL7/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg9\);
    
    \CHANNEL24/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg1\);
    
    \CHANNEL25/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_3\, Y => 
        \CHANNEL25/REGFF/data_net_3\);
    
    \CHANNEL17/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg2\, B => 
        \CHANNEL17/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_2\, Q => \CHANNEL17/REGFF/reg3\);
    
    \CHANNEL10/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/reg8_b\);
    
    \CHANNEL6/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg4\);
    
    \CHANNEL18/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg9\);
    
    \CHANNEL12/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL12/LOAD\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_6\);
    
    \CHANNEL20/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg3\, B => 
        \CHANNEL20/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_1\, Q => \CHANNEL20/REGFF/reg4\);
    
    \CHANNEL18/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg3\, B => 
        \CHANNEL18/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_1\, Q => \CHANNEL18/REGFF/reg4\);
    
    \CHANNEL18/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg5\);
    
    \CHANNEL26/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg4\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_4\);
    
    \CHANNEL22/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/reg8_b\);
    
    \CHANNEL2/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_3\, Y => 
        \CHANNEL2/REGFF/data_net_3\);
    
    \ENABLE_INBUF_20_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_20_inst/U0/NET2\, Y => 
        enable_net_11);
    
    \ENABLE_INBUF_14_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_14_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_14_inst/U0/NET2\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_1\);
    
    \CHANNEL28/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_7_y\);
    
    \ENABLE_INBUF_28_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_28_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_28_inst/U0/NET2\);
    
    \CHANNEL16/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg2\);
    
    \CHANNEL22/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_4_y\);
    
    \CHANNEL30/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg2\);
    
    \CHANNEL24/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_4\, Y => 
        \CHANNEL24/REGFF/data_net_4\);
    
    \CHANNEL5/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg2\);
    
    \CHANNEL27/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/reg8_b\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_6\);
    
    \CHANNEL30/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL30/NEW_VALUE\, Y => 
        \CHANNEL30/REGFF/DATA\);
    
    \OUTBUF32_OUTBUF_21_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_9, Y => 
        \OUTBUF32_OUTBUF_21_inst/U0/NET3\);
    
    \ENABLE_INBUF_4_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(4), Y => \ENABLE_INBUF_4_inst/U0/NET1\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/NEW_VALUE\);
    
    \CHANNEL18/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg5\);
    
    \CHANNEL28/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg0\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_9\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_1\);
    
    \CHANNEL14/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg6\);
    
    \CHANNEL7/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/GNDZ0\, B => 
        \CHANNEL7/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_3\, Q => \CHANNEL7/REGFF/reg0\);
    
    \CHANNEL29/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg5\, B => 
        \CHANNEL29/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL29/LOAD\, Q
         => \CHANNEL29/REGFF/reg6\);
    
    \ENABLE_INBUF_19_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_19_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_19_inst/U0/NET2\);
    
    \CHANNEL19/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_2_y\);
    
    \CHANNEL13/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg9\);
    
    \OUTBUF32_OUTBUF_23_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_23_inst/U0/NET2\);
    
    \CHANNEL20/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg9\);
    
    \OUTBUF32_OUTBUF_8_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_8_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_8_inst/U0/NET1\);
    
    \CHANNEL25/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/GNDZ0\, B => 
        \CHANNEL25/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_3\, Q => \CHANNEL25/REGFF/reg0\);
    
    \CHANNEL24/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_7\, Y => 
        \CHANNEL24/REGFF/data_net_7\);
    
    \CHANNEL18/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/load_net_2\);
    
    \CHANNEL18/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg1\, B => 
        \CHANNEL18/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_2\, Q => \CHANNEL18/REGFF/reg2\);
    
    \CHANNEL21/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg2\);
    
    \CHANNEL0/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_2\, Y => 
        \CHANNEL0/REGFF/data_net_2\);
    
    \CHANNEL4/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_5\, Y => 
        \CHANNEL4/REGFF/data_net_5\);
    
    \CHANNEL17/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg1\);
    
    \CHANNEL16/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_4\, Y => 
        \CHANNEL16/REGFF/data_net_4\);
    
    \CHANNEL6/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg2\);
    
    \CHANNEL6/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg3\, B => 
        \CHANNEL6/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_1\, Q => \CHANNEL6/REGFF/reg4\);
    
    \CHANNEL3/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg2\);
    
    \ENABLE_INBUF_25_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_25_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_25_inst/U0/NET2\);
    
    \CHANNEL18/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL18/REGCC10/mx2_3_y\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_3\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_9\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_3\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_3\);
    
    \CHANNEL16/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_2_y\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/NEW_VALUE\);
    
    \CHANNEL1/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg5\, B => 
        \CHANNEL1/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL1/LOAD\, Q
         => \CHANNEL1/REGFF/reg6\);
    
    \CHANNEL25/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg3\);
    
    \CHANNEL25/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg2\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_1_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_1\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_4\);
    
    \CHANNEL15/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg3\);
    
    \CHANNEL24/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_8_y\);
    
    \CHANNEL16/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg3\);
    
    \CHANNEL9/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg0\);
    
    \ENABLE_INBUF_22_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(22), Y => \ENABLE_INBUF_22_inst/U0/NET1\);
    
    \CHANNEL23/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/reg8_a\);
    
    \CHANNEL23/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg2\);
    
    \CHANNEL27/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/load_net_2\);
    
    \CHANNEL15/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_6\, Y => 
        \CHANNEL15/REGFF/data_net_6\);
    
    \CHANNEL29/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg8\, B => 
        \CHANNEL29/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL29/load_4\, Q => 
        dout_net_1);
    
    \OUTBUF32_OUTBUF_24_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_24_inst/U0/NET2\);
    
    \CHANNEL27/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_8_y\);
    
    \CHANNEL26/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/load_net_3\);
    
    \CHANNEL18/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_0_y\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_3\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_3\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_4\);
    
    \CHANNEL3/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg0\);
    
    \CHANNEL7/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg7\, B => 
        \CHANNEL7/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL7/load_4\, Q => 
        \CHANNEL7/REGFF/reg8\);
    
    \CHANNEL24/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL24/REGCC10/mx2_6_y\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/NEW_VALUE\);
    
    \CHANNEL1/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg1\);
    
    \CHANNEL15/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg3\, B => 
        \CHANNEL15/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL15/load_net_1\, Q => \CHANNEL15/REGFF/reg4\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_1\);
    
    \CHANNEL22/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_5_y\);
    
    \CHANNEL6/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg9\);
    
    \CHANNEL18/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_5\, Y => 
        \CHANNEL18/REGFF/data_net_5\);
    
    \CHANNEL17/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_2_y\);
    
    \CHANNEL30/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg6\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_1\);
    
    \CHANNEL22/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL22/REGCC10/mx2_8_y\);
    
    \CHANNEL2/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg3\);
    
    \CHANNEL2/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg0\, B => 
        \CHANNEL2/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_3\, Q => \CHANNEL2/REGFF/reg1\);
    
    \CHANNEL15/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_2_y\);
    
    \CHANNEL21/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg9\);
    
    \CHANNEL29/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg4\);
    
    \CHANNEL24/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/load_net_3\);
    
    \CHANNEL16/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg5\, B => 
        \CHANNEL16/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL16/LOAD\, Q
         => \CHANNEL16/REGFF/reg6\);
    
    \CHANNEL12/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg4\);
    
    \CHANNEL11/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg0\);
    
    \CHANNEL27/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg8\, B => 
        \CHANNEL27/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL27/load_4\, Q => 
        dout_net_3);
    
    \CHANNEL31/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_6\, Y => 
        \CHANNEL31/REGFF/data_net_6\);
    
    \CHANNEL2/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL2/REGCC10/mx2_8_y\);
    
    \CHANNEL1/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_4_y\);
    
    \CHANNEL0/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg4\, B => 
        \CHANNEL0/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL0/load_net_1\, Q => \CHANNEL0/REGFF/reg5\);
    
    \CHANNEL21/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL21/REGCC10/mx2_8_y\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/NEW_VALUE\);
    
    \CHANNEL24/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL24/load_4\);
    
    \CHANNEL10/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg1\);
    
    \CHANNEL29/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL29/NEW_VALUE\, Y => 
        \CHANNEL29/REGFF/DATA\);
    
    \CHANNEL16/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/reg8_b\);
    
    \CHANNEL9/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg5\, B => 
        \CHANNEL9/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL9/LOAD\, Q
         => \CHANNEL9/REGFF/reg6\);
    
    \ENABLE_INBUF_8_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_8_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_8_inst/U0/NET2\);
    
    \CHANNEL30/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_0_y\);
    
    \CHANNEL28/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_9_y\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_3\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_3\);
    
    NEW_VALUE_A_INBUF_2_inst_0 : BUFF
      port map(A => dat_a_net_6, Y => dat_a_net_6_0);
    
    \CHANNEL4/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg3\);
    
    NEW_VALUE_B_INBUF_3_inst_0 : BUFF
      port map(A => dat_b_net_5, Y => dat_b_net_5_0);
    
    \CHANNEL7/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL7/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/load_net_3\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_9\);
    
    \CHANNEL5/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_5_y\);
    
    \CHANNEL2/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_7\, Y => 
        \CHANNEL2/REGFF/data_net_7\);
    
    \CHANNEL19/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg1\);
    
    \CHANNEL6/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_4_y\);
    
    \NEW_VALUE_A_INBUF_1_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_1_inst/U0/NET2\, Y => 
        dat_a_net_7);
    
    \CHANNEL26/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_3_y\);
    
    \CHANNEL11/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_6_y\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_net_8\);
    
    \CHANNEL4/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg5\, B => 
        \CHANNEL4/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL4/LOAD\, Q
         => \CHANNEL4/REGFF/reg6\);
    
    \CHANNEL2/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg1\);
    
    \CHANNEL29/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_7_y\);
    
    \CHANNEL29/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_2\, Y => 
        \CHANNEL29/REGFF/data_net_2\);
    
    \ENABLE_INBUF_18_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_18_inst/U0/NET2\, Y => 
        enable_net_13);
    
    \NEW_VALUE_A_INBUF_0_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(0), Y => 
        \NEW_VALUE_A_INBUF_0_inst/U0/NET1\);
    
    \CHANNEL20/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg4\, B => 
        \CHANNEL20/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_1\, Q => \CHANNEL20/REGFF/reg5\);
    
    \CHANNEL18/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg9\);
    
    \NEW_VALUE_B_INBUF_0_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_0_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_0_inst/U0/NET2\);
    
    \CHANNEL8/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL8/REGFF/reg0\, B => 
        \CHANNEL8/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL8/load_net_3\, Q => \CHANNEL8/REGFF/reg1\);
    
    \OUTBUF32_OUTBUF_10_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_10_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_10_inst/U0/NET2\, PAD => DATA_OUTPUT(10));
    
    \CHANNEL9/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg6\);
    
    \CHANNEL11/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_1\, Y => 
        \CHANNEL11/REGFF/data_net_1\);
    
    \CLR/U0/U0\ : IOPAD_IN
      port map(PAD => RESET, Y => \CLR/U0/NET1\);
    
    \CHANNEL9/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_4_y\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_3\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_4\);
    
    \CHANNEL26/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_9\, Y => 
        \CHANNEL26/REGFF/data_9\);
    
    \CHANNEL19/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg0\);
    
    \CHANNEL13/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg6\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_2\);
    
    \CHANNEL0/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/load_net_3\);
    
    \CHANNEL19/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_1_y\);
    
    \CHANNEL30/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_2\, Y => 
        \CHANNEL30/REGFF/data_net_2\);
    
    \CHANNEL8/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg1\);
    
    \CHANNEL16/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL16/LOAD\);
    
    \CHANNEL18/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg0\, B => 
        \CHANNEL18/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_3\, Q => \CHANNEL18/REGFF/reg1\);
    
    \CHANNEL5/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/GNDZ0\, B => 
        \CHANNEL5/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_3\, Q => \CHANNEL5/REGFF/reg0\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_2\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_7\);
    
    \CHANNEL11/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_8\, Y => 
        \CHANNEL11/REGFF/data_net_8\);
    
    \CHANNEL0/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_9_y\);
    
    \CHANNEL12/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg1\, B => 
        \CHANNEL12/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_2\, Q => \CHANNEL12/REGFF/reg2\);
    
    \CHANNEL31/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/load_net_2\);
    
    \CHANNEL24/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg2\);
    
    \ENABLE_INBUF_15_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_15_inst/U0/NET2\, Y => 
        enable_net_16);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_8\);
    
    \CHANNEL21/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/load_net_1\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_9\);
    
    \CHANNEL19/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL19/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_B/reg7\);
    
    \CHANNEL29/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_8_y\);
    
    \CHANNEL10/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg1\, B => 
        \CHANNEL10/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_2\, Q => \CHANNEL10/REGFF/reg2\);
    
    \CHANNEL23/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/load_net_2\);
    
    \CHANNEL4/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/load_net_3\);
    
    \CHANNEL31/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_7_y\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_9\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_2\);
    
    \CHANNEL13/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg7\);
    
    \OUTBUF32_OUTBUF_12_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_12_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_12_inst/U0/NET2\, PAD => DATA_OUTPUT(12));
    
    \CHANNEL8/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_1\, Y => 
        \CHANNEL8/REGFF/data_net_1\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_7\);
    
    \CHANNEL22/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg2\);
    
    \CHANNEL9/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_3_y\);
    
    \CHANNEL22/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/load_net_1\);
    
    \CHANNEL6/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/reg8_a\);
    
    \CHANNEL12/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_9\, Y => 
        \CHANNEL12/REGFF/data_9\);
    
    \CHANNEL23/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg1\);
    
    \CHANNEL19/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_4\, Y => 
        \CHANNEL19/REGFF/data_net_4\);
    
    \CHANNEL3/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_7\, Y => 
        \CHANNEL3/REGFF/data_net_7\);
    
    \CHANNEL18/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL18/NEW_VALUE\, Y => 
        \CHANNEL18/REGFF/DATA\);
    
    \CHANNEL3/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_2\, Y => 
        \CHANNEL3/REGFF/data_net_2\);
    
    \CHANNEL24/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/reg8_a\);
    
    \CHANNEL8/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg9\);
    
    \CHANNEL12/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL12/new_value_net_3\, Y => 
        \CHANNEL12/REGFF/data_net_3\);
    
    \CHANNEL16/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_3\, Y => 
        \CHANNEL16/REGFF/data_net_3\);
    
    \CHANNEL22/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_2_y\);
    
    \CHANNEL11/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg1\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_2\);
    
    \CHANNEL12/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/reg8_a\);
    
    \CHANNEL29/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_net_7\, Y => 
        \CHANNEL29/REGFF/data_net_7\);
    
    \CHANNEL21/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg7\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_6\);
    
    \CHANNEL9/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL9/load_4\);
    
    \CHANNEL5/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL5/load_4\);
    
    \CHANNEL1/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_2_y\);
    
    \CHANNEL17/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg6\);
    
    \OUTBUF32_OUTBUF_17_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_17_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_17_inst/U0/NET1\);
    
    \CHANNEL31/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg4\);
    
    \CHANNEL6/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_5\, Y => 
        \CHANNEL6/REGFF/data_net_5\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_5\);
    
    \CHANNEL18/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/load_net_3\);
    
    \CHANNEL27/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg2\);
    
    \CHANNEL21/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_4\, Y => 
        \CHANNEL21/REGFF/data_net_4\);
    
    \CHANNEL5/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_4_y\);
    
    \CHANNEL16/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_1_y\);
    
    \CHANNEL29/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg5\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_2\);
    
    \OUTBUF32_OUTBUF_10_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_10_inst/U0/NET2\);
    
    \CHANNEL8/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg7\);
    
    \CHANNEL4/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_1\, Y => 
        \CHANNEL4/REGFF/data_net_1\);
    
    \CHANNEL25/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg0\);
    
    \CHANNEL14/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/GNDZ0\, B => 
        \CHANNEL14/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_3\, Q => \CHANNEL14/REGFF/reg0\);
    
    \CHANNEL9/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_2\, Y => 
        \CHANNEL9/REGFF/data_net_2\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_2\);
    
    \ENABLE_INBUF_13_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_13_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_13_inst/U0/NET2\);
    
    \CHANNEL14/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg1\);
    
    \CHANNEL28/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg7\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_7\);
    
    NEW_VALUE_A_INBUF_0_inst_0 : BUFF
      port map(A => dat_a_net_8, Y => dat_a_net_8_0);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_1\);
    
    \CHANNEL20/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg6\);
    
    \ENABLE_INBUF_28_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(28), Y => \ENABLE_INBUF_28_inst/U0/NET1\);
    
    \CHANNEL27/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg3\);
    
    \CHANNEL16/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg4\);
    
    \CHANNEL29/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/load_net_1\);
    
    \CHANNEL12/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/reg8_b\);
    
    \CHANNEL7/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_9\, Y => 
        \CHANNEL7/REGFF/data_9\);
    
    \CHANNEL25/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_5_y\);
    
    \CHANNEL24/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg7\);
    
    \CHANNEL30/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_8_y\);
    
    \OUTBUF32_OUTBUF_6_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_6_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_6_inst/U0/NET2\, PAD => DATA_OUTPUT(6));
    
    \CHANNEL20/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_6_y\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/NEW_VALUE\);
    
    \CHANNEL25/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_7_y\);
    
    \CHANNEL28/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_5_y\);
    
    \CHANNEL16/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_net_1\, Y => 
        \CHANNEL16/REGFF/data_net_1\);
    
    \ENABLE_INBUF_21_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_21_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_21_inst/U0/NET2\);
    
    NEW_VALUE_B_INBUF_6_inst_0 : BUFF
      port map(A => dat_b_net_2, Y => dat_b_net_2_0);
    
    \CHANNEL26/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_5_y\);
    
    \CHANNEL0/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg4\);
    
    \CHANNEL23/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg6\);
    
    \CHANNEL25/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_4_y\);
    
    \CHANNEL17/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/reg8_b\);
    
    \CLR/U0/U1\ : RCLKMUX
      port map(A => \CLR/U0/NET1\, Y => CLRZ0);
    
    \CHANNEL5/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg5\, B => 
        \CHANNEL5/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL5/LOAD\, Q
         => \CHANNEL5/REGFF/reg6\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_8\);
    
    \OUTBUF32_OUTBUF_12_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_12_inst/U0/NET2\);
    
    \CHANNEL0/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_3\, Y => 
        \CHANNEL0/REGFF/data_net_3\);
    
    \CHANNEL13/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL13/REGCC10/mx2_4_y\);
    
    \CHANNEL18/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg0\);
    
    \CHANNEL9/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_5\, Y => 
        \CHANNEL9/REGFF/data_net_5\);
    
    \CHANNEL3/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_5\, Y => 
        \CHANNEL3/REGFF/data_net_5\);
    
    \CHANNEL21/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL21/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_10, Q => \CHANNEL21/new_value_9\);
    
    \CHANNEL26/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg7\);
    
    \CHANNEL2/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_4\, Y => 
        \CHANNEL2/REGFF/data_net_4\);
    
    \CHANNEL9/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg3\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_1\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_5\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_0_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_2\);
    
    \CHANNEL15/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL15/REGFF/reg7\, B => 
        \CHANNEL15/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL15/load_4\, Q => 
        \CHANNEL15/REGFF/reg8\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_5\);
    
    \CHANNEL6/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_8\, Y => 
        \CHANNEL6/REGFF/data_net_8\);
    
    \CHANNEL10/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg9\);
    
    \ENABLE_INBUF_25_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(25), Y => \ENABLE_INBUF_25_inst/U0/NET1\);
    
    \CHANNEL20/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg5\);
    
    \ENABLE_INBUF_24_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_24_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_24_inst/U0/NET2\);
    
    \CHANNEL9/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_6_y\);
    
    \CHANNEL1/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_0_y\);
    
    \CHANNEL25/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_1\, Y => 
        \CHANNEL25/REGFF/data_net_1\);
    
    \CHANNEL11/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg2\);
    
    \CHANNEL24/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg1\);
    
    \CHANNEL3/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg6\, B => 
        \CHANNEL3/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL3/LOAD\, Q
         => \CHANNEL3/REGFF/reg7\);
    
    \CHANNEL3/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg3\, B => 
        \CHANNEL3/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL3/load_net_1\, Q => \CHANNEL3/REGFF/reg4\);
    
    \CHANNEL18/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_3\, Y => 
        \CHANNEL18/REGFF/data_net_3\);
    
    \CHANNEL6/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_3\, Y => 
        \CHANNEL6/REGFF/data_net_3\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/NEW_VALUE\);
    
    \CHANNEL26/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg0\);
    
    \CHANNEL27/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg5\, B => 
        \CHANNEL27/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL27/LOAD\, Q
         => \CHANNEL27/REGFF/reg6\);
    
    \CHANNEL15/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg3\);
    
    \CHANNEL7/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_1\, Y => 
        \CHANNEL7/REGFF/data_net_1\);
    
    \CHANNEL15/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg2\);
    
    \CHANNEL25/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg6\);
    
    \CHANNEL20/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/load_net_3\);
    
    \ENABLE_INBUF_29_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_29_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_29_inst/U0/NET2\);
    
    \CHANNEL21/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL21/NEW_VALUE\, Y => 
        \CHANNEL21/REGFF/DATA\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_4\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/NEW_VALUE\);
    
    \CHANNEL23/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL23/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_A/reg4\);
    
    \CHANNEL2/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/reg8_b\);
    
    \CHANNEL23/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL23/REGFF/reg6\, B => 
        \CHANNEL23/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL23/LOAD\, Q
         => \CHANNEL23/REGFF/reg7\);
    
    \CHANNEL13/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/reg8_a\);
    
    \CHANNEL13/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg2\);
    
    \CHANNEL3/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/load_net_1\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_5\);
    
    \CHANNEL21/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg5\, B => 
        \CHANNEL21/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL21/LOAD\, Q
         => \CHANNEL21/REGFF/reg6\);
    
    \CHANNEL30/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg9\);
    
    \CHANNEL0/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg7\);
    
    \CHANNEL28/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg6\, B => 
        \CHANNEL28/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL28/LOAD\, Q
         => \CHANNEL28/REGFF/reg7\);
    
    \CHANNEL5/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_1\, Y => 
        \CHANNEL5/REGFF/data_net_1\);
    
    \CHANNEL18/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/GNDZ0\, B => 
        \CHANNEL18/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL18/load_net_3\, Q => \CHANNEL18/REGFF/reg0\);
    
    \NEW_VALUE_B_INBUF_0_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(0), Y => 
        \NEW_VALUE_B_INBUF_0_inst/U0/NET1\);
    
    \CHANNEL4/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg0\);
    
    \CHANNEL1/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_9_y\);
    
    \CHANNEL7/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_4\, Y => 
        \CHANNEL7/REGFF/data_net_4\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_1\);
    
    NEW_VALUE_B_INBUF_1_inst_0 : BUFF
      port map(A => dat_b_net_7, Y => dat_b_net_7_0);
    
    \OUTBUF32_OUTBUF_16_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_16_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_16_inst/U0/NET2\, PAD => DATA_OUTPUT(16));
    
    \CHANNEL11/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg9\);
    
    \CHANNEL4/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg8\, B => 
        \CHANNEL4/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL4/load_4\, Q => 
        dout_net_26);
    
    \CHANNEL19/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg4\);
    
    \CHANNEL20/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_1_y\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_4\);
    
    \CHANNEL30/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_7_y\);
    
    \CHANNEL23/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL23/REGCC10/mx2_8_y\);
    
    \NEW_VALUE_B_INBUF_6_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_6_inst/U0/NET2\, Y => 
        dat_b_net_2);
    
    \CHANNEL30/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_6\, Y => 
        \CHANNEL30/REGFF/data_net_6\);
    
    \CHANNEL25/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/reg8_b\);
    
    \CHANNEL14/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_2_y\);
    
    \CHANNEL19/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg1\, B => 
        \CHANNEL19/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_2\, Q => \CHANNEL19/REGFF/reg2\);
    
    \CHANNEL25/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg4\);
    
    \CHANNEL28/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL28/load_4\);
    
    \CHANNEL20/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg7\);
    
    \CHANNEL9/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/load_net_2\);
    
    \CHANNEL29/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL29/LOAD\);
    
    \OUTBUF32_OUTBUF_3_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_3_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_3_inst/U0/NET2\, PAD => DATA_OUTPUT(3));
    
    \CHANNEL19/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg7\, B => 
        \CHANNEL19/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL19/load_4\, Q => 
        \CHANNEL19/REGFF/reg8\);
    
    \CHANNEL25/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg6\, B => 
        \CHANNEL25/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL25/LOAD\, Q
         => \CHANNEL25/REGFF/reg7\);
    
    \CHANNEL20/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg3\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_7\);
    
    \CHANNEL22/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_9_y\);
    
    \CHANNEL31/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_1_y\);
    
    \CHANNEL16/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg6\, B => 
        \CHANNEL16/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL16/LOAD\, Q
         => \CHANNEL16/REGFF/reg7\);
    
    \CHANNEL8/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_0_y\);
    
    \CHANNEL7/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg0\);
    
    \CHANNEL10/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_8\, Y => 
        \CHANNEL10/REGFF/data_net_8\);
    
    \CHANNEL27/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg5\);
    
    \CHANNEL7/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg0\, B => 
        \CHANNEL7/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_3\, Q => \CHANNEL7/REGFF/reg1\);
    
    \CHANNEL25/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/load_net_2\);
    
    \CHANNEL6/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg5\);
    
    \CHANNEL1/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg2\);
    
    \CHANNEL7/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_5\, Y => 
        \CHANNEL7/REGFF/data_net_5\);
    
    \CHANNEL31/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_4_y\);
    
    \CHANNEL0/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL0/REGFF/reg7\, B => 
        \CHANNEL0/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL0/load_4\, Q => 
        \CHANNEL0/REGFF/reg8\);
    
    \CHANNEL22/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL22/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_A/reg4\);
    
    \ENABLE_INBUF_11_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_11_inst/U0/NET2\, Y => 
        enable_net_20);
    
    \CHANNEL7/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_7_y\);
    
    \CHANNEL23/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_9\, Y => 
        \CHANNEL23/REGFF/data_9\);
    
    \CHANNEL20/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/load_net_2\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_7\);
    
    \CHANNEL23/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_2\, Y => 
        \CHANNEL23/REGFF/data_net_2\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_4\);
    
    \CHANNEL28/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_2_y\);
    
    \CHANNEL13/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg3\, B => 
        \CHANNEL13/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_1\, Q => \CHANNEL13/REGFF/reg4\);
    
    \CHANNEL10/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL10/new_value_net_7\, Y => 
        \CHANNEL10/REGFF/data_net_7\);
    
    \CHANNEL5/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_7\, Y => 
        \CHANNEL5/REGFF/data_net_7\);
    
    \CHANNEL8/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg4\);
    
    \CHANNEL30/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL30/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_A/reg3\);
    
    \CHANNEL17/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL17/REGCC10/mx2_4_y\);
    
    \CHANNEL17/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/GNDZ0\, B => 
        \CHANNEL17/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_3\, Q => \CHANNEL17/REGFF/reg0\);
    
    \OUTBUF32_OUTBUF_11_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_11_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_11_inst/U0/NET2\, PAD => DATA_OUTPUT(11));
    
    \CHANNEL25/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg2\, B => 
        \CHANNEL25/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_2\, Q => \CHANNEL25/REGFF/reg3\);
    
    \NEW_VALUE_A_INBUF_2_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_2_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_2_inst/U0/NET2\);
    
    \ENABLE_INBUF_2_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_2_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_2_inst/U0/NET2\);
    
    \CHANNEL5/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg1\);
    
    \NEW_VALUE_B_INBUF_2_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_2_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_2_inst/U0/NET2\);
    
    NEW_VALUE_A_INBUF_7_inst_0 : BUFF
      port map(A => dat_a_net_1, Y => dat_a_net_1_0);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_8\);
    
    \CHANNEL26/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL26/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_B/reg5\);
    
    \CHANNEL0/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_8\, Y => 
        \CHANNEL0/REGFF/data_net_8\);
    
    \CHANNEL6/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg0\);
    
    \CHANNEL6/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_5_y\);
    
    \CHANNEL27/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL27/REGCC10/mx2_1_y\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_8\);
    
    \ENABLE_INBUF_14_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_14_inst/U0/NET2\, Y => 
        enable_net_17);
    
    \CHANNEL25/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_9\, Y => 
        \CHANNEL25/REGFF/data_9\);
    
    \CHANNEL1/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_2\, Y => 
        \CHANNEL1/REGFF/data_net_2\);
    
    \OUTBUF32_OUTBUF_16_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_16_inst/U0/NET2\);
    
    \ENABLE_INBUF_1_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(1), Y => \ENABLE_INBUF_1_inst/U0/NET1\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_3\);
    
    \CHANNEL8/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg0\);
    
    \CHANNEL4/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg9\);
    
    \CHANNEL1/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL1/load_4\);
    
    \CHANNEL14/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg2\);
    
    \OUTBUF32_OUTBUF_1_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_1_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_1_inst/U0/NET2\, PAD => DATA_OUTPUT(1));
    
    \CHANNEL3/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg0\);
    
    \NEW_VALUE_B_INBUF_7_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_7_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_7_inst/U0/NET2\);
    
    \CHANNEL24/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg7\);
    
    \ENABLE_INBUF_6_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_6_inst/U0/NET2\, Y => 
        enable_net_25);
    
    \CHANNEL19/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_4_y\);
    
    \CHANNEL12/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg2\);
    
    \CHANNEL10/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_0_y\);
    
    \CHANNEL9/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_5_y\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_4_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_7\);
    
    \CHANNEL31/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_9\, Y => 
        \CHANNEL31/REGFF/data_9\);
    
    \CHANNEL21/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL21/REGFF/reg1\, B => 
        \CHANNEL21/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL21/load_net_2\, Q => \CHANNEL21/REGFF/reg2\);
    
    \CHANNEL13/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg1\);
    
    \ENABLE_INBUF_19_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_19_inst/U0/NET2\, Y => 
        enable_net_12);
    
    \CHANNEL26/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/GNDZ0\, B => 
        \CHANNEL26/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_3\, Q => \CHANNEL26/REGFF/reg0\);
    
    \CHANNEL14/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/reg8_a\);
    
    \CHANNEL17/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL17/new_value_net_8\, Y => 
        \CHANNEL17/REGFF/data_net_8\);
    
    \OUTBUF32_OUTBUF_27_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_3, Y => 
        \OUTBUF32_OUTBUF_27_inst/U0/NET3\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_8\);
    
    \CHANNEL28/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg7\, B => 
        \CHANNEL28/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL28/load_4\, Q => 
        \CHANNEL28/REGFF/reg8\);
    
    \CHANNEL9/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_3\, Y => 
        \CHANNEL9/REGFF/data_net_3\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_3\);
    
    \CHANNEL20/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/reg8_a\);
    
    \CHANNEL12/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg7\, B => 
        \CHANNEL12/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL12/load_4\, Q => 
        \CHANNEL12/REGFF/reg8\);
    
    \ENABLE_INBUF_12_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(12), Y => \ENABLE_INBUF_12_inst/U0/NET1\);
    
    \CHANNEL9/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL9/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg5\);
    
    \CHANNEL11/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg7\);
    
    \CHANNEL9/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL9/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg4\);
    
    \CHANNEL17/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/load_net_2\);
    
    \CHANNEL21/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg2\);
    
    \CHANNEL21/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/reg8_a\);
    
    \CHANNEL18/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL18/new_value_net_2\, Y => 
        \CHANNEL18/REGFF/data_net_2\);
    
    \CHANNEL13/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_6\, Y => 
        \CHANNEL13/REGFF/data_net_6\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/NEW_VALUE\);
    
    \CHANNEL16/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/load_net_3\);
    
    \NEW_VALUE_B_INBUF_9_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_9_inst/U0/NET2\, Y => 
        dat_b_9);
    
    \CHANNEL17/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg2\);
    
    \CHANNEL18/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL18/REGFF/reg8\, B => 
        \CHANNEL18/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL18/load_4\, Q => 
        dout_net_12);
    
    \CHANNEL19/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg5\);
    
    \CHANNEL25/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg4\, B => 
        \CHANNEL25/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_1\, Q => \CHANNEL25/REGFF/reg5\);
    
    \CHANNEL15/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg0\);
    
    \CHANNEL22/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL22/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/load_net_3\);
    
    \OUTBUF32_OUTBUF_11_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_11_inst/U0/NET2\);
    
    \CHANNEL1/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_8\, Y => 
        \CHANNEL1/REGFF/data_net_8\);
    
    \CHANNEL7/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg1\, B => 
        \CHANNEL7/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL7/load_net_2\, Q => \CHANNEL7/REGFF/reg2\);
    
    \CHANNEL18/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg7\);
    
    \NEW_VALUE_B_INBUF_1_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_1_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_1_inst/U0/NET2\);
    
    \CHANNEL3/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg6\);
    
    \OUTBUF32_OUTBUF_2_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_2_inst/U0/NET2\);
    
    \CHANNEL9/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL9/new_value_net_8\, Y => 
        \CHANNEL9/REGFF/data_net_8\);
    
    \CHANNEL10/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg6\);
    
    \CHANNEL16/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL16/REGFF/reg4\, B => 
        \CHANNEL16/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL16/load_net_1\, Q => \CHANNEL16/REGFF/reg5\);
    
    \CHANNEL27/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg7\, B => 
        \CHANNEL27/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL27/load_4\, Q => 
        \CHANNEL27/REGFF/reg8\);
    
    \CHANNEL22/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL22/REGCC10/mx2_3_y\);
    
    \CHANNEL17/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL17/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_A/reg3\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_8\);
    
    \ENABLE_INBUF_21_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(21), Y => \ENABLE_INBUF_21_inst/U0/NET1\);
    
    \CHANNEL14/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL14/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_A/reg7\);
    
    \OUTBUF32_OUTBUF_6_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_24, Y => 
        \OUTBUF32_OUTBUF_6_inst/U0/NET3\);
    
    \CHANNEL14/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/load_net_3\);
    
    \CHANNEL28/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg3\);
    
    \CHANNEL9/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg2\, B => 
        \CHANNEL9/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_2\, Q => \CHANNEL9/REGFF/reg3\);
    
    \CHANNEL11/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_7_y\);
    
    \CHANNEL29/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL29/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL29/load_4\);
    
    \CHANNEL19/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_1\, Y => 
        \CHANNEL19/REGFF/data_net_1\);
    
    \CHANNEL13/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg6\);
    
    \CHANNEL9/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_A/reg9\);
    
    \CHANNEL14/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL14/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL14/load_4\);
    
    \CHANNEL31/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg7\);
    
    \CHANNEL11/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/GNDZ0\, B => 
        \CHANNEL11/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_3\, Q => \CHANNEL11/REGFF/reg0\);
    
    NEW_VALUE_B_INBUF_2_inst_0 : BUFF
      port map(A => dat_b_net_6, Y => dat_b_net_6_0);
    
    \NEW_VALUE_B_INBUF_4_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_4_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_4_inst/U0/NET2\);
    
    \CHANNEL22/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_5\, Y => 
        \CHANNEL22/REGFF/data_net_5\);
    
    \CHANNEL21/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL21/REGCC10/mx2_3_y\);
    
    \CHANNEL19/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg0\, B => 
        \CHANNEL19/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_3\, Q => \CHANNEL19/REGFF/reg1\);
    
    \CHANNEL30/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL30/new_value_net_1\, Y => 
        \CHANNEL30/REGFF/data_net_1\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_net_5\);
    
    \CHANNEL8/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL8/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg9\);
    
    \ENABLE_INBUF_23_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_23_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_23_inst/U0/NET2\);
    
    \CHANNEL16/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL16/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_A/reg7\);
    
    \CHANNEL31/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_0_y\);
    
    \ENABLE_INBUF_24_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(24), Y => \ENABLE_INBUF_24_inst/U0/NET1\);
    
    \CHANNEL0/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_6\, Y => 
        \CHANNEL0/REGFF/data_net_6\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_1\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_5\);
    
    \CHANNEL24/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg5\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_9_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/new_value_net_4\);
    
    \CHANNEL27/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/load_net_3\);
    
    \CHANNEL26/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL26/new_value_net_7\, Y => 
        \CHANNEL26/REGFF/data_net_7\);
    
    \CHANNEL0/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/reg8_b\);
    
    \CHANNEL7/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL7/REGCC10/mx2_3_y\);
    
    \CHANNEL10/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg5\);
    
    \CHANNEL6/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL6/REGCC10/mx2_0_y\);
    
    \CHANNEL23/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_1\, Y => 
        \CHANNEL23/REGFF/data_net_1\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_2\);
    
    \CHANNEL5/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg2\);
    
    \CHANNEL9/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL9/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_22, Q => \CHANNEL9/new_value_net_7\);
    
    \CHANNEL6/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL6/LOAD\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_net_5\);
    
    \CHANNEL2/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg4\);
    
    \CHANNEL14/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg1\);
    
    \CHANNEL14/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_9_y\);
    
    \CHANNEL3/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL3/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_A/reg4\);
    
    \CHANNEL20/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/GNDZ0\, B => 
        \CHANNEL20/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_3\, Q => \CHANNEL20/REGFF/reg0\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_8\);
    
    \CHANNEL3/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg7\);
    
    \CHANNEL21/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg6\);
    
    \CHANNEL1/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL1/new_value_net_3\, Y => 
        \CHANNEL1/REGFF/data_net_3\);
    
    \ENABLE_INBUF_29_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(29), Y => \ENABLE_INBUF_29_inst/U0/NET1\);
    
    \CHANNEL25/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL25/LOAD\);
    
    \CHANNEL16/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg0\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_6\);
    
    \CHANNEL8/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/reg8_b\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_9\);
    
    \CHANNEL7/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL7/REGCC10/mx2_6_y\);
    
    \CHANNEL15/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg6\);
    
    \CHANNEL5/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL5/REGFF/reg4\, B => 
        \CHANNEL5/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL5/load_net_1\, Q => \CHANNEL5/REGFF/reg5\);
    
    \CHANNEL3/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg9\);
    
    \CHANNEL13/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg4\, B => 
        \CHANNEL13/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_1\, Q => \CHANNEL13/REGFF/reg5\);
    
    \CHANNEL22/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_4\, Y => 
        \CHANNEL22/REGFF/data_net_4\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/NEW_VALUE\);
    
    \CHANNEL13/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL13/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_A/reg4\);
    
    \CHANNEL10/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_8_y\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_2\);
    
    \CHANNEL14/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg5\, B => 
        \CHANNEL14/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL14/LOAD\, Q
         => \CHANNEL14/REGFF/reg6\);
    
    \CHANNEL21/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_2\, Y => 
        \CHANNEL21/REGFF/data_net_2\);
    
    \CHANNEL14/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg8\, B => 
        \CHANNEL14/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL14/load_4\, Q => 
        dout_net_16);
    
    \CHANNEL14/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_1_y\);
    
    \CHANNEL15/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_3\, Y => 
        \CHANNEL15/REGFF/data_net_3\);
    
    \CHANNEL9/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg8\, B => 
        \CHANNEL9/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL9/load_4\, Q => 
        dout_net_21);
    
    \CHANNEL17/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg3\, B => 
        \CHANNEL17/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_1\, Q => \CHANNEL17/REGFF/reg4\);
    
    \CHANNEL14/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL14/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_17, Q => \CHANNEL14/new_value_net_6\);
    
    \CHANNEL28/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL28/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_B/reg4\);
    
    \CHANNEL11/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL11/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/load_net_1\);
    
    \CHANNEL30/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg7\, B => 
        \CHANNEL30/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL30/load_4\, Q => 
        \CHANNEL30/REGFF/reg8\);
    
    \CHANNEL29/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL29/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL29/REG_A/reg0\);
    
    \CHANNEL13/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL13/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/load_net_2\);
    
    \CHANNEL6/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_7\, Y => 
        \CHANNEL6/REGFF/data_net_7\);
    
    \CHANNEL5/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL5/REGCC10/mx2_3_y\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_9\);
    
    \CHANNEL21/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL21/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL21/REG_A/reg0\);
    
    \CHANNEL25/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_9_y\);
    
    \CHANNEL26/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL26/load_4\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_6\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_net_5\);
    
    \CHANNEL12/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/load_net_1\);
    
    \CHANNEL2/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL2/load_4\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_6\);
    
    \NEW_VALUE_A_INBUF_2_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(2), Y => 
        \NEW_VALUE_A_INBUF_2_inst/U0/NET1\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_3\);
    
    \CHANNEL23/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_0_y\);
    
    \NEW_VALUE_B_INBUF_2_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(2), Y => 
        \NEW_VALUE_B_INBUF_2_inst/U0/NET1\);
    
    \CHANNEL14/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_4\, Y => 
        \CHANNEL14/REGFF/data_net_4\);
    
    \CHANNEL2/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_2\, Y => 
        \CHANNEL2/REGFF/data_net_2\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_4\);
    
    \CHANNEL30/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_4_y\);
    
    \CHANNEL25/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL25/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_A/reg7\);
    
    \CHANNEL14/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg2\, B => 
        \CHANNEL14/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_2\, Q => \CHANNEL14/REGFF/reg3\);
    
    \OUTBUF32_OUTBUF_20_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_20_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_20_inst/U0/NET1\);
    
    \CHANNEL15/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/reg8_b\);
    
    \CHANNEL5/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/load_net_3\);
    
    \ENABLE_INBUF_5_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_5_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_5_inst/U0/NET2\);
    
    \CHANNEL25/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg0\);
    
    \CHANNEL1/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL1/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg4\);
    
    \CHANNEL22/REGFF/DC2/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_6\, Y => 
        \CHANNEL22/REGFF/data_net_6\);
    
    \CHANNEL28/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL28/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL28/LOAD\);
    
    \CHANNEL7/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg0\);
    
    \CHANNEL31/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg4\);
    
    \CHANNEL26/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_4_y\);
    
    \CHANNEL15/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg4\);
    
    \CHANNEL7/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL7/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_24, Q => \CHANNEL7/new_value_net_7\);
    
    \CHANNEL10/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg7\);
    
    \OUTBUF32_OUTBUF_3_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_27, Y => 
        \OUTBUF32_OUTBUF_3_inst/U0/NET3\);
    
    \CHANNEL5/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg9\);
    
    \CHANNEL3/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_4\, Y => 
        \CHANNEL3/REGFF/data_net_4\);
    
    \NEW_VALUE_B_INBUF_7_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(7), Y => 
        \NEW_VALUE_B_INBUF_7_inst/U0/NET1\);
    
    \CHANNEL21/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/reg8_b\);
    
    \CHANNEL20/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL20/REGCC10/mx2_5_y\);
    
    \CHANNEL10/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg3\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_6\);
    
    \CHANNEL14/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL14/new_value_net_7\, Y => 
        \CHANNEL14/REGFF/data_net_7\);
    
    \ENABLE_INBUF_30_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_30_inst/U0/NET2\, Y => 
        enable_net_1);
    
    \CHANNEL13/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg1\, B => 
        \CHANNEL13/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_2\, Q => \CHANNEL13/REGFF/reg2\);
    
    \CHANNEL17/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL17/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg5\);
    
    \CHANNEL2/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg7\);
    
    \CHANNEL23/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg7\);
    
    \CHANNEL19/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL19/REGFF/reg3\, B => 
        \CHANNEL19/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL19/load_net_1\, Q => \CHANNEL19/REGFF/reg4\);
    
    \CHANNEL8/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_3\, Y => 
        \CHANNEL8/REGFF/data_net_3\);
    
    \CHANNEL4/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/reg7\, B => 
        \CHANNEL4/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL4/load_4\, Q => 
        \CHANNEL4/REGFF/reg8\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_6\);
    
    \CHANNEL4/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL4/LOAD\);
    
    \ENABLE_INBUF_18_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(18), Y => \ENABLE_INBUF_18_inst/U0/NET1\);
    
    \CHANNEL7/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL7/new_value_net_2\, Y => 
        \CHANNEL7/REGFF/data_net_2\);
    
    \CHANNEL12/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL12/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_A/reg4\);
    
    \CHANNEL2/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_1\, Y => 
        \CHANNEL2/REGFF/data_net_1\);
    
    \CHANNEL19/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL19/load_net_1\);
    
    \CHANNEL1/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg7\);
    
    \CHANNEL30/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/reg8_b\);
    
    \CHANNEL17/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL17/REGCC10/mx2_3_y\);
    
    \CHANNEL24/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg2\);
    
    \OUTBUF32_OUTBUF_22_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_22_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_22_inst/U0/NET1\);
    
    \CHANNEL19/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_0_y\);
    
    \CHANNEL20/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg2\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/NEW_VALUE\);
    
    \CHANNEL28/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg2\);
    
    \CHANNEL26/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg0\, B => 
        \CHANNEL26/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL26/load_net_3\, Q => \CHANNEL26/REGFF/reg1\);
    
    \OUTBUF32_OUTBUF_28_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_28_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_28_inst/U0/NET2\, PAD => DATA_OUTPUT(28));
    
    \ENABLE_INBUF_13_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_13_inst/U0/NET2\, Y => 
        enable_net_18);
    
    \CHANNEL27/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_4\, Y => 
        \CHANNEL27/REGFF/data_net_4\);
    
    \CHANNEL6/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg4\, B => 
        \CHANNEL6/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_1\, Q => \CHANNEL6/REGFF/reg5\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_net_5\);
    
    \CHANNEL18/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL18/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_13, Q => \CHANNEL18/new_value_net_6\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_3\);
    
    \CHANNEL6/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL6/load_4\);
    
    \CHANNEL29/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL29/REGFF/reg2\, B => 
        \CHANNEL29/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL29/load_net_2\, Q => \CHANNEL29/REGFF/reg3\);
    
    \CHANNEL27/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL27/new_value_net_7\, Y => 
        \CHANNEL27/REGFF/data_net_7\);
    
    \CHANNEL23/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/REG_B/reg4\);
    
    \CHANNEL16/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL16/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL16/REG_B/reg5\);
    
    \ENABLE_INBUF_30_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(30), Y => \ENABLE_INBUF_30_inst/U0/NET1\);
    
    \CHANNEL14/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_7_y\);
    
    \CHANNEL3/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL3/LOAD\);
    
    \CHANNEL5/REGCC10/DFC1B_CC_Q_1_inst\ : DFC1B_CC
      port map(D => \CHANNEL5/REGCC10/mx2_4_y\, CLR => CLRZ0, CLK
         => enable_net_26, Q => \CHANNEL5/new_value_net_7\);
    
    \NEW_VALUE_B_INBUF_1_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(1), Y => 
        \NEW_VALUE_B_INBUF_1_inst/U0/NET1\);
    
    \CHANNEL6/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL6/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_A/reg2\);
    
    \CHANNEL10/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_7_y\);
    
    \CHANNEL8/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_6_y\);
    
    \CHANNEL7/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL7/REGFF/reg8\, B => 
        \CHANNEL7/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL7/load_4\, Q => 
        dout_net_23);
    
    \CHANNEL11/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg0\, B => 
        \CHANNEL11/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_3\, Q => \CHANNEL11/REGFF/reg1\);
    
    \ENABLE_INBUF_3_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(3), Y => \ENABLE_INBUF_3_inst/U0/NET1\);
    
    \CHANNEL1/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL1/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_A/reg6\);
    
    \ENABLE_INBUF_15_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(15), Y => \ENABLE_INBUF_15_inst/U0/NET1\);
    
    \CHANNEL14/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg4\, B => 
        \CHANNEL14/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_1\, Q => \CHANNEL14/REGFF/reg5\);
    
    \CHANNEL20/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg0\);
    
    \ENABLE_INBUF_0_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(0), Y => \ENABLE_INBUF_0_inst/U0/NET1\);
    
    \CHANNEL6/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL6/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/load_net_3\);
    
    \OUTBUF32_OUTBUF_1_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_29, Y => 
        \OUTBUF32_OUTBUF_1_inst/U0/NET3\);
    
    \CHANNEL14/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg7\);
    
    \CHANNEL6/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg6\, B => 
        \CHANNEL6/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL6/LOAD\, Q
         => \CHANNEL6/REGFF/reg7\);
    
    \CHANNEL2/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL2/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_A/reg3\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_net_5\);
    
    \CHANNEL3/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_1_y\);
    
    \CHANNEL22/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg7\);
    
    \CHANNEL11/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_1_y\);
    
    \NEW_VALUE_B_INBUF_4_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(4), Y => 
        \NEW_VALUE_B_INBUF_4_inst/U0/NET1\);
    
    \CHANNEL12/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg5\, B => 
        \CHANNEL12/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL12/LOAD\, Q
         => \CHANNEL12/REGFF/reg6\);
    
    \CHANNEL16/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL16/REGCC10/mx2_0_y\);
    
    \CHANNEL23/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL23/REGCC10/mx2_1_y\);
    
    \CHANNEL27/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL27/REGFF/reg2\, B => 
        \CHANNEL27/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL27/load_net_2\, Q => \CHANNEL27/REGFF/reg3\);
    
    \CHANNEL5/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_0_y\);
    
    \CHANNEL19/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL19/NEW_VALUE\, Y => 
        \CHANNEL19/REGFF/DATA\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_4\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_2\);
    
    \CHANNEL7/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL7/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_B/reg6\);
    
    \CHANNEL9/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL9/REG_B/reg9\);
    
    \CHANNEL11/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL11/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_20, Q => \CHANNEL11/new_value_net_8\);
    
    \CHANNEL28/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg3\, B => 
        \CHANNEL28/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_1\, Q => \CHANNEL28/REGFF/reg4\);
    
    \CHANNEL11/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_4_y\);
    
    \CHANNEL10/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/load_net_3\);
    
    \CHANNEL10/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/reg8_a\);
    
    \CHANNEL29/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL29/new_value_9\, Y => 
        \CHANNEL29/REGFF/data_9\);
    
    \CHANNEL3/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg1\);
    
    \CHANNEL22/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_2_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_0_y\);
    
    \CHANNEL5/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_3\, Y => 
        \CHANNEL5/REGFF/data_net_3\);
    
    \CHANNEL8/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL8/REGCC10/mx2_2_y\);
    
    \CHANNEL31/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL31/REGFF/reg7\, B => 
        \CHANNEL31/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL31/load_4\, Q => 
        \CHANNEL31/REGFF/reg8\);
    
    \OUTBUF32_OUTBUF_25_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_25_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_25_inst/U0/NET2\, PAD => DATA_OUTPUT(25));
    
    \CHANNEL11/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg2\);
    
    \CHANNEL6/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL6/REGFF/reg2\, B => 
        \CHANNEL6/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL6/load_net_2\, Q => \CHANNEL6/REGFF/reg3\);
    
    \CHANNEL11/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/reg8_a\);
    
    \OUTBUF32_OUTBUF_2_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_2_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_2_inst/U0/NET1\);
    
    \OUTBUF32_OUTBUF_10_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_20, Y => 
        \OUTBUF32_OUTBUF_10_inst/U0/NET3\);
    
    \CHANNEL30/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg3\, B => 
        \CHANNEL30/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_1\, Q => \CHANNEL30/REGFF/reg4\);
    
    \CHANNEL21/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_3\, Y => 
        \CHANNEL21/REGFF/data_net_3\);
    
    \CHANNEL19/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_2\, Y => 
        \CHANNEL19/REGFF/data_net_2\);
    
    \CHANNEL20/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg7\);
    
    \CHANNEL20/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL20/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/load_net_1\);
    
    \CHANNEL25/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL25/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg5\);
    
    \CHANNEL1/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/REG_B/reg9\);
    
    \ENABLE_INBUF_9_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_9_inst/U0/NET2\, Y => 
        enable_net_22);
    
    \CHANNEL28/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL28/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL28/REG_A/reg6\);
    
    \CHANNEL15/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_1_y\);
    
    \CHANNEL18/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_7_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_4_y\);
    
    \CHANNEL20/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_9\, Y => 
        \CHANNEL20/REGFF/data_9\);
    
    \CHANNEL7/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg2\);
    
    \CHANNEL9/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg1\, B => 
        \CHANNEL9/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL9/load_net_2\, Q => \CHANNEL9/REGFF/reg2\);
    
    \CHANNEL27/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL27/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg9\);
    
    \CHANNEL16/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL16/new_value_9\, Y => 
        \CHANNEL16/REGFF/data_9\);
    
    \CHANNEL14/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL14/REGCC10/mx2_0_y\);
    
    \CHANNEL18/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg3\);
    
    \CHANNEL29/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL29/REGCC10/mx2_5_y\);
    
    \CHANNEL28/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg1\, B => 
        \CHANNEL28/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_2\, Q => \CHANNEL28/REGFF/reg2\);
    
    \ENABLE_INBUF_17_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_17_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_17_inst/U0/NET2\);
    
    \CHANNEL2/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_9_y\);
    
    \ENABLE_INBUF_23_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(23), Y => \ENABLE_INBUF_23_inst/U0/NET1\);
    
    \CHANNEL15/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL15/REGCC10/mx2_3_y\);
    
    \OUTBUF32_OUTBUF_12_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_18, Y => 
        \OUTBUF32_OUTBUF_12_inst/U0/NET3\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_6\);
    
    \CHANNEL31/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL31/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg0\);
    
    \CHANNEL18/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL18/load_4\);
    
    \CHANNEL25/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL25/REGCC10/mx2_6_y\);
    
    \CHANNEL19/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL19/LOAD\);
    
    \CHANNEL28/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL28/REGCC10/mx2_8_y\);
    
    \CHANNEL0/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg7\);
    
    \CHANNEL5/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg5\);
    
    \CHANNEL21/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg1\);
    
    \CHANNEL6/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_9\, Y => 
        \CHANNEL6/REGFF/data_9\);
    
    \CHANNEL30/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL30/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg1\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_6_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_0_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_2\);
    
    \CHANNEL26/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL26/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/REG_A/reg5\);
    
    \CHANNEL23/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_4\, Y => 
        \CHANNEL23/REGFF/data_net_4\);
    
    \CHANNEL24/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg5\);
    
    \CHANNEL14/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg5\);
    
    \CHANNEL15/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/load_net_2\);
    
    \CHANNEL0/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL0/new_value_net_1\, Y => 
        \CHANNEL0/REGFF/data_net_1\);
    
    \CHANNEL7/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL7/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL7/REG_A/reg3\);
    
    \CHANNEL22/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_6_y\);
    
    \CHANNEL3/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL3/REGCC10/mx2_3_y\, CLR => CLRZ0, CLK
         => enable_net_28, Q => \CHANNEL3/NEW_VALUE\);
    
    \CHANNEL21/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL21/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/load_net_3\);
    
    \CHANNEL27/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg7\);
    
    \NEW_VALUE_B_INBUF_3_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_3_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_3_inst/U0/NET2\);
    
    \CHANNEL4/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_1_y\);
    
    \CHANNEL24/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg4\);
    
    \CHANNEL30/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL30/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_1, Q => \CHANNEL30/new_value_net_8\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_net_8\);
    
    \CHANNEL10/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL10/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/load_net_2\);
    
    \CHANNEL0/REGCC10/MX2_8\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_0_9, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL0/REGCC10/mx2_8_y\);
    
    \ENABLE_INBUF_10_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_10_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_10_inst/U0/NET2\);
    
    \CHANNEL27/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL27/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_B/reg3\);
    
    \OUTBUF32_OUTBUF_0_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_0_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_0_inst/U0/NET2\, PAD => DATA_OUTPUT(0));
    
    \CHANNEL29/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL29/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_2, Q => \CHANNEL29/new_value_net_6\);
    
    \CHANNEL24/REG_A/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL24/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg9\);
    
    \CHANNEL4/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL4/new_value_net_2\, Y => 
        \CHANNEL4/REGFF/data_net_2\);
    
    \CHANNEL25/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg3\, B => 
        \CHANNEL25/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL25/load_net_1\, Q => \CHANNEL25/REGFF/reg4\);
    
    \CHANNEL11/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg6\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_4_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_9_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_4\);
    
    \OUTBUF32_OUTBUF_26_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_26_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_26_inst/U0/NET1\);
    
    \CHANNEL19/REGFF/DC1/U0\ : CM8BUFF
      port map(A => \CHANNEL19/new_value_net_7\, Y => 
        \CHANNEL19/REGFF/data_net_7\);
    
    \CHANNEL25/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_2\, Y => 
        \CHANNEL25/REGFF/data_net_2\);
    
    \CHANNEL22/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL22/REGCC10/mx2_7_y\);
    
    \OUTBUF32_OUTBUF_30_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_30_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_30_inst/U0/NET1\);
    
    \CHANNEL24/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL24/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_B/reg6\);
    
    \OUTBUF32_OUTBUF_9_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_9_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_9_inst/U0/NET2\, PAD => DATA_OUTPUT(9));
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_9\);
    
    \OUTBUF32_OUTBUF_29_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_29_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_29_inst/U0/NET2\, PAD => DATA_OUTPUT(29));
    
    \CHANNEL3/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg7\, B => 
        \CHANNEL3/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, PRE
         => \VCC\, E => \GND\, S => \CHANNEL3/load_4\, Q => 
        \CHANNEL3/REGFF/reg8\);
    
    \CHANNEL2/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL2/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/load_net_2\);
    
    \CHANNEL6/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL6/new_value_net_1\, Y => 
        \CHANNEL6/REGFF/data_net_1\);
    
    \CHANNEL4/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg4\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_net_8\);
    
    \CHANNEL19/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL19/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_12, Q => \CHANNEL19/new_value_net_6\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_1\);
    
    \CHANNEL11/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL11/new_value_net_4\, Y => 
        \CHANNEL11/REGFF/data_net_4\);
    
    \NEW_VALUE_B_INBUF_5_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_B_INBUF_5_inst/U0/NET2\, Y => 
        dat_b_net_3);
    
    \CHANNEL31/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_3, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL31/REGCC10/mx2_5_y\);
    
    \CHANNEL13/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg2\, B => 
        \CHANNEL13/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL13/load_net_2\, Q => \CHANNEL13/REGFF/reg3\);
    
    \CHANNEL26/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL26/REGFF/reg5\, B => 
        \CHANNEL26/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL26/LOAD\, Q
         => \CHANNEL26/REGFF/reg6\);
    
    \CHANNEL10/REGFF/REGFF_6/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg5\, B => 
        \CHANNEL10/REGFF/data_net_2\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL10/LOAD\, Q
         => \CHANNEL10/REGFF/reg6\);
    
    \CHANNEL5/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL5/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL5/REG_A/reg0\);
    
    \CHANNEL11/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg4\, B => 
        \CHANNEL11/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_1\, Q => \CHANNEL11/REGFF/reg5\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_7_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_6\);
    
    \CHANNEL8/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL8/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_23, Q => \CHANNEL8/new_value_net_5\);
    
    \CHANNEL5/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg6\);
    
    \OUTBUF32_OUTBUF_20_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_20_inst/U0/NET2\);
    
    \NEW_VALUE_A_INBUF_7_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_A_INBUF_7_inst/U0/NET1\, Y => 
        \NEW_VALUE_A_INBUF_7_inst/U0/NET2\);
    
    \CHANNEL20/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL20/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_11, Q => \CHANNEL20/new_value_net_6\);
    
    \CHANNEL18/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL18/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_B/reg4\);
    
    \CHANNEL31/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_1\, Y => 
        \CHANNEL31/REGFF/data_net_1\);
    
    \CHANNEL1/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL1/REGFF/reg2\, B => 
        \CHANNEL1/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL1/load_net_2\, Q => \CHANNEL1/REGFF/reg3\);
    
    \CHANNEL19/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL19/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL19/REG_A/reg0\);
    
    \CHANNEL11/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL11/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL11/REG_A/reg0\);
    
    \CHANNEL31/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL31/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => ENABLE, Q => \CHANNEL31/new_value_net_6\);
    
    \CHANNEL22/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL22/new_value_net_8\, Y => 
        \CHANNEL22/REGFF/data_net_8\);
    
    \CHANNEL24/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL24/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL24/REG_A/reg3\);
    
    \ENABLE_INBUF_4_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \ENABLE_INBUF_4_inst/U0/NET1\, Y => 
        \ENABLE_INBUF_4_inst/U0/NET2\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/new_value_9\);
    
    \CHANNEL11/REGCC10/MX2_0\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_2, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL11/REGCC10/mx2_0_y\);
    
    \CHANNEL1/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_5_y\);
    
    \CHANNEL20/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL20/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_A/reg1\);
    
    \CHANNEL31/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL31/new_value_net_8\, Y => 
        \CHANNEL31/REGFF/data_net_8\);
    
    \CHANNEL28/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL28/new_value_net_8\, Y => 
        \CHANNEL28/REGFF/data_net_8\);
    
    \OUTBUF32_OUTBUF_17_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_17_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_17_inst/U0/NET2\, PAD => DATA_OUTPUT(17));
    
    \CHANNEL15/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL15/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_A/reg7\);
    
    \CHANNEL10/REGCC10/DFC1B_CC_Q_2_inst\ : DFC1B_CC
      port map(D => \CHANNEL10/REGCC10/mx2_7_y\, CLR => CLRZ0, 
        CLK => enable_net_21, Q => \CHANNEL10/new_value_net_6\);
    
    \CHANNEL24/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_8\, Y => 
        \CHANNEL24/REGFF/data_net_8\);
    
    \NEW_VALUE_B_INBUF_8_inst/U0/U1\ : IOFIFO_INBUF
      port map(A => \NEW_VALUE_B_INBUF_8_inst/U0/NET1\, Y => 
        \NEW_VALUE_B_INBUF_8_inst/U0/NET2\);
    
    \CHANNEL0/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL0/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/load_net_1\);
    
    \CHANNEL11/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg3\, B => 
        \CHANNEL11/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_1\, Q => \CHANNEL11/REGFF/reg4\);
    
    \ENABLE_INBUF_26_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_26_inst/U0/NET2\, Y => 
        enable_net_5);
    
    \CHANNEL9/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL9/REGCC10/mx2_7_y\);
    
    \OUTBUF32_OUTBUF_21_inst/U0/U1\ : IOFIFO_OUTBUF
      port map(A => \OUTBUF32_OUTBUF_21_inst/U0/NET3\, Y => 
        \OUTBUF32_OUTBUF_21_inst/U0/NET1\);
    
    \CHANNEL4/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg4\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_2_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_net_8\);
    
    \CHANNEL31/REG_A/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg1\);
    
    \CHANNEL15/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg0\);
    
    \OUTBUF32_OUTBUF_22_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_22_inst/U0/NET2\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/new_value_9\);
    
    \CHANNEL5/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL5/new_value_net_8\, Y => 
        \CHANNEL5/REGFF/data_net_8\);
    
    \CHANNEL1/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL1/REGCC10/mx2_1_y\);
    
    \CHANNEL14/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg0\, B => 
        \CHANNEL14/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_3\, Q => \CHANNEL14/REGFF/reg1\);
    
    \CHANNEL10/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg6\, B => 
        \CHANNEL10/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL10/LOAD\, Q
         => \CHANNEL10/REGFF/reg7\);
    
    \CHANNEL3/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL3/REGFF/reg8\, B => 
        \CHANNEL3/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL3/load_4\, Q => 
        dout_net_27);
    
    \CHANNEL11/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/reg8_b\);
    
    \ENABLE_INBUF_7_inst/U0/U2\ : IOI_BUFF
      port map(A => \ENABLE_INBUF_7_inst/U0/NET2\, Y => 
        enable_net_24);
    
    \CHANNEL11/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg8\, B => 
        \CHANNEL11/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL11/load_4\, Q => 
        dout_net_19);
    
    \CHANNEL15/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_net_1\, Y => 
        \CHANNEL15/REGFF/data_net_1\);
    
    \CHANNEL8/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg6\);
    
    \CHANNEL12/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/GNDZ0\, B => 
        \CHANNEL12/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_3\, Q => \CHANNEL12/REGFF/reg0\);
    
    \CHANNEL21/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL21/REGCC10/mx2_2_y\);
    
    \CHANNEL4/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/reg8_b\);
    
    \CHANNEL30/REGFF/REGFF_5/U0\ : DFMEG
      port map(A => \CHANNEL30/REGFF/reg4\, B => 
        \CHANNEL30/REGFF/data_net_3\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL30/load_net_1\, Q => \CHANNEL30/REGFF/reg5\);
    
    \CHANNEL28/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL28/REGFF/reg0\, B => 
        \CHANNEL28/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL28/load_net_3\, Q => \CHANNEL28/REGFF/reg1\);
    
    \CHANNEL10/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL10/REGFF/reg0\, B => 
        \CHANNEL10/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL10/load_net_3\, Q => \CHANNEL10/REGFF/reg1\);
    
    \CHANNEL0/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_A/reg6\);
    
    \CHANNEL21/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL21/new_value_net_5\, Y => 
        \CHANNEL21/REGFF/data_net_5\);
    
    \CHANNEL12/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL12/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/load_net_3\);
    
    \CHANNEL24/REGFF/DC7/U0\ : CM8BUFF
      port map(A => \CHANNEL24/new_value_net_1\, Y => 
        \CHANNEL24/REGFF/data_net_1\);
    
    \CHANNEL13/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg7\);
    
    \CHANNEL24/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL24/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_7, Q => \CHANNEL24/new_value_net_5\);
    
    \CHANNEL2/REGFF/DC3/U0\ : CM8BUFF
      port map(A => \CHANNEL2/new_value_net_5\, Y => 
        \CHANNEL2/REGFF/data_net_5\);
    
    \CHANNEL8/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL8/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_B/reg5\);
    
    \CHANNEL22/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL22/REGFF/reg1\, B => 
        \CHANNEL22/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL22/load_net_2\, Q => \CHANNEL22/REGFF/reg2\);
    
    \CHANNEL2/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL2/REGCC10/mx2_6_y\, CLR => CLRZ0, CLK
         => enable_net_29, Q => \CHANNEL2/new_value_net_5\);
    
    \ENABLE_INBUF_11_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(11), Y => \ENABLE_INBUF_11_inst/U0/NET1\);
    
    \CHANNEL14/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL14/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL14/REG_B/reg2\);
    
    \CHANNEL29/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL29/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL29/REG_B/reg3\);
    
    \CHANNEL10/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL10/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_B/reg2\);
    
    \CHANNEL20/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL20/REGFF/reg1\, B => 
        \CHANNEL20/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL20/load_net_2\, Q => \CHANNEL20/REGFF/reg2\);
    
    \CHANNEL23/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_B_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL23/REGCC10/mx2_3_y\);
    
    \CHANNEL11/REGFF/DC8/U0\ : CM8BUFF
      port map(A => \CHANNEL11/NEW_VALUE\, Y => 
        \CHANNEL11/REGFF/DATA\);
    
    \CHANNEL3/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL3/REGCC10/mx2_5_y\);
    
    \CHANNEL18/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg2\);
    
    \CHANNEL23/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL23/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/load_net_3\);
    
    \CHANNEL19/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL19/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL19/load_4\);
    
    \OUTBUF32_OUTBUF_4_inst/U0/U0\ : IOPAD_TRI
      port map(D => \OUTBUF32_OUTBUF_4_inst/U0/NET1\, E => 
        \OUTBUF32_OUTBUF_4_inst/U0/NET2\, PAD => DATA_OUTPUT(4));
    
    \CHANNEL11/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL11/REGFF/reg2\, B => 
        \CHANNEL11/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL11/load_net_2\, Q => \CHANNEL11/REGFF/reg3\);
    
    \CHANNEL5/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL5/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL5/load_net_2\);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_7_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_1_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_1\);
    
    \CHANNEL23/REG_B/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL23/REG_B/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL23/reg8_b\);
    
    \CHANNEL19/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL19/REGCC10/mx2_9_y\);
    
    \CHANNEL27/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL27/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_4, Q => \CHANNEL27/new_value_net_3\);
    
    \CHANNEL17/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL17/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_14, Q => \CHANNEL17/new_value_net_3\);
    
    \CHANNEL12/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL12/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_19, Q => \CHANNEL12/new_value_9\);
    
    \CHANNEL8/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL8/new_value_net_4\, Y => 
        \CHANNEL8/REGFF/data_net_4\);
    
    \CHANNEL2/REGFF/REGFF_3/U0\ : DFMEG
      port map(A => \CHANNEL2/REGFF/reg2\, B => 
        \CHANNEL2/REGFF/data_net_5\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL2/load_net_2\, Q => \CHANNEL2/REGFF/reg3\);
    
    \CHANNEL13/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL13/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL13/REG_B/reg4\);
    
    \CHANNEL12/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL12/REGFF/reg3\, B => 
        \CHANNEL12/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL12/load_net_1\, Q => \CHANNEL12/REGFF/reg4\);
    
    \OUTBUF32_OUTBUF_16_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_14, Y => 
        \OUTBUF32_OUTBUF_16_inst/U0/NET3\);
    
    \ENABLE_INBUF_14_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(14), Y => \ENABLE_INBUF_14_inst/U0/NET1\);
    
    \CHANNEL10/REGCC10/MX2_4\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_7, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL10/REGCC10/mx2_4_y\);
    
    \CHANNEL25/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL25/new_value_net_4\, Y => 
        \CHANNEL25/REGFF/data_net_4\);
    
    \CHANNEL4/REG_A/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg5\);
    
    \CHANNEL26/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL26/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_5, Q => \CHANNEL26/new_value_9\);
    
    \CHANNEL17/LOAD0/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/load_net_3\);
    
    \OUTBUF32_OUTBUF_17_inst/U0/U4\ : IOOE_BUFF
      port map(A => \VCC\, Y => \OUTBUF32_OUTBUF_17_inst/U0/NET2\);
    
    \CHANNEL8/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL8/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL8/REG_A/reg6\);
    
    \CHANNEL4/REG_A/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL4/REG_A/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_A/reg3\);
    
    \CHANNEL10/REG_A/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg0\);
    
    \CHANNEL30/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL30/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL30/REG_B/reg9\);
    
    \CHANNEL22/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg1\);
    
    \CHANNEL31/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/load_net_1\);
    
    \CHANNEL12/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL12/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL12/REG_B/reg7\);
    
    \CHANNEL31/REG_A/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL31/REG_A/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_A/reg2\);
    
    \CHANNEL2/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg7\);
    
    \CHANNEL9/REGFF/REGFF_7/U0\ : DFMEG
      port map(A => \CHANNEL9/REGFF/reg6\, B => 
        \CHANNEL9/REGFF/data_net_1\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => \CHANNEL9/LOAD\, Q
         => \CHANNEL9/REGFF/reg7\);
    
    \ENABLE_INBUF_19_inst/U0/U0\ : IOPAD_IN
      port map(PAD => EN(19), Y => \ENABLE_INBUF_19_inst/U0/NET1\);
    
    \CHANNEL20/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg5\);
    
    \CHANNEL15/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL15/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL15/LOAD\);
    
    \CHANNEL30/REGCC10/MX2_2\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_8, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_2_y\);
    
    \CHANNEL22/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL22/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL22/REG_B/reg0\);
    
    \CHANNEL1/REGCC10/DFC1B_CC_Q_0_inst\ : DFC1B_CC
      port map(D => \CHANNEL1/REGCC10/mx2_2_y\, CLR => CLRZ0, CLK
         => enable_net_30, Q => \CHANNEL1/new_value_net_8\);
    
    \CHANNEL25/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL25/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_6, Q => \CHANNEL25/new_value_9\);
    
    \CHANNEL24/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL24/REGFF/GNDZ0\, B => 
        \CHANNEL24/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL24/load_net_3\, Q => \CHANNEL24/REGFF/reg0\);
    
    \CHANNEL5/REG_B/REGFF_0/U0\ : DFEG
      port map(D => \CHANNEL5/REG_B/reg9\, CLK => clk_1000, CLR
         => \VCC\, PRE => CLRZ0, E => \GND\, Q => 
        \CHANNEL5/REG_B/reg0\);
    
    \CHANNEL26/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL26/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL26/load_net_1\);
    
    \CHANNEL14/REGFF/REGFF_2/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg1\, B => 
        \CHANNEL14/REGFF/data_net_6\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_2\, Q => \CHANNEL14/REGFF/reg2\);
    
    \CHANNEL4/REG_B/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL4/REG_B/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL4/REG_B/reg7\);
    
    \CHANNEL1/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL1/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL1/load_net_2\);
    
    \CHANNEL18/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_6_y\);
    
    \CHANNEL16/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL16/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_15, Q => \CHANNEL16/NEW_VALUE\);
    
    \Z_1I155/U0/U0\ : IOPAD_IN
      port map(PAD => CLK50, Y => \PLL/PLL_INT/REFCLK\);
    
    NEW_VALUE_B_INBUF_5_inst_0 : BUFF
      port map(A => dat_b_net_3, Y => dat_b_net_3_0);
    
    \CHANNEL6/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL6/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL6/REG_B/reg3\);
    
    \CHANNEL6/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL6/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_25, Q => \CHANNEL6/new_value_9\);
    
    \CHANNEL2/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL2/REGCC10/mx2_1_y\);
    
    \CHANNEL0/REGCC10/MX2_6\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_5_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL0/REGCC10/mx2_6_y\);
    
    \CHANNEL20/REGFF/DC4/U0\ : CM8BUFF
      port map(A => \CHANNEL20/new_value_net_4\, Y => 
        \CHANNEL20/REGFF/data_net_4\);
    
    \CHANNEL3/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL3/load_4\);
    
    \CHANNEL23/REGFF/DC0/U0\ : CM8BUFF
      port map(A => \CHANNEL23/new_value_net_8\, Y => 
        \CHANNEL23/REGFF/data_net_8\);
    
    \CHANNEL28/REGCC10/DFC1B_CC_Q_3_inst\ : DFC1B_CC
      port map(D => \CHANNEL28/REGCC10/mx2_6_y\, CLR => CLRZ0, 
        CLK => enable_net_3, Q => \CHANNEL28/new_value_net_5\);
    
    \CHANNEL26/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL26/REGCC10/mx2_9_y\);
    
    \CHANNEL9/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL9/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL9/LOAD\);
    
    \CHANNEL30/REGCC10/MX2_9\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_4, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL30/REGCC10/mx2_9_y\);
    
    \NEW_VALUE_B_INBUF_3_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_B(3), Y => 
        \NEW_VALUE_B_INBUF_3_inst/U0/NET1\);
    
    \CHANNEL3/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL3/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/REG_B/reg4\);
    
    \OUTBUF32_OUTBUF_11_inst/U0/U3\ : IOOE_BUFF
      port map(A => dout_net_19, Y => 
        \OUTBUF32_OUTBUF_11_inst/U0/NET3\);
    
    \CHANNEL0/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL0/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/REG_B/reg1\);
    
    \CHANNEL10/REG_A/REGFF_7/U0\ : DFEG
      port map(D => \CHANNEL10/REG_A/reg6\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL10/REG_A/reg7\);
    
    \CHANNEL3/REGFF/DC5/U0\ : CM8BUFF
      port map(A => \CHANNEL3/new_value_net_3\, Y => 
        \CHANNEL3/REGFF/data_net_3\);
    
    \CHANNEL13/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_9\, Y => 
        \CHANNEL13/REGFF/data_9\);
    
    \CHANNEL15/REGCC10/DFC1B_CC_Q_8_inst\ : DFC1B_CC
      port map(D => \CHANNEL15/REGCC10/mx2_3_y\, CLR => CLRZ0, 
        CLK => enable_net_16, Q => \CHANNEL15/NEW_VALUE\);
    
    \CHANNEL21/REG_B/REGFF_3/U0\ : DFEG
      port map(D => \CHANNEL21/REG_B/reg2\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL21/REG_B/reg3\);
    
    \CHANNEL4/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL4/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL4/load_4\);
    
    \CHANNEL15/REG_B/REGFF_5/U0\ : DFEG
      port map(D => \CHANNEL15/REG_B/reg4\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL15/REG_B/reg5\);
    
    \CHANNEL3/LOAD1/U0\ : DFEG
      port map(D => \CHANNEL3/reg8_a\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL3/load_net_2\);
    
    \CHANNEL16/LOAD4/U0\ : DFEG
      port map(D => \CHANNEL16/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL16/load_4\);
    
    \CHANNEL13/REGFF/DC6/U0\ : CM8BUFF
      port map(A => \CHANNEL13/new_value_net_2\, Y => 
        \CHANNEL13/REGFF/data_net_2\);
    
    \CHANNEL18/REG_A/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL18/REG_A/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL18/REG_A/reg6\);
    
    \CHANNEL17/REGFF/REGFF_1/U0\ : DFMEG
      port map(A => \CHANNEL17/REGFF/reg0\, B => 
        \CHANNEL17/REGFF/data_net_7\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL17/load_net_3\, Q => \CHANNEL17/REGFF/reg1\);
    
    \CHANNEL5/REGCC10/MX2_7\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_6_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL5/REGCC10/mx2_7_y\);
    
    \CHANNEL2/REG_B/REGFF_6/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg5\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg6\);
    
    \CHANNEL4/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL4/REGCC10/mx2_8_y\, CLR => CLRZ0, CLK
         => enable_net_27, Q => \CHANNEL4/new_value_9\);
    
    \CHANNEL13/REGFF/REGFF_9/U0\ : DFMEG
      port map(A => \CHANNEL13/REGFF/reg8\, B => 
        \CHANNEL13/REGFF/data_9\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL13/load_4\, Q => 
        dout_net_17);
    
    \CHANNEL2/REG_B/REGFF_2/U0\ : DFEG
      port map(D => \CHANNEL2/REG_B/reg1\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL2/REG_B/reg2\);
    
    \CHANNEL17/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL17/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL17/REG_B/reg9\);
    
    \CHANNEL0/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL0/REGCC10/mx2_5_y\, CLR => CLRZ0, CLK
         => enable_net_31, Q => \CHANNEL0/new_value_net_3\);
    
    \CHANNEL25/REGFF/REGFF_8/U0\ : DFMEG
      port map(A => \CHANNEL25/REGFF/reg7\, B => 
        \CHANNEL25/REGFF/DATA\, CLK => clk_1000, CLR => CLRZ0, 
        PRE => \VCC\, E => \GND\, S => \CHANNEL25/load_4\, Q => 
        \CHANNEL25/REGFF/reg8\);
    
    \CHANNEL22/REGCC10/DFC1B_CC_Q_9_inst\ : DFC1B_CC
      port map(D => \CHANNEL22/REGCC10/mx2_8_y\, CLR => CLRZ0, 
        CLK => enable_net_9, Q => \CHANNEL22/new_value_9\);
    
    \CHANNEL14/REGFF/REGFF_4/U0\ : DFMEG
      port map(A => \CHANNEL14/REGFF/reg3\, B => 
        \CHANNEL14/REGFF/data_net_4\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL14/load_net_1\, Q => \CHANNEL14/REGFF/reg4\);
    
    \CHANNEL4/REGCC10/MX2_5\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_a_net_3_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL4/REGCC10/mx2_5_y\);
    
    \CHANNEL4/REGFF/REGFF_0/U0\ : DFMEG
      port map(A => \CHANNEL4/REGFF/GNDZ0\, B => 
        \CHANNEL4/REGFF/data_net_8\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, S => 
        \CHANNEL4/load_net_3\, Q => \CHANNEL4/REGFF/reg0\);
    
    \CHANNEL18/REGCC10/MX2_1\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        dat_b_net_1_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y
         => \CHANNEL18/REGCC10/mx2_1_y\);
    
    \CHANNEL31/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL31/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL31/REG_B/reg9\);
    
    \CHANNEL0/REG_A/REGFF_8/U0\ : DFEG
      port map(D => \CHANNEL0/REG_A/reg7\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL0/reg8_a\);
    
    \CHANNEL25/REG_B/REGFF_9/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/REG_B/reg9\);
    
    \NEW_VALUE_A_INBUF_8_inst/U0/U2\ : IOI_BUFF
      port map(A => \NEW_VALUE_A_INBUF_8_inst/U0/NET2\, Y => 
        DAT_A);
    
    \CHANNEL23/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL23/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_8, Q => \CHANNEL23/new_value_net_3\);
    
    \CHANNEL2/REGCC10/MX2_3\ : CM8
      port map(D0 => AFLSDF_GND, D1 => AFLSDF_VCC, D2 => 
        AFLSDF_GND, D3 => AFLSDF_GND, S00 => AFLSDF_VCC, S01 => 
        DAT_A_0, S10 => AFLSDF_GND, S11 => AFLSDF_GND, Y => 
        \CHANNEL2/REGCC10/mx2_3_y\);
    
    \CHANNEL13/REGCC10/DFC1B_CC_Q_5_inst\ : DFC1B_CC
      port map(D => \CHANNEL13/REGCC10/mx2_5_y\, CLR => CLRZ0, 
        CLK => enable_net_18, Q => \CHANNEL13/new_value_net_3\);
    
    \CHANNEL15/REGFF/DC9/U0\ : CM8BUFF
      port map(A => \CHANNEL15/new_value_9\, Y => 
        \CHANNEL15/REGFF/data_9\);
    
    \CHANNEL18/LOAD3/U0\ : DFEG
      port map(D => \CHANNEL18/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => \CHANNEL18/LOAD\);
    
    \NEW_VALUE_A_INBUF_7_inst/U0/U0\ : IOPAD_IN
      port map(PAD => DATA_INPUT_A(7), Y => 
        \NEW_VALUE_A_INBUF_7_inst/U0/NET1\);
    
    \CHANNEL25/LOAD2/U0\ : DFEG
      port map(D => \CHANNEL25/reg8_b\, CLK => clk_1000, CLR => 
        CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL25/load_net_1\);
    
    \CHANNEL20/REG_B/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL20/REG_B/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL20/REG_B/reg4\);
    
    \CHANNEL27/REG_A/REGFF_4/U0\ : DFEG
      port map(D => \CHANNEL27/REG_A/reg3\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL27/REG_A/reg4\);
    
    \CHANNEL11/REG_B/REGFF_1/U0\ : DFEG
      port map(D => \CHANNEL11/REG_B/reg0\, CLK => clk_1000, CLR
         => CLRZ0, PRE => \VCC\, E => \GND\, Q => 
        \CHANNEL11/REG_B/reg1\);
    
    GND_power_inst1 : GND
      port map( Y => GND_power_net1);

    VCC_power_inst1 : VCC
      port map( Y => VCC_power_net1);


end DEF_ARCH; 
